unit DeleteEx;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_PLATFORM OFF} //W1002

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Shellapi, IniFiles, System.IOUtils;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 400;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX1_WIDTH       = 695;

  // DLL t@C
  DELETE_DLL  = 'BonsFMminiDelete.dll';
  // LOAD_LIBRARY_SEARCH_SYSTEM32 + LOAD_LIBRARY_SEARCH_APPLICATION_DIR
  LOAD_LIBRARY_FLAG    = $00000800 or $00000200;

type
  TFormDeleteEx = class(TForm)
    RadioGroup1: TRadioGroup;
    Panel1: TPanel;
    Label2: TLabel;
    ListBox1: TListBox;
    ButtonTrash: TButton;
    ButtonCancel: TButton;
    ButtonDelete: TButton;
    Label1: TLabel;
    Label3: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonTrashClick(Sender: TObject);
    procedure ButtonDeleteClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure RadioGroup1Click(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

//    DeleteDllModule: HModule;

  public
    { Public 錾 }

  end;

var
  FormDeleteEx: TFormDeleteEx;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormDeleteEx.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormDeleteEx.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormDeleteEx.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormDeleteEx.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr4: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormDeleteEx', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormDeleteEx', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormDeleteEx', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormDeleteEx', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormDeleteEx', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //Ǎ
  ListBox1.Items.Clear;
  if FileExists(FormMain.StrExtractBase + DELETE_TXT) = TRUE then
  begin
    ListBox1.Items.LoadFromFile(FormMain.StrExtractBase + DELETE_TXT, TEncoding.Unicode);
  end;
  //ݒ
  if ListBox1.Items.Count = 0 then
  begin
    ListBox1.ItemIndex := 0;
  end;

  //Jg
  GetDir(0, sStr4);
  Label3.Caption := 'Current:' +  sStr4;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
  end;
end;

procedure TFormDeleteEx.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormDeleteEx', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormDeleteEx', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormDeleteEx', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormDeleteEx', 'Left',   FormDeleteEx.Left);
    IniFile.WriteInteger('FormDeleteEx', 'Top',    FormDeleteEx.Top);
    IniFile.WriteInteger('FormDeleteEx', 'Width',  FormDeleteEx.Width);
    IniFile.WriteInteger('FormDeleteEx', 'Height', FormDeleteEx.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteInteger('DeleteButtonFile', 'Index',   RadioGroup1.ItemIndex);
  //j
  IniFile.Free;
end;

procedure TFormDeleteEx.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormDeleteEx.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormDeleteEx.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormDeleteEx.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormDeleteEx.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormDeleteEx.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormDeleteEx.Handle, imClose);

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'DeleteEx.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormDeleteEx, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormDeleteEx, StrLanguageFileName, Sender);
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  RadioGroup1.ItemIndex := IniFile.ReadInteger('DeleteButtonFile', 'Index',  0);
  if RadioGroup1.ItemIndex = 0 then
  begin
    ButtonTrash.SetFocus;
  end
  else
  begin
    ButtonDelete.SetFocus;
  end;
  //j
  IniFile.Free;
end;

procedure TFormDeleteEx.FormResize(Sender: TObject);
begin
  ListBox1.Width   := Panel1.ClientWidth  -40;
  ListBox1.Height  := Panel1.ClientHeight -150;
  Label1.Top       := Panel1.ClientHeight -75;
  Label3.Top       := Panel1.ClientHeight -107;
  RadioGroup1.Top  := Panel1.ClientHeight -75;
  ButtonTrash.Top  := Panel1.ClientHeight -45;
  ButtonDelete.Top := Panel1.ClientHeight -45;
  ButtonCancel.Top := Panel1.ClientHeight -45;
;
end;

procedure TFormDeleteEx.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormDeleteEx.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile: TIniFile;
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormDeleteEx, StrLanguageFileName, Sender);
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ݒ
    RadioGroup1.ItemIndex := IniFile.ReadInteger('DeleteButtonFile', 'Index',  0);
    if RadioGroup1.ItemIndex = 0 then
    begin
      ButtonTrash.SetFocus;
    end
    else
    begin
      ButtonDelete.SetFocus;
    end;
    //j
    IniFile.Free;
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormDeleteEx, StrLanguageFileName, Sender);
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ݒ
    RadioGroup1.ItemIndex := IniFile.ReadInteger('DeleteButtonFile', 'Index',  0);
    if RadioGroup1.ItemIndex = 0 then
    begin
      ButtonTrash.SetFocus;
    end
    else
    begin
      ButtonDelete.SetFocus;
    end;
    //j
    IniFile.Free;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormDeleteEx.ButtonTrashClick(Sender: TObject);
var
  shOpeStrct1: TSHFILEOPSTRUCT;
  sStr1: String;
  sStr2: String;
  iRow1: Integer;
begin
  //ݒ
  sStr1 := '';
  for iRow1  := 0 to ListBox1.Items.Count-1 do
  begin
    //tH_ȂŌ\폜
    sStr2 := ListBox1.Items[iRow1];
    if Copy(sstr2, Length(sStr2), 1) = '\' then
    begin
      sStr1 := sStr1 + Copy(sStr2, 1, Length(sStr2)-1) + #0;
    end
    else
    begin
      sStr1 := sStr1 + sStr2 + #0;
    end;
  end;


  //Ōɋ؂p #0 t
  //sStr1 := sStr1 + #0;
  //ŌɃ^[~lC^p #0t
  //sStr1 := sStr1 + #0;

  //ݒ
  shOpeStrct1.Wnd               := Application.Handle;
  shOpeStrct1.wFunc             := FO_DELETE;
  shOpeStrct1.pFrom             := PWideChar(sStr1 + #0);
  shOpeStrct1.pTo               := #0;
  shOpeStrct1.fFlags            := FOF_FILESONLY or FOF_ALLOWUNDO;
//  shOpeStrct1.fFlags            := FOF_NORECURSION or FOF_ALLOWUNDO;
  shOpeStrct1.hNameMappings     := nil;
  shOpeStrct1.lpszProgressTitle := nil;
  shOpeStrct1.fAnyOperationsAborted := FALSE;

  //s
  if SHFileOperation(shOpeStrct1) = 0 then
  begin
    //I
    ModalResult := mrOK;
  end
  else
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : t@C܂̓tH_S~Ɉړł܂ł';
    end
    else
    begin
      FormMain.StrMsg := 'Error : Move to trash with file or folder failed.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormDeleteEx.ButtonDeleteClick(Sender: TObject);
var
  shOpeStrct1: TSHFILEOPSTRUCT;
  sStr1: String;
  sStr2: String;
  iRow1: Integer;
//  DeleteDll: String;
//  Start: function (AppHandle: HWND; FileName: ShortString): Boolean; stdcall;
//  FileName: ShortString;
//  bResult: Boolean;
//  SH: TSHELLEXECUTEINFO;
//  bErr1: LongBool;
begin
    //ݒ
    sStr1 := '';
    for iRow1  := 0 to ListBox1.Items.Count-1 do
    begin
      //tH_ȂŌ\폜
      sStr2 := ListBox1.Items[iRow1];
      if Copy(sstr2, Length(sStr2), 1) = '\' then
      begin
        sStr1 := sStr1 + Copy(sStr2, 1, Length(sStr2)-1) + #0;
      end
      else
      begin
        sStr1 := sStr1 + sStr2 + #0;
      end;
    end;

    //Ōɋ؂p #0 t
    //sStr1 := sStr1 + #0;
    //ŌɃ^[~lC^p #0t
    //sStr1 := sStr1 + #0;

//#define ERROR_SUCCESS 0
//#define FO_COPY &H2                     't@CRs[
//#define FO_DELETE &H3                   't@C폜
//#define FO_MOVE &H1                     't@Cړ
//#define FO_RENAME &H4                   't@CύX

//#define FOF_MULTIDESTFILES    &H1    'pTo õt@Cw肵Ă邱Ƃ
//#define FOF_CONFIRMMOUSE      &H2    'ݎgpȂ
//#define FOF_SILENT            &H4    'o߂\_CAO{bNX\Ȃ
//#define FOF_RENAMEONCOLLISION &H8    'ړARs[AO̕ύX̑ɂāAw肵t@Cłɑ݂Ăꍇɂ́AΏۂ̃t
//#define FOF_NOCONFIRMATION    &H10   '\_CAO{bNXŢ͂܂ׂ͢ģI悤ɂ
//#define FOF_WANTMAPPINGHANDLE &H20   '
//#define FOF_ALLOWUNDO         &H40   'łAhDێBpFrom Ŏw肳ꂽt@CtpXŎw肳ĂKvB폜
//#define FOF_FILESONLY         &H80   'ChJ[ht@Ci*.*jw肳ꂽꍇɂ̂ݑs
//#define FOF_SIMPLEPROGRESS    &H100  'o߂\_CAO{bNXɃt@C\Ȃ
//#define FOF_NOCONFIRMMKDIR    &H200  'VfBNg쐬KvꍇɁA쐬邩ǂ̊mFȂ
//#define FOF_NOERRORUI         &H400  'G[ꍇɁA[U[C^[tF[X\Ȃ
//#define FOF_NORECURSION       &H1000 '[JfBNĝ݂ɑsȂBTufBNgɑ΂čċAIɑsȂȂ
//#define vbNullChar chr$(0)           'NULL(\0)

//FOF_MULTIDESTFILES        = 0x   1, pToɂpFromɂP΂PőΉ镡̃Rs[w肵܂
//FOF_CONFIRMMOUSE          = 0x   2, ̃tO͎gp܂
//FOF_SILENT                = 0x   4, i󋵂̃_CAO\܂
//FOF_RENAMEONCOLLISION     = 0x   8, ̃t@Cɑ݂ꍇAVOt܂
//FOF_NOCONFIRMATION        = 0x  10, mF_CAO\Aׂāu͂vÎƂ܂
//FOF_WANTMAPPINGHANDLE     = 0x  20, FOF_RENAMEONCOLLISIONtOɂt@C̏ՓˉꍇASHFILEOPSTRUCT.hNameMappingsɐVt@C̏i[܂B̏SHFreeNameMappingsgĊJKv܂
//FOF_ALLOWUNDO             = 0x  40, \ł΁Aɖ߂悤ɂ܂
//FOF_FILESONLY             = 0x  80, ChJ[hgpꂽꍇAt@Ĉ݂ΏۂƂ܂
//FOF_SIMPLEPROGRESS        = 0x 100, i󋵂̃_CAO\܂AX̃t@C͕\܂
//FOF_NOCONFIRMMKDIR        = 0x 200, VtH_[̍쐬OɃ[U[ɊmF܂
//FOF_NOERRORUI             = 0x 400, G[Ă_CAO\܂
//FOF_NOCOPYSECURITYATTRIBS = 0x 800, t@C̃ZLeB̓Rs[܂BRs[̃t@C̓Rs[̃tH_[̃ZLeBp܂
//FOF_NORECURSION           = 0x1000, TufBNg[ċAIɏ܂B͊̓ł
//FOF_NO_CONNECTED_ELEMENTS = 0x2000, O[vƂĘAĂt@C͈ړ܂Bw肳ꂽt@Cړ܂
//FOF_WANTNUKEWARNING       = 0x4000, t@CPvIɍ폜ꍇAx\܂B̃tOFOF_NOCONFIRMATIOND悳܂
//FOF_NO_UI = FOF_SILENT | FOF_NOCONFIRMATION | FOF_NOERRORUI | FOF_NOCONFIRMMKDIR UI\܂

    //ݒ
    shOpeStrct1.Wnd               := Application.Handle;
    shOpeStrct1.wFunc             := FO_DELETE;
    shOpeStrct1.pFrom             := PWideChar(sStr1 + #0);
    shOpeStrct1.pTo               := #0;
    shOpeStrct1.fFlags            := FOF_FILESONLY or FOF_NOCONFIRMATION;
//    shOpeStrct1.fFlags            := FOF_NORECURSION;
    shOpeStrct1.hNameMappings     := nil;
    shOpeStrct1.lpszProgressTitle := nil;
    shOpeStrct1.fAnyOperationsAborted := FALSE;

    //s
    if SHFileOperation(shOpeStrct1) = 0 then
    begin
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : t@C܂̓tH_폜ł܂ł';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Delete file or folder failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;

end;

procedure TFormDeleteEx.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormDeleteEx.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormDeleteEx.RadioGroup1Click(Sender: TObject);
begin
  if Radiogroup1.ItemIndex = 0 then
  begin
    ButtonTrash.SetFocus;
  end
  else
  begin
    ButtonDelete.SetFocus;
  end;
end;

{
procedure TFormDeleteEx.ButtonDeleteClick(Sender: TObject);
var
  shOpeStrct1: TSHFILEOPSTRUCT;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  iRow1: Integer;
  iError1: Integer;
  iRet1: Integer;
  iRet2: Integer;
  bRet1: Boolean;
  bRet2: Boolean;
  StrList1: TStringList;
  StrList2: TStringList;
  File2: TWin32FindData;
  hFindData1: THandle;

  procedure ThisListFiles(
                DirName    :String;      //       fBNgtpX
                TheList    :TStringList  //       ꗗi[ TStringList
            );
  var
    sStr2: string;
    sStr3: String;
    sStr4: String;
    File2: TWin32FindData;
    hFindData1: THandle;
  begin
    //ݒ
    if Copy(DirName, Length(DirName), 1) <> '\' then
    begin
      DirName := DirName + '\';
    end;
    sStr2 := DirName + '*.*';
    //t@Č
    hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
    if hFindData1 <> INVALID_HANDLE_VALUE then
    begin
      repeat
        //efBNg܂͎qfBNg̔
        if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
        begin
          //t@C̐ݒ
          sStr3 := DirName + String(File2.cFileName);
          if (Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_READONLY) = TRUE) or
             (Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_SYSTEM)   = TRUE) or
             (Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_HIDDEN)   = TRUE) then
           begin
             sStr4 := '1';
           end
           else
           begin
             sStr4 := '0';
           end;

          //fBNg̔)
          if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
          begin
            //tH_ɂ
            sStr3 := sStr3 + '\';
            //ǉ
            TheList.Add(sStr4 + #09 + sStr3);
            //ċNIɌ
            Application.ProcessMessages;
            ThisListFiles(sStr3, TheList);
            Application.ProcessMessages;
          end
          else
          begin
            //ǉ
            TheList.Add(sStr4 + #09 + sStr3);
          end;
        end;
      //Č
      until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
      //I
      WinApi.Windows.FindClose(hFindData1);
    end;
    //
    Application.ProcessMessages;
  end;

begin
//procedure TForm1.Button2Click(Sender: TObject);
//var
//   i:integer;
//begin
//     for i:=ListBox1.items.count-1 downto 0 do
//     begin
//          if not deletefile(Listbox1.items[i]) then
//           removedir(Listbox1.items[i]);
//     end;
//end;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;

  //ꗗ擾
  for iRow1  := 0 to ListBox1.Items.Count-1 do
  begin
    //擾
    sStr1 := ListBox1.Items[iRow1];
    //tH_
    if Copy(sStr1, Length(sStr1), 1) = '\' then
    begin
      //ċAI
      StrList2.Clear;
      ThisListFiles(sStr1, StrList2);
      StrList1.AddStrings(StrList2);
      //Ō\폜
      sStr2 := Copy(sStr1, 1, Length(sStr1)-1);
    end
     //t@C
    else
    begin
      sStr2 := sStr1;
    end;

    //t@Č
    hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
    if hFindData1 <> INVALID_HANDLE_VALUE then
    begin
      if (Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_READONLY) = TRUE) or
         (Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_SYSTEM)   = TRUE) or
         (Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_HIDDEN)   = TRUE) then
       begin
         sStr4 := '1';
       end
       else
       begin
         sStr4 := '0';
       end;
       //ǉ
       StrList1.Add(sStr4 + #09 + sStr1);
    end;
  end;

  //\[g
  StrList1.Sorted := TRUE;

  //Ōォ폜
  iError1 := -1;
  for iRow1 := StrList1.Count-1 downto 0 do
  begin
    //
    iRet1 := 0;
    iRet2 := 0;
    bRet1 := TRUE;
    bRet2 := TRUE;
    //ݒ
    sStr1 := StrList1.Strings[iRow1];
    sStr2 := Copy(sStr1, 1, 1);
    sStr3 := Copy(sStr1, 3, Length(sStr1));
    //tH_
    if Copy(sStr3, Length(sStr3), 1) = '\' then
    begin
      //tH_
      sStr4 := Copy(sStr3, 1, Length(sStr3)-1);
      //Zbg
      if sStr2 = '1' then
      begin
        iRet1 := FileSetAttr(sStr4, 0);
      end;
//      TDirectory.Delete(sStr4, TRUE);
//      Application.ProcessMessages;
      bRet1 := RemoveDir(sStr4);
    end
    //t@C
    else
    begin
      //Zbg
      if sStr2 = '1' then
      begin
        iRet2 := FileSetAttr(sStr3, 0);
      end;
      bRet2 := DeleteFile(sStr3);
    end;
    //s
    if (iRet1 <> 0 )  or (bRet1 = FALSE) or  (iRet2 <> 0 )  or (bRet2 = FALSE) then
    begin
      iError1 := iRow1;
    end;
  end;

  //j
  StrList1.Free;
  StrList2.Free;

  //s
  if iError1 <> -1then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : t@C܂̓tH_폜ł܂ł';
    end
    else
    begin
      FormMain.StrMsg := 'Error : Delete file or folder failed.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end
  else
  begin
    //I
    //ModalResult := mrOK;
  end;




    //ݒ
    sStr1 := '';
    for iRow1  := 0 to ListBox1.Items.Count-1 do
    begin
      sStr1 := sStr1 + ListBox1.Items[iRow1] + #0;
    end;

    //Ōɋ؂p #0 t
    //sStr1 := sStr1 + #0;
    //ŌɃ^[~lC^p #0t
    //sStr1 := sStr1 + #0;

//#define ERROR_SUCCESS 0
//#define FO_COPY &H2                     't@CRs[
//#define FO_DELETE &H3                   't@C폜
//#define FO_MOVE &H1                     't@Cړ
//#define FO_RENAME &H4                   't@CύX

//#define FOF_MULTIDESTFILES    &H1    'pTo õt@Cw肵Ă邱Ƃ
//#define FOF_CONFIRMMOUSE      &H2    'ݎgpȂ
//#define FOF_SILENT            &H4    'o߂\_CAO{bNX\Ȃ
//#define FOF_RENAMEONCOLLISION &H8    'ړARs[AO̕ύX̑ɂāAw肵t@Cłɑ݂Ăꍇɂ́AΏۂ̃t
//#define FOF_NOCONFIRMATION    &H10   '\_CAO{bNXŢ͂܂ׂ͢ģI悤ɂ
//#define FOF_WANTMAPPINGHANDLE &H20   '
//#define FOF_ALLOWUNDO         &H40   'łAhDێBpFrom Ŏw肳ꂽt@CtpXŎw肳ĂKvB폜
//#define FOF_FILESONLY         &H80   'ChJ[ht@Ci*.*jw肳ꂽꍇɂ̂ݑs
//#define FOF_SIMPLEPROGRESS    &H100  'o߂\_CAO{bNXɃt@C\Ȃ
//#define FOF_NOCONFIRMMKDIR    &H200  'VfBNg쐬KvꍇɁA쐬邩ǂ̊mFȂ
//#define FOF_NOERRORUI         &H400  'G[ꍇɁA[U[C^[tF[X\Ȃ
//#define FOF_NORECURSION       &H1000 '[JfBNĝ݂ɑsȂBTufBNgɑ΂čċAIɑsȂȂ
//#define vbNullChar chr$(0)           'NULL(\0)

//FOF_MULTIDESTFILES        = 0x   1, pToɂpFromɂP΂PőΉ镡̃Rs[w肵܂
//FOF_CONFIRMMOUSE          = 0x   2, ̃tO͎gp܂
//FOF_SILENT                = 0x   4, i󋵂̃_CAO\܂
//FOF_RENAMEONCOLLISION     = 0x   8, ̃t@Cɑ݂ꍇAVOt܂
//FOF_NOCONFIRMATION        = 0x  10, mF_CAO\Aׂāu͂vÎƂ܂
//FOF_WANTMAPPINGHANDLE     = 0x  20, FOF_RENAMEONCOLLISIONtOɂt@C̏ՓˉꍇASHFILEOPSTRUCT.hNameMappingsɐVt@C̏i[܂B̏SHFreeNameMappingsgĊJKv܂
//FOF_ALLOWUNDO             = 0x  40, \ł΁Aɖ߂悤ɂ܂
//FOF_FILESONLY             = 0x  80, ChJ[hgpꂽꍇAt@Ĉ݂ΏۂƂ܂
//FOF_SIMPLEPROGRESS        = 0x 100, i󋵂̃_CAO\܂AX̃t@C͕\܂
//FOF_NOCONFIRMMKDIR        = 0x 200, VtH_[̍쐬OɃ[U[ɊmF܂
//FOF_NOERRORUI             = 0x 400, G[Ă_CAO\܂
//FOF_NOCOPYSECURITYATTRIBS = 0x 800, t@C̃ZLeB̓Rs[܂BRs[̃t@C̓Rs[̃tH_[̃ZLeBp܂
//FOF_NORECURSION           = 0x1000, TufBNg[ċAIɏ܂B͊̓ł
//FOF_NO_CONNECTED_ELEMENTS = 0x2000, O[vƂĘAĂt@C͈ړ܂Bw肳ꂽt@Cړ܂
//FOF_WANTNUKEWARNING       = 0x4000, t@CPvIɍ폜ꍇAx\܂B̃tOFOF_NOCONFIRMATIOND悳܂
//FOF_NO_UI = FOF_SILENT | FOF_NOCONFIRMATION | FOF_NOERRORUI | FOF_NOCONFIRMMKDIR UI\܂

    //ݒ
    shOpeStrct1.Wnd               := Application.Handle;
    shOpeStrct1.wFunc             := FO_DELETE;
    shOpeStrct1.pFrom             := PWideChar(sStr1 + #0);
    shOpeStrct1.pTo               := #0;
    shOpeStrct1.fFlags            := FOF_FILESONLY or FOF_NOCONFIRMATION;
//    shOpeStrct1.fFlags            := FOF_NORECURSION;
    shOpeStrct1.hNameMappings     := nil;
    shOpeStrct1.lpszProgressTitle := nil;
    shOpeStrct1.fAnyOperationsAborted := False;

    //s
    if SHFileOperation(shOpeStrct1) = 0 then
    begin
      //I
      ModalResult := mrOK;
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : t@C܂̓tH_폜ł܂ł';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Delete file or folder failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;

end;
}
end.

