unit Extract;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_DEPRECATED    OFF} //W1000 : for FileCtrl
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN UNIT_PLATFORM   OFF} //W1005 : for Filectrl

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Filectrl, IniFiles,
  Math, ShlObj, ActiveX, Vcl.Menus;


const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 660;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX1_WIDTH       = 695;

type
  TFormExtract = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    ListBox1: TListBox;
    Label1: TLabel;
    ButtonCurrent: TButton;
    ButtonList: TButton;
    ButtonTree: TButton;
    ButtonJumpFolder: TButton;
    ButtonCancel: TButton;
    ButtonExtract1: TButton;
    ButtonExtract2: TButton;
    ButtonExtract3: TButton;
    ButtonExtract4: TButton;
    ButtonExtract5: TButton;
    ButtonHistory1: TButton;
    ButtonHistory2: TButton;
    ButtonHistory3: TButton;
    ButtonFiler1: TButton;
    ButtonFiler2: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    ListBox3: TListBox;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuCurrent: TMenuItem;
    MenuList: TMenuItem;
    MenuTree: TMenuItem;
    MenuJumpFolder: TMenuItem;
    MenuCancel: TMenuItem;
    MenuExtract1: TMenuItem;
    MenuExtract2: TMenuItem;
    MenuExtract3: TMenuItem;
    MenuExtract4: TMenuItem;
    MenuExtract5: TMenuItem;
    MenuHistoty1: TMenuItem;
    MenuHistoty2: TMenuItem;
    MenuHistoty3: TMenuItem;
    MenuFiler1: TMenuItem;
    MenuFiler2: TMenuItem;
    MenuOption: TMenuItem;
    MenuFileName: TMenuItem;
    MenuCheckBox1: TMenuItem;
    MenuCheckBox2: TMenuItem;
    MenuCheckBox3: TMenuItem;
    MenuKeyBoard: TMenuItem;
    Label3: TLabel;
    MenuCheckBox4: TMenuItem;
    MenuRun: TMenuItem;
    Edit2: TEdit;
    Label4: TLabel;
    MenuFilePath: TMenuItem;
    N1: TMenuItem;
    ButtonRun: TButton;
    CheckBox4: TCheckBox;
    ButtonBrowse: TButton;
    MenuBrowse: TMenuItem;
    Label5: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox3DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    procedure ButtonListClick(Sender: TObject);
    procedure ButtonExtract1Click(Sender: TObject);
    procedure ButtonExtract2Click(Sender: TObject);
    procedure ButtonExtract3Click(Sender: TObject);
    procedure ButtonExtract4Click(Sender: TObject);
    procedure ButtonExtract5Click(Sender: TObject);
    procedure ButtonHistory1Click(Sender: TObject);
    procedure ButtonHistory2Click(Sender: TObject);
    procedure ButtonHistory3Click(Sender: TObject);
    procedure ButtonFiler1Click(Sender: TObject);
    procedure ButtonFiler2Click(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonJumpFolderClick(Sender: TObject);
    procedure ButtonCurrentClick(Sender: TObject);
    procedure ButtonTreeClick(Sender: TObject);
    procedure ButtonRunClick(Sender: TObject);

    function  SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;
    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
    procedure InitKeyMap(ExeType: Integer; Sender: TObject);

    procedure MenuCurrentClick(Sender: TObject);
    procedure MenuListClick(Sender: TObject);
    procedure MenuTreeClick(Sender: TObject);
    procedure MenuJumpFolderClick(Sender: TObject);
    procedure MenuCancelClick(Sender: TObject);
    procedure MenuExtract1Click(Sender: TObject);
    procedure MenuExtract2Click(Sender: TObject);
    procedure MenuExtract3Click(Sender: TObject);
    procedure MenuExtract4Click(Sender: TObject);
    procedure MenuExtract5Click(Sender: TObject);
    procedure MenuHistoty1Click(Sender: TObject);
    procedure MenuHistoty2Click(Sender: TObject);
    procedure MenuHistoty3Click(Sender: TObject);
    procedure MenuFiler1Click(Sender: TObject);
    procedure MenuFiler2Click(Sender: TObject);
    procedure MenuFileNameClick(Sender: TObject);
    procedure MenuCheckBox1Click(Sender: TObject);
    procedure MenuCheckBox2Click(Sender: TObject);
    procedure MenuCheckBox3Click(Sender: TObject);
    procedure MenuKeyBoardClick(Sender: TObject);
    procedure MenuCheckBox4Click(Sender: TObject);
    procedure MenuFilePathClick(Sender: TObject);
    procedure MenuRunClick(Sender: TObject);

    procedure HistoryUpdate(Sender: TObject);

    procedure CheckBox4Click(Sender: TObject);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ButtonBrowseClick(Sender: TObject);
    procedure MenuBrowseClick(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);

    procedure SetHistory(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrExtractPath1: String;
    StrExtractPath2: String;
    StrExtractPath3: String;
    StrExtractPath4: String;
    StrExtractPath5: String;
    StrExtractPath6: String;
    StrExtractPath7: String;
    StrExtractPath8: String;
    StrExtractPath9: String;
    StrExtractPath10: String;
    BoolKeyMapSame:Boolean;
    BoolJapanese: Boolean;
    StrListKeyMapCheck1: TStringList;
    StrListKeyMapCheck2: TStringList;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormExtract: TFormExtract;

implementation

uses
  Main, JumpFolder, Browse, KeyBoard, Tree;

{$R *.dfm}

//WindowsAPIR[obN֐ EBhE̗
function EnumWindowsProc(Wnd: HWND; lParam: Longint): Bool; stdcall; export;
var
  szCaption: array [0..255] of Char;
begin
  //ݒ
  Result:= TRUE;
  //EBhEnh擾
  GetWindowText(Wnd, szCaption, sizeof(szCaption));
  //gȊȎSĂݒ肷
  if (Wnd <> FormMain.Handle) then
  begin
    FormMain.StrListWindowName2.Add(StrPas(szCaption));
    FormMain.StrListWindowHwnd2.Add(IntToStr(Wnd));
  end;
end;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormExtract.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormExtract.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormExtract.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormExtract.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr4: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormExtract', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormExtract', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormExtract', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormExtract', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormExtract', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListKeyMapCheck1   := TStringList.Create;
  StrListKeyMapCheck2   := TStringList.Create;

  //ݒ
  ListBox1.Items.Assign(FormMain.StrListExtractFile);
  ListBox1.ItemIndex := 0;
  //ݒ
  ListBox3.Items.LoadFromFile(FormMain.StrExtractBase + RESPONSE_TXT);
  ListBox3.ItemIndex := 0;
  //ݒ
  Label1.Caption := FormMain.StrSetFormExtract;
  if UpperCase(ExtractFileExt(ListBox1.Items.Strings[0])) = UpperCase(ARC_ZIP) then
  begin
    Label1.Visible := TRUE;
    Label3.Visible := TRUE;
  end
  else
  begin
    Label1.Visible := FALSE;
    Label3.Visible := FALSE;
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  CheckBox1.Checked  := IniFile.ReadBool   ('FormExtract',      'WithPath',          TRUE);
  CheckBox2.Checked  := IniFile.ReadBool   ('FormExtract',      'MakeFolder',        TRUE);
  CheckBox3.Checked  := IniFile.ReadBool   ('FormExtract',      'DouleDisabled',     FALSE);
  CheckBox4.Checked  := IniFile.ReadBool   ('FormExtract',      'ShowPassName',      FALSE);
  //j
  IniFile.Free;

  //Jg
  GetDir(0, sStr4);
  Label5.Caption := 'Current:' +  sStr4;

  //f
  Edit2.Text := '';
  if CheckBox4.Checked = TRUE then
  begin
    Edit2.Visible     := TRUE;
    ButtonRun.Visible := TRUE;
    MenuRun.Enabled   := TRUE;
  end;
  if CheckBox4.Checked = FALSE then
  begin
    Edit2.Visible     := FALSE;
    ButtonRun.Visible := FALSE;
    MenuRun.Enabled   := FALSE;
  end;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
    ListBox3.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
    ListBox3.Style := lbStandard;
  end;
end;

procedure TFormExtract.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormExtract', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormExtract', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormExtract', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormExtract', 'Left',   FormExtract.Left);
    IniFile.WriteInteger('FormExtract', 'Top',    FormExtract.Top);
    IniFile.WriteInteger('FormExtract', 'Width',  FormExtract.Width);
    IniFile.WriteInteger('FormExtract', 'Height', FormExtract.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteBool ('FormExtract',      'WithPath',          CheckBox1.Checked);
  IniFile.WriteBool ('FormExtract',      'MakeFoler',         CheckBox2.Checked);
  IniFile.WriteBool ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
  IniFile.WriteBool ('FormExtract',      'ShowPassName',      CheckBox4.Checked);
   //j
  IniFile.Free;

  //j
  StrListKeyMapCheck1.Free;
  StrListKeyMapCheck2.Free;
end;

procedure TFormExtract.FormShow(Sender: TObject);
var
  StrList1: TStringList;
  sStr1: String;
  iRow1: Integer;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormExtract.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormExtract.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormExtract.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormExtract.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormExtract.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormExtract.Handle, imClose);

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);
  ListBox3.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);

  //ݒ
  InitKeyMap(0, Sender);

  //m
  StrList1 := TStringList.Create;
  //t@CǍ
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_EXTRACT_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    //Ǎ
    StrList1.LoadFromFile(sStr1, TEncoding.Unicode);
    //ڐ
    if StrList1.Count = FormMain.StrListKeyMapOriginalExtract.Count then
    begin
      //@\擾
      FormMain.GetFunctionList(StrList1,                              StrListKeyMapCheck1, Sender);
      FormMain.GetFunctionList(FormMain.StrListKeyMapOriginalExtract, StrListKeyMapCheck2, Sender);
      //Ƃ肠ڐ𓯂ɂĂ
      BoolKeyMapSame := TRUE;
      //ǂ`FbN
      for iRow1 := 0 to StrListKeyMapCheck2.Count-1 do
      begin
        //Ⴄ
        if StrListKeyMapCheck1.Strings[iRow1] <> StrListKeyMapCheck2.Strings[iRow1] then
        begin
          //Ⴄ
          BoolKeyMapSame := FALSE;
          //f
          Break;
        end;
      end;

      //
      if BoolKeyMapSame = FALSE then
      begin
        //XV
        FormMain.StrListKeyMapExtract.Assign(FormMain.StrListKeyMapOriginalExtract);
        //ۑ
        FormMain.StrListKeyMapExtract.SaveToFile(sStr1, TEncoding.Unicode);
      end;
    end
    else
    begin
      //XV
      FormMain.StrListKeyMapExtract.Assign(FormMain.StrListKeyMapOriginalExtract);
      //ۑ
      FormMain.StrListKeyMapExtract.SaveToFile(sStr1, TEncoding.Unicode);
      //ڐႤ
      BoolKeyMapSame := FALSE;
    end;
  end
  else
  begin
    //ۑ
    FormMain.StrListKeyMapExtract.Assign(FormMain.StrListKeyMapOriginalExtract);
    FormMain.StrListKeyMapExtract.SaveToFile(sStr1, TEncoding.Unicode);
    //ڐ
    BoolKeyMapSame := TRUE;
  end;
  //j
  StrList1.Free;

  //ݒ
  SetShortCutKey(Sender);

  //ݒ
  if CheckBox4.Checked = TRUE then
  begin
    Edit2.SetFocus;
  end
  else
  begin
    ButtonJumpFolder.SetFocus
  end;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Extract.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormExtract, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormExtract, StrLanguageFileName, Sender);
  end;

  //Ǎ
  SetHistory(Sender);
end;

procedure TFormExtract.FormResize(Sender: TObject);
begin
  ListBox1.Width       := Panel1.Width -65;
  ListBox3.Width       := Panel1.Width -65;
  Edit2.Width          := Panel1.Width -65;
  ButtonExtract1.Width := Panel1.Width -65;
  ButtonExtract2.Width := Panel1.Width -65;
  ButtonExtract3.Width := Panel1.Width -65;
  ButtonExtract4.Width := Panel1.Width -65;
  ButtonExtract5.Width := Panel1.Width -65;
  ButtonHistory1.Width := Panel1.Width -65;
  ButtonHistory2.Width := Panel1.Width -65;
  ButtonHistory3.Width := Panel1.Width -65;
  ButtonFiler1.Width   := Panel1.Width -65;
  ButtonFiler2.Width   := Panel1.Width -65;
end;

procedure TFormExtract.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormExtract.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormExtract, StrLanguageFileName, Sender);
    //Ǎ
    SetHistory(Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormExtract, StrLanguageFileName, Sender);
    //Ǎ
    SetHistory(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormExtract.ButtonCurrentClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := ExtractfilePath(FormMain.StrCurrent);
    //XV
    HistoryUpdate(Sender);
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonListClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  IniFile: TIniFile;
begin
    //ݒ
    sStr2 := ExtractfilePath(FormMain.StrCurrent);
    if DirectoryExists(sStr2) = FALSE then
    begin
      sStr2 := '';
    end;
    if SelectDirectorySh('Select Directory', sStr2, sStr1) = TRUE then
    begin
      //tH_
      if DirectoryExists(sStr1) = TRUE then
      begin
        //m
        IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
        //ۑ
        IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
        IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
        IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
        //j
        IniFile.Free;

        //ݒ
        FormMain.StrRetFormExtract := sStr1;
        //XV
        HistoryUpdate(Sender);
        //I
        if CheckBox4.Checked = FALSE then
        begin
          ModalResult := mrOK;
        end
        else
        begin
          Edit2.SetFocus;
        end;
      end
      else
      begin
          Edit2.SetFocus;
      end;
    end;
end;

procedure TFormExtract.ButtonTreeClick(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
    //
    FormMain.StrRetFormTree := '';
    FormMain.StrSetFormTree := ExtractfilePath(FormMain.StrCurrent);
    //
    FormTree := TFormTree.Create(Application);
    try
      if FormTree.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormTree.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormTree) = TRUE then
      begin
        //m
        IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
        //ۑ
        IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
        IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
        IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
        //j
        IniFile.Free;

        //ݒ
        FormMain.StrRetFormExtract := FormMain.StrRetFormTree;
        //XV
        HistoryUpdate(Sender);
        //I
        if CheckBox4.Checked = FALSE then
        begin
          ModalResult := mrOK;
        end
        else
        begin
          Edit2.SetFocus;
        end;
      end
      else
      begin
          Edit2.SetFocus;
      end;
    end;
end;

procedure TFormExtract.ButtonBrowseClick(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FOLDER);
  //j
  IniFile.Free;

    //
    FormMain.StrRetFormBrowse := '';
    FormMain.StrSetFormBrowse := ExtractfilePath(FormMain.StrCurrent);
    //
    FormBrowse := TFormBrowse.Create(Application);
    try
      if FormBrowse.ShowModal = mrOK then
      begin
         bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormBrowse.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormBrowse) = TRUE then
      begin
        //m
        IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
        //ۑ
        IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
        IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
        IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
        //j
        IniFile.Free;

        //ݒ
        FormMain.StrRetFormExtract := FormMain.StrRetFormBrowse;
        //XV
        HistoryUpdate(Sender);
        //I
        if CheckBox4.Checked = FALSE then
        begin
          ModalResult := mrOK;
        end
        else
        begin
          Edit2.SetFocus;
        end;
      end
      else
      begin
          Edit2.SetFocus;
      end;
    end;
end;

procedure TFormExtract.ButtonJumpFolderClick(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
    // 
    FormJumpFolder := TFormJumpFolder.Create(Application);
    try
      if FormJumpFolder.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      // j
      FormJumpFolder.Free;
    end;
    //ݒ肳ꂽ
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormJumpFolder) = TRUE then
      begin
        //m
        IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
        //ۑ
        IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
        IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
        IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
        //j
        IniFile.Free;

        //ݒ
        FormMain.StrRetFormExtract := FormMain.StrRetFormJumpFolder;
        //XV
        HistoryUpdate(Sender);
        //I
        if CheckBox4.Checked = FALSE then
        begin
          ModalResult := mrOK;
        end
        else
        begin
          Edit2.SetFocus;
        end;
      end
      else
      begin
          Edit2.SetFocus;
      end;
    end;
end;

procedure TFormExtract.ButtonRunClick(Sender: TObject);
begin
    //I
    if CheckBox4.Checked = TRUE then
    begin
      //
      if Edit2.Text = '' then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Information : 𓀐̃tH_ݒ肳Ă܂';
        end
        else
        begin
          FormMain.StrMsg := 'Information : Extract folder is empty.' + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;
      if Copy(Edit2.Text, Length(Edit2.Text), 1) <> '\' then
      begin
        Edit2.Text := Edit2.Text + '\';
      end;
      if DirectoryExists(Edit2.Text) = FALSE then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Information : 𓀐̃tH_܂';
        end
        else
        begin
          FormMain.StrMsg := 'Information : Extract folder is not exist.' + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;

      //ݒ
      FormMain.StrRetFormExtract := Edit2.Text;
      //XV
      HistoryUpdate(Sender);
      //I
      ModalResult := mrOK;
    end;
end;

procedure TFormExtract.ButtonExtract1Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := StrExtractPath1;
    //XV
    HistoryUpdate(Sender);
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonExtract2Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := StrExtractPath2;
    //XV
    HistoryUpdate(Sender);
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonExtract3Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := StrExtractPath3;
    //XV
    HistoryUpdate(Sender);
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonExtract4Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := StrExtractPath4;
    //XV
    HistoryUpdate(Sender);
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonExtract5Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := StrExtractPath5;
    //XV
    HistoryUpdate(Sender);
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonHistory1Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := StrExtractPath6;
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.Text := StrExtractPath6;
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonHistory2Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := StrExtractPath7;
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.Text := StrExtractPath7;
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonHistory3Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := StrExtractPath8;
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.Text := StrExtractPath8;
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonFiler1Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := StrExtractPath9;
    //XV
    HistoryUpdate(Sender);
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.Text := StrExtractPath9;
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonFiler2Click(Sender: TObject);
var
  IniFile: TIniFile;
begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ۑ
    IniFile.WriteBool   ('FormExtract',      'WithPath',          CheckBox1.Checked);
    IniFile.WriteBool   ('FormExtract',      'MakeFolder',        CheckBox2.Checked);
    IniFile.WriteBool   ('FormExtract',      'DouleDisabled',     CheckBox3.Checked);
    //j
    IniFile.Free;

    //ݒ
    FormMain.StrRetFormExtract := StrExtractPath10;
    //XV
    HistoryUpdate(Sender);
    //I
    if CheckBox4.Checked = FALSE then
    begin
      ModalResult := mrOK;
    end
    else
    begin
      Edit2.Text := StrExtractPath10;
      Edit2.SetFocus;
    end;
end;

procedure TFormExtract.ButtonCancelClick(Sender: TObject);
begin
  //ݒ
  FormMain.StrRetFormExtract := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormExtract.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormExtract.ListBox3DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;


function TFormExtract.SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;
var
  FolderPidl : PItemIDList;
  BrowseInfo : TBrowseInfo;
  BPathName  : array[0..MAX_PATH-1] of Char;
  AMalloc    : IMalloc;
begin
  //
  Result := FALSE;
  //ڎʎq̂߂̃AP[Ṽ|C^擾
  ShGetMalloc(AMalloc);
  FolderPidl := nil;
  //
  FillChar(BrowseInfo, SizeOf(BrowseInfo), #0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.lpfn      := nil;
  BrowseInfo.lpszTitle := PChar('Select Directory');
  BrowseInfo.pidlRoot  := nil;
  BrowseInfo.ulFlags   := BIF_RETURNONLYFSDIRS or
                          BIF_NEWDIALOGSTYLE   or
                          BIF_VALIDATE;

//BIF_RETURNONLYFSDIRS   $0001 t@CVXefBNĝ݂I\
//BIF_DONTGOBELOWDOMAIN  $0002 hC̃lbg[NtH_\Ȃ
//BIF_STATUSTEXT         $0004 _CAOc[̂ɕ\
//                             R[obN֐ŏKv
//BIF_RETURNFSANCESTORS	 $0008 [gȉ̃t@CCtH_̂ݑI\
//BIF_EDITBOX            $0010 OҏWp{bNX\
//BIF_VALIDATE           $0020 OҏW{bNXւ̖ȕ`FbN
//                             BIF_EDITBOX ̎w肪鎞̂ݗL
//                             ̓R[obN֐ōs
//BIF_NEWDIALOGSTYLE	   $0040	ȉ̐VX^C̃_CAO\
//                             TCY\
//                             _CAOւ̃hbOAhhbv
//                             tH_̍Đ
//                             V[gJbgj[ (ReLXg)
//                             VtH_̍쐬
//BIF_USENEWUI           $0050 OҏW{bNX̂VX^C
//                             BIF_EDITBOX or BIF_NEWDIALOGSTYLE wƓ
//BIF_BROWSEINCLUDEURLS	 $0080 URL\\Ƃ
//                             BIF_USENEWUIBIF_BROWSEINCLUDEFILES ̎wKv
//                             YtH_T|[gꍇ̂ݕ\
//BIF_UAHINT             $0100 OҏW{bNX̑Ƀqg\
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NONEWFOLDERBUTTON  $0200  [VtH_̍쐬] {^\Ȃ
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NOTRANSLATETARGETS $0400 IACeV[gJbg̏ꍇCNł͂ȂCV[gJbgg̍ڎʎqԂ
//BIF_BROWSEFORCOMPUTER  $1000 Rs[^̂ݑI\Ƃ
//BIF_BROWSEFORPRINTER   $2000 v^̂ݑI\Ƃ
//BIF_BROWSEINCLUDEFILES $4000 t@C\đI\Ƃ
//BIF_SHAREABLE          $8000 L\[X\đI\ɂ
//                             BIF_USENEWUI ̎wKv

  //̐ݒɊÂtH_Qƃ_CAO\
  try
    //擾
    FolderPidl := SHBrowseForFolder(BrowseInfo);
    If FolderPidl <> nil then
    begin
      //ڎʎqpX̕BPathNameɕϊ
      SHGetPathFromIDList(FolderPidl, BPathName);
      //
      Directory := BPathName;
      if Copy(Directory, Length(Directory), 1) <> '\' then
      begin
        Directory := Directory + '\';
      end;
      //
      Result := TRUE;
    end;
  finally
    //
    AMalloc.Free(FolderPidl);
  end;
end;


procedure TFormExtract.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //Ǎ
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_EXTRACT_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    FormMain.StrListKeyMapExtract.LoadFromFile(sStr1, TEncoding.Unicode);
  end
  //t@CȂꍇ́AftHgŐݒ肳ĂeɂȂĂ
  else
  begin
    FormMain.StrListKeyMapExtract.SaveToFile(sStr1, TEncoding.Unicode);
  end;

  //ݒ
  if FormMain.StrListKeyMapExtract.Count > 0 then
  begin
    SetShortCutNew('1001', MenuCurrent, Sender);
    SetShortCutNew('1002', MenuList, Sender);
    SetShortCutNew('1003', MenuTree, Sender);
    SetShortCutNew('1004', MenuJumpFolder, Sender);
    SetShortCutNew('1005', MenuCancel, Sender);
    SetShortCutNew('1006', MenuExtract1, Sender);
    SetShortCutNew('1007', MenuExtract2, Sender);
    SetShortCutNew('1008', MenuExtract3, Sender);
    SetShortCutNew('1009', MenuExtract4, Sender);
    SetShortCutNew('1010', MenuExtract5, Sender);
    SetShortCutNew('1011', MenuHistoty1, Sender);
    SetShortCutNew('1012', MenuHistoty2, Sender);
    SetShortCutNew('1013', MenuHistoty3, Sender);
    SetShortCutNew('1014', MenuFiler1, Sender);
    SetShortCutNew('1015', MenuFiler2, Sender);
    SetShortCutNew('1016', MenuRun, Sender);
    SetShortCutNew('1017', MenuBrowse, Sender);

    SetShortCutNew('1101', MenuFileName, Sender);
    SetShortCutNew('1102', MenuCheckBox1, Sender);
    SetShortCutNew('1103', MenuCheckBox2, Sender);
    SetShortCutNew('1104', MenuCheckBox3, Sender);
    SetShortCutNew('1105', MenuCheckBox4, Sender);
    SetShortCutNew('1106', MenuFilePath, Sender);
    SetShortCutNew('1111', MenuKeyBoard, Sender);
  end;
end;

procedure TFormExtract.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to FormMain.StrListKeyMapExtract.Count-1 do
  begin
    //擾
    sStr11 := FormMain.StrListKeyMapExtract.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //ݒ
    sStr3 := '';
  end
  else
  begin
    //ݒ
    sStr3 := sStr16;
  end;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

procedure TFormExtract.InitKeyMap(ExeType: Integer; Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin


  //NA
  FormMain.StrListKeyMapOriginalExtract.Clear;


  //File
  sStr1 :=                FormExtract.MenuCurrent.Caption;
  sStr2 := ShortCutToText(scAlt + VK_R);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1001');

  sStr1 :=                FormExtract.MenuList.Caption;
  sStr2 := ShortCutToText(scAlt + VK_L);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1002');

  sStr1 :=                FormExtract.MenuTree.Caption;
  sStr2 := ShortCutToText(scAlt + VK_T);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1003');

  sStr1 :=                FormExtract.MenuJumpFolder.Caption;
  sStr2 := ShortCutToText(scAlt + VK_J);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1004');

  sStr1 :=                FormExtract.MenuCancel.Caption;
  sStr2 := ShortCutToText(scAlt + VK_C);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1005');

  sStr1 :=                FormExtract.MenuExtract1.Caption;
  sStr2 := ShortCutToText(scAlt + VK_1);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1006');

  sStr1 :=                FormExtract.MenuExtract2.Caption;
  sStr2 := ShortCutToText(scAlt + VK_2);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1007');

  sStr1 :=                FormExtract.MenuExtract3.Caption;
  sStr2 := ShortCutToText(scAlt + VK_3);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1008');

  sStr1 :=                FormExtract.MenuExtract4.Caption;
  sStr2 := ShortCutToText(scAlt + VK_4);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1009');

  sStr1 :=                FormExtract.MenuExtract5.Caption;
  sStr2 := ShortCutToText(scAlt + VK_5);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1010');

  sStr1 :=                FormExtract.MenuHistoty1.Caption;
  sStr2 := ShortCutToText(scAlt + VK_6);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1011');

  sStr1 :=                FormExtract.MenuHistoty2.Caption;
  sStr2 := ShortCutToText(scAlt + VK_7);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1012');

  sStr1 :=                FormExtract.MenuHistoty3.Caption;
  sStr2 := ShortCutToText(scAlt + VK_8);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1013');

  sStr1 :=                FormExtract.MenuFiler1.Caption;
  sStr2 := ShortCutToText(scAlt + VK_9);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1014');

  sStr1 :=                FormExtract.MenuFiler2.Caption;
  sStr2 := ShortCutToText(scAlt + VK_0);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1015');

  sStr1 :=                FormExtract.MenuRun.Caption;
  sStr2 := ShortCutToText(scAlt + VK_E);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1016');

  sStr1 :=                FormExtract.MenuBrowse.Caption;
  sStr2 := ShortCutToText(scAlt + VK_B);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1017');

  //Operation
  sStr1 :=                FormExtract.MenuFileName.Caption;
  sStr2 := ShortCutToText(scAlt + VK_L);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1101');

  sStr1 :=                FormExtract.MenuCheckBox1.Caption;
  sStr2 := ShortCutToText(scAlt + VK_N);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1102');

  sStr1 :=                FormExtract.MenuCheckBox2.Caption;
  sStr2 := ShortCutToText(scAlt + VK_M);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1103');

  sStr1 :=                FormExtract.MenuCheckBox3.Caption;
  sStr2 := ShortCutToText(scAlt + VK_D);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1104');

  sStr1 :=                FormExtract.MenuCheckBox4.Caption;
  sStr2 := ShortCutToText(scAlt + VK_I);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1105');

  sStr1 :=                FormExtract.MenuFilePath.Caption;
  sStr2 := ShortCutToText(scAlt + VK_U);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1106');

  sStr1 :=                FormExtract.MenuKeyBoard.Caption;
  sStr2 := ShortCutToText(scAlt + VK_K);
  FormMain.StrListKeyMapOriginalExtract.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1111');
end;



procedure TFormExtract.MenuCurrentClick(Sender: TObject);
begin
  ButtonCurrentClick(Sender);
end;

procedure TFormExtract.MenuListClick(Sender: TObject);
begin
  ButtonListClick(Sender);
end;

procedure TFormExtract.MenuTreeClick(Sender: TObject);
begin
  ButtonTreeClick(Sender);
end;

procedure TFormExtract.MenuJumpFolderClick(Sender: TObject);
begin
  ButtonJumpFolderClick(Sender);
end;

procedure TFormExtract.MenuBrowseClick(Sender: TObject);
begin
  ButtonBrowseClick(Sender);
end;

procedure TFormExtract.MenuCancelClick(Sender: TObject);
begin
  ButtonCancelClick(Sender);
end;

procedure TFormExtract.MenuExtract1Click(Sender: TObject);
begin
  ButtonExtract1Click(Sender);
end;

procedure TFormExtract.MenuExtract2Click(Sender: TObject);
begin
  ButtonExtract2Click(Sender);
end;

procedure TFormExtract.MenuExtract3Click(Sender: TObject);
begin
  ButtonExtract3Click(Sender);
end;

procedure TFormExtract.MenuExtract4Click(Sender: TObject);
begin
  ButtonExtract4Click(Sender);
end;

procedure TFormExtract.MenuExtract5Click(Sender: TObject);
begin
  ButtonExtract5Click(Sender);
end;

procedure TFormExtract.MenuHistoty1Click(Sender: TObject);
begin
  ButtonHistory1Click(Sender);
end;

procedure TFormExtract.MenuHistoty2Click(Sender: TObject);
begin
  ButtonHistory2Click(Sender);
end;

procedure TFormExtract.MenuHistoty3Click(Sender: TObject);
begin
  ButtonHistory3Click(Sender);
end;

procedure TFormExtract.MenuFiler1Click(Sender: TObject);
begin
  ButtonFiler1Click(Sender);
end;

procedure TFormExtract.MenuFiler2Click(Sender: TObject);
begin
  ButtonFiler2Click(Sender);
end;

procedure TFormExtract.MenuFileNameClick(Sender: TObject);
begin
  ListBox1.SetFocus;
end;

procedure TFormExtract.MenuCheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked = TRUE then
  begin
    CheckBox1.Checked := FALSE;
  end
  else
  begin
    CheckBox1.Checked := TRUE;
  end;
end;

procedure TFormExtract.MenuCheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked = TRUE then
  begin
    CheckBox2.Checked := FALSE;
  end
  else
  begin
    CheckBox2.Checked := TRUE;
  end;
end;

procedure TFormExtract.MenuCheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked = TRUE then
  begin
    CheckBox3.Checked := FALSE;
  end
  else
  begin
    CheckBox3.Checked := TRUE;
  end;
end;

procedure TFormExtract.MenuKeyBoardClick(Sender: TObject);
var
  bResult: Boolean;
begin
  //
  FormMain.IntKeyMapTypeIndex := KEYBORD_MAP_EXTRACT;
  FormKeyBoard := TFormKeyBoard.Create(Application);
  try
    //\
    if FormKeyBoard.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormKeyBoard.Free;
  end;

  //
  if bResult = TRUE then
  begin
    //ݒ
    SetShortCutKey(Sender);
  end;
end;

procedure TFormExtract.MenuFilePathClick(Sender: TObject);
begin
  Edit2.SetFocus;
end;

procedure TFormExtract.MenuRunClick(Sender: TObject);
begin
  ButtonRunClick(Sender);
end;

procedure TFormExtract.MenuCheckBox4Click(Sender: TObject);
begin
  if CheckBox4.Checked = TRUE then
  begin
    CheckBox4.Checked := FALSE;
  end
  else
  begin
    CheckBox4.Checked := TRUE;
  end;
end;

procedure TFormExtract.HistoryUpdate(Sender: TObject);
var
  sStr2: String;
  iRow11: Integer;
  iFind11: Integer;
begin
      //ݒ
      sStr2 := ExtractFilePath(FormMain.StrRetFormExtract);

      //
      iFind11 := -1;
      for iRow11 := 0 to FormMain.StrListExtractHistory.Count-1 do
      begin
        if UpperCase(FormMain.StrListExtractHistory.Strings[iRow11]) = UpperCase(sStr2) then
        begin
          iFind11 := iRow11;
          Break;
        end;
      end;
      //ꂪ΍폜
      if iFind11 <> -1 then
      begin
        FormMain.StrListExtractHistory.Delete(iFind11);
      end;
      //擪ɒǉ
      FormMain.StrListExtractHistory.Insert(0, sStr2);
      if FormMain.StrListExtractHistory.Count > EXTRACT_HISTORY_MAX then
      begin
        FormMain.StrListExtractHistory.Delete(EXTRACT_HISTORY_MAX);
      end;
      //ۑ
      FormMain.StrListExtractHistory.SaveToFile(ExtractFilepath(ParamStr(0)) + EXTRACT_TXT, TEncoding.Unicode);

      //ݒ
      Edit2.Text := sStr2;
end;

procedure TFormExtract.CheckBox4Click(Sender: TObject);
begin
  if CheckBox4.Checked = TRUE then
  begin
    Edit2.Visible     := TRUE;
    ButtonRun.Visible := TRUE;
    MenuRun.Enabled   := TRUE;
  end;
  if CheckBox4.Checked = FALSE then
  begin
    Edit2.Visible     := FALSE;
    ButtonRun.Visible := FALSE;
    MenuRun.Enabled   := FALSE;
  end;
end;

procedure TFormExtract.Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile:TIniFile;
  iIndex1: Integer;
begin
  //RETURN
  if Key = VK_RETURN then
  begin
    key := 0;
    if Edit2.Text = '' then
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //Ǎ
      iIndex1:= IniFile.ReadInteger('FolderSelect',      'Index', 2);
      //j
      IniFile.Free;

      //s
      if      iIndex1 = 0 then
      begin
        ButtonListClick(Sender);
      end
      else if iIndex1 = 1 then
      begin
        ButtonTreeClick(Sender);
      end
      else if iIndex1 = 2 then
      begin
        ButtonBrowseClick(Sender);
      end
      else
      begin
        ButtonTreeClick(Sender);
      end;
    end
    else
    begin
      //s
      ButtonRunClick(Sender);
    end;
  end;
end;

procedure TFormExtract.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormExtract.SetHistory(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
begin
  //Ǎ
  if FileExists(ExtractFilepath(ParamStr(0)) + EXTRACT_TXT) = TRUE then
  begin
    FormMain.StrListExtractHistory.LoadFromFile(ExtractFilepath(ParamStr(0)) + EXTRACT_TXT, TEncoding.Unicode);
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //Ǎ
  StrExtractPath1 := IniFile.ReadString('ExtractFolder', '0', '');
  sStr1           := IniFile.ReadString('ExtractName',   '0', '');
  if sStr1 = '' then
  begin
    sStr1 := StrExtractPath1;
  end;
  if DirectoryExists(StrExtractPath1) = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      ButtonExtract1.Caption := '1:𓀐' + ' ' + sStr1 + ' ' + StrExtractPath1;
    end
    else
    begin
      ButtonExtract1.Caption := '1:Extract' + ' ' + sStr1 + ' ' + StrExtractPath1;
    end;
  end
  else
  begin
    ButtonExtract1.Enabled := FALSE;
    MenuExtract1.Enabled := FALSE;
  end;
  StrExtractPath2 := IniFile.ReadString('ExtractFolder', '1', '');
  sStr1           := IniFile.ReadString('ExtractName',   '1', '');
  if sStr1 = '' then
  begin
    sStr1 := StrExtractPath2;
  end;
  if DirectoryExists(StrExtractPath2) = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      ButtonExtract2.Caption := '2:𓀐' + ' ' + sStr1 + ' ' + StrExtractPath2;
    end
    else
    begin
      ButtonExtract2.Caption := '2:Extract' + ' ' + sStr1 + ' ' + StrExtractPath2;
    end;
  end
  else
  begin
    ButtonExtract2.Enabled := FALSE;
    MenuExtract2.Enabled := FALSE;
  end;
  StrExtractPath3 := IniFile.ReadString('ExtractFolder', '2', '');
  sStr1           := IniFile.ReadString('ExtractName',   '2', '');
  if sStr1 = '' then
  begin
    sStr1 := StrExtractPath3;
  end;
  if DirectoryExists(StrExtractPath3) = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      ButtonExtract3.Caption := '3:𓀐' + ' ' + sStr1 + ' ' + StrExtractPath3;
    end
    else
    begin
      ButtonExtract3.Caption := '3:Extract' + ' ' + sStr1 + ' ' + StrExtractPath3;
    end;
  end
  else
  begin
    ButtonExtract3.Enabled := FALSE;
    MenuExtract3.Enabled := FALSE;
  end;
  StrExtractPath4 := IniFile.ReadString('ExtractFolder', '3', '');
  sStr1            := IniFile.ReadString('ExtractName',   '3', '');
  if sStr1 = '' then
  begin
    sStr1 := StrExtractPath4;
  end;
  if DirectoryExists(StrExtractPath4) = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      ButtonExtract4.Caption := '4:𓀐' + ' ' + sStr1 + ' ' + StrExtractPath4;
    end
    else
    begin
      ButtonExtract4.Caption := '4:Extract' + ' ' + sStr1 + ' ' + StrExtractPath4;
    end;
  end
  else
  begin
    ButtonExtract4.Enabled := FALSE;
    MenuExtract4.Enabled := FALSE;
  end;
  StrExtractPath5 := IniFile.ReadString('ExtractFolder', '4', '');
  sStr1           := IniFile.ReadString('ExtractName',   '4', '');
  if sStr1 = '' then
  begin
    sStr1 := StrExtractPath5;
  end;
  if DirectoryExists(StrExtractPath5) = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      ButtonExtract5.Caption := '5:𓀐' + ' ' + sStr1 + ' ' + StrExtractPath5;
    end
    else
    begin
      ButtonExtract5.Caption := '5:Extract' + ' ' + sStr1 + ' ' + StrExtractPath5;
    end;
  end
  else
  begin
    ButtonExtract5.Enabled := FALSE;
    MenuExtract5.Enabled := FALSE;
  end;

  //j
  IniFile.Free;

  //Ǎ
  if FormMain.StrListExtractHistory.Count >= 1 then
  begin
    StrExtractPath6 := FormMain.StrListExtractHistory.Strings[0];
    //ݒ
    if BoolJapanese = TRUE then
    begin
      ButtonHistory1.Caption := '6:' + ' ' + FormMain.StrListExtractHistory.Strings[0];
    end
    else
    begin
      ButtonHistory1.Caption := '6:History' + ' ' + FormMain.StrListExtractHistory.Strings[0];
    end;
  end
  else
  begin
    ButtonHistory1.Enabled := FALSE;
    MenuHistoty1.Enabled := FALSE;
  end;
  if FormMain.StrListExtractHistory.Count >= 2 then
  begin
    StrExtractPath7 := FormMain.StrListExtractHistory.Strings[1];
    //ݒ
    if BoolJapanese = TRUE then
    begin
      ButtonHistory2.Caption := '7:' + ' ' + FormMain.StrListExtractHistory.Strings[1];
    end
    else
    begin
      ButtonHistory2.Caption := '7:History' + ' ' + FormMain.StrListExtractHistory.Strings[1];
    end;
  end
  else
  begin
    ButtonHistory2.Enabled := FALSE;
    MenuHistoty2.Enabled := FALSE;
  end;
  if FormMain.StrListExtractHistory.Count >= 3 then
  begin
    StrExtractPath8 := FormMain.StrListExtractHistory.Strings[2];
    //ݒ
    if BoolJapanese = TRUE then
    begin
      ButtonHistory3.Caption := '8:' + ' ' + FormMain.StrListExtractHistory.Strings[2];
    end
    else
    begin
      ButtonHistory3.Caption := '8:History' + ' ' + FormMain.StrListExtractHistory.Strings[2];
    end;
  end
  else
  begin
    ButtonHistory3.Enabled := FALSE;
    MenuHistoty3.Enabled := FALSE;
  end;

  //Ǎ
  if FormMain.StrListWindowName.Count >= 1 then
  begin
    StrExtractPath9 := FormMain.StrListWindowName.Strings[0];
    //ݒ
    if BoolJapanese = TRUE then
    begin
      ButtonFiler1.Caption := '9:̧װ' + ' ' + FormMain.StrListWindowName.Strings[0];
    end
    else
    begin
      ButtonFiler1.Caption := '9:Filer' + ' ' + FormMain.StrListWindowName.Strings[0];
    end;
  end
  else
  begin
    ButtonFiler1.Enabled := FALSE;
    MenuFiler1.Enabled := FALSE;
  end;
  if FormMain.StrListWindowName.Count >= 2 then
  begin
    StrExtractPath10 := FormMain.StrListWindowName.Strings[1];
    //ݒ
    if BoolJapanese = TRUE then
    begin
      ButtonFiler2.Caption := '10:̧װ' + ' ' + FormMain.StrListWindowName.Strings[1];
    end
    else
    begin
      ButtonFiler2.Caption := '10:Filer' + ' ' + FormMain.StrListWindowName.Strings[1];
    end;
  end
  else
  begin
    ButtonFiler2.Enabled := FALSE;
    MenuFiler2.Enabled := FALSE;
  end;
end;

end.

