unit FileTime;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN UNIT_PLATFORM     OFF} //W1005
  {$WARN SYMBOL_PLATFORM   OFF} //W1002
  {$WARN SYMBOL_PLATFORM   OFF} //W1002  FileSetDate
  {$WARN SYMBOL_DEPRECATED OFF} //W1000  for FileCtrl

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Shellapi, Filectrl, IniFiles, MyUtility, Math, ShlObj, ActiveX, System.IOUtils,
  Vcl.Menus, System.UITypes;

const
  FORM_WIDTH_SET       = 900;
  FORM_HEIGHT_SET      = 500;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX8_WIDTH       = 900;
  SYNCLONIZE_SRC_FOLDER_JPN = ' : ';
  SYNCLONIZE_DST_FOLDER_JPN = ' : ';
  SYNCLONIZE_SRC_FOLDER_ENG = 'Synclonize Src : ';
  SYNCLONIZE_DST_FOLDER_ENG = 'Synclonize Dst : ';

type
  TFormFileTime = class(TForm)
    Panel21: TPanel;
    Panel23: TPanel;
    ButtonRun2: TButton;
    ButtonCancel2: TButton;
    ButtonGet2: TButton;
    Panel24: TPanel;
    Panel25: TPanel;
    Label20: TLabel;
    ListBox1: TListBox;
    Label25: TLabel;
    Label26: TLabel;
    Label28: TLabel;
    Panel31: TPanel;
    Panel33: TPanel;
    Label34: TLabel;
    Label129: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Edit31: TEdit;
    ButtonSrcList3: TButton;
    ButtonSrcTree3: TButton;
    ButtonSrcCurrent3: TButton;
    Edit32: TEdit;
    ButtonDstList3: TButton;
    ButtonDstTree3: TButton;
    Edit33: TEdit;
    Panel32: TPanel;
    ButtonCancel3: TButton;
    ButtonOk3: TButton;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuEscape1: TMenuItem;
    MenuOperation: TMenuItem;
    MenuInput: TMenuItem;
    MenuDelete: TMenuItem;
    MenuCopy: TMenuItem;
    MenuPaste: TMenuItem;
    MenuReadMirror: TMenuItem;
    MainMenu2: TMainMenu;
    MenuItem2: TMenuItem;
    MenuEscape2: TMenuItem;
    MainMenu3: TMainMenu;
    MenuItem1: TMenuItem;
    MenuEscape3: TMenuItem;
    Panel11: TPanel;
    Panel12: TPanel;
    ButtonGetList1: TButton;
    ButtonCancel1: TButton;
    ListBox8: TListBox;
    ButtonAbort2: TButton;
    Label21: TLabel;
    Label22: TLabel;
    MenuReadTime: TMenuItem;
    ButtonSrcBrows3: TButton;
    ButtonDstBrows3: TButton;
    MenuQuit1: TMenuItem;
    MenuQuit2: TMenuItem;
    MenuQuit3: TMenuItem;
    Timer1: TTimer;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox8DblClick(Sender: TObject);
    procedure ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox8KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox8Click(Sender: TObject);

    function  SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;

    procedure ButtonRun2Click(Sender: TObject);
    procedure ButtonCancel2Click(Sender: TObject);
    procedure ButtonGet2Click(Sender: TObject);
    procedure ButtonCancel3Click(Sender: TObject);
    procedure ButtonOk3Click(Sender: TObject);
    procedure ButtonSrcList3Click(Sender: TObject);
    procedure ButtonSrcTree3Click(Sender: TObject);
    procedure ButtonSrcCurrent3Click(Sender: TObject);
    procedure ButtonDstList3Click(Sender: TObject);
    procedure ButtonDstTree3Click(Sender: TObject);
    procedure ButtonGetList1Click(Sender: TObject);
    procedure ButtonCancel1Click(Sender: TObject);

    procedure ThisListFilesDrive(DirName :String; TheList:TStringList);
    procedure ThisListFilesDriveSrc(DirName: String; TheList: TStringList);
    procedure ThisListFilesDriveDst(DirName: String; TheList: TStringList);

    procedure SetItemList(Sender: TObject);

    procedure MenuInputClick(Sender: TObject);
    procedure MenuDeleteClick(Sender: TObject);
    procedure MenuCopyClick(Sender: TObject);
    procedure MenuPasteClick(Sender: TObject);
    procedure MenuReadMirrorClick(Sender: TObject);

    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
    procedure MenuEscape1Click(Sender: TObject);
    procedure MenuEscape2Click(Sender: TObject);
    procedure MenuEscape3Click(Sender: TObject);
    procedure ButtonAbort2Click(Sender: TObject);
    procedure MenuReadTimeClick(Sender: TObject);
    procedure ButtonDstBrows3Click(Sender: TObject);
    procedure ButtonSrcBrows3Click(Sender: TObject);
    procedure Edit32KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit33KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit31KeyPress(Sender: TObject; var Key: Char);
    procedure Edit32KeyPress(Sender: TObject; var Key: Char);
    procedure Edit33KeyPress(Sender: TObject; var Key: Char);
    procedure MenuQuit1Click(Sender: TObject);
    procedure MenuQuit2Click(Sender: TObject);
    procedure MenuQuit3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListSrc: TStringList;
    StrListDst: TStringList;
    StrListCopy: TStringList;
    StrListItems: TStringList;
    StrListKeyMap: TStringList;
    StrLanguageFileName: String;
    StrCopyItem: String;
    StrSrcFolder: String;
    StrDstFolder: String;
    IntSrcCount: Integer;
    IntDstCount: Integer;
    BoolShowMem: Boolean;
    BoolAbort: Boolean;
    BoolJapanese: Boolean;

  public
    { Public 錾 }

  end;

var
  FormFileTime: TFormFileTime;

implementation

{$R *.dfm}

uses
  Main, JumpFolder, Browse, Tree, View;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormFileTime.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFileTime.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFileTime.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormFileTime.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormFileTime.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr9: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormFileTime', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFileTime', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFileTime', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFileTime', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFileTime', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //
  Timer1.Enabled := FALSE;

  //m
  StrListSrc        := TStringList.Create;
  StrListDst        := TStringList.Create;
  StrListCopy       := TStringList.Create;
  StrListItems      := TStringList.Create;
  StrListKeymap     := TStringList.Create;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
    ListBox8.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
    ListBox8.Style := lbStandard;
  end;

  //ݒ
  Panel11.Visible  := TRUE;
  Panel21.Visible  := FALSE;
  Panel31.Visible  := FALSE;
  Panel11.Align    := alClient;
  Panel21.Align    := alClient;
  Panel31.Align    := alClient;

  Panel33.Align          := alClient;

  BoolShowMem         := FALSE;

  Label25.Caption := 'Src=0';
  Label26.Caption := 'Dst=0';
  Label28.Caption := 'Time=0';

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  if BoolJapanese = TRUE then
  begin
    Label21.Caption := SYNCLONIZE_SRC_FOLDER_JPN;
    Label22.Caption := SYNCLONIZE_DST_FOLDER_JPN;
  end
  else
  begin
    Label21.Caption := SYNCLONIZE_SRC_FOLDER_ENG;
    Label22.Caption := SYNCLONIZE_DST_FOLDER_ENG;
  end;

  ButtonAbort2.Enabled := FALSE;

 //mF
  sStr9 := ExtractFilePath(ParamStr(0)) + FILE_TIME_TXT;
  if FileExists(sStr9) = TRUE then
  begin
    //Ǎ
    StrListItems.LoadFromFile(sStr9, TEncoding.Unicode);
    //\
    SetItemList(Sender);
    //
    ListBox8.ItemIndex := 0;
  end
  else
  begin
    //쐬
    StrListitems.Clear;
    StrListitems.Add('  A' + #09 + #09 + #09);
    StrListitems.Add('  B' + #09 + #09 + #09);
    StrListitems.Add('  C' + #09 + #09 + #09);
    StrListitems.Add('  D' + #09 + #09 + #09);
    StrListitems.Add('  E' + #09 + #09 + #09);
    StrListitems.Add('  F' + #09 + #09 + #09);
    StrListitems.Add('  G' + #09 + #09 + #09);
    StrListitems.Add('  H' + #09 + #09 + #09);
    StrListitems.Add('  I' + #09 + #09 + #09);
    StrListitems.Add('  J' + #09 + #09 + #09);
    StrListitems.Add('  K' + #09 + #09 + #09);
    StrListitems.Add('  L' + #09 + #09 + #09);
    StrListitems.Add('  M' + #09 + #09 + #09);
    StrListitems.Add('  N' + #09 + #09 + #09);
    StrListitems.Add('  O' + #09 + #09 + #09);
    StrListitems.Add('  P' + #09 + #09 + #09);
    StrListitems.Add('  Q' + #09 + #09 + #09);
    StrListitems.Add('  R' + #09 + #09 + #09);
    StrListitems.Add('  S' + #09 + #09 + #09);
    StrListitems.Add('  T' + #09 + #09 + #09);
    StrListitems.Add('  U' + #09 + #09 + #09);
    StrListitems.Add('  V' + #09 + #09 + #09);
    StrListitems.Add('  W' + #09 + #09 + #09);
    StrListitems.Add('  X' + #09 + #09 + #09);
    StrListitems.Add('  Y' + #09 + #09 + #09);
    StrListitems.Add('  Z' + #09 + #09 + #09);
    StrListitems.Add('  0' + #09 + #09 + #09);
    StrListitems.Add('  1' + #09 + #09 + #09);
    StrListitems.Add('  2' + #09 + #09 + #09);
    StrListitems.Add('  3' + #09 + #09 + #09);
    StrListitems.Add('  4' + #09 + #09 + #09);
    StrListitems.Add('  5' + #09 + #09 + #09);
    StrListitems.Add('  6' + #09 + #09 + #09);
    StrListitems.Add('  7' + #09 + #09 + #09);
    StrListitems.Add('  8' + #09 + #09 + #09);
    StrListitems.Add('  9' + #09 + #09 + #09);
    StrListitems.Add('s+A' + #09 + #09 + #09);
    StrListitems.Add('s+B' + #09 + #09 + #09);
    StrListitems.Add('s+C' + #09 + #09 + #09);
    StrListitems.Add('s+D' + #09 + #09 + #09);
    StrListitems.Add('s+E' + #09 + #09 + #09);
    StrListitems.Add('s+F' + #09 + #09 + #09);
    StrListitems.Add('s+G' + #09 + #09 + #09);
    StrListitems.Add('s+H' + #09 + #09 + #09);
    StrListitems.Add('s+I' + #09 + #09 + #09);
    StrListitems.Add('s+J' + #09 + #09 + #09);
    StrListitems.Add('s+K' + #09 + #09 + #09);
    StrListitems.Add('s+L' + #09 + #09 + #09);
    StrListitems.Add('s+M' + #09 + #09 + #09);
    StrListitems.Add('s+N' + #09 + #09 + #09);
    StrListitems.Add('s+O' + #09 + #09 + #09);
    StrListitems.Add('s+P' + #09 + #09 + #09);
    StrListitems.Add('s+Q' + #09 + #09 + #09);
    StrListitems.Add('s+R' + #09 + #09 + #09);
    StrListitems.Add('s+S' + #09 + #09 + #09);
    StrListitems.Add('s+T' + #09 + #09 + #09);
    StrListitems.Add('s+U' + #09 + #09 + #09);
    StrListitems.Add('s+V' + #09 + #09 + #09);
    StrListitems.Add('s+W' + #09 + #09 + #09);
    StrListitems.Add('s+X' + #09 + #09 + #09);
    StrListitems.Add('s+Y' + #09 + #09 + #09);
    StrListitems.Add('s+Z' + #09 + #09 + #09);
    StrListitems.Add('s+0' + #09 + #09 + #09);
    StrListitems.Add('s+1' + #09 + #09 + #09);
    StrListitems.Add('s+2' + #09 + #09 + #09);
    StrListitems.Add('s+3' + #09 + #09 + #09);
    StrListitems.Add('s+4' + #09 + #09 + #09);
    StrListitems.Add('s+5' + #09 + #09 + #09);
    StrListitems.Add('s+6' + #09 + #09 + #09);
    StrListitems.Add('s+7' + #09 + #09 + #09);
    StrListitems.Add('s+8' + #09 + #09 + #09);
    StrListitems.Add('s+9' + #09 + #09 + #09);
    StrListitems.Add('c+A' + #09 + #09 + #09);
    StrListitems.Add('c+B' + #09 + #09 + #09);
    StrListitems.Add('c+C' + #09 + #09 + #09);
    StrListitems.Add('c+D' + #09 + #09 + #09);
    StrListitems.Add('c+E' + #09 + #09 + #09);
    StrListitems.Add('c+F' + #09 + #09 + #09);
    StrListitems.Add('c+G' + #09 + #09 + #09);
    StrListitems.Add('c+H' + #09 + #09 + #09);
    StrListitems.Add('c+I' + #09 + #09 + #09);
    StrListitems.Add('c+J' + #09 + #09 + #09);
    StrListitems.Add('c+K' + #09 + #09 + #09);
    StrListitems.Add('c+L' + #09 + #09 + #09);
    StrListitems.Add('c+M' + #09 + #09 + #09);
    StrListitems.Add('c+N' + #09 + #09 + #09);
    StrListitems.Add('c+O' + #09 + #09 + #09);
    StrListitems.Add('c+P' + #09 + #09 + #09);
    StrListitems.Add('c+Q' + #09 + #09 + #09);
    StrListitems.Add('c+R' + #09 + #09 + #09);
    StrListitems.Add('c+S' + #09 + #09 + #09);
    StrListitems.Add('c+T' + #09 + #09 + #09);
    StrListitems.Add('c+U' + #09 + #09 + #09);
    StrListitems.Add('c+V' + #09 + #09 + #09);
    StrListitems.Add('c+W' + #09 + #09 + #09);
    StrListitems.Add('c+X' + #09 + #09 + #09);
    StrListitems.Add('c+Y' + #09 + #09 + #09);
    StrListitems.Add('c+Z' + #09 + #09 + #09);
    StrListitems.Add('c+0' + #09 + #09 + #09);
    StrListitems.Add('c+1' + #09 + #09 + #09);
    StrListitems.Add('c+2' + #09 + #09 + #09);
    StrListitems.Add('c+3' + #09 + #09 + #09);
    StrListitems.Add('c+4' + #09 + #09 + #09);
    StrListitems.Add('c+5' + #09 + #09 + #09);
    StrListitems.Add('c+6' + #09 + #09 + #09);
    StrListitems.Add('c+7' + #09 + #09 + #09);
    StrListitems.Add('c+8' + #09 + #09 + #09);
    StrListitems.Add('c+9' + #09 + #09 + #09);
    //ۑ
    StrListItems.SaveToFile(sStr9, TEncoding.Unicode);
    //\
    SetItemList(Sender);
    //
    ListBox8.ItemIndex := 0;
  end;

  //ݒ
  SetShortCutKey(Sender);
end;

procedure TFormFileTime.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFileTime', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFileTime', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFileTime', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFileTime', 'Left',   FormFileTime.Left);
    IniFile.WriteInteger('FormFileTime', 'Top',    FormFileTime.Top);
    IniFile.WriteInteger('FormFileTime', 'Width',  FormFileTime.Width);
    IniFile.WriteInteger('FormFileTime', 'Height', FormFileTime.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListSrc.Free;
  StrListDst.Free;
  StrListCopy.Free;
  StrListItems.Free;
  StrListKeymap.Free;
end;

procedure TFormFileTime.FormResize(Sender: TObject);
begin
  if BoolShowMem        = TRUE then
  begin
    //ݒ
    Edit31.Width := Panel31.ClientWidth - 40;
    Edit32.Width := Panel31.ClientWidth - 40;
    Edit33.Width := Panel31.ClientWidth - 40;
  end;
end;

procedure TFormFileTime.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormFileTime.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFileTime.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFileTime.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFileTime.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFileTime.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormFileTime.Handle, imClose);

  //XN[o[\
  ListBox8.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 3, 0);
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 3, 0);

  //j[
  FormFileTime.Menu := FormFileTime.MainMenu1;

  //
  BoolShowMem := TRUE;


  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FileTime.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFileTime, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFileTime, StrLanguageFileName, Sender);
  end;

  //\[gx
  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    Timer1.Enabled := TRUE;
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    Timer1.Enabled := TRUE;
  end;
end;

procedure TFormFileTime.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //{
  if      ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormFileTime, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormFileTime, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFileTime.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        if (Index mod 2) = 0 then
        begin
          Canvas.Font.Color  := clWhite;
        end
        else
        begin
          Canvas.Font.Color  := clWhite;
        end;
//        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        if (Index mod 2) = 0 then
        begin
          Canvas.Font.Color  := clWindowText;
        end
        else
        begin
          Canvas.Font.Color  := clBlue;
        end;
//        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        if (Index mod 2) = 0 then
        begin
          Canvas.Font.Color  := clWindowText;
        end
        else
        begin
          Canvas.Font.Color  := clBlue;
        end;
//        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        if (Index mod 2) = 0 then
        begin
          Canvas.Font.Color  := clWindowText;
        end
        else
        begin
          Canvas.Font.Color  := clBlue;
        end;
//        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;

end;

procedure TFormFileTime.ListBox8Click(Sender: TObject);
begin
    ListBox8DblClick(Sender);
end;

procedure TFormFileTime.ListBox8DblClick(Sender: TObject);
begin
  ButtonGetList1Click(Sender);
end;

procedure TFormFileTime.ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin

  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;

end;

procedure TFormFileTime.ListBox8KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //Enter
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonGetList1Click(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFileTime.MenuCopyClick(Sender: TObject);
var
  CsvList1: TStringList;
  bError: Boolean;
begin
  //
  bError := FALSE;
  //m
  CsvList1 := TStringList.Create;
  //WJ
  StringToCsvList(StrListItems.Strings[ListBox8.ItemIndex], CsvList1);
  //ݒ
  if CsvList1[2] = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʌtH_̓e󔒂Ȃ̂ŃRs[ł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Copy can not operate, because of src folder item is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    bError := TRUE;
  end;
  //ݒ
  if (CsvList1[3] = '') and (bError = FALSE) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʐtH_̓e󔒂Ȃ̂ŃRs[ł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Copy can not operate, because of dst folder item is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    bError := TRUE;
  end;
  //j
  CsvList1.Free;

  //
  if bError = TRUE then
  begin
    Exit;
  end;

  //ݒ
  StrCopyItem := StrListItems.Strings[ListBox8.ItemIndex];
end;

procedure TFormFileTime.MenuDeleteClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr8: String;
  sStr9: String;
  wRet8: Word;
  CsvList1: TStringList;
  iIndex1: Integer;
  iIndex2: Integer;
begin
  //m
  CsvList1 := TStringList.Create;
  //WJ
  StringToCsvList(StrListItems.Strings[ListBox8.ItemIndex], CsvList1);
  //ݒ
  sStr1 := CsvList1[0];
  sStr2 := CsvList1[1];
  sStr3 := CsvList1[2];
  sStr4 := CsvList1[3];
  //j
  CsvList1.Free;

  //mF
  if BoolJapanese = TRUE then
  begin
    sStr8 := 'Key : '       + Trim(sStr1) + #13#10 +
                                            #13#10 +
             'Name : '      + sStr2       + #13#10 +
             'SrcFolder : ' + sStr3       + #13#10 +
             'DstFolder : ' + sStr4       + #13#10 +
                                            #13#10 +
             '폜܂H';
  end
  else
  begin
    sStr8 := 'Key : '       + Trim(sStr1) + #13#10 +
                                            #13#10 +
             'Name : '      + sStr2       + #13#10 +
             'SrcFolder : ' + sStr3       + #13#10 +
             'DstFolder : ' + sStr4       + #13#10 +
                                            #13#10 +
             'Delete ?'                   + #13#10 +
             '[YES] / [NO]';
  end;
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    //XV
    iIndex1 := ListBox8.TopIndex;
    iIndex2 := ListBox8.ItemIndex;
    //
    StrListItems.Strings[iIndex2] := sStr1 + #09 + #09 + #09;
    //XV
    SetItemList(Sender);
    //XV
    ListBox8.TopIndex  := iIndex1;
    ListBox8.ItemIndex := iIndex2;

    //ۑ
    sStr9 := ExtractFilePath(ParamStr(0)) + MIRROR_TXT;
    StrListItems.SaveToFile(sStr9, TEncoding.Unicode);
  end
  else
  begin
    //
  end;
end;


procedure TFormFileTime.MenuEscape1Click(Sender: TObject);
begin
  ButtonCancel1Click(Sender);
end;

procedure TFormFileTime.MenuEscape2Click(Sender: TObject);
begin
  ButtonCancel2Click(Sender);
end;

procedure TFormFileTime.MenuEscape3Click(Sender: TObject);
begin
  ButtonCancel3Click(Sender);
end;

procedure TFormFileTime.MenuInputClick(Sender: TObject);
var
  CsvList1: TStringList;
begin
  //XV
  Panel11.Visible := FALSE;
  Panel21.Visible := FALSE;
  Panel31.Visible := TRUE;
  FormFileTime.Menu := FormFileTime.MainMenu3;
  //TCY
  FormResize(Sender);

  //m
  CsvList1 := TStringList.Create;
  //WJ
  StringToCsvList(StrListItems.Strings[Listbox8.ItemIndex], CsvList1);
  //ݒ
  Edit31.Text := CsvList1[1];
  Edit32.Text := CsvList1[2];
  Edit33.Text := CsvList1[3];
  //j
  CsvList1.Free;

  //ݒ
  Edit31.SetFocus;
end;

procedure TFormFileTime.MenuPasteClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr8: String;
  sStr9: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  wRet8: Word;
  CsvList1: TStringList;
  CsvList2: TStringList;
  iIndex1: Integer;
  iIndex2: Integer;
begin
  //
  if StrCopyItem = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \t̓eł' + #13#10 +
                         'ŏɃRs[sĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Paste items is empty.' + #13#10 +
                         'Copy must be done before Paste' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //m
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;
  //WJ
  StringToCsvList(StrListItems.Strings[ListBox8.ItemIndex], CsvList1);
  StringToCsvList(StrCopyItem,                              CsvList2);
  //ݒ
  sStr1  := CsvList1[0];
  sStr2  := CsvList1[1];
  sStr3  := CsvList1[2];
  sStr4  := CsvList1[3];
  sStr12 := CsvList2[1];
  sStr13 := CsvList2[2];
  sStr14 := CsvList2[3];
  //j
  CsvList1.Free;
  CsvList2.Free;

  //mF
  if BoolJapanese = TRUE then
  begin
    sStr8 := 'Key : '            + Trim(sStr1) + #13#10 +
                                                 #13#10 +
             'Name(Old) : '      + sStr2       + #13#10 +
             'Name(New) : '      + sStr12      + #13#10 +
                                                 #13#10 +
             'SrcFolder(Old) : ' + sStr3       + #13#10 +
             'SrcFolder(New) : ' + sStr13      + #13#10 +
                                                 #13#10 +
             'DstFolder(Old) : ' + sStr4       + #13#10 +
             'DstFolder(New) : ' + sStr14      + #13#10 +
                                                 #13#10 +
             '㏑܂H';
  end
  else
  begin
    sStr8 := 'Key : '            + Trim(sStr1) + #13#10 +
                                                 #13#10 +
             'Name(Old) : '      + sStr2       + #13#10 +
             'Name(New) : '      + sStr12      + #13#10 +
                                                 #13#10 +
             'SrcFolder(Old) : ' + sStr3       + #13#10 +
             'SrcFolder(New) : ' + sStr13      + #13#10 +
                                                 #13#10 +
             'DstFolder(Old) : ' + sStr4       + #13#10 +
             'DstFolder(New) : ' + sStr14      + #13#10 +
                                                 #13#10 +
             'Over Write ?'                    + #13#10 +
             '[YES] / [NO]';
  end;
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    //s
  end
  else
  begin
    //~
    Exit;
  end;

  //XV
  iIndex1 := ListBox8.TopIndex;
  iIndex2 := ListBox8.ItemIndex;
  //
  StrListItems.Strings[iIndex2] := sStr1 + #09 + sStr12 + #09 + sStr13 + #09 + sStr14;
  //XV
  SetItemList(Sender);
  //XV
  ListBox8.TopIndex  := iIndex1;
  ListBox8.ItemIndex := iIndex2;

  //ۑ
  sStr9 := ExtractFilePath(ParamStr(0)) + MIRROR_TXT;
  StrListItems.SaveToFile(sStr9, TEncoding.Unicode);
end;

procedure TFormFileTime.MenuQuit1Click(Sender: TObject);
begin
  ButtonCancel1Click(Sender);
end;

procedure TFormFileTime.MenuQuit2Click(Sender: TObject);
begin
  ButtonCancel2Click(Sender);
end;

procedure TFormFileTime.MenuQuit3Click(Sender: TObject);
begin
  ButtonCancel3Click(Sender);
end;

procedure TFormFileTime.MenuReadMirrorClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr8: String;
  wRet8: Word;
begin
  //mF
  if BoolJapanese = TRUE then
  begin
    sStr8 := 'Information : ǂݍ݂܂H';
  end
  else
  begin
    sStr8 := 'Information : Read items ?' + #13#10 +
             '[YES] / [NO]';
  end;
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    //
  end
  else
  begin
    Exit;
  end;

  //mF
  sStr1 := ExtractFilePath(ParamStr(0)) + MIRROR_TXT;
  sStr2 := ExtractFilePath(ParamStr(0)) + FILE_TIME_TXT;
  if FileExists(sStr1) = TRUE then
  begin
    //Ǎ
    StrListItems.LoadFromFile(sStr1, TEncoding.Unicode);
    //\
    SetItemList(Sender);
    //
    ListBox8.ItemIndex := 0;

    //ۑ
    StrListItems.SaveToFile(sStr2, TEncoding.Unicode);
  end
end;

procedure TFormFileTime.MenuReadTimeClick(Sender: TObject);
var
  bResult: Boolean;
begin
  //ݒ
  FormMain.StrSetFormView := FormMain.StrExtractBase + FILE_TIME_COPY_TXT;
  //
  FormView := TFormView.Create(Application);
  try
    if FormView.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormView.Free;
  end;
  if bResult = TRUE then
  begin
    //
  end
  else
  begin
    //
  end;
end;

function TFormFileTime.SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;
var
  FolderPidl : PItemIDList;
  BrowseInfo : TBrowseInfo;
  BPathName  : array[0..MAX_PATH-1] of Char;
  AMalloc    : IMalloc;
begin
  //
  Result := FALSE;
  //ڎʎq̂߂̃AP[Ṽ|C^擾
  ShGetMalloc(AMalloc);
  FolderPidl := nil;
  //
  FillChar(BrowseInfo, SizeOf(BrowseInfo), #0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.lpfn      := nil;
  BrowseInfo.lpszTitle := PChar('Select Directory');
  BrowseInfo.pidlRoot  := nil;
  BrowseInfo.ulFlags   := BIF_RETURNONLYFSDIRS or
                          BIF_NEWDIALOGSTYLE   or
                          BIF_VALIDATE;

//BIF_RETURNONLYFSDIRS   $0001 t@CVXefBNĝ݂I\
//BIF_DONTGOBELOWDOMAIN  $0002 hC̃lbg[NtH_\Ȃ
//BIF_STATUSTEXT         $0004 _CAOc[̂ɕ\
//                             R[obN֐ŏKv
//BIF_RETURNFSANCESTORS	 $0008 [gȉ̃t@CCtH_̂ݑI\
//BIF_EDITBOX            $0010 OҏWp{bNX\
//BIF_VALIDATE           $0020 OҏW{bNXւ̖ȕ`FbN
//                             BIF_EDITBOX ̎w肪鎞̂ݗL
//                             ̓R[obN֐ōs
//BIF_NEWDIALOGSTYLE	   $0040	ȉ̐VX^C̃_CAO\
//                             TCY\
//                             _CAOւ̃hbOAhhbv
//                             tH_̍Đ
//                             V[gJbgj[ (ReLXg)
//                             VtH_̍쐬
//BIF_USENEWUI           $0050 OҏW{bNX̂VX^C
//                             BIF_EDITBOX or BIF_NEWDIALOGSTYLE wƓ
//BIF_BROWSEINCLUDEURLS	 $0080 URL\\Ƃ
//                             BIF_USENEWUIBIF_BROWSEINCLUDEFILES ̎wKv
//                             YtH_T|[gꍇ̂ݕ\
//BIF_UAHINT             $0100 OҏW{bNX̑Ƀqg\
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NONEWFOLDERBUTTON  $0200  [VtH_̍쐬] {^\Ȃ
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NOTRANSLATETARGETS $0400 IACeV[gJbg̏ꍇCNł͂ȂCV[gJbgg̍ڎʎqԂ
//BIF_BROWSEFORCOMPUTER  $1000 Rs[^̂ݑI\Ƃ
//BIF_BROWSEFORPRINTER   $2000 v^̂ݑI\Ƃ
//BIF_BROWSEINCLUDEFILES $4000 t@C\đI\Ƃ
//BIF_SHAREABLE          $8000 L\[X\đI\ɂ
//                             BIF_USENEWUI ̎wKv

  //̐ݒɊÂtH_Qƃ_CAO\
  try
    //擾
    FolderPidl := SHBrowseForFolder(BrowseInfo);
    If FolderPidl <> nil then
    begin
      //ڎʎqpX̕BPathNameɕϊ
      SHGetPathFromIDList(FolderPidl, BPathName);
      //
      Directory := BPathName;
      if Copy(Directory, Length(Directory), 1) <> '\' then
      begin
        Directory := Directory + '\';
      end;
      //
      Result := TRUE;
    end;
  finally
    //
    AMalloc.Free(FolderPidl);
  end;
end;

procedure TFormFileTime.ButtonGetList1Click(Sender: TObject);
var
  CsvList1: TStringList;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
begin
  //m
  CsvList1 := TStringList.Create;

  //WJ
  StringToCsvList(StrListItems.Strings[ListBox8.ItemIndex], CsvList1);

  //ݒ
  sStr1 := CsvList1[0];
  sStr2 := CsvList1[1];
  sStr3 := CsvList1[2];
  sStr4 := CsvList1[3];
  //j
  CsvList1.Free;

  //ݒ
  StrSrcFolder    := sStr3;
  StrDstFolder    := sStr4;

  //ؑ
  Panel11.Visible := FALSE;
  Panel21.Visible := TRUE;
  Panel31.Visible := FALSE;
  FormFileTime.Menu := FormFileTime.MainMenu2;

  //ݒ
  ListBox1.SetFocus;

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 3, 0);

  //XV
  Label25.Caption := 'Src=0';
  Label26.Caption := 'Dst=0';
  Label28.Caption := 'Time=0';
  Label25.Refresh;
  Label26.Refresh;
  Label28.Refresh;

  if BoolJapanese = TRUE then
  begin
    Label21.Caption := SYNCLONIZE_SRC_FOLDER_JPN + sStr3;
    Label22.Caption := SYNCLONIZE_DST_FOLDER_JPN + sStr4;
  end
  else
  begin
    Label21.Caption := SYNCLONIZE_SRC_FOLDER_ENG + sStr3;
    Label22.Caption := SYNCLONIZE_DST_FOLDER_ENG + sStr4;
  end;
  Label21.Refresh;
  Label22.Refresh;

  //NA
  ListBox1.Items.BeginUpdate;
  ListBox1.Items.Clear;
  ListBox1.Items.EndUpdate;

  //NA
  StrListSrc.Clear;
  StrListDst.Clear;
  StrListCopy.Clear;

  //XV
  ButtonGet2.Enabled     := TRUE;
  ButtonGet2.Refresh;
  ButtonRun2.Enabled     := TRUE;
  ButtonRun2.Refresh;
  ButtonAbort2.Enabled   := FALSE;
  ButtonAbort2.Refresh;
  ButtonCancel2.Enabled  := TRUE;
  ButtonCancel2.Refresh;

end;

procedure TFormFileTime.ButtonGet2Click(Sender: TObject);
var
  iRow1: Integer;
  iRow2: Integer;
  sStr1: String;
  sStr2: String;
  sStr4: String;
  sStr5: String;

  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;

  iLen1: Integer;

  date11: TDateTime;
  date21: TDateTime;

  StrList1: TStringList;
  StrList2: TStringList;
  StrList3: TStringList;
begin
  //ݒ
  if Copy(StrSrcFolder, Length(StrSrcFolder), 1) <> '\' then
  begin
    sStr1 := StrSrcFolder + '\';
  end
  else
  begin
    sStr1 := StrSrcFolder;
  end;
  if Copy(StrDstFolder, Length(StrDstFolder), 1) <> '\' then
  begin
    sStr2 := StrDstFolder + '\';
  end
  else
  begin
    sStr2 := StrDstFolder;
  end;

  //mF
  if System.SysUtils.DirectoryExists(sStr1) = FALSE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̃tH_܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Synclonize src folder is not exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if Length(sStr1) <= Length('C:\') then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Ƀ[g͐ݒł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Synclonize src folder can not set root folder.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if System.SysUtils.DirectoryExists(sStr1) = FALSE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̃tH_܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Synclonize dst folder is not exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if Length(sStr2) <= Length('C:\') then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Ƀ[g͐ݒł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Setting is wrong, because of Synclonize dst folder can not set root folder.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if UpperCase(sStr1) = UpperCase(sStr2) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Ɠɓ̃tH_͐ݒł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Setting is wrong, because of same folder can not set src folder and dst folder.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if Pos(UpperCase(sStr1), UpperCase(sStr2)) > 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Ɋ܂܂Ăꍇ͐ݒł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Setting is wrong, because of src folder include dst folder.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if Pos(UpperCase(sStr2), UpperCase(sStr1)) > 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : 悪Ɋ܂܂Ăꍇ͐ݒł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Setting is wrong, because of dst folder include src folder.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  StrList3 := TStringList.Create;

  //XV
  Label25.Caption := 'Src=0';
  Label26.Caption := 'Dst=0';
  Label28.Caption := 'Time=0';
  Label25.Refresh;
  Label26.Refresh;
  Label28.Refresh;

  //XV
  ButtonGet2.Enabled     := FALSE;
  ButtonGet2.Refresh;
  ButtonRun2.Enabled     := FALSE;
  ButtonRun2.Refresh;
  ButtonAbort2.Enabled   := TRUE;
  ButtonAbort2.Refresh;
  ButtonCancel2.Enabled  := FALSE;
  ButtonCancel2.Refresh;

  //NA
  ListBox1.Items.BeginUpdate;
  ListBox1.Items.Clear;
  ListBox1.Items.EndUpdate;
  //NA
  StrListSrc.Clear;
  StrListDst.Clear;
  StrListCopy.Clear;

  //
  if System.SysUtils.DirectoryExists(sStr1) = TRUE then
  begin
    //NA
    StrList1.Clear;
    StrList2.Clear;
    StrList3.Clear;
    StrList1.Sorted := FALSE;
    IntSrcCount := 0;

    //z̃tH_
    ThisListFilesDriveSrc(sStr1, Strlist1);
    //]
    StrList2.Sorted := TRUE;
    StrList3.Sorted := TRUE;
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //tH_
      if Copy(StrList1.Strings[iRow1], Length(StrList1.Strings[iRow1]), 1) = '\' then
      begin
        //
        StrList3.Add(StrList1.Strings[iRow1]);
      end
      //t@C
      else
      begin
        //
        StrList2.Add(StrList1.Strings[iRow1]);
      end;
    end;
    //f
    StrListSrc.Assign(StrList2);
  end;

  //
  if System.SysUtils.DirectoryExists(sStr2) = TRUE then
  begin
    //NA
    StrList1.Clear;
    StrList2.Clear;
    StrList3.Clear;
    StrList1.Sorted := FALSE;
    IntDstCount := 0;

    //z̃tH_
    ThisListFilesDriveDst(sStr2, Strlist1);
    //]
    StrList2.Sorted := TRUE;
    StrList3.Sorted := TRUE;
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //tH_
      if Copy(StrList1.Strings[iRow1], Length(StrList1.Strings[iRow1]), 1) = '\' then
      begin
        //
        StrList3.Add(StrList1.Strings[iRow1]);
      end
      //t@C
      else
      begin
        //
        StrList2.Add(StrList1.Strings[iRow1]);
      end;
    end;
    //f
    StrListDst.Assign(StrList2);
  end;

  //
  iLen1 := Length(sStr1);  //W:\Tangochou\
  for iRow1 := 0 to StrListSrc.Count-1 do
  begin
    //RHSA 2018/09/20 16:00:33              208,828 W:\Tangochou\JAP2ENG.csv
    //擾
    sStr11 := Copy(StrListSrc.Strings[iRow1],  1, 4);      //RHSA
    sStr12 := Copy(StrListSrc.Strings[iRow1],  6, 10+1+8); //2019/01/01 00:00:00
    sStr13 := Copy(StrListSrc.Strings[iRow1], 26, 20);     //1,234,567,890,123
    sStr14 := Copy(StrListSrc.Strings[iRow1], 47, Length(StrListSrc.Strings[iRow1])); //W:\Tangochou\JAP2ENG.csv
    //ȍ~
    sStr4 := Copy(sStr14, iLen1+1, Length(sStr14));                                   //JAP2ENG.csv
    //̃tpX
    sStr5 := sStr2 + sStr4;

    //
    for iRow2 := 0 to StrListDst.Count-1 do
    begin
      //擾
      sStr21 := Copy(StrListDst.Strings[iRow2],  1, 4);      //RHSA
      sStr22 := Copy(StrListDst.Strings[iRow2],  6, 10+1+8); //2019/01/01 00:00:00
      sStr23 := Copy(StrListDst.Strings[iRow2], 26, 20);     //1,234,567,890,123
      sStr24 := Copy(StrListDst.Strings[iRow2], 47, Length(StrListDst.Strings[iRow2])); //W:\Tangochou\JAP2ENG.csv
      if UpperCase(sStr5) = UpperCase(sStr24) then
      begin
        //t
        date11 := StrToDateTime(sStr12);
        //t
        date21 := StrToDateTime(sStr22);
        //]V
        if date11 > date21 then
        begin
          StrListCopy.Add(StrListSrc.Strings[iRow1]);
          StrListCopy.Add(StrListDst.Strings[iRow2]);
        end;
        Break;
      end;
    end;

    //\XV
    if (iRow1 mod 10) = 0 then
    begin
      Label28.Caption := 'Time=*' + IntToStr(iRow1);
      Label28.Refresh;
      Application.ProcessMessages;
    end;
  end;

  //j
  StrList1.Free;
  StrList2.Free;
  StrList3.Free;

  //ۑ
  StrListSrc.SaveToFile(FormMain.StrExtractBase  + FILE_TIME_SRC_TXT,  TEncoding.Unicode);
  StrListDst.SaveToFile(FormMain.StrExtractBase  + FILE_TIME_DST_TXT,  TEncoding.Unicode);
  StrListCopy.SaveToFile(FormMain.StrExtractBase + FILE_TIME_COPY_TXT, TEncoding.Unicode);

  //f
  ListBox1.Items.BeginUpdate;
  ListBox1.Items.Assign(StrListCopy);
  ListBox1.Items.EndUpdate;

  Label25.Caption := 'Src='  + IntToStr(StrListSrc.Count);
  Label26.Caption := 'Dst='  + IntToStr(StrListDst.Count);
  Label28.Caption := 'Time=' + IntToStr(StrListCopy.Count div 2);
  Label25.Refresh;
  Label26.Refresh;
  Label28.Refresh;

  //XV
  ButtonGet2.Enabled     := TRUE;
  ButtonGet2.Refresh;
  ButtonRun2.Enabled     := TRUE;
  ButtonRun2.Refresh;
  ButtonAbort2.Enabled   := FALSE;
  ButtonAbort2.Refresh;
  ButtonCancel2.Enabled  := TRUE;
  ButtonCancel2.Refresh;

  //
  if ListBox1.Items.Count = 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Ώۃt@C͂܂ł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Target file can not find.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;

end;

procedure TFormFileTime.ButtonOk3Click(Sender: TObject);
var
  sStr1: String;
  sStr9: String;
  iIndex1: Integer;
  iIndex2: Integer;
  CsvList1: TStringList;
begin
  //
  if      (Edit32.Text = '') and (Edit33.Text = '') then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Ɠ悪ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Synclonize src folder and mirror dst folder are empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  else if (Edit32.Text = '') then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Synclonize src folder is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  else if (Edit33.Text = '') then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : 悪ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Synclonize dst folder is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  else
  begin
    //
  end;

  if Copy(Edit32.text, Length(Edit32.text), 1) <> '\' then
  begin
    Edit32.text := Edit32.text + '\';
  end;
  if Copy(Edit33.text, Length(Edit33.text), 1) <> '\' then
  begin
    Edit33.text := Edit33.text + '\';
  end;

  //m
  CsvList1 := TStringList.Create;
  //WJ
  StringToCsvList(StrListItems.Strings[ListBox8.ItemIndex], CsvList1);
  //ݒ
  sStr1 := CsvList1[0];
  //j
  CsvList1.Free;


  //XV
  iIndex1 := ListBox8.TopIndex;
  iIndex2 := ListBox8.ItemIndex;
  //
  StrListItems.Strings[iIndex2] := sStr1 + #09 + Edit31.Text + #09 + Edit32.Text + #09 + Edit33.Text;
  //ۑ
  sStr9 := ExtractFilePath(ParamStr(0)) + FILE_TIME_TXT;
  StrListItems.SaveToFile(sStr9, TEncoding.Unicode);
  //XV
  SetItemList(Sender);
  //XV
  ListBox8.TopIndex  := iIndex1;
  ListBox8.ItemIndex := iIndex2;


  //ؑ
  Panel11.Visible  := TRUE;
  Panel21.Visible  := FALSE;
  Panel31.Visible  := FALSE;
  FormFileTime.Menu := FormFileTime.MainMenu1;


  //ݒ
  ListBox8.SetFocus;
end;


procedure TFormFileTime.ButtonRun2Click(Sender: TObject);
var
  iRow1: Integer;
  date11: TDateTime;
  sStr14: String;
  sStr24: String;
  bResult: Boolean;
begin
  //mF
  if ListBox1.Items.Count = 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Ώۃt@C͂܂ł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Target file can not find.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //XV
  ButtonGet2.Enabled     := FALSE;
  ButtonGet2.Refresh;
  ButtonRun2.Enabled     := FALSE;
  ButtonRun2.Refresh;
  ButtonAbort2.Enabled   := TRUE;
  ButtonAbort2.Refresh;
  ButtonCancel2.Enabled  := FALSE;
  ButtonCancel2.Refresh;

  //s
  bResult := TRUE;
  for iRow1 := 0 to StrListCopy.Count-1 do
  begin
    if (iRow1 mod 2) = 0 then
    begin
      //擾
      sStr14 := Copy(StrListCopy.Strings[iRow1+0], 47, Length(StrListCopy.Strings[iRow1+0])); //W:\Tangochou\JAP2ENG.csv
      sStr24 := Copy(StrListCopy.Strings[iRow1+1], 47, Length(StrListCopy.Strings[iRow1+1])); //W:\Tangochou\JAP2ENG.csv
      try
        //擾
        date11 := System.IOUtils.TFile.GetLastWriteTime(sStr14);
        //
        try
          //ݒ
          System.IOUtils.TFile.SetLastWriteTime(sStr24, date11);
        except
          //XV
          ButtonGet2.Enabled     := TRUE;
          ButtonGet2.Refresh;
          ButtonRun2.Enabled     := TRUE;
          ButtonRun2.Refresh;
          ButtonAbort2.Enabled   := FALSE;
          ButtonAbort2.Refresh;
          ButtonCancel2.Enabled  := TRUE;
          ButtonCancel2.Refresh;

          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Error : ^CX^v̕ύXɎs܂' + #13#10 +
                                sStr24;
          end
          else
          begin
            FormMain.StrMsg := 'Error : Change time stamp failed.' + #13#10 +
                                sStr24 + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          bResult := FALSE;
          Break;
        end;
      except
        //XV
        ButtonGet2.Enabled     := TRUE;
        ButtonGet2.Refresh;
        ButtonRun2.Enabled     := TRUE;
        ButtonRun2.Refresh;
        ButtonAbort2.Enabled   := FALSE;
        ButtonAbort2.Refresh;
        ButtonCancel2.Enabled  := TRUE;
        ButtonCancel2.Refresh;

        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : ^CX^v̎擾Ɏs܂' + #13#10 +
                              sStr14;
        end
        else
        begin
          FormMain.StrMsg := 'Error : Get time stamp failed.' + #13#10 +
                              sStr14 + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        bResult := FALSE;
        Break;
      end;
    end;
  end;

  //s
  if bResult = FALSE then
  begin
    Exit;
  end;

  //XV
  ButtonGet2.Enabled     := TRUE;
  ButtonGet2.Refresh;
  ButtonRun2.Enabled     := TRUE;
  ButtonRun2.Refresh;
  ButtonAbort2.Enabled   := FALSE;
  ButtonAbort2.Refresh;
  ButtonCancel2.Enabled  := TRUE;
  ButtonCancel2.Refresh;

  //ݒ
  if BoolJapanese = TRUE then
  begin
    FormMain.StrMsg := 'Information : ^CX^v̕ύX܂';
  end
  else
  begin
    FormMain.StrMsg := 'Information : Change time stamp had done.' + #13#10 +
                       '[OK]';
  end;
  ShowMessage(FormMain.StrMsg);
end;

procedure TFormFileTime.ButtonCancel3Click(Sender: TObject);
begin
  //XV
  Panel11.Visible  := TRUE;
  Panel21.Visible  := FALSE;
  Panel31.Visible  := FALSE;
  FormFileTime.Menu := FormFileTime.MainMenu1;

  //ݒ
  ListBox8.SetFocus;
end;

procedure TFormFileTime.ButtonAbort2Click(Sender: TObject);
begin
  //f
  BoolAbort := TRUE;

  //XV
  ButtonGet2.Enabled     := TRUE;
  ButtonGet2.Refresh;
  ButtonRun2.Enabled     := TRUE;
  ButtonRun2.Refresh;
  ButtonAbort2.Enabled   := FALSE;
  ButtonAbort2.Refresh;
  ButtonCancel2.Enabled  := TRUE;
  ButtonCancel2.Refresh;

end;

procedure TFormFileTime.ButtonCancel1Click(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormFileTime.ButtonCancel2Click(Sender: TObject);
begin
  //ؑ
  Panel11.Visible  := TRUE;
  Panel21.Visible  := FALSE;
  Panel31.Visible  := FALSE;
  FormFileTime.Menu := FormFileTime.MainMenu1;

  //ݒ
  ListBox8.SetFocus;
end;

procedure TFormFileTime.ButtonSrcCurrent3Click(Sender: TObject);
begin
  Edit32.Text := ExtractFilePath(FormMain.StrCurrent);
  Edit32.SetFocus;
end;

procedure TFormFileTime.ButtonSrcList3Click(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  //ݒ
  if Edit32.Text = '' then
  begin
    sStr2 := '';
  end
  else
  begin
    sStr2 := Edit32.Text;
  end;
  if DirectoryExists(sStr2) = FALSE then
  begin
    sStr2 := '';
  end;
  if SelectDirectorySh('Select Directory', sStr2, sStr1) = TRUE then
  begin
    Edit32.Text := sStr1;
    Edit32.SetFocus;
  end
  else
  begin
    Edit32.SetFocus;
  end;
end;

procedure TFormFileTime.ButtonDstList3Click(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  //ݒ
  if Edit33.Text = '' then
  begin
    sStr2 := '';
  end
  else
  begin
    sStr2 := Edit33.Text;
  end;
  if DirectoryExists(sStr2) = FALSE then
  begin
    sStr2 := '';
  end;
  if SelectDirectorySh('Select Directory', sStr2, sStr1) = TRUE then
  begin
    Edit33.Text := sStr1;
    Edit33.SetFocus;
  end
  else
  begin
    Edit33.SetFocus;
  end;
end;

procedure TFormFileTime.ButtonSrcTree3Click(Sender: TObject);
var
  bResult: Boolean;
  sStr2: String;
begin
    //擾
    if Edit32.Text = '' then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end
    else
    begin
      sStr2 := Edit32.Text;
    end;
    if DirectoryExists(sStr2) = FALSE then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end;
    //
    FormMain.StrRetFormTree := '';
    FormMain.StrSetFormTree := sStr2;
    //
    FormTree := TFormTree.Create(Application);
    try
      if FormTree.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormTree.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormTree) = TRUE then
      begin
        Edit32.Text := FormMain.StrRetFormTree;
        Edit32.SetFocus;
      end
      else
      begin
        Edit32.SetFocus;
      end;
    end
    else
    begin
      Edit32.SetFocus;
    end;
end;

procedure TFormFileTime.ButtonSrcBrows3Click(Sender: TObject);
var
  bResult: Boolean;
  sStr2: String;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FOLDER);
  //j
  IniFile.Free;

    //擾
    if Edit32.Text = '' then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end
    else
    begin
      sStr2 := Edit32.Text;
    end;
    if DirectoryExists(sStr2) = FALSE then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end;
    //
    FormMain.StrRetFormBrowse := '';
    FormMain.StrSetFormBrowse := sStr2;
    //
    FormBrowse := TFormBrowse.Create(Application);
    try
      if FormBrowse.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormBrowse.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormBrowse) = TRUE then
      begin
        Edit32.Text := FormMain.StrRetFormBrowse;
        Edit32.SetFocus;
      end
      else
      begin
        Edit32.SetFocus;
      end;
    end
    else
    begin
      Edit32.SetFocus;
    end;
end;

procedure TFormFileTime.ButtonDstTree3Click(Sender: TObject);
var
  bResult: Boolean;
  sStr2: String;
begin
    //擾
    if Edit33.Text = '' then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end
    else
    begin
      sStr2 := Edit33.Text;
    end;
    if DirectoryExists(sStr2) = FALSE then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end;
    //
    FormMain.StrRetFormTree := '';
    FormMain.StrSetFormTree := sStr2;
    //
    FormTree := TFormTree.Create(Application);
    try
      if FormTree.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormTree.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormTree) = TRUE then
      begin
        Edit33.Text := FormMain.StrRetFormTree;
        Edit33.SetFocus;
      end
      else
      begin
        Edit33.SetFocus;
      end;
    end
    else
    begin
      Edit33.SetFocus;
    end;
end;

procedure TFormFileTime.ButtonDstBrows3Click(Sender: TObject);
var
  bResult: Boolean;
  sStr2: String;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FOLDER);
  //j
  IniFile.Free;

    //擾
    if Edit33.Text = '' then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end
    else
    begin
      sStr2 := Edit33.Text;
    end;
    if DirectoryExists(sStr2) = FALSE then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end;
    //
    FormMain.StrRetFormBrowse := '';
    FormMain.StrSetFormBrowse := sStr2;
    //
    FormBrowse := TFormBrowse.Create(Application);
    try
      if FormBrowse.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormBrowse.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormBrowse) = TRUE then
      begin
        Edit33.Text := FormMain.StrRetFormBrowse;
        Edit33.SetFocus;
      end
      else
      begin
        Edit33.SetFocus;
      end;
    end
    else
    begin
      Edit33.SetFocus;
    end;
end;

procedure TFormFileTime.ThisListFilesDrive(DirName :String; TheList:TStringList);
var
  sStr2: string;
  SStr3: String;
  SStr4: String;
  SStr5: String;
  SStr6: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';
  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4  := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 :=  SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE) + ' ' +
                  SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr6  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //tH_ɂ
          sStr3 := sStr3 + '\';
          //ǉ
          TheList.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + sStr3);
          //ċNIɌ
          Application.ProcessMessages;
          ThisListFilesDrive(sStr3, TheList);
          Application.ProcessMessages;
        end
        else
        begin
          //ǉ
          TheList.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + sStr3);
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;

procedure TFormFileTime.ThisListFilesDriveSrc(DirName :String; TheList:TStringList);
var
  sStr2: string;
  SStr3: String;
  SStr4: String;
  SStr5: String;
  SStr6: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';
  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4  := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 :=  SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE) + ' ' +
                  SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr6  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //tH_ɂ
          sStr3 := sStr3 + '\';
          //ǉ
          TheList.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + sStr3);
          //ċNIɌ
          Application.ProcessMessages;
          ThisListFilesDriveSrc(sStr3, TheList);
          Application.ProcessMessages;
        end
        else
        begin
          //ǉ
          TheList.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + sStr3);

          //XV
          IntSrcCount := IntSrcCount+1;
          if (IntSrcCount mod 10) = 0 then
          begin
            Label25.Caption := 'Src='    + IntToStr(IntSrcCount);
            Label25.Refresh;
            Application.ProcessMessages;
          end;
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;

procedure TFormFileTime.Timer1Timer(Sender: TObject);
begin
  //Zbg
  Timer1.Enabled := FALSE;

  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[hti쐬jł' + #13#10 +
                         '\[g[htiŏIXVjŎ擾܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Creation).' + #13#10 +
                         'But, get time by Date(LastWrite).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[htiŏIANZXjł' +#13#10 +
                         '\[g[htiŏIXVjŎ擾܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Last Access).' + #13#10 +
                         'But, get time by Date(LastWrite).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormFileTime.ThisListFilesDriveDst(DirName :String; TheList:TStringList);
var
  sStr2: string;
  SStr3: String;
  SStr4: String;
  SStr5: String;
  SStr6: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';
  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4  := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 :=  SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE) + ' ' +
                  SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr6  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //tH_ɂ
          sStr3 := sStr3 + '\';
          //ǉ
          TheList.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + sStr3);
          //ċNIɌ
          Application.ProcessMessages;
          ThisListFilesDriveDst(sStr3, TheList);
          Application.ProcessMessages;
        end
        else
        begin
          //ǉ
          TheList.Add(sStr4 + ' ' + sStr5 + ' ' + sStr6 + ' ' + sStr3);

          //XV
          IntDstCount := IntDstCount+1;
          if (IntDstCount mod 10) = 0 then
          begin
            Label26.Caption := 'Dst='    + IntToStr(IntDstCount);
            Label26.Refresh;
            Application.ProcessMessages;
          end;
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;


procedure TFormFileTime.SetItemList(Sender: TObject);
var
  iRow1: Integer;
  iMax1: Integer;
  iMax2: Integer;
  iMax3: Integer;
  iLen1: Integer;
  iLen2: Integer;
  iLen3: Integer;
  CsvList1: TStringList;
begin
  //ől擾
  iMax1 := 0;
  iMax2 := 0;
  iMax3 := 0;

  //m
  CsvList1 := TStringList.Create;

  //ݒ
  for iRow1 := 0 to StrListItems.Count-1 do
  begin
    //WJ
    CsvList1.Clear;
    StringToCsvList(StrListItems.Strings[iRow1], CsvList1);
    if Length(AnsiString(CsvList1[1])) > iMax1 then
    begin
      iMax1 := Length(AnsiString(CsvList1[1]));
    end;
    if Length(AnsiString(CsvList1[2])) > iMax2 then
    begin
      iMax2 := Length(AnsiString(CsvList1[2]));
    end;
    if Length(AnsiString(CsvList1[3])) > iMax3 then
    begin
      iMax3 := Length(AnsiString(CsvList1[3]));
    end;
  end;

  //XV
  ListBox8.Items.BeginUpdate;
  //NA
  ListBox8.Items.Clear;
  //ݒ
  for iRow1 := 0 to StrListItems.Count-1 do
  begin
    //WJ
    CsvList1.Clear;
    StringToCsvList(StrListItems.Strings[iRow1], CsvList1);
    iLen1 := Length(AnsiString(CsvList1[1]));
    iLen2 := Length(AnsiString(CsvList1[2]));
    iLen3 := Length(AnsiString(CsvList1[3]));
    ListBox8.Items.Add(CsvList1[0] + ' ' +
                       CsvList1[1] + StringOfChar(' ', iMax1-iLen1) + ' ' +
                       CsvList1[2] + StringOfChar(' ', iMax2-iLen2) + ' ' +
                       CsvList1[3] + StringOfChar(' ', iMax3-iLen3) + ' '
                       );
  end;
  //XV
  ListBox8.Items.EndUpdate;

  //j
  CsvList1.Free;
end;

procedure TFormFileTime.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //annsfm
  if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM  then
  begin
    //Ǎ
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_ANNSFM_LIST;
    if FileExists(sStr1) = TRUE then
    begin
      StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
    end;

    //ݒ
    if StrListKeyMap.Count > 0 then
    begin
      SetShortCutNew('1017', MenuQuit1, Sender);
      SetShortCutNew('1017', MenuQuit2, Sender);
      SetShortCutNew('1017', MenuQuit3, Sender);
      SetShortCutNew('1311', MenuEscape1, Sender);
      SetShortCutNew('1311', MenuEscape2, Sender);
      SetShortCutNew('1311', MenuEscape3, Sender);
    end;
  end;
end;

procedure TFormFileTime.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //ݒ
    sStr3 := '';
  end
  else
  begin
    //ݒ
    sStr3 := sStr16;
  end;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

procedure TFormFileTime.Edit31KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormFileTime.Edit32KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile:TIniFile;
  iIndex1: Integer;
begin
  //RETURN
  if Key = VK_RETURN then
  begin
    key := 0;
    if Edit32.Text = '' then
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //Ǎ
      iIndex1:= IniFile.ReadInteger('FolderSelect',      'Index', 2);
      //j
      IniFile.Free;

      //s
      if      iIndex1 = 0 then
      begin
        ButtonSrcList3Click(Sender);
      end
      else if iIndex1 = 1 then
      begin
        ButtonSrcTree3Click(Sender);
      end
      else if iIndex1 = 2 then
      begin
        ButtonSrcBrows3Click(Sender);
      end
      else
      begin
        ButtonSrcTree3Click(Sender);
      end;
    end
    else
    begin
      //
    end;
  end;
end;

procedure TFormFileTime.Edit32KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormFileTime.Edit33KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile:TIniFile;
  iIndex1: Integer;
begin
  //RETURN
  if Key = VK_RETURN then
  begin
    key := 0;
    if Edit33.Text = '' then
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //Ǎ
      iIndex1:= IniFile.ReadInteger('FolderSelect',      'Index', 2);
      //j
      IniFile.Free;

      //s
      if      iIndex1 = 0 then
      begin
        ButtonDstList3Click(Sender);
      end
      else if iIndex1 = 1 then
      begin
        ButtonDstTree3Click(Sender);
      end
      else if iIndex1 = 2 then
      begin
        ButtonDstBrows3Click(Sender);
      end
      else
      begin
        ButtonDstTree3Click(Sender);
      end;
    end
    else
    begin
      //
    end;
  end;
end;

procedure TFormFileTime.Edit33KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

end.
