unit FtpCopy;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN UNIT_PLATFORM     OFF} //W1005
  {$WARN SYMBOL_PLATFORM   OFF} //W1002
  {$WARN SYMBOL_PLATFORM   OFF} //W1002  FileSetDate
  {$WARN SYMBOL_DEPRECATED OFF} //W1000  for FileCtrl

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,

  Shellapi, Filectrl, IniFiles, MyUtility, System.IOUtils,
  Math, ShlObj, ActiveX, StrUtils,
  System.DateUtils,

  IdFTP, IdFTPList, IdAllFTPListParsers,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdExplicitTLSClientServerBase, IdAntiFreezeBase, Vcl.IdAntiFreeze,
  IdFTPCommon, IdURI, HTTPApp;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 500;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX1_WIDTH       = 695;


type
  TFormFtpCopy = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label1: TLabel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ListBox1: TListBox;
    ButtonList: TButton;
    ListBox2: TListBox;
    ButtonJumpFolder: TButton;
    ComboBox1: TComboBox;
    ButtonTree: TButton;
    IdFTP1: TIdFTP;
    Label25: TLabel;
    Label26: TLabel;
    Label29: TLabel;
    Label5: TLabel;
    Edit2: TEdit;
    ButtonAbort: TButton;
    ButtonBrowse: TButton;
    CheckBox1: TCheckBox;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonListClick(Sender: TObject);
    procedure ButtonJumpFolderClick(Sender: TObject);
    procedure ButtonTreeClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    procedure ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox2KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox2Click(Sender: TObject);

    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);

    function  SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;

    procedure ThisListFilesDrive(DirName :String; TheList:TStringList);
    procedure ThisListFilesDriveCurrent(DirName :String; TheList:TStringList);

    function  FtpConnect(Sender: TObject): Boolean;
    function  FtpDisConnect(Sender: TObject): Boolean;
    function  FtpGetDirAndFilesListCurrent(ADir: String; TheList: TStringList): Boolean;
    procedure FtpGetDirAndFilesList(ADir: String; TheList: TStringList);

    function  FtpExtractFilePath(FileName: String): String;
    function  FtpExtractFileName(FileName: String): String;
    function  FtpExtractFileExt(FileName: String): String;

    function  ThisCopyFtpToDrive(Sender: TObject): Boolean;
    procedure ButtonBrowseClick(Sender: TObject);
    procedure ListBox2Enter(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    CsvList2: TStringList;
    CsvList3: TStringList;
    CsvList4: TStringList;
    StrListSrc: TStringList;
    StrListDst: TStringList;
    StrListSrcFolder: TStringList;
    StrListFtpList: TStringList;
    BoolAbort: Boolean;
    BoolFileTimeWithin: Boolean;
    BoolJapanese: Boolean;
    IntFtpCount: Integer;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormFtpCopy: TFormFtpCopy;

implementation

uses
  Main, JumpFolder, InputFilename, Browse, Tree, FtpSelectCopy, FtpFiler;

{$R *.dfm}

//explorer
//t@C̕Ń\[g
//name<TAB>....
function CompareLogical2(List: TStringList; Index1, Index2: Integer): Integer;
var
  iPos11: Integer;
  iPos21: Integer;
  sStr11: String;
  sStr12: String;
begin
  //PosEx  StrUtils Kv
  //ŏ<TAB>
  iPos11 := PosEx(#09, List[Index1], 1);
  //t@C𒊏o
  sStr11 := Copy(List[Index1], 1, iPos11-1);

  //ŏ<TAB>
  iPos21 := PosEx(#09, List[Index2], 1);
  //t@C𒊏o
  sStr12 := Copy(List[Index2], 1, iPos21-1);

  //r
  Result := StrCmpLogicalW(PWideChar(WideString(sStr11)), PWideChar(WideString(sStr12)));
end;

//WindowsAPIR[obN֐ EBhE̗
function EnumWindowsProc(Wnd: HWND; lParam: Longint): Bool; stdcall; export;
var
  szCaption: array [0..255] of Char;
begin
  //ݒ
  Result:= TRUE;
  //EBhEnh擾
  GetWindowText(Wnd, szCaption, sizeof(szCaption));
  //gȊȎSĂݒ肷
  if (Wnd <> FormMain.Handle) then
  begin
    FormMain.StrListWindowName2.Add(StrPas(szCaption));
    FormMain.StrListWindowHwnd2.Add(IntToStr(Wnd));
  end;
end;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormFtpCopy.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFtpCopy.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormFtpCopy.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormFtpCopy.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //ݒ
  ComboBox1.AutoComplete := FALSE;

  //m
  CsvList2 := TStringList.Create;;
  CsvList3 := TStringList.Create;;
  CsvList4 := TStringList.Create;;
  StrListSrc    := TStringList.Create;
  StrListDst    := TStringList.Create;
  StrListSrcFolder := TStringList.Create;
  StrListFtpList   := TStringList.Create;

  //ݒ
  Edit2.Text := FormMain.StrSetFormFtpCopy;

  //ݒ
  ButtonAbort.Enabled := FALSE;

  //Ǎ
  if FileExists(FormMain.StrExtractBase + FTP_COPY_TXT) = TRUE then
  begin
    FormMain.StrListCopyMoveSrc.LoadFromFile(FormMain.StrExtractBase + FTP_COPY_TXT, TEncoding.Unicode);
  end;
  ListBox1.Items.Clear;
  for iRow1 := 0 to FormMain.StrListCopyMoveSrc.Count-1 do
  begin
    ListBox1.Items.Add(FormMain.StrListCopyMoveSrc.Strings[iRow1]);
  end;
  if ListBox1.Items.Count > 0 then
  begin
    ListBox1.ItemIndex := 0;
  end;
  //ݒ
  ListBox2.Items.Assign(FormMain.StrListWindowName);
  ListBox2.ItemIndex := 0;

  //
  ComboBox1.Items.Assign(FormMain.StrListCopyMoveHistory);
  ComboBox1.Text := '';

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormFtpCopy', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFtpCopy', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFtpCopy', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFtpCopy', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFtpCopy', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //g
  CheckBox1.Checked := IniFile.ReadBool('GetMySelfBonsFM', 'Add', FALSE);
  //j
  IniFile.Free;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
    ListBox2.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
    ListBox2.Style := lbStandard;
  end;

  //XV
  if BoolJapanese = TRUE then
  begin
    Label1.Caption := 'S  : ' + IntToStr(ListBox1.Items.Count);
  end
  else
  begin
    Label1.Caption := 'Total : ' + IntToStr(ListBox1.Items.Count);
  end;

  //XV
  Label25.Caption := 'Src=0';
  Label26.Caption := 'Dst=0';
  Label29.Caption := 'Get=0';

end;

procedure TFormFtpCopy.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFtpCopy', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFtpCopy', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFtpCopy', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFtpCopy', 'Left',   FormFtpCopy.Left);
    IniFile.WriteInteger('FormFtpCopy', 'Top',    FormFtpCopy.Top);
    IniFile.WriteInteger('FormFtpCopy', 'Width',  FormFtpCopy.Width);
    IniFile.WriteInteger('FormFtpCopy', 'Height', FormFtpCopy.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //g
  IniFile.WriteBool('GetMySelfBonsFM', 'Add', CheckBox1.Checked);
  //j
  IniFile.Free;

  //j
  CsvList2.Free;
  CsvList3.Free;
  CsvList4.Free;
  StrListSrc.Free;
  StrListDst.Free;
  StrListSrcFolder.Free;
  StrListFtpList.Free;
end;

procedure TFormFtpCopy.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormFtpCopy.KeyPreview := TRUE;

  //ݒ
  ComboBox1.SetFocus;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFtpCopy.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFtpCopy.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFtpCopy.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFtpCopy.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormFtpCopy.Handle, imClose);

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);
  ListBox2.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FtpCopy.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFtpCopy, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFtpCopy, StrLanguageFileName, Sender);
  end;
end;

procedure TFormFtpCopy.FormResize(Sender: TObject);
begin
  ListBox1.Width       := Panel1.ClientWidth  -40;
  ListBox2.Width       := Panel1.ClientWidth  -40;
  ComboBox1.Width      := Panel1.ClientWidth  -40;
  Edit2.Width          := Panel1.ClientWidth  -40;

  ListBox1.Height      := Panel1.ClientHeight -325;

  Label3.Top           := Panel1.ClientHeight -225;
  ButtonTree.Top       := Panel1.ClientHeight -228;
  ButtonJumpFolder.Top := Panel1.ClientHeight -228;
  ButtonList.Top       := Panel1.ClientHeight -228;
  ButtonBrowse.Top     := Panel1.ClientHeight -228;
  ComboBox1.Top        := Panel1.ClientHeight -195;

  Label4.Top           := Panel1.ClientHeight -162;
  ListBox2.Top         := Panel1.ClientHeight -135;

  ButtonOK.Top         := Panel1.ClientHeight -35;
  ButtonCancel.Top     := Panel1.ClientHeight -35;
  Label1.Top           := Panel1.ClientHeight -33;

  Label25.Top          := Panel1.ClientHeight -60;
  Label26.Top          := Panel1.ClientHeight -60;
  Label29.Top          := Panel1.ClientHeight -60;
end;

procedure TFormFtpCopy.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFtpCopy.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormFtpCopy, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormFtpCopy, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFtpCopy.ListBox2KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    key := 0;
    ListBox2Click(Sender);
    key := VK_RETURN;
    ComboBox1KeyDown(Sender, Key, Shift);
  end
  else if Key = VK_UP then
  begin
    key := 0;
    ListBox2Click(Sender);
  end
  else if Key = VK_DOWN then
  begin
    key := 0;
    ListBox2Click(Sender);
  end
  else
  begin
    inherited KeyUp(Key, Shift);
  end;
end;

procedure TFormFtpCopy.ListBox2Click(Sender: TObject);
var
  sStr1: String;
  iPos1: Integer;
  iPos2: Integer;
begin
  //
  if (ListBox2.Items.Count > 0) and (ListBox2.ItemIndex >= 0) then
  begin
    //annsFM 
    iPos1 := Pos(ANNSFM, ListBox2.Items[ListBox2.ItemIndex]);
    if iPos1 > 0 then
    begin
      sStr1 := Copy(ListBox2.Items[ListBox2.ItemIndex], 1, iPos1);
      sStr1 := TrimRight(sStr1);
      ComboBox1.Text := sStr1;
    end
    //annsFM 
    else
    begin
      //BonsFMmini 
      iPos2 := Pos(BONSFM_MINI, ListBox2.Items[ListBox2.ItemIndex]);
      if iPos2 > 0 then
      begin
        sStr1 := Copy(ListBox2.Items[ListBox2.ItemIndex], 1, iPos2);
        sStr1 := TrimRight(sStr1);
        ComboBox1.Text := sStr1;
      end;
    end;
  end;
end;

procedure TFormFtpCopy.ButtonOKClick(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
  iIndex1: Integer;
begin
  //
  if ComboBox1.Text = '' then
  begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //Ǎ
    iIndex1:= IniFile.ReadInteger('FolderSelect',      'Index', 2);
    //j
    IniFile.Free;

    //s
    if      iIndex1 = 0 then
    begin
      ButtonListClick(Sender);
    end
    else if iIndex1 = 1 then
    begin
      ButtonTreeClick(Sender);
    end
    else if iIndex1 = 2 then
    begin
      ButtonBrowseClick(Sender);
    end
    else
    begin
      ButtonTreeClick(Sender);
    end;
    //
    Exit;
  end;

  //
  if ComboBox1.Text <> '' then
  begin
    //
  end
  else
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʐ̃tH_ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  FormFtpSelectCopy := TFormFtpSelectCopy.Create(Application);
  try
    if FormFtpSelectCopy.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormFtpSelectCopy.Free;
  end;

  if bResult = TRUE then
  begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ݒ
    BoolFileTimeWithin := IniFile.ReadBool('FormFtpSelectCopy', 'TimeStampWithin',  FALSE);
    //j
    IniFile.Free;

    //s
    if ThisCopyFtpToDrive(Sender) = TRUE then
    begin
      //
    end;
  end;
end;

procedure TFormFtpCopy.ButtonCancelClick(Sender: TObject);
begin
  //߂l
  FormMain.StrRetFormFtpCopy := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormFtpCopy.ButtonListClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  //ݒ
  if ComboBox1.Text = '' then
  begin
    sStr2 := '';
  end
  else
  begin
    sStr2 := ComboBox1.Text;
  end;
  if System.SysUtils.DirectoryExists(sStr2) = FALSE then
  begin
    sStr2 := '';
  end;
  if SelectDirectorySh('Select Directory', sStr2, sStr1) = TRUE then
  begin
    ComboBox1.Text := sStr1;
    ComboBox1.SetFocus;
  end
  else
  begin
    ComboBox1.SetFocus;
  end;
end;

procedure TFormFtpCopy.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormFtpCopy.ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormFtpCopy.ListBox2Enter(Sender: TObject);
begin
  ListBox2Click(Sender);
end;

procedure TFormFtpCopy.ButtonJumpFolderClick(Sender: TObject);
var
  bResult: Boolean;
begin
  // 
  FormJumpFolder := TFormJumpFolder.Create(Application);
  try
    if FormJumpFolder.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    // j
    FormJumpFolder.Free;
  end;
  //ݒ肳ꂽ
  if bResult = TRUE then
  begin
    //tH_
    if System.SysUtils.DirectoryExists(FormMain.StrRetFormJumpFolder) = TRUE then
    begin
      ComboBox1.Text := FormMain.StrRetFormJumpFolder;
      ComboBox1.SetFocus;
    end
    else
    begin
      ComboBox1.SetFocus;
    end;
  end
  else
  begin
    ComboBox1.SetFocus;
  end;
end;

procedure TFormFtpCopy.ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile:TIniFile;
  iIndex1: Integer;
begin
  //RETURN
  if Key = VK_RETURN then
  begin
    key := 0;
    if ComboBox1.Text = '' then
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //Ǎ
      iIndex1:= IniFile.ReadInteger('FolderSelect',      'Index', 2);
      //j
      IniFile.Free;

      //s
      if      iIndex1 = 0 then
      begin
        ButtonListClick(Sender);
      end
      else if iIndex1 = 1 then
      begin
        ButtonTreeClick(Sender);
      end
      else if iIndex1 = 2 then
      begin
        ButtonBrowseClick(Sender);
      end
      else
      begin
        ButtonTreeClick(Sender);
      end;
    end
    else
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end;
end;

procedure TFormFtpCopy.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormFtpCopy.ButtonTreeClick(Sender: TObject);
var
  bResult: Boolean;
begin
    //
    FormMain.StrRetFormTree := '';
    FormMain.StrSetFormTree := ExtractfilePath(ComboBox1.Text);
    //
    FormTree := TFormTree.Create(Application);
    try
      if FormTree.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormTree.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if System.SysUtils.DirectoryExists(FormMain.StrRetFormTree) = TRUE then
      begin
        ComboBox1.Text := FormMain.StrRetFormTree;
        ComboBox1.SetFocus;
      end
      else
      begin
        ComboBox1.SetFocus;
      end;
    end
    else
    begin
      ComboBox1.SetFocus;
    end;
end;

procedure TFormFtpCopy.ButtonBrowseClick(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FOLDER);
  //j
  IniFile.Free;

    //
    FormMain.StrRetFormBrowse := '';
    FormMain.StrSetFormBrowse := ExtractfilePath(FormMain.StrCurrent);
    //
    FormBrowse := TFormBrowse.Create(Application);
    try
      if FormBrowse.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormBrowse.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if System.SysUtils.DirectoryExists(FormMain.StrRetFormBrowse) = TRUE then
      begin
        ComboBox1.Text := FormMain.StrRetFormBrowse;
        ComboBox1.SetFocus;
      end
      else
      begin
        ComboBox1.SetFocus;
      end;
    end
    else
    begin
      ComboBox1.SetFocus;
    end;
end;

function TFormFtpCopy.SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;
var
  FolderPidl : PItemIDList;
  BrowseInfo : TBrowseInfo;
  BPathName  : array[0..MAX_PATH-1] of Char;
  AMalloc    : IMalloc;
begin
  //
  Result := FALSE;
  //ڎʎq̂߂̃AP[Ṽ|C^擾
  ShGetMalloc(AMalloc);
  FolderPidl := nil;
  //
  FillChar(BrowseInfo, SizeOf(BrowseInfo), #0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.lpfn      := nil;
  BrowseInfo.lpszTitle := PChar('Select Directory');
  BrowseInfo.pidlRoot  := nil;
  BrowseInfo.ulFlags   := BIF_RETURNONLYFSDIRS or
                          BIF_NEWDIALOGSTYLE   or
                          BIF_VALIDATE;

//BIF_RETURNONLYFSDIRS   $0001 t@CVXefBNĝ݂I\
//BIF_DONTGOBELOWDOMAIN  $0002 hC̃lbg[NtH_\Ȃ
//BIF_STATUSTEXT         $0004 _CAOc[̂ɕ\
//                             R[obN֐ŏKv
//BIF_RETURNFSANCESTORS	 $0008 [gȉ̃t@CCtH_̂ݑI\
//BIF_EDITBOX            $0010 OҏWp{bNX\
//BIF_VALIDATE           $0020 OҏW{bNXւ̖ȕ`FbN
//                             BIF_EDITBOX ̎w肪鎞̂ݗL
//                             ̓R[obN֐ōs
//BIF_NEWDIALOGSTYLE	   $0040	ȉ̐VX^C̃_CAO\
//                             TCY\
//                             _CAOւ̃hbOAhhbv
//                             tH_̍Đ
//                             V[gJbgj[ (ReLXg)
//                             VtH_̍쐬
//BIF_USENEWUI           $0050 OҏW{bNX̂VX^C
//                             BIF_EDITBOX or BIF_NEWDIALOGSTYLE wƓ
//BIF_BROWSEINCLUDEURLS	 $0080 URL\\Ƃ
//                             BIF_USENEWUIBIF_BROWSEINCLUDEFILES ̎wKv
//                             YtH_T|[gꍇ̂ݕ\
//BIF_UAHINT             $0100 OҏW{bNX̑Ƀqg\
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NONEWFOLDERBUTTON  $0200  [VtH_̍쐬] {^\Ȃ
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NOTRANSLATETARGETS $0400 IACeV[gJbg̏ꍇCNł͂ȂCV[gJbgg̍ڎʎqԂ
//BIF_BROWSEFORCOMPUTER  $1000 Rs[^̂ݑI\Ƃ
//BIF_BROWSEFORPRINTER   $2000 v^̂ݑI\Ƃ
//BIF_BROWSEINCLUDEFILES $4000 t@C\đI\Ƃ
//BIF_SHAREABLE          $8000 L\[X\đI\ɂ
//                             BIF_USENEWUI ̎wKv

  //̐ݒɊÂtH_Qƃ_CAO\
  try
    //擾
    FolderPidl := SHBrowseForFolder(BrowseInfo);
    If FolderPidl <> nil then
    begin
      //ڎʎqpX̕BPathNameɕϊ
      SHGetPathFromIDList(FolderPidl, BPathName);
      //
      Directory := BPathName;
      if Copy(Directory, Length(Directory), 1) <> '\' then
      begin
        Directory := Directory + '\';
      end;
      //
      Result := TRUE;
    end;
  finally
    //
    AMalloc.Free(FolderPidl);
  end;
end;







procedure TFormFtpCopy.ThisListFilesDrive(DirName :String; TheList:TStringList);
var
  sStr2: string;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';

  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4 := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 := SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE);
        sstr6 := SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr7  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //tH_ɂ
          sStr3 := sStr3 + '\';
          //ǉ
          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);

          //ċNIɌ
          Application.ProcessMessages;
          ThisListFilesDrive(sStr3, TheList);
          Application.ProcessMessages;
        end
        else
        begin
          //ǉ
          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;

procedure TFormFtpCopy.ThisListFilesDriveCurrent(DirName :String; TheList:TStringList);
var
  sStr2: string;
  SStr3: String;
  SStr4: String;
  SStr5: String;
  SStr6: String;
  SStr7: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';
  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4 := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 := SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE);
        sstr6 := SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr7  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //tH_ɂ
          sStr3 := sStr3 + '\';
          //ǉ
          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);
        end
        else
        begin
          //ǉ
          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;




function  TFormFtpCopy.ThisCopyFtpToDrive(Sender: TObject): Boolean;
var
  StrList1: TStringList;
  StrList2: TStringList;
  StrList3: TStringList;
  StrList4: TStringList;
  CsvList1: TStringList;
  CsvList2: TStringList;

  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;

  iLen1: Integer;
  iRow1: Integer;
  iRow2: Integer;
  iRow11: Integer;
  iFind1: Integer;
  iCopyNum1: Integer;

  date11: TDateTime;
  date21: TDateTime;
  date31: TDateTime;
  i64Int2: Int64;

  bCopy1: Boolean;
  bRename1: Boolean;
  bResult: Boolean;
  bExcept1: Boolean;
  bExcept2: Boolean;
  bRet1: Boolean;
begin
  //
  Result := FALSE;

  //擾
  sStr2 := ComboBox1.Text;
  //
  if sStr2 = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʐ̃tH_ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;

  //ݒ
  if Copy(sStr2, Length(sStr2), 1) <> '\' then
  begin
    sStr2 := sStr2 + '\';
    ComboBox1.Text := sStr2;
  end;

  //
  if Length(sStr2) < Length('C:\') then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʐ̃tH_̐ݒ肪Rȉł';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder name is less than 3 letters.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;

  //
  if Pos('\\', sStr2) > 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʐ̃tH_̐ݒ \\ ̎w͂ł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder name is not available \\.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;

  //
  if System.SysUtils.DirectoryExists(sStr2) = FALSE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʐ̃tH_܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder is not exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  StrList3 := TStringList.Create;
  StrList4 := TStringList.Create;
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;

  //XV
  ButtonOK.Enabled     := FALSE;
  ButtonOK.Refresh;
  ButtonAbort.Enabled  := TRUE;
  ButtonAbort.Refresh;
  ButtonCancel.Enabled := FALSE;
  ButtonCancel.Refresh;

  //XV
  Label25.Caption := 'Src=0';
  Label26.Caption := 'Dst=0';
  Label29.Caption := 'Get=0';
  Label25.Refresh;
  Label26.Refresh;
  Label29.Refresh;

  //NA
  StrListSrc.Clear;
  StrListDst.Clear;
  StrListSrcFolder.Clear;

  //ݒ
  BoolAbort := FALSE;
  bExcept1  := FALSE;
  bExcept2  := FALSE;
  bRet1     := FALSE;

  //ڑ
  if FtpConnect(Sender) = TRUE then
  begin
    //݂Ă
    StrList4.Clear;
    FtpGetDirAndFilesListCurrent(Edit2.Text, StrList4);
    //ǉ
    StrList4.Insert(0, Edit2.Text + #09 + #09 + #09);

    //s
    for iRow1 := 0 to ListBox1.Items.Count-1 do
    begin
      //NA
      StrList1.Clear;
      StrList2.Clear;
      StrList3.Clear;
      StrList1.Sorted := FALSE;

      //tH_
      if Copy(ListBox1.Items.Strings[iRow1], Length(ListBox1.Items.Strings[iRow1]), 1) = '/' then
      begin
        //z̃tH_
        FtpGetDirAndFilesList(Edit2.Text + ListBox1.Items.Strings[iRow1], StrList1);

        //]
        StrList2.Sorted := TRUE;
        StrList3.Sorted := TRUE;
        for iRow2 := 0 to StrList1.Count-1 do
        begin
          //WJ
          CsvList2.Clear;
          StringToCsvList(StrList1.Strings[iRow2], CsvList2);
          //tH_
          if Copy(CsvList2[0], Length(CsvList2[0]), 1) = '/' then
          begin
            //
            StrList3.Add(StrList1.Strings[iRow2]);
          end
          //t@C
          else
          begin
            //
            StrList2.Add(StrList1.Strings[iRow2]);
          end;
        end;

        //f
        StrListSrc.AddStrings(StrList2);

        //f
        for iRow2 := 0 to StrList4.Count-1 do
        begin
          //WJ
          CsvList2.Clear;
          StringToCsvList(StrList4.Strings[iRow2], CsvList2);
          //
          if CsvList2[0] = (Edit2.Text + ListBox1.Items.Strings[iRow1]) then
          begin
            StrListSrcFolder.Add(StrList4.Strings[iRow2]);
            Break;
          end;
        end;
        //f
        StrListSrcFolder.AddStrings(StrList3);
      end
      //t@C
      else
      begin
        for iRow2 := 0 to StrList4.Count-1 do
        begin
          //WJ
          CsvList2.Clear;
          StringToCsvList(StrList4.Strings[iRow2], CsvList2);
          //
          if CsvList2[0] = (Edit2.Text + ListBox1.Items.Strings[iRow1]) then
          begin
            StrListSrc.Add(StrList4.Strings[iRow2]);
            Break;
          end;
        end;
      end;

      //XV
      Label25.Caption := 'Src=' + IntToStr(StrListSrc.Count);
      Label25.Refresh;
      Application.ProcessMessages;
    end;

    //XV
    Label25.Caption := 'Src=' + IntToStr(StrListSrc.Count);
    Label25.Refresh;
    Application.ProcessMessages;

    //\[g
    StrListSrc.Sorted := FALSE;
    StrListSrc.CustomSort(CompareLogical2);
    //\[g
    StrListSrcFolder.Sorted := FALSE;
    StrListSrcFolder.CustomSort(CompareLogical2);
  end
  else
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //I
    Exit;
  end;


  //f
  if BoolAbort = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : f܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Operation had stopped.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  if System.SysUtils.DirectoryExists(ComboBox1.Text) = TRUE then
  begin
    //NA
    StrList1.Clear;
    StrList1.Sorted := FALSE;
    StrList2.Clear;
    StrList2.Sorted := FALSE;
    StrList3.Clear;
    StrList3.Sorted := FALSE;

    //z̃tH_
    ThisListFilesDrive(ComboBox1.Text, StrList1);
    //]
    StrList2.Sorted := TRUE;
    StrList3.Sorted := TRUE;
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //WJ
      CsvList2.Clear;
      StringToCsvList(StrList1.Strings[iRow1], CsvList2);
      //tH_
      if Copy(CsvList2[0], Length(CsvList2[0]), 1) = '\' then
      begin
        //
        StrList3.Add(StrList1.Strings[iRow1]);
      end
      //t@C
      else
      begin
        //
        StrList2.Add(StrList1.Strings[iRow1]);
      end;
    end;
    //f
    StrListDst.Assign(StrList2);
    StrListDst.Sorted := FALSE;
    StrListDst.CustomSort(CompareLogical2);

    //XV
    Label26.Caption := 'Dst=' + IntToStr(StrListDst.Count);
    Label26.Refresh;
    Application.ProcessMessages;

  end;

  //f
  if BoolAbort = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : f܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Operation had stopped.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  StrListSrc.SaveToFile(FormMain.StrExtractBase        + FTP_COPY_SRC_TXT,         TEncoding.Unicode);
  StrListDst.SaveToFile(FormMain.StrExtractBase        + FTP_COPY_DST_TXT,         TEncoding.Unicode);
  StrListSrcFolder.SaveToFile(FormMain.StrExtractBase  + FTP_COPY_SRC_FOLDER_TXT,  TEncoding.Unicode);

  //ڑ
  if FtpConnect(Sender) = TRUE then
  begin
    //
    iCopyNum1 := 0;
    //ʂ
    iLen1 := Length(Edit2.Text);
    for iRow1 := 0 to StrListSrc.Count-1 do
    begin
      //f
      if BoolAbort = TRUE then
      begin
        Break;
      end;

      //WJ
      CsvList1.Clear;
      StringToCsvList(StrListSrc.Strings[iRow1], CsvList1);
      //擾
      sStr11 := CsvList1[1];
      sStr12 := CsvList1[2] +  ' ' + CsvList1[3];
      sStr13 := CsvList1[4];
      sStr14 := CsvList1[0];
      //ȍ~
      sStr4 := Copy(sStr14, iLen1+1, Length(sStr14));
      //̃tpX
      sStr5 := ComboBox1.Text + sStr4;
      sStr5 := StringReplace(sStr5, '/', '\', [rfReplaceAll]);

      //
      bCopy1   := FALSE;
      bRename1 := FALSE;
      bExcept1 := FALSE;
      iFind1 := -1;
      for iRow2 := 0 to StrListDst.Count-1 do
      begin
        //WJ
        CsvList2.Clear;
        StringToCsvList(StrListDst.Strings[iRow2], CsvList2);
        //擾
        sStr21 := CsvList2[1];
        sStr22 := CsvList2[2]  + ' ' + CsvList2[3];
        sStr23 := CsvList2[4];
        sStr24 := CsvList2[0];

        if UpperCase(sStr5) = UpperCase(sStr24) then
        begin
          //
          iFind1 := iRow2;

          //rŎsꍇ́At@CTCY 0 Ȃ̂ŁAɕʂ
          if sStr23 = '                   0' then
          begin
            bCopy1  := TRUE;
            Break;
          end;

          if FormMain.IntCopyModeIndex = COPY_MOVE_MODE_DATE then
          begin
            //t
            date11 := StrToDateTime(sStr12);
            //t
            date21 := StrToDateTime(sStr22);
            //b
            i64Int2 := System.DateUtils.SecondsBetween(date11, date21);

            //2bȓ͓ƂĔr
            if BoolFileTimeWithin = TRUE then
            begin
              //2bȓ
              if Abs(i64Int2) <= 2 then
              begin
                ;
              end
              //2bȏ
              else
              begin
                //]V
                if date11 > date21 then
                begin
                  bCopy1 := TRUE;
                end;
              end;
            end
            //Pɔr
            else
            begin
              //]V
              if date11 > date21 then
              begin
                bCopy1 := TRUE;
              end;
            end;
            Break;
          end;

          if FormMain.IntCopyModeIndex = COPY_MOVE_MODE_OVERWRITE then
          begin
            bCopy1  := TRUE;
            Break;
          end;

          if FormMain.IntCopyModeIndex = COPY_MOVE_MODE_NEW then
          begin
            bCopy1  := FALSE;
            Break;
          end;

          if FormMain.IntCopyModeIndex = COPY_MOVE_MODE_RENAME then
          begin
            bRename1  := TRUE;
            Break;
          end;
        end;
      end;


      //tH_Ȃ
      if System.SysUtils.DirectoryExists(ExtractFilePath(sStr5)) = FALSE then
      begin
        //s
        if ForceDirectories(ExtractFilePath(sStr5)) = FALSE then
        begin
          bRet1 := TRUE;
          Break;
        end;
      end;

      //
      if      (bCopy1 = TRUE) then
      begin
        //s
        try
          //XV
          iCopyNum1 := iCopyNum1+1;
          //oCiłeLXgt@CłftBinary̎w肪Kv
          IdFTP1.TransferType := ftBinary;
          //㏑Ń_E[h
          IdFTP1.Get(sStr14, sStr5, TRUE);

          //[J̃^CX^vύX
          date31 := StrToDateTime(sStr12);
          //ύX
          try
            //ݒ
            System.IOUtils.TFile.SetLastWriteTime(sStr5, date31);
          except
            bExcept2 := TRUE;
            Break;
          end;

          //XV
          Label29.Caption := 'Get=' + IntToStr(iCopyNum1);
          Label29.Refresh;
          Application.ProcessMessages;
        except
          bExcept1 := TRUE;
          Break;
        end;
      end
      else if (iFind1 = -1) then
      begin
        //s
        try
          //XV
          iCopyNum1 := iCopyNum1+1;
          //oCiłeLXgt@CłftBinary̎w肪Kv
          IdFTP1.TransferType := ftBinary;
          //㏑Ń_E[h
          IdFTP1.Get(sStr14, sStr5, TRUE);

          //[J̃^CX^vύX
          date31 := StrToDateTime(sStr12);
          //ύX
          try
            //ݒ
            System.IOUtils.TFile.SetLastWriteTime(sStr5, date31);
          except
            bExcept2 := TRUE;
            Break;
          end;

          //XV
          Label29.Caption := 'Get=' + IntToStr(iCopyNum1);
          Label29.Refresh;
          Application.ProcessMessages;
        except
          bExcept1 := TRUE;
          Break;
        end;
      end
      else if (bRename1 = TRUE) then
      begin
        //
        FormMain.StrRetFormInputFilename := ExtractFileName(sStr5);
        FormMain.StrSetFormInputFilename := ExtractFilePath(sStr5);

        //
        FormInputFilename := TFormInputFilename.Create(Application);
        try
          if FormInputFilename.ShowModal = mrOK then
          begin
            bResult := TRUE;
          end
          else
          begin
            bResult := FALSE;
          end;
        finally
          //j
          FormInputFilename.Free;
        end;
        Application.ProcessMessages;
        //ݒǍ
        if bResult = TRUE then
        begin
          //s
          try
            //t@CVݒ
            sStr6 := ExtractFilePath(sStr5) + FormMain.StrRetFormInputFilename;
            //XV
            iCopyNum1 := iCopyNum1+1;
            //oCiłeLXgt@CłftBinary̎w肪Kv
            IdFTP1.TransferType := ftBinary;
            //㏑Ń_E[h
            IdFTP1.Get(sStr14, sStr6, TRUE);

            //[J̃^CX^vύX
            date31 := StrToDateTime(sStr12);
            //ύX
            try
              //ݒ
              System.IOUtils.TFile.SetLastWriteTime(sStr5, date31);
            except
              bExcept2 := TRUE;
              Break;
            end;

            //XV
            Label29.Caption := 'Get=' + IntToStr(iCopyNum1);
            Label29.Refresh;
            Application.ProcessMessages;
          except
            bExcept1 := TRUE;
            Break;
          end;
        end
        else
        begin
          //j
          if StrList1 <> nil then
          begin
            StrList1.Free;
          end;
          if StrList2 <> nil then
          begin
            StrList2.Free;
          end;
          if StrList3 <> nil then
          begin
            StrList3.Free;
          end;
          if CsvList1 <> nil then
          begin
            CsvList1.Free;
          end;
          if CsvList2 <> nil then
          begin
            CsvList2.Free;
          end;

          //ؒf
          FtpDisConnect(Sender);
          //XV
          ButtonOK.Enabled     := TRUE;
          ButtonOK.Refresh;
          ButtonAbort.Enabled  := FALSE;
          ButtonAbort.Refresh;
          ButtonCancel.Enabled := TRUE;
          ButtonCancel.Refresh;
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Information : Vt@C͂܂ł';
          end
          else
          begin
            FormMain.StrMsg := 'Information : New filename is empty.' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Exit;
        end;
      end
      else
      begin
        //
      end;
    end;
  end
  else
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //I
    Exit;
  end;

  //{^ɂ钆f
  if BoolAbort = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //ؒf
    FtpDisConnect(Sender);
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : _E[h𒆒f܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Download had stopped.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //O̒f
  if  bExcept1 = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //ؒf
    FtpDisConnect(Sender);
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : _E[hɎs܂' + #13#10 +
                          sStr5;
    end
    else
    begin
      FormMain.StrMsg := 'Error : Download failed.' + #13#10 +
                          sStr5 + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //O̒f
  if  bExcept2 = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //ؒf
    FtpDisConnect(Sender);
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : ^CX^v̕ύXɎs܂' + #13#10 +
                          sStr5;
    end
    else
    begin
      FormMain.StrMsg := 'Error : Change time stamp failed.' + #13#10 +
                          sStr5 + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //tH_̍쐬
  for iRow1 := 0 to StrListSrcFolder.Count-1 do
  begin
    //WJ
    CsvList1.Clear;
    StringToCsvList(StrListSrcFolder.Strings[iRow1], CsvList1);
    //擾
    sStr11 := CsvList1[1];
    sStr12 := CsvList1[2] +  ' ' + CsvList1[3];
    sStr13 := CsvList1[4];
    sStr14 := CsvList1[0];
    //ȍ~
    sStr4 := Copy(sStr14, iLen1+1, Length(sStr14));
    //̃tpX
    sStr5 := ComboBox1.Text + sStr4;
    sStr5 := StringReplace(sStr5, '/', '\', [rfReplaceAll]);

    //tH_Ȃ
    if System.SysUtils.DirectoryExists(ExtractFilePath(sStr5)) = FALSE then
    begin
      //s
      if ForceDirectories(ExtractFilePath(sStr5)) = FALSE then
      begin
        bRet1 := TRUE;
        Break;
      end;
    end;
  end;

  //
  if bRet1 = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : tH_쐬ł܂ł' + #13#10 +
                          ExtractFilePath(sStr5);
    end
    else
    begin
      FormMain.StrMsg := 'Error : Folder can not make.' + #13#10 +
                          ExtractFilePath(sStr5) + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  //f
  if BoolAbort = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonOK.Enabled     := TRUE;
    ButtonOK.Refresh;
    ButtonAbort.Enabled  := FALSE;
    ButtonAbort.Refresh;
    ButtonCancel.Enabled := TRUE;
    ButtonCancel.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : f܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Operation had stopped.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //j
  StrList1.Free;
  StrList2.Free;
  StrList3.Free;
  StrList4.Free;
  CsvList1.Free;
  CsvList2.Free;

  //
  for iRow11 := FormMain.StrListCopyMoveHistory.Count-1 downto 0 do
  begin
    if UpperCase(FormMain.StrListCopyMoveHistory.Strings[iRow11]) = UpperCase(ExtractFilePath(sStr2)) then
    begin
      FormMain.StrListCopyMoveHistory.Delete(iRow11);
    end;
  end;
  //擪ɒǉ
  FormMain.StrListCopyMoveHistory.Insert(0, ExtractFilePath(sStr2));
  //폜
  for iRow11 := FormMain.StrListCopyMoveHistory.Count-1 downto COPY_MOVE_HISTORY_MAX do
  begin
    FormMain.StrListCopyMoveHistory.Delete(iRow11);
  end;
  //ۑ
  FormMain.StrListCopyMoveHistory.SaveToFile(ExtractFilePath(ParamStr(0)) + COPY_MOVE_TXT, TEncoding.Unicode);

  //XV
  ButtonOK.Enabled     := TRUE;
  ButtonOK.Refresh;
  ButtonAbort.Enabled  := FALSE;
  ButtonAbort.Refresh;
  ButtonCancel.Enabled := TRUE;
  ButtonCancel.Refresh;

  //ݒ
  if BoolJapanese = TRUE then
  begin
    FormMain.StrMsg := 'Information : t@C̕ʂ܂';
  end
  else
  begin
    FormMain.StrMsg := 'Information : Copy file had done.' + #13#10 +
                       '[OK]';
  end;
  ShowMessage(FormMain.StrMsg);
  Result := TRUE;
end;


function  TFormFtpCopy.FtpConnect(Sender: TObject): Boolean;
begin
  //
  Result := FALSE;

  if FormMain.StrServerName = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : T[oݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Server name is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if FormMain.StrPortNumber = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : |[gԍݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Port number is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    try
      IdFTP1.Disconnect;
    except
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : ؒfɎs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Network disconnect failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //ݒ
  IdFTP1.Host     :=          FormMain.StrServerName;
  IdFTP1.Port     := StrToInt(FormMain.StrPortNumber);
  IdFTP1.Username :=          FormMain.StrUserName;
  IdFTP1.Password :=          FormMain.StrPassword;
  IdFTP1.Passive  :=          FormMain.BoolPassiveMode;
  //
  try
    //ڑ
    IdFTP1.Connect;
  except
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : ڑɎs܂';
    end
    else
    begin
      FormMain.StrMsg := 'Error : Network connect failed.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  Result := TRUE;

end;

function  TFormFtpCopy.FtpDisConnect(Sender: TObject): Boolean;
begin
  //
  Result := FALSE;

  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    try
      //ؒf
      IdFTP1.Disconnect;
    except
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : ؒfɎs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Network disconnect failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //
  Result := TRUE;
end;

procedure TFormFtpCopy.FtpGetDirAndFilesList(ADir: String; TheList: TStringList);
var
  LFileList : TStringList;
  iRow1     : Integer;
  iRow2     : Integer;
  LCount    : Integer;
  LListItem : TIdFTPListItem;
  LFileName : String;
  LFileSize : Int64;
  LFileDate : TDateTime;
  LFilePermission: String;
  LCurDir   : String;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
begin
  //m
  LFileList := TStringList.Create;
  //s
  try
    try
      //ύX
      IdFTP1.ChangeDir(ADir);
    except
      ;
    end;
    //擾
    IdFTP1.List;

    //List\bhsDirectoryListingŃt@C̃Xg擾ł
    LCount := IdFTP1.DirectoryListing.Count;
    //DirectroyListing͐VList\bhsƏĂ܂
    //čċȀꍇ͗płȂ̂ŕʃXg쐬
    LFileList.Clear;
    //s
    for iRow1 := 0 to LCount - 1 do
    begin
      //f
      if BoolAbort = TRUE then
      begin
        Break;
      end;

      //ꗗ擾
      LListItem := IdFTP1.DirectoryListing[iRow1];
      //t@C
      LFileName := LListItem.FileName;
      //t@CTCY
      LFileSize := LListItem.Size;
      //t@C̍ŏIXV
      LFileDate := LListItem.ModifiedDate;
      //t@C̃p[~bV
      LFilePermission := LListItem.PermissionDisplay;

      //q܂͐e
      if (LFileName = '.') or (LFileName = '..') then
      begin
        Continue;
      end;

      //fBNg
      if LListItem.ItemType = ditDirectory then
      begin
        //擾
        LCurDir := IdFTP1.RetrieveCurrentDir + '/' + LFileName;
        LFileList.Add(LCurDir);
      end;


      //ݒ
      if LListItem.ItemType = ditDirectory then
      begin
        sStr1 := IdFTP1.RetrieveCurrentDir + '/' + LFileName + '/';
      end
      else
      begin
        sStr1 := IdFTP1.RetrieveCurrentDir + '/' + LFileName;
      end;
      //ݒ
      if LFilePermission = '' then
      begin
        sStr2 := '*****-**-*';
      end
      else
      begin
        sStr2 := LFilePermission;
      end;
      //ϊ
      DateTimeToString(sStr3, 'yyyy/MM/dd', LFileDate);
      DateTimeToString(sStr4, 'HH:mm:ss', LFileDate);
      //ϊ
      sStr5 := ConvertInt64ToStr20(LFileSize);

      //ǉ
      //[0]name [1]attr [2]date [3]time [4]size
      TheList.Add(sStr1 + #09 + sStr2 + #09 + sStr3 + #09 + sStr4 + #09 + sStr5);

      //tH_
      if LListItem.ItemType = ditDirectory then
      begin
        //
      end
      //t@C
      else
      begin
        //XV
        IntFtpCount := IntFtpCount+1;
        if (IntFtpCount mod 10) = 0 then
        begin
          Label25.Caption := 'Src='    + IntToStr(IntFtpCount);
          Label25.Refresh;
          Application.ProcessMessages;
        end;
      end;
    end;

    //̎_SLɉwfBNg΃pXœĂ
    //wfBNgċAIɌListBoxItemɒǉĂ
    for iRow2 := 0 to LFileList.Count - 1 do
    begin
      //f
      if BoolAbort = TRUE then
      begin
        Break;
      end;
      //擾
      FtpGetDirAndFilesList(LFileList[iRow2], TheList);
    end;
  finally
    //j
    FreeAndNil(LFileList);
  end;
end;

function  TFormFtpCopy.FtpGetDirAndFilesListCurrent(ADir: String; TheList: TStringList): Boolean;
var
  FTPListItems: TIdFTPListItems;
  FTPListItem:  TIdFTPListItem;
  sFileName: String;
  iFileSize: Integer;
  ModifiedDate: TDateTime;
  sPermissionDisplay: string;
  sItemType: String;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  iRow1: Integer;
begin
  //
  Result := TRUE;

  try
    //ύX
    IdFTP1.ChangeDir(ADir);
  except
    ;
  end;
  //t@C̈ꗗ擾
  IdFTP1.List;
  FTPListItems := IdFTP1.DirectoryListing;

  //t@C\
  for iRow1 := 0 to FTPListItems.Count - 1 do
  begin
    //t@C
    FTPListItem := FTPListItems.Items[iRow1];
    //t@C
    sFileName := FTPListItem.FileName;
    //t@CTCY
    iFileSize := FTPListItem.Size;
    //t@C̍ŏIXV
    ModifiedDate := FTPListItem.ModifiedDate;
    //p[~bV
    sPermissionDisplay := FTPListItem.PermissionDisplay;
    //
    case FTPListItem.ItemType of
      ditDirectory:       sItemType := 'Directory';
      ditFile:            sItemType := 'File';
      ditSymbolicLink:    sItemType := 'SymbolicLink';
      ditSymbolicLinkDir: sItemType := 'SymbolicLinkDir';
      ditBlockDev:        sItemType := 'BlockDev';
      ditCharDev:         sItemType := 'CharDev';
      ditFIFO:            sItemType := 'FIFO';
      ditSocket:          sItemType := 'Socket';
    end;

    //ݒ
    if sItemType = 'Directory' then
    begin
      sStr1 := sFileName + '/';
    end
    else
    begin
      sStr1 := sFileName;
    end;
    //ݒ
    if sPermissionDisplay = '' then
    begin
      sStr2 := '*****-**-*';
    end
    else
    begin
      sStr2 := sPermissionDisplay;
    end;
    //ϊ
    DateTimeToString(sStr3, 'yyyy/MM/dd', ModifiedDate);
    DateTimeToString(sStr4, 'HH:mm:ss', ModifiedDate);
    //ϊ
    sStr5 := ConvertInt64ToStr20(iFileSize);

    //ǉ
    //[0]name [1]attr [2]date [3]time [4]size
    TheList.Add(ADir + sStr1 + #09 + sStr2 + #09 + sStr3 + #09 + sStr4 + #09 + sStr5);
  end;
end;

function  TFormFtpCopy.FtpExtractFilePath(FileName: String): String;
var
 iPos1: Integer;
 iIndex1: Integer;
 sStr1: String;
 sStr2: String;
begin
  sStr1 := FileName;
  iIndex1 := 0;
  while TRUE do
  begin
    iPos1 := Pos('/', sStr1);
    if iPos1 > 0 then
    begin
      iIndex1 := iIndex1 + iPos1;
      sStr2 := Copy(sStr1, iPos1+1, Length(sStr1));
      sStr1 := sStr2;
    end
    else
    begin
      Break
    end;
  end;
  Result := Copy(FileName, 1, iIndex1);
end;

function  TFormFtpCopy.FtpExtractFileName(FileName: String): String;
var
 iPos1: Integer;
 iIndex1: Integer;
 sStr1: String;
 sStr2: String;
begin
  sStr1 := FileName;
  iIndex1 := 0;
  while TRUE do
  begin
    iPos1 := Pos('/', sStr1);
    if iPos1 > 0 then
    begin
      iIndex1 := iIndex1 + iPos1;
      sStr2 := Copy(sStr1, iPos1+1, Length(sStr1));
      sStr1 := sStr2;
    end
    else
    begin
      Break
    end;
  end;
  Result := Copy(FileName, iIndex1+1, Length(FileName));
end;

function  TFormFtpCopy.FtpExtractFileExt(FileName: String): String;
var
 iPos1: Integer;
 iPos2: Integer;
 iIndex1: Integer;
 iIndex2: Integer;
 sStr1: String;
 sStr2: String;
 sStr3: String;
 sStr4: String;
 sStr5: String;
begin
  sStr1 := FileName;
  iIndex1 := 0;
  while TRUE do
  begin
    iPos1 := Pos('/', sStr1);
    if iPos1 > 0 then
    begin
      iIndex1 := iIndex1 + iPos1;
      sStr2 := Copy(sStr1, iPos1+1, Length(sStr1));
      sStr1 := sStr2;
    end
    else
    begin
      Break
    end;
  end;
  sStr3 := Copy(FileName, iIndex1+1, Length(FileName));

  sStr4 := sStr3;
  iIndex2 := 0;
  while TRUE do
  begin
    iPos2 := Pos('.', sStr4);
    if iPos2 > 0 then
    begin
      iIndex2 := iIndex2 + iPos2;
      sStr5 := Copy(sStr4, iPos2+1, Length(sStr4));
      sStr4 := sStr5;
    end
    else
    begin
      Break
    end;
  end;
  Result := Copy(sStr3, iIndex2, Length(sStr3));
end;

procedure TFormFtpCopy.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

end.
