unit ImageGrid;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_DEPRECATED    OFF} //W1000 : for FileCtrl
  {$WARN UNIT_PLATFORM   OFF} //W1005 : for Filectrl
  {$WARN SYMBOL_PLATFORM   OFF} //W1002  FileSetDate

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.ExtCtrls, Vcl.ComCtrls,
   Vcl.StdCtrls, Vcl.Buttons,
  IniFiles, ShellApi, ExifData, GDIPAPI, GDIPOBJ, GDIPUTIL, Math, Clipbrd, Filectrl,
  ShlObj, ActiveX, StrUtils, MyUtility;

const
  FORM_WIDTH_SET       = 860; //930
  FORM_HEIGHT_SET      = 570; //720
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LOOP_TIME1           =  5;
  LOOP_TIME2           = 100;
  LOOP_TIME3           =  30;
  LOOP_TIME4           =  5;

type
  TFormImageGrid = class(TForm)
    Panel53: TPanel;
    Panel52: TPanel;
    Panel54: TPanel;
    Image54: TImage;
    Label52: TLabel;

    MainMenu1: TMainMenu;
    MenuOperation: TMenuItem;
    MenuFile: TMenuItem;
    MenuEscape: TMenuItem;
    MenuMove: TMenuItem;
    MenuMoveTop: TMenuItem;
    MenuMovePrev: TMenuItem;
    MenuMoveUp: TMenuItem;
    MenuMoveDown: TMenuItem;
    MenuMoveNext: TMenuItem;
    MenuMoveEnd: TMenuItem;
    MenuDispChange: TMenuItem;
    MenuMark: TMenuItem;
    MenuEnter: TMenuItem;
    MenuSetting: TMenuItem;
    MenuCloseEscKey: TMenuItem;
    MenuKeyBoard: TMenuItem;
    Sepatater41: TMenuItem;
    Sepatater21: TMenuItem;
    Timer2: TTimer;
    Panel25: TPanel;
    Panel26: TPanel;
    Panel27: TPanel;
    Panel28: TPanel;
    Panel29: TPanel;
    Panel30: TPanel;
    Panel31: TPanel;
    Panel32: TPanel;
    MenuAllMarkFile: TMenuItem;
    MenuMarkReverse: TMenuItem;
    MenuFileList: TMenuItem;
    Sepatater22: TMenuItem;
    Panel55: TPanel;
    Memo1: TMemo;
    Timer1: TTimer;
    ColorDialog1: TColorDialog;
    ColorDialog2: TColorDialog;
    ColorDialog3: TColorDialog;
    Sepatater42: TMenuItem;
    MenuMarkColor: TMenuItem;
    MenuCurrentColor: TMenuItem;
    MenuBackColor: TMenuItem;
    Panel33: TPanel;
    Panel56: TPanel;
    Image56: TImage;
    Panel1: TPanel;
    MenuQuit: TMenuItem;
    Timer3: TTimer;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ThisListFilesDriveFileCount(DirName: String; TheList: TStringList);

    procedure MenuEscapeClick(Sender: TObject);
    procedure MenuMoveTopClick(Sender: TObject);
    procedure MenuMovePrevClick(Sender: TObject);
    procedure MenuMoveUpClick(Sender: TObject);
    procedure MenuMoveDownClick(Sender: TObject);
    procedure MenuMoveNextClick(Sender: TObject);
    procedure MenuMoveEndClick(Sender: TObject);
    procedure MenuEnterClick(Sender: TObject);
    procedure MenuCloseEscKeyClick(Sender: TObject);
    procedure MenuKeyBoardClick(Sender: TObject);
    procedure MenuDispChangeClick(Sender: TObject);
    procedure MenuMarkClick(Sender: TObject);
    procedure MenuAllMarkFileClick(Sender: TObject);
    procedure MenuMarkReverseClick(Sender: TObject);
    procedure MenuFileListClick(Sender: TObject);
    procedure MenuMarkColorClick(Sender: TObject);
    procedure MenuCurrentColorClick(Sender: TObject);
    procedure MenuBackColorClick(Sender: TObject);

    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);

    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);

    procedure Panel25Click(Sender: TObject);
    procedure Panel26Click(Sender: TObject);
    procedure Panel27Click(Sender: TObject);
    procedure Panel28Click(Sender: TObject);
    procedure Panel29Click(Sender: TObject);
    procedure Panel30Click(Sender: TObject);
    procedure Panel31Click(Sender: TObject);
    procedure Panel32Click(Sender: TObject);
    procedure Panel33Click(Sender: TObject);

    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);

    procedure Image54MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Image54DblClick(Sender: TObject);
    procedure Image56DblClick(Sender: TObject);
    procedure Image56MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure InitImageGrid(Sender: TObject);
    procedure ShowImageGrid(Sender: TObject);
    procedure ShowText(Sender: TObject);
    procedure MenuQuitClick(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);



  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    IntFormShiftX: Integer;
    IntFormShiftY: Integer;
    StrFormState: String;

    IntImageIndex: Integer;
    IntLocalCount: Integer;
    IntImageWidthHeight: Integer;
    IntWheelStatus: Integer;
    IntWheelCount: Integer;
    IntWheelCountNum: Integer;
    IntYokoCount: Integer;
    IntTateCount: Integer;
    StrListFile: TStringList;
    StrListMark: TStringList;
    StrListErrorFile: TStringList;
    BoolStop: Boolean;
    BoolImageShowing: Boolean;
    BoolImageMarking: Boolean;
    BoolImageGrid: Boolean;
    BoolWheelDirectionUp: Boolean;
    BoolWheelCount: Boolean;
    BoolTextSort: Boolean;
    BoolShow: Boolean;
    BoolJapanese: Boolean;
    colorMark: Tcolor;
    colorCurrent: Tcolor;
    colorBack: Tcolor;
    StrThumbNailFolder: String;
    StrLanguageFileName: String;

  public
    { Public 錾 }

    procedure InitKeyMap(ExeType: Integer; Sender: TObject);

  end;

var
  FormImageGrid: TFormImageGrid;

implementation

{$R *.dfm}

uses
  Main, KeyBoard, View;



//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormImageGrid.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormImageGrid.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormImageGrid.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormImageGrid.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormImageGrid.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  FormPosLeft   := IniFile.ReadInteger('FormImageGrid', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormImageGrid', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormImageGrid', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormImageGrid', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormImageGrid', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListFile           := TStringList.Create;
  StrListMark           := TStringList.Create;
  StrListErrorFile      := TStringList.Create;

  //
  colorMark    := clWhite;
  colorCurrent := clGreen;
  colorBack    := clBlack;

  Label52.Caption := '';

  Panel52.Caption := '';
  Panel53.Caption := '';
  Panel54.Caption := '';
  Panel55.Caption := '';
  Panel56.Caption := '';

  IntImageWidthHeight  := GRID_WIDTH_HEGHT;

  Timer1.Enabled := FALSE;
  Timer2.Enabled := FALSE;
  Timer3.Enabled := FALSE;

  BoolImageShowing := FALSE;
  BoolImageMarking := FALSE;
  BoolImageGrid    := TRUE;
  BoolShow         := FALSE;


  Panel54.Align := alClient;
  Panel55.Align := alClient;
  Panel56.Align := alClient;
  Panel54.Visible := FALSE;
  Panel55.Visible := FALSE;
  Panel56.Visible := TRUE;

  Panel26.Width := 110;
  Panel27.Width :=  60;
  Panel28.Width :=  60;
  Panel29.Width :=  60;
  Panel30.Width :=  60;
  Panel31.Width :=  60;
  Panel32.Width :=  60;
  Panel33.Width :=   0;
  Panel26.Enabled := TRUE;
  Panel27.Enabled := TRUE;
  Panel28.Enabled := TRUE;
  Panel29.Enabled := TRUE;
  Panel30.Enabled := TRUE;
  Panel31.Enabled := TRUE;
  Panel32.Enabled := TRUE;
  Panel33.Enabled := FALSE;

  Memo1.Align   := alClient;

  Image54.Align   := alClient;
  Image54.Stretch := FALSE;
  Image56.Align   := alClient;
  Image56.Stretch := FALSE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //Ǎ
  MenuCloseEsckey.Checked := IniFile.ReadBool  ('GridImage',       'CloseESCkey', TRUE);
  StrThumbNailFolder      := IniFile.ReadString('ThumbNailFolder', 'Name',        ExtractFilePath(ParamStr(0)) + FOLDER_THUMB_NAIL + '\');
  //Ǎ
  FormMain.FRichEditViewColor     := StringToColor(IniFile.ReadString('FRichEditView',      'Color',     ColorToString(clWhite)));
  FormMain.FRichEditViewFontColor := StringToColor(IniFile.ReadString('FRichEditView',      'FontColor', ColorToString(clBlack)));
  FormMain.FRichEditViewFontName  :=               IniFile.ReadString('FRichEditView',      'FontName',  'lr SVbN');
  FormMain.FRichEditViewFontSize  :=      StrToInt(IniFile.ReadString('FRichEditView',      'FontSize',  '14'));
  //f
  Memo1.Color      := FormMain.FRichEditViewColor;
  Memo1.Font.Color := FormMain.FRichEditViewFontColor;
  Memo1.Font.Name  := FormMain.FRichEditViewFontName;
  Memo1.Font.Size  := FormMain.FRichEditViewFontSize;
  //Ǎ
  colorMark    := StringToColor(IniFile.ReadString('FImageGridMark',      'Color',     ColorToString(clAqua)));
  colorCurrent := StringToColor(IniFile.ReadString('FImageGridCurrent',   'Color',     ColorToString(clGreen)));
  //e[}
  if      FormMain.IntVclStyle = 0 then
  begin
    colorBack    := StringToColor(IniFile.ReadString('FImageGridBack',      'Color',     ColorToString(clBlack)));
    MenuBackColor.Enabled := TRUE;
  end
  else if FormMain.IntVclStyle = 1 then
  begin
    ColorBack       := FormMain.FListViewColorCarbon;
    MenuBackColor.Enabled := FALSE;
  end
  else if FormMain.IntVclStyle = 2 then
  begin
    ColorBack       := FormMain.FListViewColorCharcoal;
    MenuBackColor.Enabled := FALSE;
  end
  else
  begin
    colorBack    := StringToColor(IniFile.ReadString('FImageGridBack',      'Color',     ColorToString(clBlack)));
    MenuBackColor.Enabled := TRUE;
  end;
  //f
  ColorDialog1.Color := colorMark;
  ColorDialog2.Color := colorCurrent;
  ColorDialog3.Color := colorBack;
  //Ǎ
  IntWheelCountNum   := StrToInt(IniFile.ReadString ('ImageWheelCount',  'Text', '2'));
  //j
  IniFile.Free;

end;

procedure TFormImageGrid.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormImageGrid', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormImageGrid', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormImageGrid', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormImageGrid', 'Left',   FormImageGrid.Left);
    IniFile.WriteInteger('FormImageGrid', 'Top',    FormImageGrid.Top);
    IniFile.WriteInteger('FormImageGrid', 'Width',  FormImageGrid.Width);
    IniFile.WriteInteger('FormImageGrid', 'Height', FormImageGrid.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteString('FImageGridMark',    'Color',     ColorToString(ColorDialog1.Color));
  IniFile.WriteString('FImageGridCurrent', 'Color',     ColorToString(ColorDialog2.Color));
  IniFile.WriteString('FImageGridBack',    'Color',     ColorToString(ColorDialog3.Color));
  //j
  IniFile.Free;

  //j
  StrListFile.Free;
  StrListMark.Free;
  StrListErrorFile.Free;
end;

procedure TFormImageGrid.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //{
  if       ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormImageGrid, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormImageGrid, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormImageGrid.FormResize(Sender: TObject);
begin
  if BoolShow = TRUE then
  begin
    ShowImageGrid(Sender);
  end;
end;

procedure TFormImageGrid.FormShow(Sender: TObject);
var
  sStr1: String;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormImageGrid.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormImageGrid.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormImageGrid.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormImageGrid.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormImageGrid.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  InitKeyMap(0, Sender);

  //t@CǍ
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_IMAGE_GRID_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    //Ǎ
    FormMain.StrListKeyMapImageGrid.LoadFromFile(sStr1, TEncoding.Unicode);
  end
  else
  begin
    //ۑ
    FormMain.StrListKeyMapImageGrid.Assign(FormMain.StrListKeyMapOriginalImageGrid);
    FormMain.StrListKeyMapImageGrid.SaveToFile(sStr1, TEncoding.Unicode);
  end;

  //ݒ
  SetShortCutKey(Sender);

  //Obh
  InitImageGrid(Sender);


  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'ImageGrid.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormImageGrid, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormImageGrid, StrLanguageFileName, Sender);
  end;

  //ꗗ擾
  Timer2.Enabled := TRUE;

  //ݒ
  BoolShow := TRUE;

  //\[gx
  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    Timer3.Enabled := TRUE;
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    Timer3.Enabled := TRUE;
  end;
end;

procedure TFormImageGrid.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  bCountUp1: Boolean;
begin
  //VtgԂ擾
  IntWheelStatus := 0;
  if (shift = [ssShift]) then
  begin
    IntWheelStatus := IntWheelStatus + 1;
  end;
  if (shift = [ssCtrl]) then
  begin
    IntWheelStatus := IntWheelStatus + 2;
  end;
  if (shift = [ssAlt]) then
  begin
    IntWheelStatus := IntWheelStatus + 4;
  end;

  //zC[l̃JEgAbv
  IntWheelCount := IntWheelCount+1;
  if IntWheelCount >= IntWheelCountNum then
  begin
    IntWheelCount := 0;
    bCountUp1 := TRUE;
  end
  else
  begin
    bCountUp1 := FALSE;
  end;

  //
  if bCountUp1 = TRUE then
  begin
    //
    if BoolWheelCount = TRUE then
    begin
      ;
    end
    else
    begin
      //
      BoolWheelCount := TRUE;
      if BoolWheelDirectionUp = TRUE then
      begin
        MenuMoveUpClick(Sender);
      end
      //
      else
      begin
        MenuMoveDownClick(Sender);
      end;
      //N
      Timer1.Enabled := TRUE;
    end;
  end;

  //Handled ́CRg[Cxgǂ܂B
  //Handled  false ɐݒ肷ƁCIuWFNg̐eCxg悤ɂ邱Ƃł܂B
  Handled := False;
end;

procedure TFormImageGrid.FormMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  BoolWheelDirectionUp := FALSE;
end;

procedure TFormImageGrid.FormMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  BoolWheelDirectionUp := TRUE;
end;

procedure TFormImageGrid.Image54DblClick(Sender: TObject);
begin
  MenuEnterClick(Sender);
end;

procedure TFormImageGrid.Image54MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
  begin
    MenuDispChangeClick(Sender);
  end;
end;



procedure TFormImageGrid.ThisListFilesDriveFileCount(DirName: String; TheList: TStringList);
var
  sStr2: string;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';

  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //f
      if BoolStop = TRUE then
      begin
        Break;
      end;

      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4 := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 := SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE);
        sstr6 := SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr7  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //
        end
        else
        begin
          //ǉ
//          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);
          TheList.Add(sStr3);

          //XV
          IntLocalCount := IntLocalCount+1;
          if (IntLocalCount mod 10) = 0 then
          begin
            Label52.Caption := IntToStr(IntLocalCount);
            Label52.Refresh;
            Application.ProcessMessages;
            Application.ProcessMessages;
          end;
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;

procedure TFormImageGrid.ShowImageGrid(Sender: TObject);
var
  iRow1: Integer;
  Graphics: TGPGraphics;
  SrcBmp: TGPBitMap;
  DstBmp: TBitMap;
  ResultBmp: TBitMap;
  ImageSrcWidth: Integer;
  ImageSrcHeight: Integer;
  iWidth2: integer;
  iHeight2: integer;
  iTop1: Integer;
  iLeft1: Integer;
  VerticalRate: Real;
  HorizontalRate: Real;

  sStr1: String;
  iMod1: Integer;
  iStart1: Integer;
  iEnd1: Integer;
  iYoko1: Integer;
  iTate1: Integer;

  GPBrush2: TGPSolidBrush;
  Rect2: TGPRect;
  iLeft2: Integer;
  iTop2: Integer;
  iDiameterWidth2: Integer;
  iDiameterHeight2: Integer;

  GPBrush3: TGPSolidBrush;
  Rect3: TGPRect;
  iLeft3: Integer;
  iTop3: Integer;
  iDiameterWidth3: Integer;
  iDiameterHeight3: Integer;
begin
  //ݒ
  Panel54.Color := colorBack;
  Panel56.Color := colorBack;

  //
  if Panel54.Visible = TRUE then
  begin
    //͈͓
    if IntImageIndex <= StrListFile.Count-1 then
    begin
      //쐬
      ResultBmp := TBitMap.Create;
      ResultBmp.Width  := Image54.Width;
      ResultBmp.Height := Image54.Height;
      ResultBmp.Canvas.Brush.Color := colorBack;
      ResultBmp.Canvas.FillRect(ResultBmp.Canvas.ClipRect);
      Graphics  := TGPGraphics.Create(ResultBmp.Canvas.Handle);

      // 1
      try
        //t@CmF
        sStr1 := StrListFile.Strings[IntImageIndex];
        if FileExists(sStr1) = TRUE then
        begin
          // 2
          try
            //t@Cǂݍ
            SrcBmp := TGPBitMap.Create(sStr1);
            DstBmp := TBitMap.Create;
            // 3
            try

              //p̐ݒ
              ImageSrcHeight  := SrcBmp.GetHeight;
              ImageSrcWidth   := SrcBmp.GetWidth;

              //摜TCY̏cƉ œKȏԂŕ\悤ɐݒ肷
              VerticalRate   := ImageSrcHeight / Panel54.ClientHeight;
              HorizontalRate := ImageSrcWidth  / Panel54.ClientWidth;
              if (VerticalRate > 1) and (HorizontalRate > 1) then
              begin
                if (VerticalRate >= HorizontalRate) then
                begin
                  iHeight2 := Image54.ClientHeight - IMAGE_EDGE_WIDTH;
                  iWidth2  := Round(iHeight2 * ImageSrcWidth / ImageSrcHeight);
                end
                else
                begin
                  iWidth2  := Image54.ClientWidth - IMAGE_EDGE_WIDTH;
                  iHeight2 := Round(iWidth2 * ImageSrcHeight / ImageSrcWidth);
                end;
              end
              else if (VerticalRate > 1) then
              begin
                iHeight2 := Image54.ClientHeight - IMAGE_EDGE_WIDTH;
                iWidth2  := Round(iHeight2 * ImageSrcWidth / ImageSrcHeight);
              end
              else if (HorizontalRate > 1) then
              begin
                iWidth2  := Image54.ClientWidth - IMAGE_EDGE_WIDTH;
                iHeight2 := Round(iWidth2 * ImageSrcHeight / ImageSrcWidth);
              end
              else
              begin
                iHeight2 := ImageSrcHeight;
                iWidth2  := ImageSrcWidth;
              end;

              //ݒ
              DstBmp.Width  := iWidth2;
              DstBmp.Height := iHeight2;

              //쐬eDstɔf
              iLeft1 := ((Image54.ClientWidth  - iWidth2 ) div 2);
              iTop1  := ((Image54.ClientHeight - iHeight2) div 2);
              Graphics.DrawImage (SrcBmp, iLeft1, iTop1, iWidth2, iHeight2);

              //ݒ
              iLeft2 := (Image54.ClientWidth div 2) - GRID_MARK_LEFT_ORIGINAL;
              iTop2  := GRID_MARK_TOP_ORIGINAL;
              iDiameterWidth2  := GRID_MARK_WIDTH_HEGHT;
              iDiameterHeight2 := GRID_MARK_WIDTH_HEGHT;

              //}[N
              if StrListMark.Strings[IntImageIndex] = FILE_MARK_ON then
              begin
                //TGPSolidBrush𐶐
                GPBrush2 := TGPSolidBrush.Create(ColorRefToARGB(colorMark));
                //`̈w
                Rect2 := MakeRect(iLeft2, iTop2, iDiameterWidth2, iDiameterHeight2);
                //`
                Graphics.FillEllipse(GPBrush2, Rect2);
                //
                GPBrush2.Free;
              end;

            // 3
            finally
              DstBmp.Free;
              SrcBmp.Free;
            end;
          // 2
          except
            //
          end;

        end;
        //\
        Image54.Picture.Graphic := ResultBmp;
      // 1
      finally
        //
        Graphics.Free;
        ResultBmp.Free;
      end;
    end
    //͈͊O
    else
    begin
      //\
      Image54.Picture := nil;
    end;
  end;

  //ꗗ
  if Panel56.Visible = TRUE then
  begin
    //ݒ
    iYoko1 := Image56.ClientWidth  div  IntImageWidthHeight;
    iTate1 := Image56.ClientHeight div  IntImageWidthHeight;
    IntYokoCount := iYoko1;
    IntTateCount := iTate1;


    //ݒ
    iStart1 := (IntImageIndex div (iYoko1 * iTate1)) * (iYoko1 * iTate1);
    iEnd1   := (IntImageIndex div (iYoko1 * iTate1)) * (iYoko1 * iTate1) + (iYoko1 * iTate1) - 1;
    if iEnd1 > StrListFile.Count-1 then
    begin
      iEnd1 :=StrListFile.Count-1;
    end;

    //쐬
    ResultBmp := TBitMap.Create;
    ResultBmp.Width  := Image56.Width;
    ResultBmp.Height := Image56.Height;
    ResultBmp.Canvas.Brush.Color := colorBack;
    ResultBmp.Canvas.FillRect(ResultBmp.Canvas.ClipRect);
    Graphics  := TGPGraphics.Create(ResultBmp.Canvas.Handle);

    // 1
    try
      //s
      for iRow1 := iStart1 to iEnd1 do
      begin
        //t@CmF
        sStr1 := StrListFile.Strings[iRow1];
        if FileExists(sStr1) = TRUE then
        begin
          // 2
          try
            //t@Cǂݍ
            SrcBmp := TGPBitMap.Create(sStr1);
            DstBmp := TBitMap.Create;
            // 3
            try

              //p̐ݒ
              ImageSrcHeight  := SrcBmp.GetHeight;
              ImageSrcWidth   := SrcBmp.GetWidth;

              //摜TCY̏cƉ œKȏԂŕ\悤ɐݒ肷
              VerticalRate   := ImageSrcHeight / IntImageWidthHeight;
              HorizontalRate := ImageSrcWidth  / IntImageWidthHeight;
              if (VerticalRate > 1) and (HorizontalRate > 1) then
              begin
                if (VerticalRate >= HorizontalRate) then
                begin
                  iHeight2 := IntImageWidthHeight - IMAGE_EDGE_WIDTH;
                  iWidth2  := Round(iHeight2 * ImageSrcWidth / ImageSrcHeight);
                end
                else
                begin
                  iWidth2  := IntImageWidthHeight - IMAGE_EDGE_WIDTH;
                  iHeight2 := Round(iWidth2 * ImageSrcHeight / ImageSrcWidth);
                end;
              end
              else if (VerticalRate > 1) then
              begin
                iHeight2 := IntImageWidthHeight - IMAGE_EDGE_WIDTH;
                iWidth2  := Round(iHeight2 * ImageSrcWidth / ImageSrcHeight);
              end
              else if (HorizontalRate > 1) then
              begin
                iWidth2  := IntImageWidthHeight - IMAGE_EDGE_WIDTH;
                iHeight2 := Round(iWidth2 * ImageSrcHeight / ImageSrcWidth);
              end
              else
              begin
                iHeight2 := ImageSrcHeight;
                iWidth2  := ImageSrcWidth;
              end;

              //ݒ
              DstBmp.Width  := iWidth2;
              DstBmp.Height := iHeight2;

              //쐬eDstɔf
              iLeft1 := (((iRow1 - iStart1) mod iYoko1) * GRID_WIDTH_HEGHT) + ((GRID_WIDTH_HEGHT - iWidth2 ) div 2);
              iTop1  := (((iRow1 - iStart1) div iYoko1) * GRID_WIDTH_HEGHT) + ((GRID_WIDTH_HEGHT - iHeight2) div 2);
              Graphics.DrawImage (SrcBmp, iLeft1, iTop1, iWidth2, iHeight2);

              //ݒ
              iLeft2 := (((iRow1 - iStart1) mod iYoko1) * GRID_WIDTH_HEGHT) + GRID_MARK_LEFT;
              iTop2  := (((iRow1 - iStart1) div iYoko1) * GRID_WIDTH_HEGHT) + GRID_MARK_TOP;
              iDiameterWidth2  := GRID_MARK_WIDTH_HEGHT;
              iDiameterHeight2 := GRID_MARK_WIDTH_HEGHT;

              //ݒ
              iLeft3 := (((iRow1 - iStart1) mod iYoko1) * GRID_WIDTH_HEGHT) + GRID_CURRENT_LEFT;
              iTop3  := (((iRow1 - iStart1) div iYoko1) * GRID_WIDTH_HEGHT) + GRID_CURRENT_TOP;
              iDiameterWidth3  := GRID_CURRENT_WIDTH_HEGHT;
              iDiameterHeight3 := GRID_CURRENT_WIDTH_HEGHT;

              //}[N
              if StrListMark.Strings[iRow1] = FILE_MARK_ON then
              begin
                //TGPSolidBrush𐶐
                GPBrush2 := TGPSolidBrush.Create(ColorRefToARGB(colorMark));
                //`̈w
                Rect2 := MakeRect(iLeft2, iTop2, iDiameterWidth2, iDiameterHeight2);
                //`
                Graphics.FillEllipse(GPBrush2, Rect2);
                //
                GPBrush2.Free;
              end;

              //Jg
              if iRow1 = IntImageIndex then
              begin
                //TGPSolidBrush𐶐
                GPBrush3 := TGPSolidBrush.Create(ColorRefToARGB(colorCurrent));
                //`̈w
                Rect3 := MakeRect(iLeft3, iTop3, iDiameterWidth3, iDiameterHeight3);
                //`
                Graphics.FillEllipse(GPBrush3, Rect3);
                //
                GPBrush3.Free;
              end;
            // 3
            finally
              DstBmp.Free;
              SrcBmp.Free;
            end;
          // 2
          except
            //
          end;

        end;
      end;
      //\
      Image56.Picture.Graphic := ResultBmp;
    // 1
    finally
      //
      Graphics.Free;
      ResultBmp.Free;
    end;
  end;

  //XV
  if StrListFile.Count > 0 then
  begin
    Label52.Caption := '[' + IntToStr(IntImageIndex+1) + '/' + IntToStr(StrListFile.Count) + '] ' +
                       ExtractFileName(StrListFile.Strings[IntImageIndex]);
    Label52.Refresh;
  end
  else
  begin
    Label52.Caption := '[' + IntToStr(0) + '/' + IntToStr(0) + '] ';
    Label52.Refresh;
  end;

end;

procedure TFormImageGrid.InitImageGrid(Sender: TObject);
begin
  //ݒ
  Panel54.Color := colorBack;
  Panel56.Color := colorBack;

  //
  if Panel54.Visible = TRUE then
  begin
    Image54.Picture := nil;
  end;

  //ꗗ
  if Panel56.Visible = TRUE then
  begin
    Image56.Picture := nil;
  end;


  //XV
  Label52.Caption := '[' + IntToStr(0) + '/' + IntToStr(0) + '] ';
  Label52.Refresh;

end;

procedure TFormImageGrid.MenuKeyBoardClick(Sender: TObject);
var
  bResult: Boolean;
begin

  //
  FormMain.IntKeyMapTypeIndex := KEYBORD_MAP_IMAGE_GRID;
  //
  FormKeyBoard := TFormKeyBoard.Create(Application);
  try
    //\
    if FormKeyBoard.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormKeyBoard.Free;
  end;

  //
  if bResult = TRUE then
  begin
    //ݒ
    SetShortCutKey(Sender);
  end;
end;

procedure TFormImageGrid.MenuEscapeClick(Sender: TObject);
begin
  if Panel55.Visible = TRUE then
  begin
    if BoolImageGrid = TRUE then
    begin
      Panel56.Visible := TRUE;
      Panel54.Visible := FALSE;
    end
    else
    begin
      Panel56.Visible := FALSE;
      Panel54.Visible := TRUE;
    end;

    Panel55.Visible := FALSE;
    Panel26.Width := 110;
    Panel27.Width :=  60;
    Panel28.Width :=  60;
    Panel29.Width :=  60;
    Panel30.Width :=  60;
    Panel31.Width :=  60;
    Panel32.Width :=  60;
    Panel33.Width :=   0;
    Panel26.Enabled := TRUE;
    Panel27.Enabled := TRUE;
    Panel28.Enabled := TRUE;
    Panel29.Enabled := TRUE;
    Panel30.Enabled := TRUE;
    Panel31.Enabled := TRUE;
    Panel32.Enabled := TRUE;
    Panel33.Enabled := FALSE;
    MenuEnter.Enabled       := TRUE;
    MenuMark.Enabled        := TRUE;
    MenuAllMarkFile.Enabled := TRUE;
    MenuMarkReverse.Enabled := TRUE;
    MenuDispChange.Enabled  := TRUE;
    MenuMoveTop.Enabled     := TRUE;
    MenuMovePrev.Enabled    := TRUE;
    MenuMoveUp.Enabled      := TRUE;
    MenuMoveDown.Enabled    := TRUE;
    MenuMoveNext.Enabled    := TRUE;
    MenuMoveEnd.Enabled     := TRUE;
    MenuKeyBoard.Enabled    := TRUE;
    MenuMarkColor.Enabled              := TRUE;
    MenuCurrentColor.Enabled           := TRUE;
    MenuBackColor.Enabled              := TRUE;

  end
  else
  begin
    if Panel54.Visible = TRUE then
    begin
      //ؑ
      MenuDispChangeClick(Sender);
    end
    else
    begin
      //I
      ModalResult := mrCancel;
    end;
  end;
end;

procedure TFormImageGrid.MenuCloseEscKeyClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  if MenuCloseESCkey.Checked = TRUE then
  begin
    MenuCloseESCkey.Checked := FALSE;
  end
  else
  begin
    MenuCloseESCkey.Checked := TRUE;
  end;
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool  ('GridImage', 'CloseESCkey',      MenuCloseEsckey.Checked);
  //j
  IniFile.Free;
end;

procedure TFormImageGrid.MenuEnterClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  iRow1: Integer;
begin
    if StrListFile.Count = 0 then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : TlCt@C܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Thumbnails file is not exist.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    for iRow1 := 0 to FormMain.StrListMarkImage.Count-1 do
    begin
      //擾
      if iRow1 = IntImageIndex then
      begin
        sStr1 := '1 ';
      end
      else
      begin
        sStr1 := '0 ';
      end;
      if StrListMark.Strings[iRow1] = FILE_MARK_ON then
      begin
        sStr2 := '1 ';
      end
      else
      begin
        sStr2 := '0 ';
      end;
      sStr3 := Copy(FormMain.StrListMarkImage.Strings[iRow1], 5, Length(FormMain.StrListMarkImage.Strings[iRow1]));
      //
      FormMain.StrListMarkImage.Strings[iRow1] := sStr1 + sStr2 + sStr3;
    end;

    //I
    ModalResult := mrOK;
end;

procedure TFormImageGrid.MenuFileListClick(Sender: TObject);
begin
  if Panel55.Visible = TRUE then
  begin
    MenuEscapeClick(Sender);
  end
  else
  begin
    //ݒ
    BoolTextSort := FALSE;

    //\
    ShowText(Sender);

    //ؑ
    Panel54.Visible := FALSE;
    Panel55.Visible := TRUE;
    Panel56.Visible := FALSE;

    Panel26.Width :=   0;
    Panel27.Width :=   0;
    Panel28.Width :=   0;
    Panel29.Width :=   0;
    Panel30.Width :=   0;
    Panel31.Width :=   0;
    Panel32.Width :=   0;
    Panel33.Width := 110;
    Panel26.Enabled := FALSE;
    Panel27.Enabled := FALSE;
    Panel28.Enabled := FALSE;
    Panel29.Enabled := FALSE;
    Panel30.Enabled := FALSE;
    Panel31.Enabled := FALSE;
    Panel32.Enabled := FALSE;
    Panel33.Enabled := TRUE;

    MenuEnter.Enabled       := FALSE;
    MenuMark.Enabled        := FALSE;
    MenuAllMarkFile.Enabled := FALSE;
    MenuMarkReverse.Enabled := FALSE;
    MenuDispChange.Enabled  := FALSE;
    MenuMoveTop.Enabled     := FALSE;
    MenuMovePrev.Enabled    := FALSE;
    MenuMoveUp.Enabled      := FALSE;
    MenuMoveDown.Enabled    := FALSE;
    MenuMoveNext.Enabled    := FALSE;
    MenuMoveEnd.Enabled     := FALSE;
    MenuKeyBoard.Enabled    := FALSE;
    MenuMarkColor.Enabled              := FALSE;
    MenuCurrentColor.Enabled           := FALSE;
    MenuBackColor.Enabled              := FALSE;

  end;
end;

procedure TFormImageGrid.MenuMoveTopClick(Sender: TObject);
var
  iRow1: Integer;
begin

  if StrListFile.Count > 0 then
  begin
    //
    if IntImageIndex = 0 then
    begin
      Exit;
    end;

    //
    if BoolImageShowing = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageShowing := TRUE;

    //ݒ
    IntImageIndex := 0;
    //Obh\
    ShowImageGrid(Sender);

    for iRow1 := 0 to LOOP_TIME1 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //XV
    BoolImageShowing := FALSE;
  end;
end;

procedure TFormImageGrid.MenuMovePrevClick(Sender: TObject);
var
  iRow1: Integer;
begin

  if StrListFile.Count > 0 then
  begin
    //
    if IntImageIndex = 0 then
    begin
      Exit;
    end;

    //
    if BoolImageShowing = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageShowing := TRUE;

    //ݒ
    IntImageIndex := IntImageIndex - (IntYokoCount * IntTateCount);
    if IntImageIndex < 0 then
    begin
      IntImageIndex := 0;
    end;
    //Obh\
    ShowImageGrid(Sender);

    for iRow1 := 0 to LOOP_TIME1 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //XV
    BoolImageShowing := FALSE;
  end;
end;

procedure TFormImageGrid.MenuMoveUpClick(Sender: TObject);
var
  iRow1: Integer;
begin

  if StrListFile.Count > 0 then
  begin
    //
    if IntImageIndex = 0 then
    begin
      Exit;
    end;

    //
    if BoolImageShowing = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageShowing := TRUE;

    //ݒ
    IntImageIndex := IntImageIndex - 1;
    //Obh\
    ShowImageGrid(Sender);

    for iRow1 := 0 to LOOP_TIME1 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //XV
    BoolImageShowing := FALSE;
  end;
end;

procedure TFormImageGrid.MenuQuitClick(Sender: TObject);
begin
  if Panel55.Visible = TRUE then
  begin
    if BoolImageGrid = TRUE then
    begin
      Panel56.Visible := TRUE;
      Panel54.Visible := FALSE;
    end
    else
    begin
      Panel56.Visible := FALSE;
      Panel54.Visible := TRUE;
    end;

    Panel55.Visible := FALSE;
    Panel26.Width := 110;
    Panel27.Width :=  60;
    Panel28.Width :=  60;
    Panel29.Width :=  60;
    Panel30.Width :=  60;
    Panel31.Width :=  60;
    Panel32.Width :=  60;
    Panel33.Width :=   0;
    Panel26.Enabled := TRUE;
    Panel27.Enabled := TRUE;
    Panel28.Enabled := TRUE;
    Panel29.Enabled := TRUE;
    Panel30.Enabled := TRUE;
    Panel31.Enabled := TRUE;
    Panel32.Enabled := TRUE;
    Panel33.Enabled := FALSE;
    MenuEnter.Enabled       := TRUE;
    MenuMark.Enabled        := TRUE;
    MenuAllMarkFile.Enabled := TRUE;
    MenuMarkReverse.Enabled := TRUE;
    MenuDispChange.Enabled  := TRUE;
    MenuMoveTop.Enabled     := TRUE;
    MenuMovePrev.Enabled    := TRUE;
    MenuMoveUp.Enabled      := TRUE;
    MenuMoveDown.Enabled    := TRUE;
    MenuMoveNext.Enabled    := TRUE;
    MenuMoveEnd.Enabled     := TRUE;
    MenuKeyBoard.Enabled    := TRUE;
    MenuMarkColor.Enabled              := TRUE;
    MenuCurrentColor.Enabled           := TRUE;
    MenuBackColor.Enabled              := TRUE;

  end
  else
  begin
    if Panel54.Visible = TRUE then
    begin
      //ؑ
      MenuDispChangeClick(Sender);
    end
    else
    begin
      //I
      ModalResult := mrCancel;
    end;
  end;
end;

procedure TFormImageGrid.MenuMarkClick(Sender: TObject);
var
  iRow1: Integer;
begin

  if StrListFile.Count > 0 then
  begin
    //
    if BoolImageMarking = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageMarking := TRUE;

    if StrListMark.Strings[IntImageIndex] = FILE_MARK_ON then
    begin
      StrListMark.Strings[IntImageIndex] := FILE_MARK_CLEAR;
    end
    else
    begin
      StrListMark.Strings[IntImageIndex] := FILE_MARK_ON;
    end;

    if IntImageIndex = (StrListMark.Count-1) then
    begin
      //Obh\
      ShowImageGrid(Sender);
    end
    else
    begin
      //ړ
      MenuMoveDownClick(Sender);
    end;

    for iRow1 := 0 to LOOP_TIME3 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //XV
    BoolImageMarking := FALSE;
  end;
end;

procedure TFormImageGrid.MenuMarkColorClick(Sender: TObject);
begin
  if ColorDialog1.Execute = TRUE then
  begin
    //ݒ
    ColorMark := ColorDialog1.Color;

    //
    if BoolImageShowing = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageShowing := TRUE;

    //Obh
    InitImageGrid(Sender);

    //Obh\
    ShowImageGrid(Sender);

    //XV
    BoolImageShowing := FALSE;
  end
end;

procedure TFormImageGrid.MenuCurrentColorClick(Sender: TObject);
begin
  if ColorDialog2.Execute = TRUE then
  begin
    //ݒ
    ColorCurrent := ColorDialog2.Color;

    //
    if BoolImageShowing = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageShowing := TRUE;

    //Obh
    InitImageGrid(Sender);

    //Obh\
    ShowImageGrid(Sender);

    //XV
    BoolImageShowing := FALSE;
  end
end;

procedure TFormImageGrid.MenuBackColorClick(Sender: TObject);
begin
  if ColorDialog3.Execute = TRUE then
  begin
    //ݒ
    ColorBack := ColorDialog3.Color;

    //
    if BoolImageShowing = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageShowing := TRUE;

    //Obh
    InitImageGrid(Sender);

    //Obh\
    ShowImageGrid(Sender);

    //XV
    BoolImageShowing := FALSE;
  end
end;

procedure TFormImageGrid.MenuAllMarkFileClick(Sender: TObject);
var
  iRow1: Integer;
  iFind1: Integer;
begin

  if StrListFile.Count > 0 then
  begin
    //
    if BoolImageMarking = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageMarking := TRUE;


    //}[NT
    iFind1 := -1;
    for iRow1 := 0 to StrListMark.Count-1 do
    begin
      if StrListMark.Strings[iRow1] = FILE_MARK_ON then
      begin
        iFind1 := iRow1;
        Break;
      end;
    end;

    //}[N𔽓]
    for iRow1 := 0 to StrListMark.Count-1 do
    begin
      if iFind1 = -1 then
      begin
        StrListMark.Strings[iRow1] := FILE_MARK_ON;
      end
      else
      begin
        StrListMark.Strings[iRow1] := FILE_MARK_CLEAR;
      end;
    end;

    //Obh\
    ShowImageGrid(Sender);

    for iRow1 := 0 to LOOP_TIME3 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //XV
    BoolImageMarking := FALSE;
  end;

end;

procedure TFormImageGrid.MenuMarkReverseClick(Sender: TObject);
var
  iRow1: Integer;
begin

  if StrListFile.Count > 0 then
  begin
    //
    if BoolImageMarking = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageMarking := TRUE;


    //}[N𔽓]
    for iRow1 := 0 to StrListMark.Count-1 do
    begin
      if StrListMark.Strings[iRow1] = FILE_MARK_ON then
      begin
        StrListMark.Strings[iRow1] := FILE_MARK_CLEAR;
      end
      else
      begin
        StrListMark.Strings[iRow1] := FILE_MARK_ON;
      end;
    end;

    //Obh\
    ShowImageGrid(Sender);

    for iRow1 := 0 to LOOP_TIME3 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //XV
    BoolImageMarking := FALSE;
  end;

end;

procedure TFormImageGrid.MenuMoveDownClick(Sender: TObject);
var
  iRow1: Integer;
begin

  if StrListFile.Count > 0 then
  begin
    //
    if IntImageIndex = StrListFile.Count -1 then
    begin
      Exit;
    end;

    //
    if BoolImageShowing = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageShowing := TRUE;

    //ݒ
    IntImageIndex := IntImageIndex + 1;
    //Obh\
    ShowImageGrid(Sender);

    for iRow1 := 0 to LOOP_TIME1 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //XV
    BoolImageShowing := FALSE;
  end;
end;

procedure TFormImageGrid.MenuMoveNextClick(Sender: TObject);
var
  iRow1: Integer;
begin

  if StrListFile.Count > 0 then
  begin
    //
    if IntImageIndex = StrListFile.Count -1 then
    begin
      Exit;
    end;

    //
    if BoolImageShowing = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageShowing := TRUE;

    //ݒ
    IntImageIndex := IntImageIndex + (IntYokoCount * IntTateCount);
    if IntImageIndex > StrListFile.Count -1 then
    begin
      IntImageIndex := StrListFile.Count -1;
    end;
    //Obh\
    ShowImageGrid(Sender);

    for iRow1 := 0 to LOOP_TIME1 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //XV
    BoolImageShowing := FALSE;
  end;
end;

procedure TFormImageGrid.MenuMoveEndClick(Sender: TObject);
var
  iRow1: Integer;
begin

  if StrListFile.Count > 0 then
  begin
    //
    if IntImageIndex = StrListFile.Count -1 then
    begin
      Exit;
    end;

    //
    if BoolImageShowing = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageShowing := TRUE;

    //ݒ
    IntImageIndex := StrListFile.Count-1;
    //Obh\
    ShowImageGrid(Sender);

    for iRow1 := 0 to LOOP_TIME1 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //XV
    BoolImageShowing := FALSE;
  end;
end;

procedure TFormImageGrid.MenuDispChangeClick(Sender: TObject);
begin
    //
    if BoolImageShowing = TRUE then
    begin
      Exit;
    end;
    //XV
    BoolImageShowing := TRUE;

    //Obh
    InitImageGrid(Sender);

    if Panel56.Visible = TRUE then
    begin
      Panel56.Visible := FALSE;
      Panel54.Visible := TRUE;
      BoolImageGrid   := FALSE;
    end
    else
    begin
      Panel56.Visible := TRUE;
      Panel54.Visible := FALSE;
      BoolImageGrid   := TRUE;
    end;

    //Obh\
    ShowImageGrid(Sender);

    //XV
    BoolImageShowing := FALSE;
end;

procedure TFormImageGrid.Timer1Timer(Sender: TObject);
begin
  //Zbg
  Timer1.Enabled := FALSE;

  //Zbg
  BoolWheelCount := FALSE;
end;

procedure TFormImageGrid.Timer2Timer(Sender: TObject);
var
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr9: String;
  iRow1: Integer;
  iNum1: Integer;
  iPos1: Integer;
  iFind1: Integer;
begin
  //Zbg
  Timer2.Enabled := FALSE;

  //
  iPos1 := Pos(UpperCase(StrThumbNailFolder), UpperCase(FormMain.StrCurrent));
  //TlCtH_ȊO
  if iPos1 = 0 then
  begin
    //NA
    StrListMark.Clear;
    StrListMark.Sorted := FALSE;
    StrListFile.Clear;
    StrListFile.Sorted := FALSE;
    StrListErrorFile.Clear;
    StrListErrorFile.Sorted := FALSE;
    IntImageIndex := 0;

    //
    for iRow1 := 0 to FormMain.StrListMarkImage.Count-1 do
    begin
      //擾
      sStr2 := Copy(FormMain.StrListMarkImage.Strings[iRow1], 11, Length(FormMain.StrListMarkImage.Strings[iRow1]));
      sStr3 := Copy(sStr2, 1, 1) + Copy(sStr2, 3, Length(sStr2));
      sStr4 := Copy(FormMain.StrListMarkImage.Strings[iRow1], 3, 1);
      sStr5 := Copy(FormMain.StrListMarkImage.Strings[iRow1], 1, 1);
      sStr9 := StrThumbNailFolder + sStr3;
      //TlC̃t@C
      sStr6 := sStr9 + '.WIC.JPG';
      sStr7 := sStr9 + '.GDI.JPG';

      //t@C
      if      FileExists(sStr6) = TRUE then
      begin
        StrListFile.Add(sStr6);
        StrListErrorFile.Add(FILE_MARK_OFF + ' ' + sStr6);
      end
      else if FileExists(sStr7) = TRUE then
      begin
        StrListFile.Add(sStr7);
        StrListErrorFile.Add(FILE_MARK_OFF + ' ' + sStr7);
      end
      else
      begin
        StrListFile.Add('');
        StrListErrorFile.Add(FILE_MARK_NOT_EXIST + ' ' + sStr9);
      end;

      //CfNX
      if sStr5 = '1' then
      begin
        IntImageIndex := iRow1;
      end;

      //}[N
      if sStr4 = '1' then
      begin
        StrListMark.Add(FILE_MARK_ON);
      end
      else
      begin
        StrListMark.Add(FILE_MARK_CLEAR);
      end;

      //XV
      if (StrListFile.Count mod 10) = 0 then
      begin
        Label52.Caption := IntToStr(StrListFile.Count);
        Label52.Refresh;
        Application.ProcessMessages;
        Application.ProcessMessages;
      end;
    end;

    //XV
    Label52.Caption := IntToStr(StrListFile.Count);
    Label52.Refresh;

    for iRow1 := 0 to LOOP_TIME2 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //Tlt@Cꍇ̏
    iFind1 := -1;
    iNum1  := 0;
    for iRow1 := 0 to StrListFile.Count-1 do
    begin
      if StrListFile.Strings[iRow1] = '' then
      begin
        iFind1 := iRow1;
        iNum1 := iNum1+1;
      end;
    end;
    if iFind1 = -1 then
    begin
      //Obh\
      ShowImageGrid(Sender);
    end
    else
    begin
      Label52.Caption := '[' + IntToStr(StrListFile.Count) + ']';
      Label52.Refresh;
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ' + IntToStr(StrListFile.Count) + ' ̂ ' +
                            IntToStr(iNum1) + ' ̃TlCt@C܂' + #13#10 +
                           'uv́ut@CXg\vŃt@Cꗗ\܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Total ' + IntToStr(StrListFile.Count) + ' files, but ' +
                            IntToStr(iNum1) + ' files are not exist.' + #13#10 +
                           'File list show [Show File List] in [Operation] by Menu.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      StrListFile.Clear;
    end;

  end
  //TlCtH_
  else
  begin
    //NA
    StrListMark.Clear;
    StrListMark.Sorted := FALSE;
    StrListFile.Clear;
    StrListFile.Sorted := FALSE;
    StrListErrorFile.Clear;
    StrListErrorFile.Sorted := FALSE;
    IntImageIndex := 0;

    //
    for iRow1 := 0 to FormMain.StrListMarkImage.Count-1 do
    begin
      //擾
      sStr2 := Copy(FormMain.StrListMarkImage.Strings[iRow1], 11, Length(FormMain.StrListMarkImage.Strings[iRow1]));
      sStr4 := Copy(FormMain.StrListMarkImage.Strings[iRow1], 3, 1);
      sStr5 := Copy(FormMain.StrListMarkImage.Strings[iRow1], 1, 1);

      //t@C
      if      FileExists(sStr2) = TRUE then
      begin
        StrListFile.Add(sStr2);
        StrListErrorFile.Add(FILE_MARK_OFF + ' ' + sStr2);
      end
      else
      begin
        StrListFile.Add('');
        StrListErrorFile.Add(FILE_MARK_NOT_EXIST + ' ' + sStr2);
      end;

      //CfNX
      if sStr5 = '1' then
      begin
        IntImageIndex := iRow1;
      end;

      //}[N
      if sStr4 = '1' then
      begin
        StrListMark.Add(FILE_MARK_ON);
      end
      else
      begin
        StrListMark.Add(FILE_MARK_CLEAR);
      end;

      //XV
      if (StrListFile.Count mod 10) = 0 then
      begin
        Label52.Caption := IntToStr(StrListFile.Count);
        Label52.Refresh;
        Application.ProcessMessages;
        Application.ProcessMessages;
      end;
    end;

    //XV
    Label52.Caption := IntToStr(StrListFile.Count);
    Label52.Refresh;

    for iRow1 := 0 to LOOP_TIME2 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //Tlt@Cꍇ̏
    iFind1 := -1;
    iNum1  := 0;
    for iRow1 := 0 to StrListFile.Count-1 do
    begin
      if StrListFile.Strings[iRow1] = '' then
      begin
        iFind1 := iRow1;
        iNum1 := iNum1+1;
      end;
    end;
    if iFind1 = -1 then
    begin
      //Obh\
      ShowImageGrid(Sender);
    end
    else
    begin
      Label52.Caption := '[' + IntToStr(StrListFile.Count) + ']';
      Label52.Refresh;
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ' + IntToStr(StrListFile.Count) + ' ̂ ' +
                            IntToStr(iNum1) + ' ̃TlCt@C܂' + #13#10 +
                           'uv́ut@CXg\vŃt@Cꗗ\܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Total ' + IntToStr(StrListFile.Count) + ' files, but ' +
                            IntToStr(iNum1) + ' files are not exist.' + #13#10 +
                           'File list show [Show File List] in [Operation] by Menu.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      StrListFile.Clear;
    end;


  end;

end;

procedure TFormImageGrid.Timer3Timer(Sender: TObject);
begin
  //Zbg
  Timer3.Enabled := FALSE;

  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[hti쐬jł' + #13#10 +
                         '\[g[htiŏIXVjŎ擾܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Creation).' + #13#10 +
                         'But, get time by Date(LastWrite).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[htiŏIANZXjł' +#13#10 +
                         '\[g[htiŏIXVjŎ擾܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Last Access).' + #13#10 +
                         'But, get time by Date(LastWrite).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormImageGrid.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //Ǎ
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_IMAGE_GRID_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    FormMain.StrListKeyMapImageGrid.LoadFromFile(sStr1, TEncoding.Unicode);
  end
  //t@CȂꍇ́AftHgŐݒ肳ĂeɂȂĂ
  else
  begin
    FormMain.StrListKeyMapImageGrid.SaveToFile(sStr1, TEncoding.Unicode);
  end;


  //ݒ
  if FormMain.StrListKeyMapImageGrid.Count > 0 then
  begin

    SetShortCutNew('1001', MenuEnter, Sender);
    SetShortCutNew('1002', MenuEscape, Sender);
    SetShortCutNew('1003', MenuQuit, Sender);

    SetShortCutNew('1101', MenuFileList, Sender);
    SetShortCutNew('1102', MenuMark, Sender);
    SetShortCutNew('1103', MenuAllMarkFile, Sender);
    SetShortCutNew('1104', MenuMarkReverse, Sender);
    SetShortCutNew('1105', MenuDispChange, Sender);

    SetShortCutNew('1201', MenuMoveTop, Sender);
    SetShortCutNew('1202', MenuMovePrev, Sender);
    SetShortCutNew('1203', MenuMoveUp, Sender);
    SetShortCutNew('1204', MenuMoveDown, Sender);
    SetShortCutNew('1205', MenuMoveNext, Sender);
    SetShortCutNew('1206', MenuMoveEnd, Sender);

    SetShortCutNew('1301', MenuCloseEscKey, Sender);
    SetShortCutNew('1302', MenuKeyBoard, Sender);
    SetShortCutNew('1303', MenuMarkColor, Sender);
    SetShortCutNew('1304', MenuCurrentColor, Sender);
    SetShortCutNew('1305', MenuBackColor, Sender);

  end;

end;


procedure TFormImageGrid.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to FormMain.StrListKeyMapImageGrid.Count-1 do
  begin
    //擾
    sStr11 := FormMain.StrListKeyMapImageGrid.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //ݒ
    sStr3 := '';
  end
  else
  begin
    //ݒ
    sStr3 := sStr16;
  end;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

procedure TFormImageGrid.InitKeyMap(ExeType: Integer; Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  //NA
  FormMain.StrListKeyMapOriginalImageGrid.Clear;

  //File
  sStr1 :=                FormImageGrid.MenuEnter.Caption;
  sStr2 := ShortCutToText(scShift + VK_RETURN);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1001');

  sStr1 :=                FormImageGrid.Menuescape.Caption;
  sStr2 := ShortCutToText(VK_ESCAPE);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1002');

  sStr1 :=                FormImageGrid.Menuescape.Caption;
  sStr2 := ShortCutToText(VK_Q);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1003');

  //Operation
  sStr1 :=                FormImageGrid.MenuFileList.Caption;
  sStr2 := ShortCutToText(0);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1101');

  sStr1 :=                FormImageGrid.MenuMark.Caption;
  sStr2 := ShortCutToText(VK_SPACE);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1102');

  sStr1 :=                FormImageGrid.MenuAllMarkFile.Caption;
  sStr2 := ShortCutToText(VK_HOME);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1103');

  sStr1 :=                FormImageGrid.MenuMarkReverse.Caption;
  sStr2 := ShortCutToText(scCtrl + VK_Z);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1104');

  sStr1 :=                FormImageGrid.MenuDispChange.Caption;
  sStr2 := ShortCutToText(VK_RETURN);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_OPERATION + #09 + sStr1 + #09 + sStr2 + #09 + '1105');

  //Move
  sStr1 :=                FormImageGrid.MenuMoveTop.Caption;
  sStr2 := ShortCutToText(0);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1201');

  sStr1 :=                FormImageGrid.MenuMovePrev.Caption;
  sStr2 := ShortCutToText(VK_LEFT);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1202');

  sStr1 :=                FormImageGrid.MenuMoveUp.Caption;
  sStr2 := ShortCutToText(VK_UP);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1203');

  sStr1 :=                FormImageGrid.MenuMoveDown.Caption;
  sStr2 := ShortCutToText(VK_DOWN);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1204');

  sStr1 :=                FormImageGrid.MenuMoveNext.Caption;
  sStr2 := ShortCutToText(VK_RIGHT);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1205');

  sStr1 :=                FormImageGrid.MenuMoveEnd.Caption;
  sStr2 := ShortCutToText(0);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1206');

  //Setting
  sStr1 :=                FormImageGrid.MenuCloseEscKey.Caption;
  sStr2 := ShortCutToText(0);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_SETTING + #09 + sStr1 + #09 + sStr2 + #09 + '1301');

  sStr1 :=                FormImageGrid.MenuKeyBoard.Caption;
  sStr2 := ShortCutToText(0);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_SETTING + #09 + sStr1 + #09 + sStr2 + #09 + '1302');

  sStr1 :=                FormImageGrid.MenuMarkColor.Caption;
  sStr2 := ShortCutToText(0);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_SETTING + #09 + sStr1 + #09 + sStr2 + #09 + '1303');

  sStr1 :=                FormImageGrid.MenuCurrentColor.Caption;
  sStr2 := ShortCutToText(0);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_SETTING + #09 + sStr1 + #09 + sStr2 + #09 + '1304');

  sStr1 :=                FormImageGrid.MenuBackColor.Caption;
  sStr2 := ShortCutToText(0);
  FormMain.StrListKeyMapOriginalImagegrid.Add(SHORTCUT_ITEM_SETTING + #09 + sStr1 + #09 + sStr2 + #09 + '1305');


end;


procedure TFormImageGrid.Panel25Click(Sender: TObject);
begin
  MenuEscapeClick(Sender);
end;

procedure TFormImageGrid.Panel26Click(Sender: TObject);
begin
  MenuDispChangeClick(Sender);
end;

procedure TFormImageGrid.Panel27Click(Sender: TObject);
begin
  MenuMoveTopClick(Sender);
end;

procedure TFormImageGrid.Panel28Click(Sender: TObject);
begin
  MenuMovePrevClick(Sender);
end;

procedure TFormImageGrid.Panel29Click(Sender: TObject);
begin
  MenuMoveUpClick(Sender);
end;

procedure TFormImageGrid.Panel30Click(Sender: TObject);
begin
  MenuMoveDownClick(Sender);
end;

procedure TFormImageGrid.Panel31Click(Sender: TObject);
begin
  MenuMoveNextClick(Sender);
end;

procedure TFormImageGrid.Panel32Click(Sender: TObject);
begin
  MenuMoveEndClick(Sender);
end;

procedure TFormImageGrid.Panel33Click(Sender: TObject);
begin
  if BoolTextSort = TRUE then
  begin
    BoolTextSort := FALSE;
  end
  else
  begin
    BoolTextSort := TRUE;
  end;
  //\
  ShowText(Sender);
end;

procedure TFormImageGrid.ShowText(Sender: TObject);
var
  StrList1: TStringList;
  iRow1: Integer;
  iFind1: Integer;
begin
    //
    iFind1 := -1;
    for iRow1 := 0 to StrListErrorFile.Count-1 do
    begin
      if Copy(StrListErrorFile.Strings[iRow1], 1, 1) = FILE_MARK_NOT_EXIST then
      begin
        iFind1 := iRow1;
        Break;
      end;
    end;

    //G[
    if iFind1 <> -1 then
    begin
      //ݒ
      StrList1 := TStringList.Create;
      if BoolTextSort = FALSE then
      begin
        for iRow1 := 0 to StrListErrorFile.Count-1 do
        begin
          StrList1.Add(StrListErrorFile.Strings[iRow1]);
        end;
      end
      else
      begin
        for iRow1 := 0 to StrListErrorFile.Count-1 do
        begin
          if Copy(StrListErrorFile.Strings[iRow1], 1, 1) =  FILE_MARK_NOT_EXIST then
          begin
            StrList1.Add(StrListErrorFile.Strings[iRow1]);
          end;
        end;
        for iRow1 := 0 to StrListErrorFile.Count-1 do
        begin
          if Copy(StrListErrorFile.Strings[iRow1], 1, 1) <> FILE_MARK_NOT_EXIST then
          begin
            StrList1.Add(StrListErrorFile.Strings[iRow1]);
          end;
        end;
      end;
      Memo1.Lines.BeginUpdate;
      Memo1.Lines.Assign(StrList1);
      Memo1.Lines.EndUpdate;
      StrList1.Free;
    end
    //G[Ȃ
    else
    begin
      //ݒ
      StrList1 := TStringList.Create;
      for iRow1 := 0 to StrListFile.Count-1 do
      begin
        if StrListMark.Strings[iRow1] = FILE_MARK_ON then
        begin
          StrList1.Add(FILE_MARK_ON  + ' ' + StrListFile.Strings[iRow1]);
        end
        else
        begin
          StrList1.Add(FILE_MARK_OFF + ' ' + StrListFile.Strings[iRow1]);
        end;
      end;
      Memo1.Lines.BeginUpdate;
      Memo1.Lines.Assign(StrList1);
      Memo1.Lines.EndUpdate;
      StrList1.Free;
    end;
end;

procedure TFormImageGrid.Image56DblClick(Sender: TObject);
var
  Pt1: TPoint;
  Pt2: TPoint;
  iFindTate1: Integer;
  iFindYoko1: Integer;
  iRow1: Integer;
  iStart1: Integer;
  iIndex1: Integer;
  iIndex2: Integer;
begin
  //
  if StrListFile.Count = 0 then
  begin
    Exit;
  end;

  //}EX XN[ʒu
  GetCursorPos(Pt1);
  //}EX NCAgʒu
  Pt2 := ScreenToClient(Pt1);

  //
  iFindYoko1 := 0;
  for iRow1 := 0 to IntYokoCount-1 do
  begin
    if ((IntImageWidthHeight * (iRow1+0)) <= Pt2.X ) and (Pt2.X <=(IntImageWidthHeight * (iRow1+1))) then
    begin
      iFindYoko1 := iRow1;
    end;
  end;

  //
  iFindTate1 := 0;
  for iRow1 := 0 to IntTateCount-1 do
  begin
    if ((IntImageWidthHeight * (iRow1+0)) <= Pt2.Y ) and (Pt2.Y <=(IntImageWidthHeight * (iRow1+1))) then
    begin
      iFindTate1 := iRow1;
    end;
  end;

  //CfNXʒu
  iIndex1 := (iFindTate1 * IntYokoCount) + iFindYoko1;
  iStart1 := (IntImageIndex div (IntYokoCount * IntTateCount)) * (IntYokoCount * IntTatecount);
  iIndex2 := iStart1 + iIndex1;

  //͈͊O
  if iIndex2 > StrListFile.Count-1 then
  begin
    Exit;
  end;

  //ݒ
  IntImageIndex := iIndex2;
  //m
  MenuEnterClick(Sender);

end;

procedure TFormImageGrid.Image56MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Pt1: TPoint;
  Pt2: TPoint;
  iFindTate1: Integer;
  iFindYoko1: Integer;
  iRow1: Integer;
  iStart1: Integer;
  iIndex1: Integer;
  iIndex2: Integer;
begin
  //
  if StrListFile.Count = 0 then
  begin
    Exit;
  end;

  //}EX XN[ʒu
  GetCursorPos(Pt1);
  //}EX NCAgʒu
  Pt2 := ScreenToClient(Pt1);

  //
  iFindYoko1 := 0;
  for iRow1 := 0 to IntYokoCount-1 do
  begin
    if ((IntImageWidthHeight * (iRow1+0)) <= Pt2.X ) and (Pt2.X <=(IntImageWidthHeight * (iRow1+1))) then
    begin
      iFindYoko1 := iRow1;
    end;
  end;

  //
  iFindTate1 := 0;
  for iRow1 := 0 to IntTateCount-1 do
  begin
    if ((IntImageWidthHeight * (iRow1+0)) <= Pt2.Y ) and (Pt2.Y <=(IntImageWidthHeight * (iRow1+1))) then
    begin
      iFindTate1 := iRow1;
    end;
  end;

  //CfNXʒu
  iIndex1 := (iFindTate1 * IntYokoCount) + iFindYoko1;
  iStart1 := (IntImageIndex div (IntYokoCount * IntTateCount)) * (IntYokoCount * IntTatecount);
  iIndex2 := iStart1 + iIndex1;

  //͈͊O
  if iIndex2 > StrListFile.Count-1 then
  begin
    Exit;
  end;

  //ݒ
  IntImageIndex := iIndex2;
  //Obh\
  ShowImageGrid(Sender);

  if (Button = mbRight) then
  begin
    MenuDispChangeClick(Sender);
  end;
end;

end.
