unit ImageTimeStamp;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_PLATFORM OFF} //W1002

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, DecEdit, Vcl.StdCtrls, Vcl.Imaging.jpeg,
  IniFiles, MyUtility,  System.IOUtils, GDIPAPI, GDIPOBJ, GDIPUTIL;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 560;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  IMAGE_EDGE_WIDTH1     = 0;

type
  TFormImageTimeStamp = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label4: TLabel;
    DecEdit1: TDecEdit;
    DecEdit2: TDecEdit;
    DecEdit3: TDecEdit;
    DecEdit4: TDecEdit;
    DecEdit5: TDecEdit;
    DecEdit6: TDecEdit;
    Image1: TImage;
    ListBox1: TListBox;
    Label5: TLabel;
    DecEdit11: TDecEdit;
    DecEdit12: TDecEdit;
    DecEdit13: TDecEdit;
    Label6: TLabel;
    DecEdit14: TDecEdit;
    DecEdit15: TDecEdit;
    DecEdit16: TDecEdit;
    ButtonSkip: TButton;
    ButtonUp: TButton;
    ButtonDown: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Timer1: TTimer;
    Label11: TLabel;
    Label9: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonSkipClick(Sender: TObject);
    procedure ButtonDownClick(Sender: TObject);
    procedure ButtonUpClick(Sender: TObject);

    procedure DecEditKeyPress(Sender: TObject; var Key: Char);

    procedure ListBox1Click(Sender: TObject);

    procedure ShowImage(FileName: String; Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    CsvList1: TStringList;
    CsvList2: TStringList;
    StrList1: TStringList;
    StrListExif: TStringList;
    IntImageWidthHeight: Integer;
    IntAutoRotateIndex: Integer;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormImageTimeStamp: TFormImageTimeStamp;

implementation

uses
  Main, ExifData;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormImageTimeStamp.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormImageTimeStamp.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormImageTimeStamp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormImageTimeStamp.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormImageTimeStamp.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormImageTimeStamp', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormImageTimeStamp', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormImageTimeStamp', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormImageTimeStamp', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormImageTimeStamp', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //
  Timer1.Enabled := FALSE;

  //쐬
  CsvList1 := TStringList.Create;;
  CsvList2 := TStringList.Create;;
  StrList1 := TStringList.Create;;
  StrListExif := TStringList.Create;

  //ݒ
  Edit1.ReadOnly       := TRUE;
  DecEdit1.ReadOnly    := TRUE;
  DecEdit2.ReadOnly    := TRUE;
  DecEdit3.ReadOnly    := TRUE;
  DecEdit4.ReadOnly    := TRUE;
  DecEdit5.ReadOnly    := TRUE;
  DecEdit6.ReadOnly    := TRUE;
  DecEdit11.ReadOnly   := TRUE;
  DecEdit12.ReadOnly   := TRUE;
  DecEdit13.ReadOnly   := TRUE;
  DecEdit14.ReadOnly   := TRUE;
  DecEdit15.ReadOnly   := TRUE;
  DecEdit16.ReadOnly   := TRUE;

  Edit1.Font.Color     := clBlue;
  DecEdit1.Font.Color  := clBlue;
  DecEdit2.Font.Color  := clBlue;
  DecEdit3.Font.Color  := clBlue;
  DecEdit4.Font.Color  := clBlue;
  DecEdit5.Font.Color  := clBlue;
  DecEdit6.Font.Color  := clBlue;
  DecEdit11.Font.Color := clBlue;
  DecEdit12.Font.Color := clBlue;
  DecEdit13.Font.Color := clBlue;
  DecEdit14.Font.Color := clBlue;
  DecEdit15.Font.Color := clBlue;
  DecEdit16.Font.Color := clBlue;

  GroupBox1.TabStop := FALSE;
  Edit1.TabStop     := FALSE;
  DecEdit1.TabStop  := FALSE;
  DecEdit2.TabStop  := FALSE;
  DecEdit3.TabStop  := FALSE;
  DecEdit4.TabStop  := FALSE;
  DecEdit5.TabStop  := FALSE;
  DecEdit6.TabStop  := FALSE;
  DecEdit11.TabStop := FALSE;
  DecEdit12.TabStop := FALSE;
  DecEdit13.TabStop := FALSE;
  DecEdit14.TabStop := FALSE;
  DecEdit15.TabStop := FALSE;
  DecEdit16.TabStop := FALSE;

  //Ǎ
  if FileExists(FormMain.StrExtractBase + TIME_TXT) = TRUE then
  begin
    //Ǎ
    StrList1.LoadFromFile(FormMain.StrExtractBase + TIME_TXT, TEncoding.Unicode);
  end;
  ListBox1.Items.Clear;
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    //擾
    CsvList2.Clear;
    StringToCsvList(StrList1.Strings[iRow1], CsvList2);
    //ǉ
    ListBox1.Items.Add(ExtractFileName(CsvList2[0]));
  end;
  ListBox1.ItemIndex := 0;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
  end;

end;

procedure TFormImageTimeStamp.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormImageTimeStamp', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormImageTimeStamp', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormImageTimeStamp', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormImageTimeStamp', 'Left',   FormImageTimeStamp.Left);
    IniFile.WriteInteger('FormImageTimeStamp', 'Top',    FormImageTimeStamp.Top);
    IniFile.WriteInteger('FormImageTimeStamp', 'Width',  FormImageTimeStamp.Width);
    IniFile.WriteInteger('FormImageTimeStamp', 'Height', FormImageTimeStamp.Height);
  end;
  //j
  IniFile.Free;

  //j
  CsvList1.Free;
  CsvList2.Free;
  StrList1.Free;
  StrListExif.Free;
end;

procedure TFormImageTimeStamp.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormImageTimeStamp.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormImageTimeStamp.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormImageTimeStamp.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormImageTimeStamp.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormImageTimeStamp.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  ListBox1.SetFocus;

  //IMEIt
  SetImeMode(FormImageTimeStamp.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'ImageTimeStamp.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormImageTimeStamp, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormImageTimeStamp, StrLanguageFileName, Sender);
  end;

  //\
  Timer1.Enabled := TRUE;
end;

procedure TFormImageTimeStamp.FormResize(Sender: TObject);
var
  iWidth1: Integer;

begin
  Edit1.Width      := Panel1.Width -30 -30;
  ListBox1.Width   := (Panel1.Width -30 -30) *2 div 3;
  ListBox1.Height  := Panel1.Height -310;

  Label3.Top       := Panel1.Height -270;
  Label7.Top       := Panel1.Height -110;
  Label8.Top       := Panel1.Height -85;
  Label9.Top       := Panel1.Height -65;
  Edit1.Top        := Panel1.Height -245;
  GroupBox1.Top    := Panel1.Height -205;
  ButtonOK.Top     := Panel1.Height -35;
  ButtonCancel.Top := Panel1.Height -35;
  ButtonSkip.Top   := Panel1.Height -35;
  ButtonUp.Top     := Panel1.Height -35;
  ButtonDown.Top   := Panel1.Height -35;

  Image1.Left  := ListBox1.Left + ListBox1.Width + 10;
  iWidth1     := Panel1.Width -30 -30 - ListBox1.Width -10 -10;

  if iWidth1 > ListBox1.Height then
  begin
    IntImageWidthHeight := ListBox1.Height;
  end
  else
  begin
    IntImageWidthHeight := iWidth1;
  end;
  Image1.Width   := IntImageWidthHeight;
  Image1.Height  := IntImageWidthHeight;

  //擾
  CsvList2.Clear;
  StringToCsvList(StrList1.Strings[ListBox1.ItemIndex], CsvList2);
  ShowImage(CsvList2[0], Sender);

end;

procedure TFormImageTimeStamp.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormImageTimeStamp, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormImageTimeStamp, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormImageTimeStamp.ButtonOKClick(Sender: TObject);
var
  tDateTime1: TDateTime;
  sStr1: String;
  iRet1: Integer;
  iAttr1: integer;
  iAttr2: integer;
begin
  if DecEdit11.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Nw肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Year is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if DecEdit12.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : w肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Month is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if DecEdit13.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : w肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Date is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if DecEdit14.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : w肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Hour is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if DecEdit15.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : w肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Minute is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if DecEdit16.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : bw肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Second is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DecEdit11.Text) < 1900 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : N̎w 1900 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Year must be set greater than or equal to 1900.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DecEdit12.Text) < 1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 1 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Month must be set greater than or equal to 1.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DecEdit12.Text) > 12 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 12 ȉɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Month must be set less than or equal to 12.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DecEdit13.Text) < 1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 1 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Day must be set greater than or equal to 1.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DecEdit13.Text) > 31 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 31 ȉɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Day must be set less than or equal to 31.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DecEdit14.Text) < 1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 1 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Hour must be set greater than or equal to 1.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DecEdit14.Text) > 23 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 23 ȉɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Hour must be set less than or equal to 23.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DecEdit15.Text) < 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 0 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Minute must be set greater than or equal to 0.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DecEdit15.Text) > 59 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 59 ȉɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Minute must be set less than or equal to 59.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DecEdit16.Text) < 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : b̎w 0 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Second must be set greater than or equal to 0.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DecEdit16.Text) > 59 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : b̎w 59 ȉɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Second must be set less than or equal to 59.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //TDateTime date = StrToDateTime("2006/8/14 10:23:42");
  sStr1 := DecEdit11.Text + '/' + DecEdit12.Text + '/' + DecEdit13.Text + ' ' +
           DecEdit14.Text + ':' + DecEdit15.Text + ':' + DecEdit16.Text;
  tDateTime1 := StrToDateTime(sStr1);


    //WJ
    CsvList2.Clear;
    StringToCsvList(StrList1.Strings[ListBox1.ItemIndex], CsvList2);
    //ݒ
    FormMain.StrRetFormImageTimeStamp := CsvList2[0];

    //ReadOnly
    if Copy(CsvList2[3], 1 ,1) = 'R' then
    begin
      //ݒ
      iAttr1 := 0;
      if Copy(CsvList2[3], 1 ,1) = 'R' = true then
      begin
        iAttr1 := iAttr1 + FILE_ATTRIBUTE_READONLY;
      end;
      if Copy(CsvList2[3], 2 ,1) = 'H' = true then
      begin
        iAttr1 := iAttr1 + FILE_ATTRIBUTE_HIDDEN;
      end;
      if Copy(CsvList2[3], 3 ,1) = 'S' then
      begin
        iAttr1 := iAttr1 + FILE_ATTRIBUTE_SYSTEM;
      end;
      if Copy(CsvList2[3], 4 ,1) = 'A' then
      begin
        iAttr1 := iAttr1 + FILE_ATTRIBUTE_ARCHIVE;
      end;
      //ReadOnlyO
      iAttr2 := iAttr1 - FILE_ATTRIBUTE_READONLY;

      //UĕύX
      iRet1 := FileSetAttr(CsvList2[0], iAttr2);
      //s
      if iRet1 <> 0 then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : t@C鑀삪s܂' + #13#10 +
                             CsvList2[0];
        end
        else
        begin
          FormMain.StrMsg := 'Error : Change file attribute failed before change.' + #13#10 +
                             CsvList2[0] + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;

      //ύX
      try
        //ݒ
        System.IOUtils.TFile.SetLastWriteTime(CsvList2[0], tDateTime1);
      except
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : ^CX^v̕ύXɎs܂' + #13#10 +
                             CsvList2[0];
        end
        else
        begin
          FormMain.StrMsg := 'Error : Change time stamp failed.' + #13#10 +
                             CsvList2[0] + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;

      //ύXAɖ߂߂ɕύX
      iRet1 := FileSetAttr(CsvList2[0], iAttr1);
      //s
      if iRet1 <> 0 then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : t@C߂삪s܂' + #13#10 +
                             CsvList2[0];
        end
        else
        begin
          FormMain.StrMsg := 'Error : Change file attribute failed after change.' + #13#10 +
                             CsvList2[0] + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;

    end
    //ReadOnlyłȂ
    else
    begin
      //ύX
      try
        //ݒ
        System.IOUtils.TFile.SetLastWriteTime(CsvList2[0], tDateTime1);
      except
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : ^CX^v̕ύXɎs܂' + #13#10 +
                             CsvList2[0];
        end
        else
        begin
          FormMain.StrMsg := 'Error : Change time stamp failed.' + #13#10 +
                             CsvList2[0] + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;
    end;

  if ListBox1.Items.Count = 1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ύX܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Change had done.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    ModalResult := mrOK;
  end
  else
  begin
    //ŌłȂ΁AɈړ
    if ListBox1.ItemIndex <> (ListBox1.Items.Count-1) then
    begin
      //ݒ
      ListBox1.ItemIndex := ListBox1.ItemIndex+1;
      //XV
      ListBox1Click(Sender);
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : Ō̕ύXs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : All change had done.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      ModalResult := mrOK;
    end;
  end;
end;

procedure TFormImageTimeStamp.ButtonSkipClick(Sender: TObject);
begin
    //ŌłȂ΁AɈړ
    if ListBox1.ItemIndex = (ListBox1.Items.Count-1) then
    begin
      Exit;
    end
    else
    begin
      //ݒ
      ListBox1.ItemIndex := ListBox1.ItemIndex+1;
      //XV
      ListBox1Click(Sender);
    end;
end;

procedure TFormImageTimeStamp.ButtonUpClick(Sender: TObject);
begin
    //ŌłȂ΁AɈړ
    if ListBox1.ItemIndex = 0 then
    begin
      Exit;
    end
    else
    begin
      //ݒ
      ListBox1.ItemIndex := ListBox1.ItemIndex-1;
      //XV
      ListBox1Click(Sender);
    end;
end;

procedure TFormImageTimeStamp.ButtonDownClick(Sender: TObject);
begin
    //ŌłȂ΁AɈړ
    if ListBox1.ItemIndex = (ListBox1.Items.Count-1) then
    begin
      Exit;
    end
    else
    begin
      //ݒ
      ListBox1.ItemIndex := ListBox1.ItemIndex+1;
      //XV
      ListBox1Click(Sender);
    end;
end;

procedure TFormImageTimeStamp.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormImageTimeStamp.DecEditKeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormImageTimeStamp.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormImageTimeStamp.ListBox1Click(Sender: TObject);
var
  iRow1: Integer;
begin
    //擾
    CsvList2.Clear;
    StringToCsvList(StrList1.Strings[ListBox1.ItemIndex], CsvList2);
    //ݒ
    Edit1.Text := ExtractFilePath(CsvList2[0]);
    //ݒ
    DecEdit1.Text  := Copy(CsvList2[1],  1, 4);
    DecEdit2.Text  := Copy(CsvList2[1],  6, 2);
    DecEdit3.Text  := Copy(CsvList2[1],  9, 2);
    DecEdit4.Text  := Copy(CsvList2[1], 12, 2);
    DecEdit5.Text  := Copy(CsvList2[1], 15, 2);
    DecEdit6.Text  := Copy(CsvList2[1], 18, 2);

    //ݒ
    DecEdit11.Text := Copy(CsvList2[1],  1, 4);
    DecEdit12.Text := Copy(CsvList2[1],  6, 2);
    DecEdit13.Text := Copy(CsvList2[1],  9, 2);
    DecEdit14.Text := Copy(CsvList2[1], 12, 2);
    DecEdit15.Text := Copy(CsvList2[1], 15, 2);
    DecEdit16.Text := Copy(CsvList2[1], 18, 2);
    Label7.Caption := 'Maker   [0x010F] : ';
    Label8.Caption := 'Model   [0x0110] : ';
    Label9.Caption := 'Rotation[0x0112] : ';
    IntAutoRotateIndex := 0;
    DecEdit11.Font.Color := clBlue;
    DecEdit12.Font.Color := clBlue;
    DecEdit13.Font.Color := clBlue;
    DecEdit14.Font.Color := clBlue;
    DecEdit15.Font.Color := clBlue;
    DecEdit16.Font.Color := clBlue;

    //Exif  IFD 擾
    if GetValue(CsvList2[0], StrListExif, Sender) = TRUE then
    begin
      //WJ
      for iRow1 := 0 to StrListExif.Count-1 do
      begin
        //擾
        CsvList1.Clear;
        StringToCsvList(StrListExif.Strings[iRow1], CsvList1);
        //t
        if CSvList1[0] = '0x0132' then
        begin
          DecEdit11.Text := Copy(CsvList1[4],  1, 4);
          DecEdit12.Text := Copy(CsvList1[4],  6, 2);
          DecEdit13.Text := Copy(CsvList1[4],  9, 2);
          DecEdit14.Text := Copy(CsvList1[4], 12, 2);
          DecEdit15.Text := Copy(CsvList1[4], 15, 2);
          DecEdit16.Text := Copy(CsvList1[4], 18, 2);
          DecEdit11.Font.Color := clRed;
          DecEdit12.Font.Color := clRed;
          DecEdit13.Font.Color := clRed;
          DecEdit14.Font.Color := clRed;
          DecEdit15.Font.Color := clRed;
          DecEdit16.Font.Color := clRed;
          Break;
        end;

        //Maker
        if CSvList1[0] = '0x010F' then
        begin
          Label7.Caption := 'Maker   [0x010F] : ' + CsvList1[4];
        end;

        //Model
        if CSvList1[0] = '0x0110' then
        begin
          Label8.Caption := 'Model   [0x0110] : ' + CsvList1[4];
        end;

        if CSvList1[0] = '0x0112' then
        begin
          //ɖ߂߂Ɏ{
          //1 sv(]E]Ȃ)
          //2 ɔ]
          //3 v180x]
          //4 ɔ]
          //5 ɔ]+v270x]
          //6 v90x]
          //7 ɔ]+v90x]
          //8 v270x]

          //0
          if      CSvList1[3] = '0x00010000' then
          begin
            IntAutoRotateIndex := 0;
            //ݒ
            if BoolJapanese = TRUE then
            begin
              Label9.Caption := 'Rotation[0x0112] : ' + CsvList1[3] + ' 000 x';
            end
            else
            begin
              Label9.Caption := 'Rotation[0x0112] : ' + CsvList1[3] + ' 000 deg.';
            end;
          end
          //90
          else if CSvList1[3] = '0x00060000' then
          begin
            IntAutoRotateIndex := 1;
            //ݒ
            if BoolJapanese = TRUE then
            begin
              Label9.Caption := 'Rotation[0x0112] : ' + CsvList1[3] + ' 090 x';
            end
            else
            begin
              Label9.Caption := 'Rotation[0x0112] : ' + CsvList1[3] + ' 090 deg.';
            end;
          end
          //180
          else if CSvList1[3] = '0x00030000' then
          begin
            IntAutoRotateIndex := 2;
            //ݒ
            if BoolJapanese = TRUE then
            begin
              Label9.Caption := 'Rotation[0x0112] : ' + CsvList1[3] + ' 180 x';
            end
            else
            begin
              Label9.Caption := 'Rotation[0x0112] : ' + CsvList1[3] + ' 180 deg.';
            end;
          end
          //270
          else if CSvList1[3] = '0x00080000' then
          begin
            IntAutoRotateIndex := 3;
            //ݒ
            if BoolJapanese = TRUE then
            begin
              Label9.Caption := 'Rotation[0x0112] : ' + CsvList1[3] + ' 270 x';
            end
            else
            begin
              Label9.Caption := 'Rotation[0x0112] : ' + CsvList1[3] + ' 270 deg.';
            end;
          end
          //0
          else
          begin
            IntAutoRotateIndex := 0;
            //ݒ
            if BoolJapanese = TRUE then
            begin
              Label9.Caption := 'Rotation[0x0112] : ' + CsvList1[3] + ' ̑';
            end
            else
            begin
              Label9.Caption := 'Rotation[0x0112] : ' + CsvList1[3] + ' Others';
            end;
          end;
        end;
      end;
    end;

    //摜\
    ShowImage(CsvList2[0], Sender);
end;


procedure TFormImageTimeStamp.ShowImage(FileName: String; Sender: TObject);
var
  Graphics: TGPGraphics;
  SrcBmp: TGPBitMap;
  DstBmp: TBitMap;
  ImageSrcWidth: Integer;
  ImageSrcHeight: Integer;
  iWidth2: integer;
  iWidth3: integer;
  iHeight2: integer;
  iHeight3: integer;
  VerticalRate: Real;
  HorizontalRate: Real;
begin
  //
  Image1.Picture.Graphic := nil;

  //t@CmF
  if FileExists(FileName) = TRUE then
  begin
    //
    try
      //t@Cǂݍ
      SrcBmp := TGPBitMap.Create(FileName);
      DstBmp := TBitMap.Create;

        //]
        if      IntAutoRotateIndex =  0 then
        begin
          //
        end
        else if IntAutoRotateIndex = 1 then
        begin
          SrcBmp.RotateFlip(Rotate90FlipNone);
        end
        else if IntAutoRotateIndex = 2 then
        begin
          SrcBmp.RotateFlip(Rotate180FlipNone);
        end
        else if IntAutoRotateIndex = 3 then
        begin
          SrcBmp.RotateFlip(Rotate270FlipNone);
        end
        else
        begin
          //
        end;

      //
      try
        //p̐ݒ
        ImageSrcHeight  := SrcBmp.GetHeight;
        ImageSrcWidth   := SrcBmp.GetWidth;

        //摜TCY̏cƉ œKȏԂŕ\悤ɐݒ肷
        VerticalRate   := ImageSrcHeight / IntImageWidthHeight;
        HorizontalRate := ImageSrcWidth  / IntImageWidthHeight;
        if (VerticalRate > 1) and (HorizontalRate > 1) then
        begin
          if (VerticalRate >= HorizontalRate) then
          begin
            iHeight2 := IntImageWidthHeight - IMAGE_EDGE_WIDTH1;
            iWidth2  := Round(iHeight2 * ImageSrcWidth / ImageSrcHeight);
          end
          else
          begin
            iWidth2  := IntImageWidthHeight - IMAGE_EDGE_WIDTH1;
            iHeight2 := Round(iWidth2 * ImageSrcHeight / ImageSrcWidth);
          end;
        end
        else if (VerticalRate > 1) then
        begin
          iHeight2 := IntImageWidthHeight - IMAGE_EDGE_WIDTH1;
          iWidth2  := Round(iHeight2 * ImageSrcWidth / ImageSrcHeight);
        end
        else if (HorizontalRate > 1) then
        begin
          iWidth2  := IntImageWidthHeight - IMAGE_EDGE_WIDTH1;
          iHeight2 := Round(iWidth2 * ImageSrcHeight / ImageSrcWidth);
        end
        else
        begin
          iHeight2 := ImageSrcHeight;
          iWidth2  := ImageSrcWidth;
        end;

        //ݒ
        DstBmp.Width  := iWidth2;
        DstBmp.Height := iHeight2;
        //ݒ
        iWidth3  := iWidth2;
        iHeight3 := iHeight2;



        //쐬
        Graphics  := TGPGraphics.Create(DstBmp.Canvas.Handle);
        //
        try
          //쐬eDstɔf
          Graphics.DrawImage(SrcBmp, 0, 0, iWidth3, iHeight3);
          //t@C\
          Image1.Stretch := FALSE;
          Image1.Picture.Graphic := DstBmp;
        finally
          //
          Graphics.Free;
        end;
        finally
          //j
          SrcBmp.Free;
          DstBmp.Free;
        end;
      except
        //
      end;
    end;
end;

procedure TFormImageTimeStamp.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := FALSE;
  ListBox1Click(Sender);
end;

end.
