unit InputFile;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_DEPRECATED    OFF} //W1000 : for FileCtrl
  {$WARN UNIT_PLATFORM   OFF} //W1005 : for Filectrl
  {$WARN SYMBOL_PLATFORM   OFF} //W1002  FileSetDate

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Filectrl, IniFiles,
  Math, ShlObj, ActiveX;

const
  FORM_WIDTH_SET  = 750;
  FORM_HEIGHT_SET = 225;
  FORM_MAX        = 'MAX';
  FORM_MIN        = 'MIN';
  FORM_NORMAL     = 'NORMAL';

type
  TFormInputFile = class(TForm)
    ButtonList: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label129: TLabel;
    ButtonCurrent: TButton;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    OpenDialog1: TOpenDialog;
    Button1: TButton;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonListClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCurrentClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button1Click(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListItems: TStringList;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormInputFile: TFormInputFile;

implementation


{$R *.dfm}

uses
  Main, Browse;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormInputFile.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormInputFile.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormInputFile.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormInputFile.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormInputFile.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
  sStr9: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //Ǎ
  FormPosLeft   := IniFile.ReadInteger('FormInputFile', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormInputFile', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormInputFile', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormInputFile', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormInputFile', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListItems := TStringList.Create;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //j
  IniFile.Free;

  //mF
  if FormMain.StrAnnsFMPath = '' then
  begin
    sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_JF2;
  end
  else
  begin
    sStr9 := FormMain.StrAnnsFMPath + FILENAME_JF2;
  end;
  if FileExists(sStr9) = TRUE then
  begin
    //Ǎ
    StrListItems.LoadFromFile(sStr9);
    sStr1 := StrListItems.Strings[FormMain.IntJumpFileIndex];
    Edit1.Text := Trim(Copy(sStr1,  5, 12));
    Edit2.Text := Copy(sStr1, 18, Length(sStr1));
  end
  else
  begin
    //쐬
    StrListitems.Clear;
    StrListitems.Add('  A              ');
    StrListitems.Add('  B              ');
    StrListitems.Add('  C              ');
    StrListitems.Add('  D              ');
    StrListitems.Add('  E              ');
    StrListitems.Add('  F              ');
    StrListitems.Add('  G              ');
    StrListitems.Add('  H              ');
    StrListitems.Add('  I              ');
    StrListitems.Add('  J              ');
    StrListitems.Add('  K              ');
    StrListitems.Add('  L              ');
    StrListitems.Add('  M              ');
    StrListitems.Add('  N              ');
    StrListitems.Add('  O              ');
    StrListitems.Add('  P              ');
    StrListitems.Add('  Q              ');
    StrListitems.Add('  R              ');
    StrListitems.Add('  S              ');
    StrListitems.Add('  T              ');
    StrListitems.Add('  U              ');
    StrListitems.Add('  V              ');
    StrListitems.Add('  W              ');
    StrListitems.Add('  X              ');
    StrListitems.Add('  Y              ');
    StrListitems.Add('  Z              ');
    StrListitems.Add('  0              ');
    StrListitems.Add('  1              ');
    StrListitems.Add('  2              ');
    StrListitems.Add('  3              ');
    StrListitems.Add('  4              ');
    StrListitems.Add('  5              ');
    StrListitems.Add('  6              ');
    StrListitems.Add('  7              ');
    StrListitems.Add('  8              ');
    StrListitems.Add('  9              ');
    StrListitems.Add('s+A              ');
    StrListitems.Add('s+B              ');
    StrListitems.Add('s+C              ');
    StrListitems.Add('s+D              ');
    StrListitems.Add('s+E              ');
    StrListitems.Add('s+F              ');
    StrListitems.Add('s+G              ');
    StrListitems.Add('s+H              ');
    StrListitems.Add('s+I              ');
    StrListitems.Add('s+J              ');
    StrListitems.Add('s+K              ');
    StrListitems.Add('s+L              ');
    StrListitems.Add('s+M              ');
    StrListitems.Add('s+N              ');
    StrListitems.Add('s+O              ');
    StrListitems.Add('s+P              ');
    StrListitems.Add('s+Q              ');
    StrListitems.Add('s+R              ');
    StrListitems.Add('s+S              ');
    StrListitems.Add('s+T              ');
    StrListitems.Add('s+U              ');
    StrListitems.Add('s+V              ');
    StrListitems.Add('s+W              ');
    StrListitems.Add('s+X              ');
    StrListitems.Add('s+Y              ');
    StrListitems.Add('s+Z              ');
    StrListitems.Add('s+0              ');
    StrListitems.Add('s+1              ');
    StrListitems.Add('s+2              ');
    StrListitems.Add('s+3              ');
    StrListitems.Add('s+4              ');
    StrListitems.Add('s+5              ');
    StrListitems.Add('s+6              ');
    StrListitems.Add('s+7              ');
    StrListitems.Add('s+8              ');
    StrListitems.Add('s+9              ');
    StrListitems.Add('c+A              ');
    StrListitems.Add('c+B              ');
    StrListitems.Add('c+C              ');
    StrListitems.Add('c+D              ');
    StrListitems.Add('c+E              ');
    StrListitems.Add('c+F              ');
    StrListitems.Add('c+G              ');
    StrListitems.Add('c+H              ');
    StrListitems.Add('c+I              ');
    StrListitems.Add('c+J              ');
    StrListitems.Add('c+K              ');
    StrListitems.Add('c+L              ');
    StrListitems.Add('c+M              ');
    StrListitems.Add('c+N              ');
    StrListitems.Add('c+O              ');
    StrListitems.Add('c+P              ');
    StrListitems.Add('c+Q              ');
    StrListitems.Add('c+R              ');
    StrListitems.Add('c+S              ');
    StrListitems.Add('c+T              ');
    StrListitems.Add('c+U              ');
    StrListitems.Add('c+V              ');
    StrListitems.Add('c+W              ');
    StrListitems.Add('c+X              ');
    StrListitems.Add('c+Y              ');
    StrListitems.Add('c+Z              ');
    StrListitems.Add('c+0              ');
    StrListitems.Add('c+1              ');
    StrListitems.Add('c+2              ');
    StrListitems.Add('c+3              ');
    StrListitems.Add('c+4              ');
    StrListitems.Add('c+5              ');
    StrListitems.Add('c+6              ');
    StrListitems.Add('c+7              ');
    StrListitems.Add('c+8              ');
    StrListitems.Add('c+9              ');
  end;

end;

procedure TFormInputFile.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormInputFile', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormInputFile', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormInputFile', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormInputFile', 'Left',   FormInputFile.Left);
    IniFile.WriteInteger('FormInputFile', 'Top',    FormInputFile.Top);
    IniFile.WriteInteger('FormInputFile', 'Width',  FormInputFile.Width);
    IniFile.WriteInteger('FormInputFile', 'Height', FormInputFile.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListItems.Free;
end;

procedure TFormInputFile.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormInputFile, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormInputFile, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormInputFile.FormResize(Sender: TObject);
begin
;
end;

procedure TFormInputFile.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormInputFile.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormInputFile.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormInputFile.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormInputFile.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormInputFile.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormInputFile.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'InputFile.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormInputFile, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormInputFile, StrLanguageFileName, Sender);
  end;
end;

procedure TFormInputFile.ButtonCurrentClick(Sender: TObject);
begin
  if FormMain.ListView1.Items[FormMain.ListView1.ItemIndex].SubItems[2] = DIR_MARK then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : tH_͎wł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Folder can not accept.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  Edit2.Text := FormMain.StrCurrent + FormMain.ListView1.Items[FormMain.ListView1.ItemIndex].SubItems[8];
  Edit2.SetFocus;
end;

procedure TFormInputFile.Button1Click(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FILE);
  //j
  IniFile.Free;

    //
    FormMain.StrRetFormBrowse := '';
    FormMain.StrSetFormBrowse := ExtractfilePath(FormMain.StrCurrent);
    //
    FormBrowse := TFormBrowse.Create(Application);
    try
      if FormBrowse.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormBrowse.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //t@C
      if FileExists(FormMain.StrRetFormBrowse) = TRUE then
      begin
        Edit2.Text := FormMain.StrRetFormBrowse;
        Edit2.SetFocus;
      end
      else
      begin
        Edit2.SetFocus;
      end;
    end
    else
    begin
      Edit2.SetFocus;
    end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FOLDER);
  //j
  IniFile.Free;

end;

procedure TFormInputFile.ButtonListClick(Sender: TObject);
var
  sStr2: String;
begin
  //ݒ
  if Edit2.Text = '' then
  begin
    sStr2 := '';
  end
  else
  begin
    sStr2 := Edit2.Text;
  end;
  OpenDialog1.Filter := 'Exe(*.exe)|*.exe|All(*.*)|*.*';
  if FileExists(sStr2) = TRUE then
  begin
    OpenDialog1.InitialDir := ExtractFilePath(sStr2);
    OpenDialog1.FileName   := ExtractFileName(sStr2);
  end
  else
  begin
    OpenDialog1.InitialDir := '';
    OpenDialog1.FileName   := '';
  end;
  if OpenDialog1.Execute() = TRUE then
  begin
    Edit2.Text := OpenDialog1.FileName;
    Edit2.SetFocus;
  end
  else
  begin
    Edit2.SetFocus;
  end;
end;

procedure TFormInputFile.ButtonOKClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr9: String;
  iRow1: Integer;
begin
    //`
    Edit2.Text := TrimRight(Edit2.Text);
    //ݒ
    sStr1 := Edit2.Text;

    //ExẽhCuύX
    if      UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%d') then
    begin
      sStr2 := FormMain.StrExeDrive + Copy(sStr1, 3,  Length(sStr1));
    end
    else if UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%p') then
    begin
      sStr2 := FormMain.StrExePath  + Copy(sStr1, 3,  Length(sStr1));
    end
    else
    begin
      sStr2 := sStr1;
    end;

    //
    if FileExists(sStr2) = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : Wṽt@C܂' + #13#10 +
                            sStr2;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Jump file is not exist.' + #13#10 +
                           sStr2 + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end
    else
    begin
      if      Length(AnsiString(Edit1.Text)) < 12 then
      begin
        sStr5 := Edit1.Text + StringOfChar(' ', 12-Length(AnsiString(Edit1.Text)));
      end
      else if Length(AnsiString(Edit1.Text)) = 12 then
      begin
        sStr5 := Edit1.Text;
      end
      else
      begin
        sStr6 := '';
        for iRow1 := 0 to Length(Edit1.Text)-1 do
        begin
          sStr6 := Copy(Edit1.Text, 1, iRow1);
          if Length(AnsiString(sStr6)) > 12 then
          begin
            sStr6 := Copy(Edit1.Text, 1, iRow1-1);
            Break;
          end;
        end;
        sStr5 := sStr6 + StringOfChar(' ', 12-Length(AnsiString(sStr6)));
      end;
      sStr3 := StrListItems.Strings[FormMain.IntJumpFileIndex];
      sStr4 := Copy(sStr3, 1, 3) + ' ' +
               sStr5             + ' ' +
               Edit2.Text;

      //f
      StrListItems.Strings[FormMain.IntJumpFileIndex] := sStr4;
      //ۑ
      if FormMain.StrAnnsFMPath = '' then
      begin
        sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_JF2;
      end
      else
      begin
        sStr9 := FormMain.StrAnnsFMPath + FILENAME_JF2;
      end;
      StrListItems.SaveToFile(sStr9);
      //I
      ModalResult := mrOK;
    end;
end;

procedure TFormInputFile.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormInputFile.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputFile.Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //RETURN
  if Key = VK_RETURN then
  begin
    if Edit2.Text = '' then
    begin
      //
    end
    else
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end;
end;

procedure TFormInputFile.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

end.
