unit InputFolder;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_DEPRECATED    OFF} //W1000 : for FileCtrl
  {$WARN UNIT_PLATFORM   OFF} //W1005 : for Filectrl
  {$WARN SYMBOL_PLATFORM   OFF} //W1002  FileSetDate

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Filectrl, IniFiles,
  Math, ShlObj, ActiveX;

const
  FORM_WIDTH_SET  = 750;
  FORM_HEIGHT_SET = 225;
  FORM_MAX        = 'MAX';
  FORM_MIN        = 'MIN';
  FORM_NORMAL     = 'NORMAL';

type
  TFormInputFolder = class(TForm)
    ButtonList: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label129: TLabel;
    ButtonTree: TButton;
    ButtonCurrent: TButton;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ButtonBrowse: TButton;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonListClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);

    function  SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;

    procedure ButtonTreeClick(Sender: TObject);
    procedure ButtonCurrentClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure ButtonBrowseClick(Sender: TObject);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListItems: TStringList;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormInputFolder: TFormInputFolder;

implementation


{$R *.dfm}

uses
  Main, Browse, Tree;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormInputFolder.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormInputFolder.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormInputFolder.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormInputFolder.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormInputFolder.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
  sStr9: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormInputFolder', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormInputFolder', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormInputFolder', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormInputFolder', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormInputFolder', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListItems := TStringList.Create;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //j
  IniFile.Free;

  //mF
  if FormMain.StrAnnsFMPath = '' then
  begin
    sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_JP2;
  end
  else
  begin
    sStr9 := FormMain.StrAnnsFMPath +  FILENAME_JP2;
  end;
  if FileExists(sStr9) = TRUE then
  begin
    //Ǎ
    StrListItems.LoadFromFile(sStr9);
    sStr1 := StrListItems.Strings[FormMain.IntJumpFolderIndex];
    Edit1.Text := Trim(Copy(sStr1,  5, 12));
    Edit2.Text := Copy(sStr1, 18, Length(sStr1));
  end
  else
  begin
    //쐬
    StrListitems.Clear;
    StrListitems.Add('  A              ');
    StrListitems.Add('  B              ');
    StrListitems.Add('  C              ');
    StrListitems.Add('  D              ');
    StrListitems.Add('  E              ');
    StrListitems.Add('  F              ');
    StrListitems.Add('  G              ');
    StrListitems.Add('  H              ');
    StrListitems.Add('  I              ');
    StrListitems.Add('  J              ');
    StrListitems.Add('  K              ');
    StrListitems.Add('  L              ');
    StrListitems.Add('  M              ');
    StrListitems.Add('  N              ');
    StrListitems.Add('  O              ');
    StrListitems.Add('  P              ');
    StrListitems.Add('  Q              ');
    StrListitems.Add('  R              ');
    StrListitems.Add('  S              ');
    StrListitems.Add('  T              ');
    StrListitems.Add('  U              ');
    StrListitems.Add('  V              ');
    StrListitems.Add('  W              ');
    StrListitems.Add('  X              ');
    StrListitems.Add('  Y              ');
    StrListitems.Add('  Z              ');
    StrListitems.Add('  0              ');
    StrListitems.Add('  1              ');
    StrListitems.Add('  2              ');
    StrListitems.Add('  3              ');
    StrListitems.Add('  4              ');
    StrListitems.Add('  5              ');
    StrListitems.Add('  6              ');
    StrListitems.Add('  7              ');
    StrListitems.Add('  8              ');
    StrListitems.Add('  9              ');
    StrListitems.Add('s+A              ');
    StrListitems.Add('s+B              ');
    StrListitems.Add('s+C              ');
    StrListitems.Add('s+D              ');
    StrListitems.Add('s+E              ');
    StrListitems.Add('s+F              ');
    StrListitems.Add('s+G              ');
    StrListitems.Add('s+H              ');
    StrListitems.Add('s+I              ');
    StrListitems.Add('s+J              ');
    StrListitems.Add('s+K              ');
    StrListitems.Add('s+L              ');
    StrListitems.Add('s+M              ');
    StrListitems.Add('s+N              ');
    StrListitems.Add('s+O              ');
    StrListitems.Add('s+P              ');
    StrListitems.Add('s+Q              ');
    StrListitems.Add('s+R              ');
    StrListitems.Add('s+S              ');
    StrListitems.Add('s+T              ');
    StrListitems.Add('s+U              ');
    StrListitems.Add('s+V              ');
    StrListitems.Add('s+W              ');
    StrListitems.Add('s+X              ');
    StrListitems.Add('s+Y              ');
    StrListitems.Add('s+Z              ');
    StrListitems.Add('s+0              ');
    StrListitems.Add('s+1              ');
    StrListitems.Add('s+2              ');
    StrListitems.Add('s+3              ');
    StrListitems.Add('s+4              ');
    StrListitems.Add('s+5              ');
    StrListitems.Add('s+6              ');
    StrListitems.Add('s+7              ');
    StrListitems.Add('s+8              ');
    StrListitems.Add('s+9              ');
    StrListitems.Add('c+A              ');
    StrListitems.Add('c+B              ');
    StrListitems.Add('c+C              ');
    StrListitems.Add('c+D              ');
    StrListitems.Add('c+E              ');
    StrListitems.Add('c+F              ');
    StrListitems.Add('c+G              ');
    StrListitems.Add('c+H              ');
    StrListitems.Add('c+I              ');
    StrListitems.Add('c+J              ');
    StrListitems.Add('c+K              ');
    StrListitems.Add('c+L              ');
    StrListitems.Add('c+M              ');
    StrListitems.Add('c+N              ');
    StrListitems.Add('c+O              ');
    StrListitems.Add('c+P              ');
    StrListitems.Add('c+Q              ');
    StrListitems.Add('c+R              ');
    StrListitems.Add('c+S              ');
    StrListitems.Add('c+T              ');
    StrListitems.Add('c+U              ');
    StrListitems.Add('c+V              ');
    StrListitems.Add('c+W              ');
    StrListitems.Add('c+X              ');
    StrListitems.Add('c+Y              ');
    StrListitems.Add('c+Z              ');
    StrListitems.Add('c+0              ');
    StrListitems.Add('c+1              ');
    StrListitems.Add('c+2              ');
    StrListitems.Add('c+3              ');
    StrListitems.Add('c+4              ');
    StrListitems.Add('c+5              ');
    StrListitems.Add('c+6              ');
    StrListitems.Add('c+7              ');
    StrListitems.Add('c+8              ');
    StrListitems.Add('c+9              ');
  end;

end;

procedure TFormInputFolder.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormInputFolder', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormInputFolder', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormInputFolder', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormInputFolder', 'Left',   FormInputFolder.Left);
    IniFile.WriteInteger('FormInputFolder', 'Top',    FormInputFolder.Top);
    IniFile.WriteInteger('FormInputFolder', 'Width',  FormInputFolder.Width);
    IniFile.WriteInteger('FormInputFolder', 'Height', FormInputFolder.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListItems.Free;
end;

procedure TFormInputFolder.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormInputFolder, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormInputFolder, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormInputFolder.FormResize(Sender: TObject);
begin
  Edit2.Width := Panel1.ClientWidth - 40;
end;

procedure TFormInputFolder.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormInputFolder.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormInputFolder.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormInputFolder.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormInputFolder.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormInputFolder.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormInputFolder.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'InputFolder.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormInputFolder, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormInputFolder, StrLanguageFileName, Sender);
  end;
end;

procedure TFormInputFolder.ButtonCurrentClick(Sender: TObject);
begin
  Edit2.Text := ExtractFilePath(FormMain.StrCurrent);
  Edit2.SetFocus;
end;

procedure TFormInputFolder.ButtonTreeClick(Sender: TObject);
var
  bResult: Boolean;
  sStr2: String;
begin
    //擾
    if Edit2.Text = '' then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end
    else
    begin
      sStr2 := Edit2.Text;
    end;
    if DirectoryExists(sStr2) = FALSE then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end;
    //
    FormMain.StrRetFormTree := '';
    FormMain.StrSetFormTree := sStr2;
    //
    FormTree := TFormTree.Create(Application);
    try
      if FormTree.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormTree.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormTree) = TRUE then
      begin
        Edit2.Text := FormMain.StrRetFormTree;
        Edit2.SetFocus;
      end
      else
      begin
        Edit2.SetFocus;
      end;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormInputFolder.ButtonBrowseClick(Sender: TObject);
var
  bResult: Boolean;
  sStr2: String;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FOLDER);
  //j
  IniFile.Free;

    //擾
    if Edit2.Text = '' then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end
    else
    begin
      sStr2 := Edit2.Text;
    end;
    if DirectoryExists(sStr2) = FALSE then
    begin
      sStr2 := ExtractfilePath(FormMain.StrCurrent);
    end;
    //
    FormMain.StrRetFormBrowse := '';
    FormMain.StrSetFormBrowse := sStr2;
    //
    FormBrowse := TFormBrowse.Create(Application);
    try
      if FormBrowse.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormBrowse.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormBrowse) = TRUE then
      begin
        Edit2.Text := FormMain.StrRetFormBrowse;
        Edit2.SetFocus;
      end
      else
      begin
        Edit2.SetFocus;
      end;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormInputFolder.ButtonListClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  //ݒ
  if Edit2.Text = '' then
  begin
    sStr2 := '';
  end
  else
  begin
    sStr2 := Edit2.Text;
  end;
  if DirectoryExists(sStr2) = FALSE then
  begin
    sStr2 := '';
  end;
  if SelectDirectorySh('Select Directory', sStr2, sStr1) = TRUE then
  begin
    Edit2.Text := sStr1;
    Edit2.SetFocus;
  end
  else
  begin
    Edit2.SetFocus;
  end;
end;

procedure TFormInputFolder.ButtonOKClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr9: String;
  iRow1: Integer;
begin
    //
    if Edit2.Text = '' then
    begin
      ButtonListClick(Sender);
      Exit;
    end;

    //`
    Edit2.Text := TrimRight(Edit2.Text);
    //ݒ
    if Copy(Edit2.Text, Length(Edit2.Text), 1) <> '\' then
    begin
      sStr1 := Edit2.Text + '\';
    end
    else
    begin
      sStr1 := Edit2.Text;
    end;

    //ExẽhCuύX
    if      UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%d') then
    begin
      sStr2 := FormMain.StrExeDrive + Copy(sStr1, 3,  Length(sStr1));
    end
    else if UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%p') then
    begin
      sStr2 := FormMain.StrExePath  + Copy(sStr1, 3,  Length(sStr1));
    end
    else
    begin
      sStr2 := sStr1;
    end;

    //
    if DirectoryExists(sStr2) = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : WṽtH_܂' + #13#10 +
                           sStr2;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Jump folder is not exist.' + #13#10 +
                           sStr2 + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end
    else
    begin
      if      Length(AnsiString(Edit1.Text)) < 12 then
      begin
        sStr5 := Edit1.Text + StringOfChar(' ', 12-Length(AnsiString(Edit1.Text)));
      end
      else if Length(AnsiString(Edit1.Text)) = 12 then
      begin
        sStr5 := Edit1.Text;
      end
      else
      begin
        sStr6 := '';
        for iRow1 := 0 to Length(Edit1.Text)-1 do
        begin
          sStr6 := Copy(Edit1.Text, 1, iRow1);
          if Length(AnsiString(sStr6)) > 12 then
          begin
            sStr6 := Copy(Edit1.Text, 1, iRow1-1);
            Break;
          end;
        end;
        sStr5 := sStr6 + StringOfChar(' ', 12-Length(AnsiString(sStr6)));
      end;
      sStr3 := StrListItems.Strings[FormMain.IntJumpFolderIndex];
      sStr4 := Copy(sStr3, 1, 3) + ' ' +
               sStr5             + ' ' +
               Edit2.Text;

      //f
      StrListItems.Strings[FormMain.IntJumpFolderIndex] := sStr4;
      //ۑ
      if FormMain.StrAnnsFMPath = '' then
      begin
        sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_JP2;
      end
      else
      begin
        sStr9 := FormMain.StrAnnsFMPath +  FILENAME_JP2;
      end;
      StrListItems.SaveToFile(sStr9);
      //I
      ModalResult := mrOK;
    end;
end;

procedure TFormInputFolder.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

function TFormInputFolder.SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;
var
  FolderPidl : PItemIDList;
  BrowseInfo : TBrowseInfo;
  BPathName  : array[0..MAX_PATH-1] of Char;
  AMalloc    : IMalloc;
begin
  //
  Result := FALSE;
  //ڎʎq̂߂̃AP[Ṽ|C^擾
  ShGetMalloc(AMalloc);
  FolderPidl := nil;
  //
  FillChar(BrowseInfo, SizeOf(BrowseInfo), #0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.lpfn      := nil;
  BrowseInfo.lpszTitle := PChar('Select Directory');
  BrowseInfo.pidlRoot  := nil;
  BrowseInfo.ulFlags   := BIF_RETURNONLYFSDIRS or
                          BIF_NEWDIALOGSTYLE   or
                          BIF_VALIDATE;

//BIF_RETURNONLYFSDIRS   $0001 t@CVXefBNĝ݂I\
//BIF_DONTGOBELOWDOMAIN  $0002 hC̃lbg[NtH_\Ȃ
//BIF_STATUSTEXT         $0004 _CAOc[̂ɕ\
//                             R[obN֐ŏKv
//BIF_RETURNFSANCESTORS	 $0008 [gȉ̃t@CCtH_̂ݑI\
//BIF_EDITBOX            $0010 OҏWp{bNX\
//BIF_VALIDATE           $0020 OҏW{bNXւ̖ȕ`FbN
//                             BIF_EDITBOX ̎w肪鎞̂ݗL
//                             ̓R[obN֐ōs
//BIF_NEWDIALOGSTYLE	   $0040	ȉ̐VX^C̃_CAO\
//                             TCY\
//                             _CAOւ̃hbOAhhbv
//                             tH_̍Đ
//                             V[gJbgj[ (ReLXg)
//                             VtH_̍쐬
//BIF_USENEWUI           $0050 OҏW{bNX̂VX^C
//                             BIF_EDITBOX or BIF_NEWDIALOGSTYLE wƓ
//BIF_BROWSEINCLUDEURLS	 $0080 URL\\Ƃ
//                             BIF_USENEWUIBIF_BROWSEINCLUDEFILES ̎wKv
//                             YtH_T|[gꍇ̂ݕ\
//BIF_UAHINT             $0100 OҏW{bNX̑Ƀqg\
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NONEWFOLDERBUTTON  $0200  [VtH_̍쐬] {^\Ȃ
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NOTRANSLATETARGETS $0400 IACeV[gJbg̏ꍇCNł͂ȂCV[gJbgg̍ڎʎqԂ
//BIF_BROWSEFORCOMPUTER  $1000 Rs[^̂ݑI\Ƃ
//BIF_BROWSEFORPRINTER   $2000 v^̂ݑI\Ƃ
//BIF_BROWSEINCLUDEFILES $4000 t@C\đI\Ƃ
//BIF_SHAREABLE          $8000 L\[X\đI\ɂ
//                             BIF_USENEWUI ̎wKv

  //̐ݒɊÂtH_Qƃ_CAO\
  try
    //擾
    FolderPidl := SHBrowseForFolder(BrowseInfo);
    If FolderPidl <> nil then
    begin
      //ڎʎqpX̕BPathNameɕϊ
      SHGetPathFromIDList(FolderPidl, BPathName);
      //
      Directory := BPathName;
      if Copy(Directory, Length(Directory), 1) <> '\' then
      begin
        Directory := Directory + '\';
      end;
      //
      Result := TRUE;
    end;
  finally
    //
    AMalloc.Free(FolderPidl);
  end;
end;

procedure TFormInputFolder.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormInputFolder.Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile:TIniFile;
  iIndex1: Integer;
begin
  //RETURN
  if Key = VK_RETURN then
  begin
    key := 0;
    if Edit2.Text = '' then
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //Ǎ
      iIndex1:= IniFile.ReadInteger('FolderSelect',      'Index', 2);
      //j
      IniFile.Free;

      //s
      if      iIndex1 = 0 then
      begin
        ButtonListClick(Sender);
      end
      else if iIndex1 = 1 then
      begin
        ButtonTreeClick(Sender);
      end
      else if iIndex1 = 2 then
      begin
        ButtonBrowseClick(Sender);
      end
      else
      begin
        ButtonTreeClick(Sender);
      end;
    end
    else
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end;
end;

procedure TFormInputFolder.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

end.
