unit InputPack;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_DEPRECATED    OFF} //W1000 : for FileCtrl
  {$WARN UNIT_PLATFORM   OFF} //W1005 : for Filectrl
  {$WARN SYMBOL_PLATFORM   OFF} //W1002  FileSetDate

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Filectrl, IniFiles,
  Math, ShlObj, ActiveX;

const
  FORM_WIDTH_SET    = 750;
  FORM_HEIGHT_SET   = 225;
  FORM_MAX          = 'MAX';
  FORM_MIN          = 'MIN';
  FORM_NORMAL       = 'NORMAL';

type
  TFormInputPack = class(TForm)
    ButtonList: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    ButtonTree: TButton;
    ButtonBrowse: TButton;
    ButtonCurrent: TButton;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Label129: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonListClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);

    function  SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;
    procedure ButtonTreeClick(Sender: TObject);
    procedure ButtonCurrentClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure ButtonBrowseClick(Sender: TObject);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormInputPack: TFormInputPack;

implementation


{$R *.dfm}

uses  Main, ArchiveSetting, Extract, Browse, Tree;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormInputPack.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormInputPack.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormInputPack.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormInputPack.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormInputPack.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormInputPack', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormInputPack', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormInputPack', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormInputPack', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormInputPack', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  Edit1.Text := IniFile.ReadString('PackName',   IntToStr(FormMain.IntPackIndex), '');
  Edit2.Text := IniFile.ReadString('PackFolder', IntToStr(FormMain.IntPackIndex), '');
  //j
  IniFile.Free;
end;

procedure TFormInputPack.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormInputPack', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormInputPack', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormInputPack', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormInputPack', 'Left',   FormInputPack.Left);
    IniFile.WriteInteger('FormInputPack', 'Top',    FormInputPack.Top);
    IniFile.WriteInteger('FormInputPack', 'Width',  FormInputPack.Width);
    IniFile.WriteInteger('FormInputPack', 'Height', FormInputPack.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormInputPack.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormInputPack, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormInputPack, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormInputPack.FormResize(Sender: TObject);
begin
  Edit2.Width := Panel1.ClientWidth - 40;
end;

procedure TFormInputPack.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormInputPack.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormInputPack.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormInputPack.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormInputPack.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormInputPack.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormInputPack.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'InputPack.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormInputPack, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormInputPack, StrLanguageFileName, Sender);
  end;
end;

procedure TFormInputPack.ButtonTreeClick(Sender: TObject);
var
  bResult: Boolean;
begin
    //
    FormMain.StrRetFormTree := '';
    FormMain.StrSetFormTree := ExtractfilePath(FormMain.StrCurrent);
    //
    FormTree := TFormTree.Create(Application);
    try
      if FormTree.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormTree.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormTree) = TRUE then
      begin
        Edit2.Text := FormMain.StrRetFormTree;
        Edit2.SetFocus;
      end
      else
      begin
        Edit2.SetFocus;
      end;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormInputPack.ButtonBrowseClick(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FOLDER);
  //j
  IniFile.Free;

    //
    FormMain.StrRetFormBrowse := '';
    FormMain.StrSetFormBrowse := ExtractfilePath(FormMain.StrCurrent);
    //
    FormBrowse := TFormBrowse.Create(Application);
    try
      if FormBrowse.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormBrowse.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //tH_
      if DirectoryExists(FormMain.StrRetFormBrowse) = TRUE then
      begin
        Edit2.Text := FormMain.StrRetFormBrowse;
        Edit2.SetFocus;
      end
      else
      begin
        Edit2.SetFocus;
      end;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormInputPack.ButtonCurrentClick(Sender: TObject);
begin
  Edit2.Text := ExtractFilePath(FormMain.StrCurrent);
  Edit2.SetFocus;
end;

procedure TFormInputPack.ButtonListClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  //ݒ
  if Edit2.Text = '' then
  begin
    sStr2 := '';
  end
  else
  begin
    sStr2 := Edit2.Text;
  end;
  if DirectoryExists(sStr2) = FALSE then
  begin
    sStr2 := '';
  end;
  if SelectDirectorySh('Select Directory', sStr2, sStr1) = TRUE then
  begin
    Edit2.Text := sStr1;
    Edit2.SetFocus;
  end
  else
  begin
    Edit2.SetFocus;
  end;
end;

procedure TFormInputPack.ButtonOKClick(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
  sStr2: String;
begin
    //ݒ
    if Copy(Edit2.Text, Length(Edit2.Text), 1) <> '\' then
    begin
      Edit2.Text := Edit2.Text + '\';
    end;
    sStr1 := Edit2.Text;

    //ExẽhCuύX
    if      UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%d') then
    begin
      sStr2 := FormMain.StrExeDrive + Copy(sStr1, 3,  Length(sStr1));
    end
    else if UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%p') then
    begin
      sStr2 := FormMain.StrExePath  + Copy(sStr1, 3,  Length(sStr1));
    end
    else
    begin
      sStr2 := sStr1;
    end;

    //
    if DirectoryExists(sStr2) = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : o^̃tH_܂' + #13#10 +
                            sStr2;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Registered folder is not exist.' + #13#10 +
                           sStr2 + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end
    else
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //Ǎ
      IniFile.WriteString('PackName',   IntToStr(FormMain.IntPackIndex), Edit1.Text);
      IniFile.WriteString('PackFolder', IntToStr(FormMain.IntPackIndex), sStr2);
      //j
      IniFile.Free;
      //I
      ModalResult := mrOK;
    end;
end;

procedure TFormInputPack.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

function TFormInputPack.SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;
var
  FolderPidl : PItemIDList;
  BrowseInfo : TBrowseInfo;
  BPathName  : array[0..MAX_PATH-1] of Char;
  AMalloc    : IMalloc;
begin
  //
  Result := FALSE;
  //ڎʎq̂߂̃AP[Ṽ|C^擾
  ShGetMalloc(AMalloc);
  FolderPidl := nil;
  //
  FillChar(BrowseInfo, SizeOf(BrowseInfo), #0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.lpfn      := nil;
  BrowseInfo.lpszTitle := PChar('Select Directory');
  BrowseInfo.pidlRoot  := nil;
  BrowseInfo.ulFlags   := BIF_RETURNONLYFSDIRS or
                          BIF_NEWDIALOGSTYLE   or
                          BIF_VALIDATE;

//BIF_RETURNONLYFSDIRS   $0001 t@CVXefBNĝ݂I\
//BIF_DONTGOBELOWDOMAIN  $0002 hC̃lbg[NtH_\Ȃ
//BIF_STATUSTEXT         $0004 _CAOc[̂ɕ\
//                             R[obN֐ŏKv
//BIF_RETURNFSANCESTORS	 $0008 [gȉ̃t@CCtH_̂ݑI\
//BIF_EDITBOX            $0010 OҏWp{bNX\
//BIF_VALIDATE           $0020 OҏW{bNXւ̖ȕ`FbN
//                             BIF_EDITBOX ̎w肪鎞̂ݗL
//                             ̓R[obN֐ōs
//BIF_NEWDIALOGSTYLE	   $0040	ȉ̐VX^C̃_CAO\
//                             TCY\
//                             _CAOւ̃hbOAhhbv
//                             tH_̍Đ
//                             V[gJbgj[ (ReLXg)
//                             VtH_̍쐬
//BIF_USENEWUI           $0050 OҏW{bNX̂VX^C
//                             BIF_EDITBOX or BIF_NEWDIALOGSTYLE wƓ
//BIF_BROWSEINCLUDEURLS	 $0080 URL\\Ƃ
//                             BIF_USENEWUIBIF_BROWSEINCLUDEFILES ̎wKv
//                             YtH_T|[gꍇ̂ݕ\
//BIF_UAHINT             $0100 OҏW{bNX̑Ƀqg\
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NONEWFOLDERBUTTON  $0200  [VtH_̍쐬] {^\Ȃ
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NOTRANSLATETARGETS $0400 IACeV[gJbg̏ꍇCNł͂ȂCV[gJbgg̍ڎʎqԂ
//BIF_BROWSEFORCOMPUTER  $1000 Rs[^̂ݑI\Ƃ
//BIF_BROWSEFORPRINTER   $2000 v^̂ݑI\Ƃ
//BIF_BROWSEINCLUDEFILES $4000 t@C\đI\Ƃ
//BIF_SHAREABLE          $8000 L\[X\đI\ɂ
//                             BIF_USENEWUI ̎wKv

  //̐ݒɊÂtH_Qƃ_CAO\
  try
    //擾
    FolderPidl := SHBrowseForFolder(BrowseInfo);
    If FolderPidl <> nil then
    begin
      //ڎʎqpX̕BPathNameɕϊ
      SHGetPathFromIDList(FolderPidl, BPathName);
      //
      Directory := BPathName;
      if Copy(Directory, Length(Directory), 1) <> '\' then
      begin
        Directory := Directory + '\';
      end;
      //
      Result := TRUE;
    end;
  finally
    //
    AMalloc.Free(FolderPidl);
  end;
end;


procedure TFormInputPack.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputPack.Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile:TIniFile;
  iIndex1: Integer;
begin
  //RETURN
  if Key = VK_RETURN then
  begin
    key := 0;
    if Edit2.Text = '' then
    begin
      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //Ǎ
      iIndex1:= IniFile.ReadInteger('FolderSelect',      'Index', 2);
      //j
      IniFile.Free;

      //s
      if      iIndex1 = 0 then
      begin
        ButtonListClick(Sender);
      end
      else if iIndex1 = 1 then
      begin
        ButtonTreeClick(Sender);
      end
      else if iIndex1 = 2 then
      begin
        ButtonBrowseClick(Sender);
      end
      else
      begin
        ButtonTreeClick(Sender);
      end;
    end
    else
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end;
end;

procedure TFormInputPack.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

end.
