unit Launcher;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, Clipbrd, Vcl.Menus, System.UITypes;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 540;
  FORM_MAX        = 'MAX';
  FORM_MIN        = 'MIN';
  FORM_NORMAL     = 'NORMAL';

  LISTBOX1_WIDTH       = 690;

type
  TFormLauncher = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    ListBox8: TListBox;
    ButtonCancel: TButton;
    ButtonOK: TButton;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuOperation: TMenuItem;
    MenuInput: TMenuItem;
    MenuDelete: TMenuItem;
    MenuKey: TMenuItem;
    MenuShift: TMenuItem;
    MenuCtrl: TMenuItem;
    MenuCA: TMenuItem;
    MenuA: TMenuItem;
    MenuSA: TMenuItem;
    MenuB: TMenuItem;
    MenuC: TMenuItem;
    MenuD: TMenuItem;
    MenuE: TMenuItem;
    MenuF: TMenuItem;
    MenuG: TMenuItem;
    MenuH: TMenuItem;
    MenuI: TMenuItem;
    MenuJ: TMenuItem;
    MenuK: TMenuItem;
    MenuL: TMenuItem;
    MenuM: TMenuItem;
    MenuN: TMenuItem;
    MenuO: TMenuItem;
    MenuP: TMenuItem;
    MenuQ: TMenuItem;
    MenuR: TMenuItem;
    MenuS: TMenuItem;
    MenuT: TMenuItem;
    MenuU: TMenuItem;
    MenuV: TMenuItem;
    MenuW: TMenuItem;
    MenuX: TMenuItem;
    MenuY: TMenuItem;
    MenuZ: TMenuItem;
    Menu0: TMenuItem;
    Menu1: TMenuItem;
    Menu2: TMenuItem;
    Menu3: TMenuItem;
    Menu4: TMenuItem;
    Menu5: TMenuItem;
    Menu6: TMenuItem;
    Menu7: TMenuItem;
    Menu8: TMenuItem;
    Menu9: TMenuItem;
    MenuSB: TMenuItem;
    MenuSC: TMenuItem;
    MenuSD: TMenuItem;
    MenuSE: TMenuItem;
    MenuSF: TMenuItem;
    MenuSG: TMenuItem;
    MenuSH: TMenuItem;
    MenuSI: TMenuItem;
    MenuSJ: TMenuItem;
    MenuSK: TMenuItem;
    MenuSL: TMenuItem;
    MenuSM: TMenuItem;
    MenuSN: TMenuItem;
    MenuSO: TMenuItem;
    MenuSP: TMenuItem;
    MenuSQ: TMenuItem;
    MenuSR: TMenuItem;
    MenuSS: TMenuItem;
    MenuST: TMenuItem;
    MenuSU: TMenuItem;
    MenuSV: TMenuItem;
    MenuSW: TMenuItem;
    MenuSX: TMenuItem;
    MenuSY: TMenuItem;
    MenuSZ: TMenuItem;
    MenuS0: TMenuItem;
    MenuS1: TMenuItem;
    MenuS2: TMenuItem;
    MenuS3: TMenuItem;
    MenuS4: TMenuItem;
    MenuS5: TMenuItem;
    MenuS6: TMenuItem;
    MenuS7: TMenuItem;
    MenuS8: TMenuItem;
    MenuS9: TMenuItem;
    MenuCB: TMenuItem;
    MenuCC: TMenuItem;
    MenuCD: TMenuItem;
    MenuCE: TMenuItem;
    MenuCF: TMenuItem;
    MenuCG: TMenuItem;
    MenuCH: TMenuItem;
    MenuCI: TMenuItem;
    MenuCJ: TMenuItem;
    MenuCK: TMenuItem;
    MenuCL: TMenuItem;
    MenuCM: TMenuItem;
    MenuCN: TMenuItem;
    MenuCO: TMenuItem;
    MenuCP: TMenuItem;
    MenuCQ: TMenuItem;
    MenuCR: TMenuItem;
    MenuCS: TMenuItem;
    MenuCT: TMenuItem;
    MenuCU: TMenuItem;
    MenuCV: TMenuItem;
    MenuCW: TMenuItem;
    MenuCX: TMenuItem;
    MenuCY: TMenuItem;
    MenuCZ: TMenuItem;
    MenuC0: TMenuItem;
    MenuC1: TMenuItem;
    MenuC2: TMenuItem;
    MenuC3: TMenuItem;
    MenuC4: TMenuItem;
    MenuC5: TMenuItem;
    MenuC6: TMenuItem;
    MenuC7: TMenuItem;
    MenuC8: TMenuItem;
    MenuC9: TMenuItem;
    MenuEscape: TMenuItem;
    MenuCopy: TMenuItem;
    MenuPaste: TMenuItem;
    MenuQuit: TMenuItem;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure ListBox8DblClick(Sender: TObject);
    procedure ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    procedure SetItemList(Sender: TObject);
    procedure MenuInputClick(Sender: TObject);
    procedure MenuDeleteClick(Sender: TObject);

    procedure MenuAClick(Sender: TObject);
    procedure MenuBClick(Sender: TObject);
    procedure MenuCClick(Sender: TObject);
    procedure MenuDClick(Sender: TObject);
    procedure MenuEClick(Sender: TObject);
    procedure MenuGClick(Sender: TObject);
    procedure MenuFClick(Sender: TObject);
    procedure MenuHClick(Sender: TObject);
    procedure MenuIClick(Sender: TObject);
    procedure MenuJClick(Sender: TObject);
    procedure MenuKClick(Sender: TObject);
    procedure MenuLClick(Sender: TObject);
    procedure MenuMClick(Sender: TObject);
    procedure MenuNClick(Sender: TObject);
    procedure MenuOClick(Sender: TObject);
    procedure MenuPClick(Sender: TObject);
    procedure MenuQClick(Sender: TObject);
    procedure MenuRClick(Sender: TObject);
    procedure MenuSClick(Sender: TObject);
    procedure MenuTClick(Sender: TObject);
    procedure MenuUClick(Sender: TObject);
    procedure MenuVClick(Sender: TObject);
    procedure MenuWClick(Sender: TObject);
    procedure MenuXClick(Sender: TObject);
    procedure MenuYClick(Sender: TObject);
    procedure MenuZClick(Sender: TObject);
    procedure Menu0Click(Sender: TObject);
    procedure Menu1Click(Sender: TObject);
    procedure Menu2Click(Sender: TObject);
    procedure Menu3Click(Sender: TObject);
    procedure Menu4Click(Sender: TObject);
    procedure Menu5Click(Sender: TObject);
    procedure Menu6Click(Sender: TObject);
    procedure Menu7Click(Sender: TObject);
    procedure Menu8Click(Sender: TObject);
    procedure Menu9Click(Sender: TObject);

    procedure MenuSAClick(Sender: TObject);
    procedure MenuSBClick(Sender: TObject);
    procedure MenuSCClick(Sender: TObject);
    procedure MenuSDClick(Sender: TObject);
    procedure MenuSEClick(Sender: TObject);
    procedure MenuSFClick(Sender: TObject);
    procedure MenuSGClick(Sender: TObject);
    procedure MenuSHClick(Sender: TObject);
    procedure MenuSIClick(Sender: TObject);
    procedure MenuSJClick(Sender: TObject);
    procedure MenuSKClick(Sender: TObject);
    procedure MenuSLClick(Sender: TObject);
    procedure MenuSMClick(Sender: TObject);
    procedure MenuSNClick(Sender: TObject);
    procedure MenuSOClick(Sender: TObject);
    procedure MenuSPClick(Sender: TObject);
    procedure MenuSQClick(Sender: TObject);
    procedure MenuSRClick(Sender: TObject);
    procedure MenuSSClick(Sender: TObject);
    procedure MenuSTClick(Sender: TObject);
    procedure MenuSUClick(Sender: TObject);
    procedure MenuSVClick(Sender: TObject);
    procedure MenuSWClick(Sender: TObject);
    procedure MenuSXClick(Sender: TObject);
    procedure MenuSYClick(Sender: TObject);
    procedure MenuSZClick(Sender: TObject);
    procedure MenuS0Click(Sender: TObject);
    procedure MenuS1Click(Sender: TObject);
    procedure MenuS2Click(Sender: TObject);
    procedure MenuS3Click(Sender: TObject);
    procedure MenuS4Click(Sender: TObject);
    procedure MenuS5Click(Sender: TObject);
    procedure MenuS6Click(Sender: TObject);
    procedure MenuS7Click(Sender: TObject);
    procedure MenuS8Click(Sender: TObject);
    procedure MenuS9Click(Sender: TObject);

    procedure MenuCAClick(Sender: TObject);
    procedure MenuCBClick(Sender: TObject);
    procedure MenuCCClick(Sender: TObject);
    procedure MenuCDClick(Sender: TObject);
    procedure MenuCEClick(Sender: TObject);
    procedure MenuCFClick(Sender: TObject);
    procedure MenuCGClick(Sender: TObject);
    procedure MenuCHClick(Sender: TObject);
    procedure MenuCIClick(Sender: TObject);
    procedure MenuCJClick(Sender: TObject);
    procedure MenuCKClick(Sender: TObject);
    procedure MenuCLClick(Sender: TObject);
    procedure MenuCMClick(Sender: TObject);
    procedure MenuCNClick(Sender: TObject);
    procedure MenuCOClick(Sender: TObject);
    procedure MenuCPClick(Sender: TObject);
    procedure MenuCQClick(Sender: TObject);
    procedure MenuCRClick(Sender: TObject);
    procedure MenuCSClick(Sender: TObject);
    procedure MenuCTClick(Sender: TObject);
    procedure MenuCUClick(Sender: TObject);
    procedure MenuCVClick(Sender: TObject);
    procedure MenuCWClick(Sender: TObject);
    procedure MenuCXClick(Sender: TObject);
    procedure MenuCYClick(Sender: TObject);
    procedure MenuCZClick(Sender: TObject);
    procedure MenuC0Click(Sender: TObject);
    procedure MenuC1Click(Sender: TObject);
    procedure MenuC2Click(Sender: TObject);
    procedure MenuC3Click(Sender: TObject);
    procedure MenuC4Click(Sender: TObject);
    procedure MenuC5Click(Sender: TObject);
    procedure MenuC6Click(Sender: TObject);
    procedure MenuC7Click(Sender: TObject);
    procedure MenuC8Click(Sender: TObject);
    procedure MenuC9Click(Sender: TObject);

    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
    procedure MenuCopyClick(Sender: TObject);
    procedure MenuPasteClick(Sender: TObject);
    procedure MenuEscapeClick(Sender: TObject);
    procedure MenuQuitClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListItems: TStringList;
    StrListKeyMap: TStringList;
    StrName : String;
    StrFile : String;
    StrCurrent : String;
    StrApplication : String;
    StrOptions : String;
    StrLanguageFileName: String;
    BoolJapanese: Boolean;

  public
    { Public 錾 }

  end;

var
  FormLauncher: TFormLauncher;

implementation

uses  Main, InputFolder, InputLauncher;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormLauncher.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormlauncher.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormLauncher.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormLauncher.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormLauncher.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr9: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormLauncher', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormLauncher', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormLauncher', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormLauncher', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormLauncher', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListItems := TStringList.Create;
  StrListKeyMap := TStringList.Create;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox8.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox8.Style := lbStandard;
  end;

  //mF
  if FormMain.StrAnnsFMPath = '' then
  begin
    sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_LNC;
  end
  else
  begin
    sStr9 := FormMain.StrAnnsFMPath +  FILENAME_LNC;
  end;
  if FileExists(sStr9) = TRUE then
  begin
    //Ǎ
    StrListItems.LoadFromFile(sStr9);
    //\
    SetItemList(Sender);
  end
  else
  begin
    //쐬
    StrListitems.Clear;
    StrListitems.Add('  A');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  B');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  C');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  D');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  E');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  F');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  G');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  H');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  I');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  J');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  K');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  L');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  M');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  N');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  O');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  P');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  Q');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  R');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  S');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  T');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  U');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  V');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  W');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  X');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  Y');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  Z');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  0');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  1');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  2');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  3');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  4');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  5');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  6');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  7');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  8');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  9');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+A');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+B');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+C');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+D');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+E');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+F');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+G');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+H');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+I');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+J');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+K');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+L');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+M');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+N');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+O');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+P');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+Q');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+R');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+S');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+T');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+U');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+V');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+W');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+X');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+Y');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+Z');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+0');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+1');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+2');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+3');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+4');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+5');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+6');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+7');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+8');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+9');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+A');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+B');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+C');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+D');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+E');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+F');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+G');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+H');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+I');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+J');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+K');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+L');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+M');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+N');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+O');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+P');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+Q');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+R');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+S');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+T');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+U');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+V');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+W');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+X');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+Y');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+Z');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+0');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+1');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+2');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+3');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+4');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+5');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+6');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+7');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+8');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+9');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    //ۑ
    StrListItems.SaveToFile(sStr9);
    //\
    SetItemList(Sender);
  end;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox8.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox8.Style := lbStandard;
  end;
end;

procedure TFormLauncher.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormLauncher', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormLauncher', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormLauncher', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormLauncher', 'Left',   FormLauncher.Left);
    IniFile.WriteInteger('FormLauncher', 'Top',    FormLauncher.Top);
    IniFile.WriteInteger('FormLauncher', 'Width',  FormLauncher.Width);
    IniFile.WriteInteger('FormLauncher', 'Height', FormLauncher.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListItems.Free;
  StrListKeyMap.Free;
end;

procedure TFormLauncher.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormLauncher.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormLauncher.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormLauncher.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormLauncher.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormLauncher.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  ListBox8.SetFocus;

  //XN[o[\
  ListBox8.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);

  //IMEIt
  SetImeMode(FormLauncher.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Launcher.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormLauncher, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormLauncher, StrLanguageFileName, Sender);
  end;
end;

procedure TFormLauncher.FormResize(Sender: TObject);
begin
  //
end;

procedure TFormLauncher.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //Return
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //key
  else if (Shift = []) and (key = VK_A) then
  begin
    ListBox8.ItemIndex := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_B) then
  begin
    ListBox8.ItemIndex := 1;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_C) then
  begin
    ListBox8.ItemIndex := 2;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_D) then
  begin
    ListBox8.ItemIndex := 3;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_E) then
  begin
    ListBox8.ItemIndex := 4;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_F) then
  begin
    ListBox8.ItemIndex := 5;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_G) then
  begin
    ListBox8.ItemIndex := 6;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_H) then
  begin
    ListBox8.ItemIndex := 7;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_I) then
  begin
    ListBox8.ItemIndex := 8;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_J) then
  begin
    ListBox8.ItemIndex := 9;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_K) then
  begin
    ListBox8.ItemIndex := 10;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_L) then
  begin
    ListBox8.ItemIndex := 11;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_M) then
  begin
    ListBox8.ItemIndex := 12;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_N) then
  begin
    ListBox8.ItemIndex := 13;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_O) then
  begin
    ListBox8.ItemIndex := 14;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_P) then
  begin
    ListBox8.ItemIndex := 15;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_Q) then
  begin
    ListBox8.ItemIndex := 16;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_R) then
  begin
    ListBox8.ItemIndex := 17;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_S) then
  begin
    ListBox8.ItemIndex := 18;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_T) then
  begin
    ListBox8.ItemIndex := 19;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_U) then
  begin
    ListBox8.ItemIndex := 20;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_V) then
  begin
    ListBox8.ItemIndex := 21;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_W) then
  begin
    ListBox8.ItemIndex := 22;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_X) then
  begin
    ListBox8.ItemIndex := 23;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_Y) then
  begin
    ListBox8.ItemIndex := 24;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = []) and (key = VK_Z) then
  begin
    ListBox8.ItemIndex := 25;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //shift
  else if (Shift = [ssShift]) and (key = VK_A) then
  begin
    ListBox8.ItemIndex := 0+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_B) then
  begin
    ListBox8.ItemIndex := 1+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_C) then
  begin
    ListBox8.ItemIndex := 2+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_D) then
  begin
    ListBox8.ItemIndex := 3+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_E) then
  begin
    ListBox8.ItemIndex := 4+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_F) then
  begin
    ListBox8.ItemIndex := 5+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_G) then
  begin
    ListBox8.ItemIndex := 6+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_H) then
  begin
    ListBox8.ItemIndex := 7+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_I) then
  begin
    ListBox8.ItemIndex := 8+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_J) then
  begin
    ListBox8.ItemIndex := 9+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_K) then
  begin
    ListBox8.ItemIndex := 10+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_L) then
  begin
    ListBox8.ItemIndex := 11+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_M) then
  begin
    ListBox8.ItemIndex := 12+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_N) then
  begin
    ListBox8.ItemIndex := 13+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_O) then
  begin
    ListBox8.ItemIndex := 14+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_P) then
  begin
    ListBox8.ItemIndex := 15+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_Q) then
  begin
    ListBox8.ItemIndex := 16+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_R) then
  begin
    ListBox8.ItemIndex := 17+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_S) then
  begin
    ListBox8.ItemIndex := 18+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_T) then
  begin
    ListBox8.ItemIndex := 19+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_U) then
  begin
    ListBox8.ItemIndex := 20+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_V) then
  begin
    ListBox8.ItemIndex := 21+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_W) then
  begin
    ListBox8.ItemIndex := 22+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_X) then
  begin
    ListBox8.ItemIndex := 23+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_Y) then
  begin
    ListBox8.ItemIndex := 24+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_Z) then
  begin
    ListBox8.ItemIndex := 25+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //ctrl
  else if (Shift = [ssCtrl]) and (key = VK_A) then
  begin
    ListBox8.ItemIndex := 0+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_B) then
  begin
    ListBox8.ItemIndex := 1+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_C) then
  begin
    ListBox8.ItemIndex := 2+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_D) then
  begin
    ListBox8.ItemIndex := 3+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_E) then
  begin
    ListBox8.ItemIndex := 4+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_F) then
  begin
    ListBox8.ItemIndex := 5+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_G) then
  begin
    ListBox8.ItemIndex := 6+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_H) then
  begin
    ListBox8.ItemIndex := 7+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_I) then
  begin
    ListBox8.ItemIndex := 8+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_J) then
  begin
    ListBox8.ItemIndex := 9+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_K) then
  begin
    ListBox8.ItemIndex := 10+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_L) then
  begin
    ListBox8.ItemIndex := 11+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_M) then
  begin
    ListBox8.ItemIndex := 12+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_N) then
  begin
    ListBox8.ItemIndex := 13+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_O) then
  begin
    ListBox8.ItemIndex := 14+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_P) then
  begin
    ListBox8.ItemIndex := 15+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_Q) then
  begin
    ListBox8.ItemIndex := 16+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_R) then
  begin
    ListBox8.ItemIndex := 17+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_S) then
  begin
    ListBox8.ItemIndex := 18+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_T) then
  begin
    ListBox8.ItemIndex := 19+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_U) then
  begin
    ListBox8.ItemIndex := 20+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_V) then
  begin
    ListBox8.ItemIndex := 21+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_W) then
  begin
    ListBox8.ItemIndex := 22+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_X) then
  begin
    ListBox8.ItemIndex := 23+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_Y) then
  begin
    ListBox8.ItemIndex := 24+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_Z) then
  begin
    ListBox8.ItemIndex := 25+26+26;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormLauncher, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormLauncher, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormLauncher.ButtonOKClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  IniFile: TIniFile;
begin
  //ݒȂ
  if Listbox8.Items.Count = 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Item is enpty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //I
  else if Listbox8.ItemIndex = -1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eIĂ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Item is not selected.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end
  //s
  else
  begin
    //ݒ
    sStr3 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 2];
    sStr1 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 3];
    sStr4 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 4];
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
    if IniFile.ReadBool('LauncherChangeDir', IntToStr(ListBox8.itemIndex), FALSE) = TRUE
    then
    begin
      sStr6 := '1';
    end
    else
    begin
      sStr6 := '0';
    end;
    //j
    IniFile.Free;

    //ExẽhCuύX
    if      UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%d') then
    begin
      sStr2 := FormMain.StrExeDrive + Copy(sStr1, 3,  Length(sStr1));
    end
    else if UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%p') then
    begin
      sStr2 := FormMain.StrExePath  + Copy(sStr1, 3,  Length(sStr1));
    end
    else
    begin
      sStr2 := sStr1;
    end;

    //
    if sStr2 <> '' then
    begin
      if (Copy(sStr2, 1, 1) = '"') and (Copy(sStr2, Length(sStr2), 1) = '"') then
      begin
        sStr5 := Copy(sStr2, 2, Length(sStr2)-2);
        sStr2 := sStr5;
      end;
    end;
    if FileExists(sStr2) = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : o^AvP[V܂' + #13#10 +
                            sStr2;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Registered aplication is not exist.' + #13#10 +
                            sStr2 + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end
    else
    begin
      //߂l
      FormMain.StrRetFormLauncherCurrent := sStr6;
      FormMain.StrRetFormLauncherFile    := sStr3;
      FormMain.StrRetFormLauncherName    := sStr2;
      FormMain.StrRetFormLauncherOption  := sStr4;
      //I
      ModalResult := mrOK;
    end;
  end;
end;

procedure TFormLauncher.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;


procedure TFormLauncher.ListBox8DblClick(Sender: TObject);
begin
  //OK
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormLauncher.MenuInputClick(Sender: TObject);
var
  iRow1: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr9: String;
  bResult: Boolean;
  IniFile: TIniFile;
begin
  // 
  FormMain.IntLauncherIndex := ListBox8.ItemIndex;
  FormInputLauncher := TFormInputLauncher.Create(Application);
  try
    if FormInputLauncher.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    // j
    FormInputLauncher.Free;
  end;
  if bResult = TRUE then
  begin
      //Ǎ
      if FormMain.StrAnnsFMPath = '' then
      begin
        sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_LNC;
      end
      else
      begin
        sStr9 := FormMain.StrAnnsFMPath +  FILENAME_LNC;
      end;
      StrListItems.LoadFromFile(sStr9);

      //ւ
      iRow1 := ListBox8.ItemIndex;

      //t@Cn
      if StrListItems.Strings[(iRow1 * 5) + 2] = '1' then
      begin
        sStr3 := 'File=ON ';
      end
      else
      begin
        sStr3 := 'File=OFF';
      end;

      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
      if IniFile.ReadBool('LauncherChangeDir', IntToStr(iRow1), FALSE) = TRUE then
      begin
        sStr7 := 'ChgCur=ON ';
      end
      else
      begin
        sStr7 := 'ChgCur=OFF';
      end;
      //j
      IniFile.Free;

      //ւ
      sStr1 := StrListItems.Strings[(iRow1 * 5) + 0];
      sStr2 := StrListItems.Strings[(iRow1 * 5) + 1];
//    sStr3 := StrListItems.Strings[(iRow1 * 5) + 2];
      sStr4 := StrListItems.Strings[(iRow1 * 5) + 3];
      sStr5 := StrListItems.Strings[(iRow1 * 5) + 4];
      sStr6 := sStr1 + ' ' +
               sStr2 + StringOfChar(' ', 12-Length(AnsiString(sStr2))) + ' ' +
               sStr3 + ' ' +
               sStr7 + ' ' +
               sStr4 + ' ' +
               sStr5;
      ListBox8.Items.Strings[ListBox8.ItemIndex] := sStr6;
  end;
end;

procedure TFormLauncher.MenuDeleteClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  wRet8: Word;
  iRow1: Integer;
  IniFile: TIniFile;
begin
  //擾
  sStr1 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 0];
  sStr2 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 1];
  sStr3 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 2];
  sStr4 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 3];
  sStr5 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 4];

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
  if IniFile.ReadBool('LauncherChangeDir', IntToStr(ListBox8.itemIndex), FALSE) = TRUE then
  begin
    sStr7 := '1';
  end
  else
  begin
    sStr7 := '0';
  end;
  //j
  IniFile.Free;

  //mF
  if BoolJapanese = TRUE then
  begin
    sStr8 := 'Key : '         + sStr1 + #13#10 +
                                        #13#10 +
             'Name : '        + sStr2 + #13#10 +
             'File : '        + sStr3 + #13#10 +
             'Current : '     + sStr7 + #13#10 +
             'Application : ' + sStr4 + #13#10 +
             'Options : '     + sStr5 + #13#10 +
                                        #13#10 +
             '폜܂H';
  end
  else
  begin
    sStr8 := 'Key : '         + sStr1 + #13#10 +
                                        #13#10 +
             'Name : '        + sStr2 + #13#10 +
             'File : '        + sStr3 + #13#10 +
             'Current : '     + sStr7 + #13#10 +
             'Application : ' + sStr4 + #13#10 +
             'Options : '     + sStr5 + #13#10 +
                                        #13#10 +
             'Delete ?'               + #13#10 +
             '[YES] / [NO]';
  end;
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    //ւ
    StrListItems.Strings[(ListBox8.itemIndex * 5) + 0] := sStr1;
    StrListItems.Strings[(ListBox8.itemIndex * 5) + 1] := '';
    StrListItems.Strings[(ListBox8.itemIndex * 5) + 2] := '1';
    StrListItems.Strings[(ListBox8.itemIndex * 5) + 3] := '';
    StrListItems.Strings[(ListBox8.itemIndex * 5) + 4] := '';

    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
    IniFile.WriteBool('LauncherChangeDir', IntToStr(ListBox8.itemIndex), FALSE);
    //j
    IniFile.Free;

    //ۑ
    if FormMain.StrAnnsFMPath = '' then
    begin
      sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_LNC;
    end
    else
    begin
      sStr9 := FormMain.StrAnnsFMPath +  FILENAME_LNC;
    end;
    StrListItems.SaveToFile(sStr9);

    //ւ
    iRow1 := ListBox8.ItemIndex;

    //t@Cn
    if StrListItems.Strings[(iRow1 * 5) + 2] = '1' then
    begin
      sStr3 := 'File=ON ';
    end
    else
    begin
      sStr3 := 'File=OFF';
    end;

    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
    if IniFile.ReadBool('LauncherChangeDir', IntToStr(iRow1), FALSE) = TRUE then
    begin
      sStr7 := 'ChgCur=ON ';
    end
    else
    begin
      sStr7 := 'ChgCur=OFF';
    end;
    //j
    IniFile.Free;

    //ւ
    sStr1 := StrListItems.Strings[(iRow1 * 5) + 0];
    sStr2 := StrListItems.Strings[(iRow1 * 5) + 1];
//  sStr3 := StrListItems.Strings[(iRow1 * 5) + 2];
    sStr4 := StrListItems.Strings[(iRow1 * 5) + 3];
    sStr5 := StrListItems.Strings[(iRow1 * 5) + 4];
    sStr6 := sStr1 + ' ' +
             sStr2 + StringOfChar(' ', 12-Length(AnsiString(sStr2))) + ' ' +
             sStr3 + ' ' +
             sStr7 + ' ' +
             sStr4 + ' ' +
             sStr5;
    ListBox8.Items.Strings[ListBox8.ItemIndex] := sStr6;
  end
  else
  begin
    //
  end;
end;

procedure TFormLauncher.MenuCopyClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr7: String;
  IniFile: TIniFile;
begin
  //擾
  sStr1 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 0];
  sStr2 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 1];
  sStr3 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 2];
  sStr4 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 3];
  sStr5 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 4];

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
  if IniFile.ReadBool('LauncherChangeDir', IntToStr(ListBox8.itemIndex), FALSE) = TRUE then
  begin
    sStr7 := '1';
  end
  else
  begin
    sStr7 := '0';
  end;
  //j
  IniFile.Free;

  //
  if sStr4 = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : e󔒂Ȃ̂ŃRs[ł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Copy can not operate , because of item is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  //ݒ
  StrName        := sStr2;
  StrFile        := sStr3;
  StrApplication := sStr4;
  StrOptions     := sStr5;
  StrCurrent     := sStr7;

end;

procedure TFormLauncher.MenuPasteClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr10: String;
  wRet8: Word;
  iRow1: Integer;
  IniFile: TIniFile;
begin
  //
  if StrApplication = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \t̓eł' + #13#10 +
                         'ŏɃRs[sĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Paste items is empty.' + #13#10 +
                         'Copy must be done before Paste' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //擾
  sStr1 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 0];
  sStr2 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 1];
  sStr3 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 2];
  sStr4 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 3];
  sStr5 := StrListItems.Strings[(ListBox8.itemIndex * 5) + 4];

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
  if IniFile.ReadBool('LauncherChangeDir', IntToStr(ListBox8.itemIndex), FALSE) = TRUE then
  begin
    sStr10 := '1';
  end
  else
  begin
    sStr10 := '0';
  end;
  //j
  IniFile.Free;

  //
  if (sStr4 <> '') or (sStr5 <> '') then
  begin
    //mF
    if BoolJapanese = TRUE then
    begin
      sStr8 := 'Key : '              + sStr1 +          #13#10 +
                                                        #13#10 +
               'Name(Old) : '        + sStr2 +          #13#10 +
               'Name(New) : '        + StrName +        #13#10 +
                                                        #13#10 +
               'File(Old) : '        + sStr3 +          #13#10 +
               'File(New) : '        + StrFile +        #13#10 +
                                                        #13#10 +
               'Current(Old) : '     + sStr10 +         #13#10 +
               'Current(New) : '     + StrCurrent +     #13#10 +
                                                        #13#10 +
               'Application(Old) : ' + sStr4 +          #13#10 +
               'Application(New) : ' + StrApplication + #13#10 +
                                                        #13#10 +
               'Options(Old) : '     + sStr5 +          #13#10 +
               'Options(New) : '     + StrOptions +     #13#10 +
                                                        #13#10 +
               '㏑܂H';
    end
    else
    begin
      sStr8 := 'Key : '              + sStr1 +          #13#10 +
                                                        #13#10 +
               'Name(Old) : '        + sStr2 +          #13#10 +
               'Name(New) : '        + StrName +        #13#10 +
                                                        #13#10 +
               'File(Old) : '        + sStr3 +          #13#10 +
               'File(New) : '        + StrFile +        #13#10 +
                                                        #13#10 +
               'Current(Old) : '     + sStr10 +         #13#10 +
               'Current(New) : '     + StrCurrent +     #13#10 +
                                                        #13#10 +
               'Application(Old) : ' + sStr4 +          #13#10 +
               'Application(New) : ' + StrApplication + #13#10 +
                                                        #13#10 +
               'Options(Old) : '     + sStr5 +          #13#10 +
               'Options(New) : '     + StrOptions +     #13#10 +
                                                        #13#10 +
               'Over Write ?'                         + #13#10 +
               '[YES] / [NO]';
    end;
    wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
    if wRet8 = mrYes then
    begin
      //s
    end
    else
    begin
      //~
      Exit;
    end;

  end
  else
  begin
    //
  end;

    //ւ
    StrListItems.Strings[(ListBox8.itemIndex * 5) + 0] := sStr1;
    StrListItems.Strings[(ListBox8.itemIndex * 5) + 1] := StrName;
    StrListItems.Strings[(ListBox8.itemIndex * 5) + 2] := StrFile;
    StrListItems.Strings[(ListBox8.itemIndex * 5) + 3] := StrApplication;
    StrListItems.Strings[(ListBox8.itemIndex * 5) + 4] := StrOptions;
    //ۑ
    if FormMain.StrAnnsFMPath = '' then
    begin
      sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_LNC;
    end
    else
    begin
      sStr9 := FormMain.StrAnnsFMPath +  FILENAME_LNC;
    end;
    StrListItems.SaveToFile(sStr9);

    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
    if StrCurrent = '1' then
    begin
      IniFile.WriteBool('LauncherChangeDir', IntToStr(ListBox8.itemIndex), TRUE);
    end
    else
    begin
      IniFile.WriteBool('LauncherChangeDir', IntToStr(ListBox8.itemIndex), FALSE);
    end;
    //j
    IniFile.Free;

    //ւ
    iRow1 := ListBox8.ItemIndex;

    //t@Cn
    if StrListItems.Strings[(iRow1 * 5) + 2] = '1' then
    begin
      sStr3 := 'File=ON ';
    end
    else
    begin
      sStr3 := 'File=OFF';
    end;

    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
    if IniFile.ReadBool('LauncherChangeDir', IntToStr(iRow1), FALSE) = TRUE then
    begin
      sStr7 := 'ChgCur=ON ';
    end
    else
    begin
      sStr7 := 'ChgCur=OFF';
    end;
    //j
    IniFile.Free;

    //ւ
    sStr1 := StrListItems.Strings[(iRow1 * 5) + 0];
    sStr2 := StrListItems.Strings[(iRow1 * 5) + 1];
//  sStr3 := StrListItems.Strings[(iRow1 * 5) + 2];
    sStr4 := StrListItems.Strings[(iRow1 * 5) + 3];
    sStr5 := StrListItems.Strings[(iRow1 * 5) + 4];
    sStr6 := sStr1 + ' ' +
             sStr2 + StringOfChar(' ', 12-Length(AnsiString(sStr2))) + ' ' +
             sStr3 + ' ' +
             sStr7 + ' ' +
             sStr4 + ' ' +
             sStr5;
    ListBox8.Items.Strings[ListBox8.ItemIndex] := sStr6;

end;


procedure TFormLauncher.SetItemList(Sender: TObject);
var
  iRow1: Integer;
  iCount1: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  iRow11: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //NA
  ListBox8.Items.Clear;
  //ݒ
  iCount1 := StrListItems.Count div 5;
  for iRow1 := 0 to iCount1-1 do
  begin
      sStr13 := StrListItems.Strings[(iRow1 * 5) + 1];
      if sStr13 <> '' then
      begin
        sStr11 := '';
        sStr12 := '';
        for iRow11 := 0 to Length(sStr13) do
        begin
          sStr12:= sStr12 + Copy(sStr13, iRow11+1, 1);
          if Length(AnsiString(sStr12)) <= LAUNCHER_NAME_MAX then
          begin
            sStr11:= sStr11 + Copy(sStr13, iRow11+1, 1);
          end;
        end;
      end
      else
      begin
        sStr11 := sStr13;
      end;
      //t@Cn
      if StrListItems.Strings[(iRow1 * 5) + 2] = '1' then
      begin
        sStr3 := 'File=ON ';
      end
      else
      begin
        sStr3 := 'File=OFF';
      end;

      //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
      if IniFile.ReadBool('LauncherChangeDir', IntToStr(iRow1), FALSE) = TRUE then
      begin
        sStr7 := 'ChgCur=ON ';
      end
      else
      begin
        sStr7 := 'ChgCur=OFF';
      end;

      //ݒ
      sStr1 := StrListItems.Strings[(iRow1 * 5) + 0];
      sStr2 := sStr11;
//      sStr3 := StrListItems.Strings[(iRow1 * 5) + 2];
      sStr4 := StrListItems.Strings[(iRow1 * 5) + 3];
      sStr5 := StrListItems.Strings[(iRow1 * 5) + 4];
      sStr6 := sStr1 + ' ' +
               sStr2 + StringOfChar(' ', 12-Length(AnsiString(sStr2))) + ' ' +
               sStr3 + ' ' +
               sStr7 + ' ' +
               sStr4 + ' ' +
               sStr5;
      ListBox8.Items.Add(sStr6);
  end;
  ListBox8.ItemIndex := 0;

  //j
  IniFile.Free;
end;

procedure TFormLauncher.MenuAClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 0;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuBClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 1;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 2;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuDClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 3;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuEClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 4;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuEscapeClick(Sender: TObject);
begin
  ButtonCancelClick(Sender);
end;

procedure TFormLauncher.MenuFClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 5;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuGClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 6;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuHClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 7;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuIClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 8;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuJClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 9;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuKClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 10;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuLClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 11;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuMClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 12;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuNClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 13;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuOClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 14;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuPClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 15;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuQClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 16;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuQuitClick(Sender: TObject);
begin
  ButtonCancelClick(Sender);
end;

procedure TFormLauncher.MenuRClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 17;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 18;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuTClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 19;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuUClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 20;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuVClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 21;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuWClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 22;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuXClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 23;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuYClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 24;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuZClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 25;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.Menu0Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 26+0;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.Menu1Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 26+1;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.Menu2Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 26+2;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.Menu3Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 26+3;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.Menu4Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 26+4;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.Menu5Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 26+5;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.Menu6Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 26+6;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.Menu7Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 26+7;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.Menu8Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 26+8;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.Menu9Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 26+9;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;



procedure TFormLauncher.MenuSAClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+0;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSBClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+1;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSCClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+2;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSDClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+3;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSEClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+4;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSFClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+5;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSGClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+6;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSHClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+7;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSIClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+8;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSJClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+9;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSKClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+10;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSLClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+11;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSMClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+12;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSNClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+13;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSOClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+14;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSPClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+15;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSQClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+16;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSRClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+17;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSSClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+18;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSTClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+19;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSUClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+20;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSVClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+21;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSWClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+22;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSXClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+23;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSYClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+24;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuSZClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 36+25;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuS0Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 37+0;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuS1Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 37+1;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuS2Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 37+2;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuS3Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 37+3;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuS4Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 37+4;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuS5Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 37+5;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuS6Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 37+6;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuS7Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 37+7;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuS8Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 37+8;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuS9Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 37+9;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCAClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+0;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCBClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+1;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCCClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+2;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCDClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+3;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCEClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+4;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCFClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+5;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCGClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+6;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCHClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+7;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCIClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+8;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCJClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+9;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCKClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+10;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCLClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+11;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCMClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+12;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCNClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+13;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCOClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+14;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCPClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+15;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCQClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+16;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCRClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+17;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCSClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+18;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCTClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+19;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCUClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+20;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCVClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+21;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCWClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+22;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCXClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+23;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCYClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+24;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuCZClick(Sender: TObject);
begin
  ListBox8.ItemIndex := 72+25;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuC0Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 73+0;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuC1Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 73+1;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuC2Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 73+2;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuC3Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 73+3;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuC4Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 73+4;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuC5Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 73+5;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuC6Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 73+6;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuC7Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 73+7;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuC8Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 73+8;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.MenuC9Click(Sender: TObject);
begin
  ListBox8.ItemIndex := 73+9;
  ButtonOK.SetFocus;
  ButtonOKClick(Sender);
end;

procedure TFormLauncher.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //annsfm
  if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
  begin
    //Ǎ
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_ANNSFM_LIST;
    if FileExists(sStr1) = TRUE then
    begin
      StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
    end;

    //ݒ
    if StrListKeyMap.Count > 0 then
    begin
//      SetShortCutNew('1017', MenuQuit, Sender);
      SetShortCutNew('1311', MenuEscape, Sender);
    end;
  end;
end;

procedure TFormLauncher.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //ݒ
    sStr3 := '';
  end
  else
  begin
    //ݒ
    sStr3 := sStr16;
  end;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

end.

