unit RenameAll;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_PLATFORM OFF} //W1002

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, DecEdit, Vcl.ExtCtrls,
  IniFiles, System.IOUtils, System.UITypes, Character, MyUtility;

const
  FORM_WIDTH_SET       = 720;
  FORM_HEIGHT_SET      = 720;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX1_WIDTH       = 345;

type
  TFormRenameAll = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    GroupBox1: TGroupBox;
    CheckBox3: TCheckBox;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    DecEdit1: TDecEdit;
    DecEdit2: TDecEdit;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    ButtonTest: TButton;
    ButtonRename: TButton;
    ButtonCancel: TButton;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Timer1: TTimer;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit3: TEdit;
    RadioGroup1: TRadioGroup;
    ButtonUp: TButton;
    ButtonDown: TButton;
    Label4: TLabel;
    Label5: TLabel;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    Edit4: TEdit;
    Edit5: TEdit;
    ButtonSet1: TButton;
    ButtonSet2: TButton;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonTestClick(Sender: TObject);
    procedure ButtonRenameClick(Sender: TObject);

    function  GetNumber(Digit: Integer; AddZero: Boolean; Start: Integer; Index: Integer; Step: Integer): String;
    procedure Timer1Timer(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure ButtonUpClick(Sender: TObject);
    procedure ButtonDownClick(Sender: TObject);
    procedure ButtonSet1Click(Sender: TObject);
    procedure ButtonSet2Click(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolKeyRun: Boolean;
    BoolJapanese: Boolean;
    BoolRenameDone: Boolean;
    StrLanguageFileName: String;
    IntItemIndex: Integer;

  public
    { Public 錾 }

  end;

var
  FormRenameAll: TFormRenameAll;

implementation

{$R *.dfm}

uses Main, InputDateTime;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormRenameAll.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormRenameAll.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormRenameAll.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormRenameAll.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormRenameAll.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormRenameAll', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormRenameAll', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormRenameAll', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormRenameAll', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormRenameAll', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //Ǎ
  if FileExists(FormMain.StrExtractBase + RENAME_ALL_TXT) = TRUE then
  begin
    FormMain.StrListRenameAllSrc.LoadFromFile(FormMain.StrExtractBase + RENAME_ALL_TXT, TEncoding.Unicode);
  end;
  ListBox1.Items.BeginUpdate;
  ListBox1.Items.Clear;
  for iRow1 := 0 to FormMain.StrListRenameAllSrc.Count-1 do
  begin
    ListBox1.Items.Add(FormMain.StrListRenameAllSrc.Strings[iRow1]);
  end;
  ListBox1.Items.EndUpdate;
  ListBox1.ItemIndex := 0;

  //NA
  ListBox2.Items.Clear;
  //NA
  FormMain.StrListRenameAllResult.Clear;
  //t@Ĉݐݒ肷
  for iRow1 := 0 to FormMain.StrListRenameAllSrc.Count-1 do
  begin
    FormMain.StrListRenameAllResult.Add(ExtractFilePath(FormMain.StrCurrent) + FormMain.StrListRenameAllSrc.Strings[iRow1]);
  end;

  //Ǎ
  if FileExists(ExtractFilePath(ParamStr(0)) + RENAME_ALL_DATE_TXT) = TRUE then
  begin
    FormMain.StrListRenameAllDate.LoadFromFile(ExtractFilePath(ParamStr(0)) + RENAME_ALL_DATE_TXT, TEncoding.Unicode);
  end
  else
  begin
    FormMain.StrListRenameAllDate.Add('');
    FormMain.StrListRenameAllDate.Add('');
    FormMain.StrListRenameAllDate.Add('');
    FormMain.StrListRenameAllDate.Add('');
    FormMain.StrListRenameAllDate.Add('');
  end;

  //
  BoolRenameDone := FALSE;
  BoolKeyRun := FALSE;
  Edit4.ReadOnly := TRUE;
  Edit5.ReadOnly := TRUE;
  Label6.Left := 20;
  Label7.Left := 20;
  Label8.Left := 20;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
    ListBox2.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
    ListBox2.Style := lbStandard;
  end;
end;

procedure TFormRenameAll.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormRenameAll', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormRenameAll', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormRenameAll', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormRenameAll', 'Left',   FormRenameAll.Left);
    IniFile.WriteInteger('FormRenameAll', 'Top',    FormRenameAll.Top);
    IniFile.WriteInteger('FormRenameAll', 'Width',  FormRenameAll.Width);
    IniFile.WriteInteger('FormRenameAll', 'Height', FormRenameAll.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteInteger('FormRenameAll', 'NumberMode',      RadioGroup1.ItemIndex);
  IniFile.WriteInteger('FormRenameAll', 'NoneUpperLower',  RadioGroup2.ItemIndex);
  IniFile.WriteInteger('FormRenameAll', 'HankakuZenkaku',  RadioGroup3.ItemIndex);
  IniFile.WriteBool   ('FormRenameAll', 'SameName',        CheckBox1.Checked);
  IniFile.WriteBool   ('FormRenameAll', 'ChangeExtention', CheckBox2.Checked);
  IniFile.WriteBool   ('FormRenameAll', 'NumberZero',      CheckBox3.Checked);
  IniFile.WriteBool   ('FormRenameAll', 'TextAddTop',      CheckBox4.Checked);
  IniFile.WriteBool   ('FormRenameAll', 'TextAddEnd',      CheckBox5.Checked);
  IniFile.WriteBool   ('FormRenameAll', 'FileTimeAddTop',  CheckBox6.Checked);
  IniFile.WriteBool   ('FormRenameAll', 'FileTimeAddEnd',  CheckBox7.Checked);
  IniFile.WriteString ('FormRenameAll', 'NumberStart',     DecEdit1.Text);
  IniFile.WriteString ('FormRenameAll', 'NumberAdd',       DecEdit2.Text);
  //j
  IniFile.Free;

  //ݒ
  FormMain.StrListRenameAllDate.Strings[0] := Edit1.Text;
  FormMain.StrListRenameAllDate.Strings[1] := Edit2.Text;
  FormMain.StrListRenameAllDate.Strings[2] := Edit3.Text;
  FormMain.StrListRenameAllDate.Strings[3] := Edit4.Text;
  FormMain.StrListRenameAllDate.Strings[4] := Edit5.Text;
  //ۑ
  FormMain.StrListRenameAllDate.SaveToFile(ExtractFilePath(ParamStr(0)) + RENAME_ALL_DATE_TXT, TEncoding.Unicode);

end;

procedure TFormRenameAll.FormResize(Sender: TObject);
begin
  ListBox1.Width := Panel2.ClientWidth div 2;
end;

procedure TFormRenameAll.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormRenameAll.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormRenameAll.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormRenameAll.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormRenameAll.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormRenameAll.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormRenameAll.Handle, imClose);

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 5, 0);
  ListBox2.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 5, 0);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'RenameAll.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormRenameAll, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormRenameAll, StrLanguageFileName, Sender);
  end;

  //ݒ
  if      FormMain.IntSortMode1 = 5 then
  begin
    Label6.Visible := FALSE;
    Label7.Visible := TRUE;
    Label8.Visible := FALSE;
  end
  else if FormMain.IntSortMode1 = 6 then
  begin
    Label6.Visible := FALSE;
    Label7.Visible := FALSE;
    Label8.Visible := TRUE;
  end
  else
  begin
    Label6.Visible := TRUE;
    Label7.Visible := FALSE;
    Label8.Visible := FALSE;
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  CheckBox1.Checked     := IniFile.ReadBool   ('FormRenameAll', 'SameName',         TRUE);
  CheckBox2.Checked     := IniFile.ReadBool   ('FormRenameAll', 'ChangeExtention', FALSE);
  CheckBox3.Checked     := IniFile.ReadBool   ('FormRenameAll', 'NumberZero',      FALSE);
  CheckBox4.Checked     := IniFile.ReadBool   ('FormRenameAll', 'TextAddTop',      FALSE);
  CheckBox5.Checked     := IniFile.ReadBool   ('FormRenameAll', 'TextAddEnd',      FALSE);
  CheckBox6.Checked     := IniFile.ReadBool   ('FormRenameAll', 'FileTimeAddTop',  FALSE);
  CheckBox7.Checked     := IniFile.ReadBool   ('FormRenameAll', 'FileTimeAddEnd',  FALSE);
  DecEdit1.Text         := IniFile.ReadString ('FormRenameAll', 'NumberStart',        '1');
  DecEdit2.Text         := IniFile.ReadString ('FormRenameAll', 'NumberAdd',          '1');
  RadioGroup1.ItemIndex := IniFile.ReadInteger('FormRenameAll', 'NumberMode',          4);
  RadioGroup2.ItemIndex := IniFile.ReadInteger('FormRenameAll', 'NoneUpperLower',      0);
  RadioGroup3.ItemIndex := IniFile.ReadInteger('FormRenameAll', 'HankakuZenkaku',      0);
  //j
  IniFile.Free;

  //ݒ
  Edit1.Text := FormMain.StrListRenameAllDate.Strings[0];
  Edit2.Text := FormMain.StrListRenameAllDate.Strings[1];
  Edit3.Text := FormMain.StrListRenameAllDate.Strings[2];
  Edit4.Text := FormMain.StrListRenameAllDate.Strings[3];
  Edit5.Text := FormMain.StrListRenameAllDate.Strings[4];

  //ݒ
  RadioGroup1Click(Sender);
  CheckBox2Click(Sender);
  if RadioGroup1.ItemIndex <> 4 then
  begin
    CheckBox3Click(Sender);
  end;
  CheckBox4Click(Sender);
  CheckBox5Click(Sender);
end;

procedure TFormRenameAll.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iIndex1: Integer;
  iIndex2: Integer;
  iIndex3: Integer;
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //L
    iIndex1 := RadioGroup1.ItemIndex;
    iIndex2 := RadioGroup2.ItemIndex;
    iIndex3 := RadioGroup3.ItemIndex;

    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormRenameAll, StrLanguageFileName, Sender);

    //ݒ
    RadioGroup1.ItemIndex := iIndex1;
    RadioGroup2.ItemIndex := iIndex2;
    RadioGroup3.ItemIndex := iIndex3;
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //L
    iIndex1 := RadioGroup1.ItemIndex;
    iIndex2 := RadioGroup2.ItemIndex;
    iIndex3 := RadioGroup3.ItemIndex;

    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormRenameAll, StrLanguageFileName, Sender);

    //ݒ
    RadioGroup1.ItemIndex := iIndex1;
    RadioGroup2.ItemIndex := iIndex2;
    RadioGroup3.ItemIndex := iIndex3;
  end
  //Up
  else if ((Shift = [ssCtrl]) and (key = VK_UP)) then
  begin
    ButtonUpClick(Sender);
    key := 0;
  end
  //Down
  else if ((Shift = [ssCtrl]) and (key = VK_DOWN)) then
  begin
    ButtonDownClick(Sender);
    key := 0;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormRenameAll.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormRenameAll.ListBox2DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormRenameAll.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex = 4 then
  begin
      CheckBox3.Visible := FALSE;

      ComboBox1.Visible := FALSE;

      Label1.Visible    := FALSE;
      Label2.Visible    := FALSE;
      Label3.Visible    := FALSE;

      DecEdit1.Visible  := FALSE;
      DecEdit2.Visible  := FALSE;
  end
  else
  begin
      CheckBox3.Visible := TRUE;

      ComboBox1.Visible := TRUE;

      Label1.Visible    := TRUE;
      Label2.Visible    := TRUE;
      Label3.Visible    := TRUE;

      DecEdit1.Visible  := TRUE;
      DecEdit2.Visible  := TRUE;

      CheckBox3Click(Sender);
  end;
end;

procedure TFormRenameAll.Timer1Timer(Sender: TObject);
begin
  if (ListBox1.Items.Count > 0) and (ListBox2.Items.Count > 0)then
  begin
    //ŏIʒuƈقȂ
    if ListBox1.TopIndex <> IntItemIndex then
    begin
      ListBox2.TopIndex := ListBox1.TopIndex;
    end
    else
    begin
      ListBox1.TopIndex := ListBox2.TopIndex;
    end;
    //ʒuL
    IntItemIndex := ListBox1.TopIndex;
  end;
end;

procedure TFormRenameAll.ButtonTestClick(Sender: TObject);
var
  iRow1: Integer;
  iRow2: Integer;
  iStart1: Integer;
  iDegit1: Integer;
  iStep1: Integer;
  iMax1: Integer;
  iValue1: Integer;
  iFind1: Integer;
  iError1: Integer;
  bError1: Boolean;
  bError2: Boolean;
  bError3: Boolean;
  bError4: Boolean;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr10: String;
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos6: Integer;
  iPos7: Integer;
  iPos8: Integer;
  iPos9: Integer;

  function HankakuUpper(Src: String): String;
  var
    Str1: String;
  begin
    Str1 := Src;
    Str1 := System.SysUtils.StringReplace(Str1, 'a', 'A', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'b', 'B', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'c', 'C', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'd', 'D', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'e', 'E', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'f', 'F', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'g', 'G', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'h', 'H', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'i', 'I', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'j', 'J', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'k', 'K', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'l', 'L', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'm', 'M', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'n', 'N', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'o', 'O', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'p', 'P', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'q', 'Q', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'r', 'R', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 's', 'S', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 't', 'T', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'u', 'U', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'v', 'V', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'w', 'W', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'x', 'X', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'y', 'Y', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'z', 'Z', [rfReplaceAll]);
    Result := Str1;
  end;

  function HankakuLower(Src: String): String;
  var
    Str1: String;
  begin
    Str1 := Src;
    Str1 := System.SysUtils.StringReplace(Str1, 'A', 'a', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'B', 'b', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'C', 'c', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'D', 'd', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'E', 'e', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'F', 'f', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'G', 'g', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'H', 'h', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'I', 'i', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'J', 'j', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'K', 'k', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'L', 'l', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'M', 'm', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'N', 'n', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'O', 'o', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'P', 'p', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'Q', 'q', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'R', 'r', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'S', 's', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'T', 't', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'U', 'u', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'V', 'v', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'W', 'w', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'X', 'x', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'Y', 'y', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'Z', 'z', [rfReplaceAll]);
    Result := Str1;
  end;

  function ZenkakuUpper(Src: String): String;
  var
    Str1: String;
  begin
    Str1 := Src;
    Str1 := System.SysUtils.StringReplace(Str1, '', '`', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'a', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'b', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'c', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'd', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'e', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'f', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'g', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'h', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'i', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'j', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'k', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'l', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'm', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'n', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'o', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'p', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'q', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'r', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 's', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 't', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'u', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'v', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'w', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'x', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, '', 'y', [rfReplaceAll]);
    Result := Str1;
  end;

  function ZenkakuLower(Src: String): String;
  var
    Str1: String;
  begin
    Str1 := Src;
    Str1 := System.SysUtils.StringReplace(Str1, '`', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'a', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'b', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'c', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'd', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'e', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'f', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'g', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'h', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'i', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'j', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'k', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'l', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'm', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'n', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'o', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'p', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'q', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'r', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 's', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 't', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'u', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'v', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'w', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'x', '', [rfReplaceAll]);
    Str1 := System.SysUtils.StringReplace(Str1, 'y', '', [rfReplaceAll]);
    Result := Str1;
  end;

  function GetDateTime(FileName: String; DateTime: String; var ResultDateTime: String): Boolean;
  var
    sStr5: String;
    sStr6: String;
    sYear1: String;
    sMonth1: String;
    sDay1: String;
    sHour1: String;
    sMinute1: String;
    sSecond1: String;
    sYear2: String;
    sMonth2: String;
    sDay2: String;
    sHour2: String;
    sMinute2: String;
    sSecond2: String;
    File2: TWin32FindData;
    hFindData1: THandle;
  begin
//ȉ̍ڂ̐ݒ肪\ł
//yyyy NS
//mm   Q
//dd   Q
//hh   Q
//nn   Q
//ss   bQ
//
//YY NQ
//M  P܂͂Q
//D  P܂͂Q
//H  P܂͂Q
//N  P܂͂Q
//S  bP܂͂Q
//
//ł
//yyyy/mm/dd hh:mm:ss 2021/01/02 07:08:09
//YY/mm/dd hh:mm:ss   21/01/02 07:08:09
//yyyy/M/D H:N:S      2021/1/2 7:8:9
//yyyy/M/D H:N:S      2021/01/02 07:08:09

    //
    ResultDateTime := '';
    Result := TRUE;

    //t@Č
    hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(FileName), File2);
    if hFindData1 <> INVALID_HANDLE_VALUE then
    begin
      //ݒ
      if      FormMain.IntSortMode1 = 5 then
      begin
            sStr5 :=  SearchRecFileTimeToDateEx(File2.ftCreationTime, FALSE) + ' ' +
                      SearchRecFileTimeToTimeEx(File2.ftCreationTime, FALSE);
      end
      else if FormMain.IntSortMode1 = 6 then
      begin
            sStr5 :=  SearchRecFileTimeToDateEx(File2.ftLastAccessTime, FALSE) + ' ' +
                      SearchRecFileTimeToTimeEx(File2.ftLastAccessTime, FALSE);
      end
      else
      begin
            sStr5 :=  SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE) + ' ' +
                      SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
      end;
        //ݎ
        //sStr5 := FormatDateTime('yyyy-mm-dd hh-nn-ss', Now);
        //t@C
        //sStr5 :=                 'yyyy/mm/dd hh:nn:ss';

        //擾
        sYear1   := Copy(sStr5,  1, 4);
        sMonth1  := Copy(sStr5,  6, 2);
        sDay1    := Copy(sStr5,  9, 2);
        sHour1   := Copy(sStr5, 12, 2);
        sMinute1 := Copy(sStr5, 15, 2);
        sSecond1 := Copy(sStr5, 18, 2);
        //擾
        sYear2   := Copy(sYear1, 3, 2);
        sMonth2  := StringReplace(sMonth1,  '0', '', [rfReplaceAll]);
        sDay2    := StringReplace(sDay1,    '0', '', [rfReplaceAll]);
        sHour2   := StringReplace(sHour1,   '0', '', [rfReplaceAll]);
        sMinute2 := StringReplace(sMinute1, '0', '', [rfReplaceAll]);
        sSecond2 := StringReplace(sSecond1, '0', '', [rfReplaceAll]);

        //擾
        sStr6 := DateTime;
        //u
        sStr6 := StringReplace(sStr6, 'yyyy', sYear1,   [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'mm',   sMonth1,  [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'dd',   sDay1,    [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'hh',   sHour1,   [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'nn',   sMinute1, [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'ss',   sSecond1, [rfReplaceAll]);
        //u
        sStr6 := StringReplace(sStr6, 'YY',   sYear2,   [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'M',    sMonth2,  [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'D',    sDay2,    [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'H',    sHour2,   [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'N',    sMinute2, [rfReplaceAll]);
        sStr6 := StringReplace(sStr6, 'S',    sSecond2, [rfReplaceAll]);
        //
        ResultDateTime := sStr6;
        Result := FALSE;
    end;
  end;

begin
  if ListBox1.Items.Count > 0 then
  begin
//  AX^XN (*)
//  c_ (|)
//  ~L (\)
//  R (:)
//  dp (")
//  s (菬) (<)
//  s () (>)
//  ^╄ (?)
//  XbV (/)

    //
    iPos1 := Pos('*', Edit1.Text);
    iPos2 := Pos('|', Edit1.Text);
    iPos3 := Pos('\', Edit1.Text);
    iPos4 := Pos(':', Edit1.Text);
    iPos5 := Pos('"', Edit1.Text);
    iPos6 := Pos('<', Edit1.Text);
    iPos7 := Pos('>', Edit1.Text);
    iPos8 := Pos('?', Edit1.Text);
    iPos9 := Pos('/', Edit1.Text);
    if (iPos1 > 0) or (iPos2 > 0) or (iPos3 > 0) or (iPos4 > 0) or
       (iPos5 > 0) or (iPos6 > 0) or (iPos7 > 0) or (iPos8 > 0) or
       (iPos9 > 0) then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : O̒ǉɁAsȕ܂܂Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Add top letters can not accept.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //
    iPos1 := Pos('*', Edit2.Text);
    iPos2 := Pos('|', Edit2.Text);
    iPos3 := Pos('\', Edit2.Text);
    iPos4 := Pos(':', Edit2.Text);
    iPos5 := Pos('"', Edit2.Text);
    iPos6 := Pos('<', Edit2.Text);
    iPos7 := Pos('>', Edit2.Text);
    iPos8 := Pos('?', Edit2.Text);
    iPos9 := Pos('/', Edit2.Text);
    if (iPos1 > 0) or (iPos2 > 0) or (iPos3 > 0) or (iPos4 > 0) or
       (iPos5 > 0) or (iPos6 > 0) or (iPos7 > 0) or (iPos8 > 0) or
       (iPos9 > 0) then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ̒ǉɁAsȕ܂܂Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Add end letters can not accept.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //ől̐ݒ
    iDegit1 := StrToInt(ComboBox1.Text);
    iStart1 := StrToInt(DecEdit1.Text);
    iStep1  := StrToInt(DecEdit2.Text);
    if      iDegit1 = 1 then
    begin
      iMax1 := 9;
    end
    else if iDegit1 = 2 then
    begin
      iMax1 := 99;
    end
    else if iDegit1 = 3 then
    begin
      iMax1 := 999;
    end
    else if iDegit1 = 4 then
    begin
      iMax1 := 9999;
    end
    else if iDegit1 = 5 then
    begin
      iMax1 := 99999;
    end
    else if iDegit1 = 6 then
    begin
      iMax1 := 999999;
    end
    else if iDegit1 = 7 then
    begin
      iMax1 := 9999999;
    end
    else if iDegit1 = 8 then
    begin
      iMax1 := 99999999;
    end
    else if iDegit1 = 9 then
    begin
      iMax1 := 999999999;
    end
    else
    begin
      iMax1 := 9;
    end;

    //ԍmF
    iValue1 := iStart1;
    for iRow1 := 0 to ListBox1.Items.Count-1 do
    begin
      iValue1 := iValue1 + iStep1;
    end;
    if iValue1 > iMax1 then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
       FormMain.StrMsg := 'Information : ŏIԍ𒴂Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Degit of last number is lather than degit.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //gqݒ
    if CheckBox2.Checked = TRUE then
    begin
      if Edit3.Text <> '' then
      begin
        if Copy(Edit3.Text, 1, 1) <> '.' then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
           FormMain.StrMsg := 'Information : 擪 . [sIh] ܂';
          end
          else
          begin
            FormMain.StrMsg := 'Information : Top letter is not . [piriod].' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Exit;
        end;
        if Length(Edit3.Text) < 2 then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
           FormMain.StrMsg := 'Information : gq 2 ȏݒ肵ĉ';
          end
          else
          begin
            FormMain.StrMsg := 'Information : Extention length must be greater than or equal to 2 letters.' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Exit;
        end;
      end;

    end;

    //Zbg
    BoolRenameDone := FALSE;

    //XV
    ListBox2.Items.BeginUpdate;
    ListBox2.Items.Clear;
    ListBox2.Items.EndUpdate;

    //
    sStr6 := '';
    iFind1 := -1;
    bError1 := FALSE;
    bError2 := FALSE;
    bError3 := FALSE;
    bError4 := FALSE;

    //XV
    ListBox2.Items.BeginUpdate;
    //
    for iRow1 := 0 to ListBox1.Items.Count-1 do
    begin
      sStr1 := '';
      sStr2 := '';
      sStr4 := '';
      sStr5 := '';
      //O{ԍ
      if      RadioGroup1.ItemIndex = 0 then
      begin
        //GetNumber(Digit: Integer; AddZero: Boolean; Start: Integer; Index: Integer; Step: Integer): String;
        if CheckBox4.Checked = TRUE then
        begin
          sStr1 := Edit1.Text + GetNumber(iDegit1, CheckBox3.Checked, iStart1, iRow1, iStep1);
        end
        else
        begin
          sStr1 := GetNumber(iDegit1, CheckBox3.Checked, iStart1, iRow1, iStep1);
        end;

        if CheckBox5.Checked = TRUE then
        begin
          sStr2 := Edit2.Text;
        end;
      end
      //ԍ{O
      else if RadioGroup1.ItemIndex = 1 then
      begin
        if CheckBox4.Checked = TRUE then
        begin
          sStr1 := GetNumber(iDegit1, CheckBox3.Checked, iStart1, iRow1, iStep1) + Edit1.Text;
        end
        else
        begin
          sStr1 := GetNumber(iDegit1, CheckBox3.Checked, iStart1, iRow1, iStep1);
        end;

        if CheckBox5.Checked = TRUE then
        begin
          sStr2 := Edit2.Text;
        end;
      end
      //{ԍ
      else if RadioGroup1.ItemIndex = 2 then
      begin
        if CheckBox4.Checked = TRUE then
        begin
          sStr1 := Edit1.Text;
        end;

        if CheckBox5.Checked = TRUE then
        begin
          sStr2 := Edit2.Text + GetNumber(iDegit1, CheckBox3.Checked, iStart1, iRow1, iStep1);
        end
        else
        begin
          sStr2 := GetNumber(iDegit1, CheckBox3.Checked, iStart1, iRow1, iStep1);
        end;
      end
      //ԍ{
      else if RadioGroup1.ItemIndex = 3 then
      begin
        if CheckBox4.Checked = TRUE then
        begin
          sStr1 := Edit1.Text;
        end;

        if CheckBox5.Checked = TRUE then
        begin
          sStr2 := GetNumber(iDegit1, CheckBox3.Checked, iStart1, iRow1, iStep1) + Edit2.Text;
        end
        else
        begin
          sStr2 := GetNumber(iDegit1, CheckBox3.Checked, iStart1, iRow1, iStep1);
        end;
      end
      //
      else
      begin
        if CheckBox4.Checked = TRUE then
        begin
          sStr1 := Edit1.Text;
        end;
        if CheckBox5.Checked = TRUE then
        begin
          sStr2 := Edit2.Text;
        end;
      end;
      //擾
      sStr3 := ListBox1.Items.Strings[iRow1];
      //gq
      if CheckBox2.Checked = TRUE then
      begin
        sStr4 := Edit3.Text;
      end
      else
      begin
        sStr4 := ExtractFileExt(sStr3);
      end;
      //O
      if CheckBox1.Checked = TRUE then
      begin
        sStr5 := Copy(sStr3, 1, Length(sStr3) - Length(ExtractFileExt(sStr3)));
      end
      else
      begin
        sStr5 := '';
      end;

      //gqύX
      if CheckBox2.Checked = TRUE then
      begin
        //擪L
        if iRow1 = 0 then
        begin
          sStr6 := UpperCase(ExtractFileExt(sStr3));
        end;
        //gq𔻒
        if iFind1 = -1 then
        begin
          //Ⴄgq
          if sStr6 <> UpperCase(ExtractFileExt(sStr3)) then
          begin
            iFind1 := iRow1;
          end;
        end;
      end;

      //t@C̏ϊ
      if (CheckBox6.Checked = TRUE) and (Edit4.Text <> '') then
      begin
        //t@C
        sStr10 := ExtractFilePath(FormMain.StrCurrent) + ListBox1.Items.Strings[iRow1];
        sStr8 := '';
        //^CX^v擾
        bError3 := GetDateTime(sStr10, Edit4.Text, sStr8);
        if bError3 = TRUE then
        begin
          Break;
        end;
      end
      else
      begin
        sStr8 := '';
      end;

      //t@C̏ϊ
      if (CheckBox7.Checked = TRUE) and (Edit5.Text <> '') then
      begin
        //t@C
        sStr10 := ExtractFilePath(FormMain.StrCurrent) + ListBox1.Items.Strings[iRow1];
        sStr9 := '';
        //^CX^v擾
        bError4 := GetDateTime(sStr10, Edit5.Text, sStr9);
        if bError4 = TRUE then
        begin
          Break;
        end;
      end
      else
      begin
        sStr9 := '';
      end;

      //ݒ薳
      if (sStr1 + sStr8 + sStr5 + sStr2 + sStr9) = '' then
      begin
        bError1 := TRUE;
        Break;
      end;

      //ǉ
      sStr7 := sStr1 + sStr8 + sStr5 + sStr2 + sStr9 + sStr4;
      //
      if      RadioGroup2.ItemIndex = 1 then
      begin
        sStr7 := HankakuUpper(sStr7);
      end
      else if RadioGroup2.ItemIndex = 2 then
      begin
        sStr7 := HankakuLower(sStr7);
      end
      else
      begin
        ;
      end;
      //
      if      RadioGroup3.ItemIndex = 1 then
      begin
        sStr7 := ZenkakuUpper(sStr7);
      end
      else if RadioGroup3.ItemIndex = 2 then
      begin
        sStr7 := ZenkakuLower(sStr7);
      end
      else
      begin
        ;
      end;
      ListBox2.Items.Add(sStr7);
    end;
    ListBox2.Items.EndUpdate;

    //Oݒ肳ĂȂ
    if bError1 = TRUE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : Oݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Name is empty.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //`FbN
    iError1 := 0;
    for iRow1 := 0 to ListBox2.items.Count-1 do
    begin
      for iRow2 := 0 to ListBox2.items.Count-1 do
      begin
        if iRow1 <> iRow2 then
        begin
          if UpperCase(ListBox2.Items.Strings[iRow1]) = UpperCase(ListBox2.Items.Strings[iRow2]) then
          begin
            bError2 := TRUE;
            iError1 := iRow1;
            Break;
          end;
        end;
      end;
      if bError2 = TRUE then
      begin
        Break;
      end;
    end;

    //ꂪ
    if bError2 = TRUE then
    begin
      //ړ
      ListBox2.ItemIndex := iError1;
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ꖼ܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Same name is found.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //擾Ɏs
    if (bError3 = TRUE) then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : uOɒǉṽt@C̎擾Ɏs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Get file time stamp in Add Top failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //擾Ɏs
    if (bError4 = TRUE) then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : uɒǉṽt@C̎擾Ɏs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Get file time stamp in Add End failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //Ⴄgq
    if iFind1 <> -1 then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : Xg쐬܂' + #13#10 +
                           'AقȂgq܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Make list had done.' + #13#10 +
                           'But, some extention is not same.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : Xg쐬܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Make list had done.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;
  end;
end;

procedure TFormRenameAll.ButtonUpClick(Sender: TObject);
begin
  //JԂ𐧌
  if BoolKeyRun = TRUE then
  begin
    Exit;
  end;
  BoolKeyRun := TRUE;

  //ݒȂ
  if Listbox1.Items.Count = 0 then
  begin
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Item is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    BoolKeyRun := FALSE;
    Exit;
  end
  //I
  else if Listbox1.ItemIndex = -1 then
  begin
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eIĂ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Item is not select.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    BoolKeyRun := FALSE;
    Exit;
  end;

  if ListBox1.Items.Count <= 1 then
  begin
    BoolKeyRun := FALSE;
    Exit;
  end;
  if ListBox1.ItemIndex = 0 then
  begin
    BoolKeyRun := FALSE;
    Exit;
  end;
  //ړ
  ListBox1.Items.Exchange(ListBox1.ItemIndex, ListBox1.ItemIndex-1);

  //XV
  BoolKeyRun := FALSE;
end;

procedure TFormRenameAll.ButtonDownClick(Sender: TObject);
begin
  //JԂ𐧌
  if BoolKeyRun = TRUE then
  begin
    Exit;
  end;
  BoolKeyRun := TRUE;

  //ݒȂ
  if Listbox1.Items.Count = 0 then
  begin
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Item is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    BoolKeyRun := FALSE;
    Exit;
  end
  //I
  else if Listbox1.ItemIndex = -1 then
  begin
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eIĂ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Item is not select.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    BoolKeyRun := FALSE;
    Exit;
  end;

  if ListBox1.Items.Count <= 1 then
  begin
    BoolKeyRun := FALSE;
    Exit;
  end;
  if ListBox1.ItemIndex = ListBox1.Items.Count-1 then
  begin
    BoolKeyRun := FALSE;
    Exit;
  end;
  //ړ
  ListBox1.Items.Exchange(ListBox1.ItemIndex, ListBox1.ItemIndex+1);

  //XV
  BoolKeyRun := FALSE;
end;

procedure TFormRenameAll.ButtonRenameClick(Sender: TObject);
var
  iRow1: Integer;
  iRow2: Integer;
  iError1: Integer;
  sStr1: String;
  sStr2: String;
  sStr8: String;
  bError2: Boolean;
  bResult1: Boolean;
  File1: TWin32FindData;
  hFindData1: THandle;
  iRet1: Integer;
  wRet8: Word;
begin
  if ListBox2.Items.Count = 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
     FormMain.StrMsg := 'Information : ŏɁuXg쐬v𑀍삵Ă';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Operate [MakeList] before [Rename].' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //`FbN
  iError1 := 0;
  bError2 := FALSE;
  for iRow1 := 0 to ListBox2.items.Count-1 do
  begin
    for iRow2 := 0 to ListBox2.items.Count-1 do
    begin
      if iRow1 <> iRow2 then
      begin
        if UpperCase(ListBox2.Items.Strings[iRow1]) = UpperCase(ListBox2.Items.Strings[iRow2]) then
        begin
          bError2 := TRUE;
          iError1 := iRow1;
          Break;
        end;
      end;
    end;
    if bError2 = TRUE then
    begin
      Break;
    end;
  end;

  //ꂪ
  if bError2 = TRUE then
  begin
    //ړ
    ListBox2.ItemIndex := iError1;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ꖼ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Same name is found.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //mF
  if BoolJapanese = TRUE then
  begin
    sStr8 := 'Information : ꊇŖOύX܂' + #13#10 +
             'ύX܂H';
  end
  else
  begin
    sStr8 := 'Information : Rename all files at one time.' + #13#10 +
             'Rename files ?' + #13#10 +
             '[YES] / [NO]';
  end;
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    ;
  end
  else
  begin
    Exit;
  end;

  //Xg쐬ς
  if ListBox2.Items.Count > 0 then
  begin
    //s
    for iRow1 := 0 to ListBox2.Items.Count-1 do
    begin
      //t@C
      sStr1 := ExtractFilePath(FormMain.StrCurrent) + ListBox1.Items.Strings[iRow1];
      //t@C
      sStr2 := ExtractFilePath(FormMain.StrCurrent) + ListBox2.Items.Strings[iRow1];

      //t@C擾
      hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr1), File1);
      try
        ;
      finally
        WinApi.Windows.FindClose(hFindData1);
      end;

      //
      if hFindData1 <> INVALID_HANDLE_VALUE then
      begin
        //𔻒
        if ((File1.dwFileAttributes and faReadOnly) = faReadOnly) or
           ((File1.dwFileAttributes and faHidden)   = faHidden)   or
           ((File1.dwFileAttributes and faSysFile)  = faSysFile)  then
        begin
          //Zbg
          iRet1 := FileSetAttr(sStr1, 0);
          //s
          if iRet1 <> 0 then
          begin
            //ݒ
            if BoolJapanese = TRUE then
            begin
              FormMain.StrMsg := 'Error : t@C̕ύXs܂' + #13#10 +
                                  sStr1;
            end
            else
            begin
              FormMain.StrMsg := 'Error : File attribute can not change.' + #13#10 +
                                  sStr1 + #13#10 +
                                 '[OK]';
            end;
            ShowMessage(FormMain.StrMsg);
            Exit;
          end;
        end;

//        //SHFileOperation ͋󔒂܂񂾃t@C̕ϊɎŝ TFile g
//        //ύX
//        bResult1 := TRUE;
//        try
//          TFile.Move(sStr1, sStr2);
//        except
//          bResult1 := FALSE;
//        end;

        //̃t@CŁA啶Ə̕ύXɑΉ邽߂ RenameFile ɕύX
        bResult1 := RenameFile(sStr1, sStr2);

        //
        if bResult1 = FALSE then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Error : t@C̕ύXɎs܂' + #13#10 +
                                sStr1 + #13#10 +
                                sStr2;
          end
          else
          begin
            FormMain.StrMsg := 'Error : File name can not rename.' + #13#10 +
                                sStr1 + #13#10 +
                                sStr2 + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Exit;
        end;

        //瑮߂
        iRet1 := FileSetAttr(sStr2, File1.dwFileAttributes);
        //s
        if iRet1 <> 0 then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Error : t@C̕ύXs܂' + #13#10 +
                                sStr2;
          end
          else
          begin
            FormMain.StrMsg := 'Error : File attribute can not change.' + #13#10 +
                                sStr2 + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Exit;
        end;
        //ւ
        FormMain.StrListRenameAllResult.Strings[iRow1] := ExtractFilePath(FormMain.StrCurrent) + ListBox2.Items.Strings[iRow1];
      end;
    end;

    //
    BoolRenameDone := TRUE;

    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : OύX܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Rename had done.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormRenameAll.ButtonSet1Click(Sender: TObject);
var
  bResult: Boolean;
begin
    //ݒ
    FormMain.StrRetFormInputDateTime := Edit4.Text;
    //
    FormInputDateTime := TFormInputDateTime.Create(Application);
    try
      if FormInputDateTime.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormInputDateTime.Free;
    end;
    Application.ProcessMessages;
    FormMain.ListView1.SetFocus;
    //ݒǍ
    if bResult = TRUE then
    begin
      //ݒ
      Edit4.Text := FormMain.StrRetFormInputDateTime;
    end;
end;

procedure TFormRenameAll.ButtonSet2Click(Sender: TObject);
var
  bResult: Boolean;
begin
    //ݒ
    FormMain.StrRetFormInputDateTime := Edit5.Text;
    //
    FormInputDateTime := TFormInputDateTime.Create(Application);
    try
      if FormInputDateTime.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormInputDateTime.Free;
    end;
    Application.ProcessMessages;
    FormMain.ListView1.SetFocus;
    //ݒǍ
    if bResult = TRUE then
    begin
      //ݒ
      Edit5.Text := FormMain.StrRetFormInputDateTime;
    end;
end;

procedure TFormRenameAll.ButtonCancelClick(Sender: TObject);
begin
  if BoolRenameDone = TRUE then
  begin
    //I
    ModalResult := mrOK;
  end
  else
  begin
    //I
    ModalResult := mrCancel;
  end;
end;

function  TFormRenameAll.GetNumber(Digit: Integer; AddZero: Boolean; Start: Integer; Index: Integer; Step: Integer): String;
var
  sStr1: String;
begin
  //[ L
  if AddZero = TRUE then
  begin
    if      Digit = 1 then
    begin
      sStr1 := Format('%.1d', [Start + (Index * Step)]);
    end
    else if Digit = 2 then
    begin
      sStr1 := Format('%.2d', [Start + (Index * Step)]);
    end
    else if Digit = 3 then
    begin
      sStr1 := Format('%.3d', [Start + (Index * Step)]);
    end
    else if Digit = 4 then
    begin
      sStr1 := Format('%.4d', [Start + (Index * Step)]);
    end
    else if Digit = 5 then
    begin
      sStr1 := Format('%.5d', [Start + (Index * Step)]);
    end
    else if Digit = 6 then
    begin
      sStr1 := Format('%.6d', [Start + (Index * Step)]);
    end
    else if Digit = 7 then
    begin
      sStr1 := Format('%.7d', [Start + (Index * Step)]);
    end
    else if Digit = 8 then
    begin
      sStr1 := Format('%.8d', [Start + (Index * Step)]);
    end
    else if Digit = 9 then
    begin
      sStr1 := Format('%.9d', [Start + (Index * Step)]);
    end
    else
    begin
      sStr1 := Format('%.1d', [Start + (Index * Step)]);
    end;
  end
  //[ 
  else
  begin
      sStr1 := Format('%d', [Start + (Index * Step)]);
  end;
  //
  Result := sStr1;
end;

procedure TFormRenameAll.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked = TRUE then
  begin
    Edit3.Visible    := TRUE;
  end
  else
  begin
    Edit3.Visible    := FALSE;
  end;
end;

procedure TFormRenameAll.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked = TRUE then
  begin
    Label1.Visible    := TRUE;
    ComboBox1.Visible := TRUE;
  end
  else
  begin
    Label1.Visible    := FALSE;
    ComboBox1.Visible := FALSE;
  end;
end;

procedure TFormRenameAll.CheckBox4Click(Sender: TObject);
begin
  if CheckBox4.Checked = TRUE then
  begin
    Edit1.Visible    := TRUE;
  end
  else
  begin
    Edit1.Visible    := FALSE;
  end;
end;

procedure TFormRenameAll.CheckBox5Click(Sender: TObject);
begin
  if CheckBox5.Checked = TRUE then
  begin
    Edit2.Visible    := TRUE;
  end
  else
  begin
    Edit2.Visible    := FALSE;
  end;
end;

end.
