unit RunProgram;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN UNIT_PLATFORM   OFF} //W1005 : for Filectrl

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, MyUtility, Filectrl;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 230;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormRunProgram = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label95: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    OpenDialog1: TOpenDialog;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ButtonList: TButton;
    ButtonBrowse: TButton;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonListClick(Sender: TObject);

    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ComboBox2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ButtonBrowseClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormRunProgram: TFormRunProgram;

implementation

uses
  Main, Browse;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormRunProgram.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormRunProgram.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormRunProgram.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormRunProgram.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  StrList1: TStringList;
  StrList2: TStringList;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormRunProgram', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormRunProgram', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormRunProgram', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormRunProgram', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormRunProgram', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //ݒ
  ComboBox1.AutoComplete := FALSE;
  ComboBox2.AutoComplete := FALSE;

  //m
  StrList1 := TStringList.Create;
  //Ǎ
  if FileExists(ExtractFilePath(ParamStr(0)) + RUN_TXT) = TRUE then
  begin
    StrList1.LoadFromFile(ExtractFilePath(ParamStr(0)) + RUN_TXT, TEncoding.Unicode);
  end
  else
  begin
    for iRow1 := 0 to RUN_PROGRAN_HISTORY_MAX-1 do
    begin
      StrList1.Add('');
    end;
  end;
  ComboBox1.Items.Assign(StrList1);
  //j
  StrList1.Free;
  //ݒ
  ComboBox1.Text := FormMain.StrSetFormRunProgramExeName;

  //m
  StrList2 := TStringList.Create;
  //Ǎ
  if FileExists(ExtractFilePath(ParamStr(0)) + OPT_TXT) = TRUE then
  begin
    StrList2.LoadFromFile(ExtractFilePath(ParamStr(0)) + OPT_TXT, TEncoding.Unicode);
  end
  else
  begin
    for iRow1 := 0 to RUN_PROGRAN_HISTORY_MAX-1 do
    begin
      StrList2.Add('');
    end;
  end;
  ComboBox2.Items.Assign(StrList2);
  //j
  StrList2.Free;
  //ݒ
  ComboBox2.Text := '';
end;

procedure TFormRunProgram.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
  StrList1: TStringList;
  StrList2: TStringList;
  iRow1: Integer;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString ('FormRunProgram', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString ('FormRunProgram', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormRunProgram', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormRunProgram', 'Left',   FormRunProgram.Left);
    IniFile.WriteInteger('FormRunProgram', 'Top',    FormRunProgram.Top);
    IniFile.WriteInteger('FormRunProgram', 'Width',  FormRunProgram.Width);
    IniFile.WriteInteger('FormRunProgram', 'Height', FormRunProgram.Height);
  end;
  //j
  IniFile.Free;

  //m
  StrList1 := TStringList.Create;
  //ۑ
  StrList1.Clear;
  for iRow1 := 0 to RUN_PROGRAN_HISTORY_MAX-1 do
  begin
    StrList1.Add(ComboBox1.Items.Strings[iRow1]);
  end;
  StrList1.SaveToFile(ExtractFilePath(ParamStr(0)) + RUN_TXT, TEncoding.Unicode);
  //j
  StrList1.Free;

  //m
  StrList2 := TStringList.Create;
  //ۑ
  StrList2.Clear;
  for iRow1 := 0 to RUN_PROGRAN_HISTORY_MAX-1 do
  begin
    StrList2.Add(ComboBox2.Items.Strings[iRow1]);
  end;
  StrList2.SaveToFile(ExtractFilePath(ParamStr(0)) + OPT_TXT, TEncoding.Unicode);
  //j
  StrList2.Free;

end;

procedure TFormRunProgram.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormRunProgram.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormRunProgram.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormRunProgram.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormRunProgram.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormRunProgram.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormRunProgram.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'RunProgram.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormRunProgram, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormRunProgram, StrLanguageFileName, Sender);
  end;
end;

procedure TFormRunProgram.FormResize(Sender: TObject);
begin
  ComboBox1.Width := Panel1.ClientWidth - 40;
  ComboBox2.Width := Panel1.ClientWidth - 40;
end;

procedure TFormRunProgram.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormRunProgram.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormRunProgram, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormRunProgram, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormRunProgram.ButtonOKClick(Sender: TObject);
var
  iIndex1: Integer;
begin
  //XV
  with ComboBox1 do
  begin
    if Text <> '' then
    begin
      //
      for iIndex1 := 0 to Items.Count-1 do
      begin
        if Items[iIndex1] = Text then
        begin
          //폜
          Items.Delete(iIndex1);
          Break;
        end;
      end;
      //擪ɑ}
      Items.Insert(0, Text);
      if Items.Count > RUN_PROGRAN_HISTORY_MAX then
      begin
        Items.Delete(Items.Count-1);
      end;

      //
      for iIndex1 := Items.Count-1 downto 0 do
      begin
        if Items[iIndex1] = '' then
        begin
          //폜
          Items.Delete(iIndex1);
        end;
      end;
    end;
  end;

  //XV
  with ComboBox2 do
  begin
    if Text <> '' then
    begin
      //
      for iIndex1 := 0 to Items.Count-1 do
      begin
        if Items[iIndex1] = Text then
        begin
          //폜
          Items.Delete(iIndex1);
          Break;
        end;
      end;
      //擪ɑ}
      Items.Insert(0, Text);
      if Items.Count > RUN_PROGRAN_HISTORY_MAX then
      begin
        Items.Delete(Items.Count-1);
      end;

      //
      for iIndex1 := Items.Count-1 downto 0 do
      begin
        if Items[iIndex1] = '' then
        begin
          //폜
          Items.Delete(iIndex1);
        end;
      end;
    end;
  end;

  //߂l
  FormMain.StrRetFormRunProgramExeName := ComboBox1.Text;
  FormMain.StrRetFormRunProgramOptions := ComboBox2.Text;
  //I
  ModalResult := mrOK;
end;

procedure TFormRunProgram.ButtonBrowseClick(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FILE);
  //j
  IniFile.Free;

  //
  FormMain.StrRetFormBrowse := '';
  FormMain.StrSetFormBrowse := ExtractfilePath(FormMain.StrCurrent);
  //
  FormBrowse := TFormBrowse.Create(Application);
  try
    if FormBrowse.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormBrowse.Free;
  end;
  //
  if bResult = TRUE then
  begin
    //t@C
    if FileExists(FormMain.StrRetFormBrowse) = TRUE then
    begin
      ComboBox1.Text := FormMain.StrRetFormBrowse;
      ComboBox1.SetFocus;
    end;
  end
  else
  begin
    ComboBox1.SetFocus;
  end;
end;

procedure TFormRunProgram.ButtonCancelClick(Sender: TObject);
begin
  //߂l
  FormMain.StrRetFormRunProgramExeName := '';
  FormMain.StrRetFormRunProgramOptions := '';
  //I
  ModalResult := mrCancel;
end;

procedure TFormRunProgram.ButtonListClick(Sender: TObject);
begin
  //ݒ
  OpenDialog1.Filter := 'Exe(*.exe)|*.exe|All(*.*)|*.*';
  if FileExists(ComboBox1.Text) = TRUE then
  begin
    OpenDialog1.InitialDir := ExtractFilePath(ComboBox1.Text);
    OpenDialog1.FileName   := ExtractFileName(ComboBox1.Text);
  end
  else
  begin
    OpenDialog1.InitialDir := '';
    OpenDialog1.FileName   := '';
  end;
  if OpenDialog1.Execute() = TRUE then
  begin
    ComboBox1.Text := OpenDialog1.FileName;
    ComboBox1.SetFocus;
  end
  else
  begin
    ComboBox1.SetFocus;
  end;
end;

procedure TFormRunProgram.ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    //
    if ComboBox1.Text = '' then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : st@Cݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Target application is empty.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end
    else
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end;
end;

procedure TFormRunProgram.ComboBox2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    //s
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end;
end;

procedure TFormRunProgram.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormRunProgram.ComboBox2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

end.
