unit ThumbNail;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_DEPRECATED    OFF} //W1000 : for FileCtrl
  {$WARN UNIT_PLATFORM   OFF} //W1005 : for Filectrl
  {$WARN SYMBOL_PLATFORM   OFF} //W1002  FileSetDate

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,

  IniFiles, ShellApi, ExifData, GDIPAPI, GDIPOBJ, GDIPUTIL, Math, Clipbrd, Filectrl,
  ShlObj, ActiveX, StrUtils, MyUtility, System.IOUtils;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 610;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormThumbNail = class(TForm)
    Panel51: TPanel;
    Panel55: TPanel;
    Memo1: TMemo;
    Panel53: TPanel;
    Panel25: TPanel;
    Panel3: TPanel;
    Label6: TLabel;
    ButtonCancel: TButton;
    ButtonGet: TButton;
    ButtonStop: TButton;
    ButtonMake: TButton;
    ButtonFileList: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    ButtonBrowse: TButton;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    ButtonInitWic: TButton;
    Edit4: TEdit;
    Panel2: TPanel;
    Panel4: TPanel;
    Label4: TLabel;
    ListBox1: TListBox;
    ButtonInitGdi: TButton;
    Edit3: TEdit;
    Label5: TLabel;
    ComboBox1: TComboBox;
    Label7: TLabel;
    ComboBox2: TComboBox;
    Timer1: TTimer;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonBrowseClick(Sender: TObject);
    procedure ButtonGetClick(Sender: TObject);
    procedure ButtonMakeClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    function  SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;

    procedure ThisListFilesDrive(DirName: String; TheList: TStringList);
    procedure ThisListFilesDriveFileCount(DirName: String; TheList: TStringList);

    function  FileTimeToDateTime(ATime: TFileTime): TDateTime;
    procedure ButtonInitWicClick(Sender: TObject);
    procedure ButtonFileListClick(Sender: TObject);
    procedure Panel25Click(Sender: TObject);
    procedure ButtonInitGdiClick(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox2KeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    IntFormShiftX: Integer;
    IntFormShiftY: Integer;
    StrFormState: String;

    StrListFile: TStringList;
    IntLocalCount: Integer;
    IntThumbNialHeight: Integer;
    IntCompressRatio: Integer;
    StrThumbNailFolder: String;
    StrLanguageFileName: String;
    BoolJapanese: Boolean;
    BoolStop: Boolean;

  public
    { Public 錾 }

  end;

var
  FormThumbNail: TFormThumbNail;

implementation

{$R *.dfm}

uses
  Main, View;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormThumbNail.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormThumbNail.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormThumbNail.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormThumbNail.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormThumbNail.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  FormPosLeft   := IniFile.ReadInteger('FormThumbNail', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormThumbNail', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormThumbNail', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormThumbNail', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormThumbNail', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //
  Timer1.Enabled := FALSE;

  //m
  StrListFile := TStringList.Create;

  //
  Panel51.Align := alClient;
  Panel55.Align := alClient;
  Memo1.Align   := alClient;
  Panel51.Visible := TRUE;
  Panel55.Visible := FALSE;

  Label1.Enabled := TRUE;
  Label2.Caption := 'Search=0' ;
  Label3.Caption := 'File=0';
  Label6.Caption := '[0/0]';
  ButtonGet.Enabled      := TRUE;
  ButtonMake.Enabled     := TRUE;
  ButtonStop.Enabled     := FALSE;
  ButtonCancel.Enabled   := TRUE;
  ButtonFileList.Enabled := FALSE;
  ButtonBrowse.Enabled   := TRUE;
  ButtonInitGdi.Enabled  := TRUE;
  ButtonInitWic.Enabled  := TRUE;
  CheckBox1.Enabled      := TRUE;
  //ݒ
  Edit2.Text := FormMain.StrSetFormThumbNail;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  CheckBox1.Checked   := IniFile.ReadBool   ('SubFolder',       'Serach',  FALSE);
  ComboBox1.ItemIndex := IniFile.ReadInteger('CompressRatio',   'Index', 3);
  ComboBox2.ItemIndex := IniFile.ReadInteger('ImageSize',       'Index', 3);
  Edit1.Text          := IniFile.ReadString ('ThumbNailGdi',    'Ext',   INIT_GDI_ADD);
  Edit3.Text          := IniFile.ReadString ('ThumbNailWic',    'Ext',   INIT_WIC);
  Edit4.Text          := IniFile.ReadString ('ThumbNailFolder', 'Name',  ExtractFilePath(ParamStr(0)) + FOLDER_THUMB_NAIL + '\');
  StrThumbNailFolder  := Edit4.Text;
  //Ǎ
  FormMain.FRichEditViewColor     := StringToColor(IniFile.ReadString('FRichEditView',      'Color',     ColorToString(clWhite)));
  FormMain.FRichEditViewFontColor := StringToColor(IniFile.ReadString('FRichEditView',      'FontColor', ColorToString(clBlack)));
  FormMain.FRichEditViewFontName  :=               IniFile.ReadString('FRichEditView',      'FontName',  'lr SVbN');
  FormMain.FRichEditViewFontSize  :=      StrToInt(IniFile.ReadString('FRichEditView',      'FontSize',  '14'));
  //f
  Memo1.Color      := FormMain.FRichEditViewColor;
  Memo1.Font.Color := FormMain.FRichEditViewFontColor;
  Memo1.Font.Name  := FormMain.FRichEditViewFontName;
  Memo1.Font.Size  := FormMain.FRichEditViewFontSize;
  //j
  IniFile.Free;

end;

procedure TFormThumbNail.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormThumbNail', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormThumbNail', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormThumbNail', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormThumbNail', 'Left',   FormThumbNail.Left);
    IniFile.WriteInteger('FormThumbNail', 'Top',    FormThumbNail.Top);
    IniFile.WriteInteger('FormThumbNail', 'Width',  FormThumbNail.Width);
    IniFile.WriteInteger('FormThumbNail', 'Height', FormThumbNail.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteBool   ('SubFolder',       'Serach',  CheckBox1.Checked);
  IniFile.WriteInteger('CompressRatio',   'Index',   ComboBox1.ItemIndex);
  IniFile.WriteInteger('ImageSize',       'Index',   ComboBox2.ItemIndex);
  IniFile.WriteString ('ThumbNailGdi',    'Ext',     Edit1.Text);
  IniFile.WriteString ('ThumbNailWic',    'Ext',     Edit3.Text);
  //j
  IniFile.Free;

  //j
  StrListFile.Free;
end;

procedure TFormThumbNail.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  IniFile: TIniFile;
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    if Panel51.Visible = TRUE then
    begin
      ButtonCancelClick(Sender);
    end;
    if Panel55.Visible = TRUE then
    begin
      Panel25Click(Sender);
    end;
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormThumbNail, StrLanguageFileName, Sender);
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //Ǎ
    ComboBox1.ItemIndex := IniFile.ReadInteger('CompressRatio',   'Index', 3);
    ComboBox2.ItemIndex := IniFile.ReadInteger('ImageSize',       'Index', 3);
    //j
    IniFile.Free;
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormThumbNail, StrLanguageFileName, Sender);
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //Ǎ
    ComboBox1.ItemIndex := IniFile.ReadInteger('CompressRatio',   'Index', 3);
    ComboBox2.ItemIndex := IniFile.ReadInteger('ImageSize',       'Index', 3);
    //j
    IniFile.Free;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormThumbNail.FormResize(Sender: TObject);
begin
  Edit1.Width := Panel1.ClientWidth -  40;
  Edit2.Width := Panel1.ClientWidth -  40;
  Edit3.Width := Panel1.ClientWidth -  40;
  Edit4.Width := Panel1.ClientWidth -  40;
end;

procedure TFormThumbNail.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormThumbNail.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormThumbNail.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormThumbNail.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormThumbNail.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormThumbNail.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, FORM_WIDTH_SET*5, 0);

  //IMEIt
  SetImeMode(FormThumbNail.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'ThumbNail.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormThumbNail, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormThumbNail, StrLanguageFileName, Sender);
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  ComboBox1.ItemIndex := IniFile.ReadInteger('CompressRatio',   'Index', 3);
  ComboBox2.ItemIndex := IniFile.ReadInteger('ImageSize',       'Index', 3);
  //j
  IniFile.Free;

  //\[gx
  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    Timer1.Enabled := TRUE;
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    Timer1.Enabled := TRUE;
  end;
end;

procedure TFormThumbNail.Panel25Click(Sender: TObject);
begin
  Panel51.Visible := TRUE;
  Panel55.Visible := FALSE;
  FormResize(Sender);
end;

procedure TFormThumbNail.ButtonInitGdiClick(Sender: TObject);
begin
  Edit1.Text := INIT_GDI_ADD;
end;

procedure TFormThumbNail.ButtonInitWicClick(Sender: TObject);
begin
  Edit3.Text := INIT_WIC;
end;

procedure TFormThumbNail.ButtonFileListClick(Sender: TObject);
begin
  if ListBox1.Items.Count > 0 then
  begin
    Panel51.Visible := FALSE;
    Panel55.Visible := TRUE;
    Memo1.Lines.BeginUpdate;
    Memo1.Lines.Assign(ListBox1.Items);
    Memo1.Lines.EndUpdate;
  end;
end;

procedure TFormThumbNail.ButtonBrowseClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  //ݒ
  if Edit2.Text = '' then
  begin
    sStr2 := '';
  end
  else
  begin
    sStr2 := Edit2.Text;
  end;
  if DirectoryExists(sStr2) = FALSE then
  begin
    sStr2 := '';
  end;
  if SelectDirectorySh('Select Directory', sStr2, sStr1) = TRUE then
  begin
    Edit2.Text := sStr1;
    Edit2.SetFocus;
  end
  else
  begin
    Edit2.SetFocus;
  end;
end;

function TFormThumbNail.SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;
var
  FolderPidl : PItemIDList;
  BrowseInfo : TBrowseInfo;
  BPathName  : array[0..MAX_PATH-1] of Char;
  AMalloc    : IMalloc;
begin
  //
  Result := FALSE;
  //ڎʎq̂߂̃AP[Ṽ|C^擾
  ShGetMalloc(AMalloc);
  FolderPidl := nil;
  //
  FillChar(BrowseInfo, SizeOf(BrowseInfo), #0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.lpfn      := nil;
  BrowseInfo.lpszTitle := PChar('Select Directory');
  BrowseInfo.pidlRoot  := nil;
  BrowseInfo.ulFlags   := BIF_RETURNONLYFSDIRS or
                          BIF_NEWDIALOGSTYLE   or
                          BIF_VALIDATE;

//BIF_RETURNONLYFSDIRS   $0001 t@CVXefBNĝ݂I\
//BIF_DONTGOBELOWDOMAIN  $0002 hC̃lbg[NtH_\Ȃ
//BIF_STATUSTEXT         $0004 _CAOc[̂ɕ\
//                             R[obN֐ŏKv
//BIF_RETURNFSANCESTORS	 $0008 [gȉ̃t@CCtH_̂ݑI\
//BIF_EDITBOX            $0010 OҏWp{bNX\
//BIF_VALIDATE           $0020 OҏW{bNXւ̖ȕ`FbN
//                             BIF_EDITBOX ̎w肪鎞̂ݗL
//                             ̓R[obN֐ōs
//BIF_NEWDIALOGSTYLE	   $0040	ȉ̐VX^C̃_CAO\
//                             TCY\
//                             _CAOւ̃hbOAhhbv
//                             tH_̍Đ
//                             V[gJbgj[ (ReLXg)
//                             VtH_̍쐬
//BIF_USENEWUI           $0050 OҏW{bNX̂VX^C
//                             BIF_EDITBOX or BIF_NEWDIALOGSTYLE wƓ
//BIF_BROWSEINCLUDEURLS	 $0080 URL\\Ƃ
//                             BIF_USENEWUIBIF_BROWSEINCLUDEFILES ̎wKv
//                             YtH_T|[gꍇ̂ݕ\
//BIF_UAHINT             $0100 OҏW{bNX̑Ƀqg\
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NONEWFOLDERBUTTON  $0200  [VtH_̍쐬] {^\Ȃ
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NOTRANSLATETARGETS $0400 IACeV[gJbg̏ꍇCNł͂ȂCV[gJbgg̍ڎʎqԂ
//BIF_BROWSEFORCOMPUTER  $1000 Rs[^̂ݑI\Ƃ
//BIF_BROWSEFORPRINTER   $2000 v^̂ݑI\Ƃ
//BIF_BROWSEINCLUDEFILES $4000 t@C\đI\Ƃ
//BIF_SHAREABLE          $8000 L\[X\đI\ɂ
//                             BIF_USENEWUI ̎wKv

  //̐ݒɊÂtH_Qƃ_CAO\
  try
    //擾
    FolderPidl := SHBrowseForFolder(BrowseInfo);
    If FolderPidl <> nil then
    begin
      //ڎʎqpX̕BPathNameɕϊ
      SHGetPathFromIDList(FolderPidl, BPathName);
      //
      Directory := BPathName;
      if Copy(Directory, Length(Directory), 1) <> '\' then
      begin
        Directory := Directory + '\';
      end;
      //
      Result := TRUE;
    end;
  finally
    //
    AMalloc.Free(FolderPidl);
  end;
end;


procedure TFormThumbNail.ButtonGetClick(Sender: TObject);
var
  iFind1: Integer;
  StrList1: TStringList;
  iRow1: Integer;
  iRow2: Integer;
  sStr1: String;
begin
    //
    if StrThumbNailFolder = '' then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : TlC̃tH_ݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Thumbnails folder is empty.' + #13#10 +
                          '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
    if DirectoryExists(StrThumbNailFolder) = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : TlC̃tH_܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Thumbnails folder is not exist.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //
    if Edit2.Text = '' then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : tH_ݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Folder is empty.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
    if Copy(Edit2.Text, Length(Edit2.Text), 1) <> '\' then
    begin
      Edit2.Text := Edit2.Text + '\';
    end;
    if DirectoryExists(Edit2.Text) = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : tH_܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Folder is not exist.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //
    if Pos(UpperCase(Edit4.Text), UpperCase(Edit2.Text)) > 0 then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : 摜TlCtH_tH_Ɋ܂܂Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Thumbnails folder found in search folder.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //
    sStr1 := Edit1.Text;
    if ExtractExtItem(sStr1, FormMain.StrListGdiExt, '', Sender) = FALSE then
    begin
      Exit;
    end;

    //XV
    Label6.Caption := '[0/0]';
    Label6.Refresh;
    Application.ProcessMessages;
    Application.ProcessMessages;
    //XV
    ListBox1.Items.BeginUpdate;
    ListBox1.Items.Clear;
    ListBox1.Items.EndUpdate;
    //XV
    ButtonGet.Enabled      := FALSE;
    ButtonGet.Refresh;
    ButtonMake.Enabled     := FALSE;
    ButtonMake.Refresh;
    ButtonStop.Enabled     := TRUE;
    ButtonStop.Refresh;
    ButtonCancel.Enabled   := FALSE;
    ButtonCancel.Refresh;
    ButtonFileList.Enabled := FALSE;
    ButtonFileList.Refresh;
    ButtonBrowse.Enabled   := FALSE;
    ButtonBrowse.Refresh;
    ButtonInitGdi.Enabled  := FALSE;
    ButtonInitGdi.Refresh;
    ButtonInitWic.Enabled  := FALSE;
    ButtonInitWic.Refresh;
    Edit1.Enabled          := FALSE;
    Edit2.Enabled          := FALSE;
    Edit3.Enabled          := FALSE;
    ComboBox1.Enabled      := FALSE;
    ComboBox2.Enabled      := FALSE;

    BoolStop := FALSE;

    for iRow1 := 0 to 300 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //m
    StrList1 := TStringList.Create;

    //XV
    Label2.Caption := 'Search=0';
    Label2.Refresh;
    //
    if Checkbox1.Checked = TRUE then
    begin
      ThisListFilesDrive(Edit2.Text, StrList1);
    end
    else
    begin
      ThisListFilesDriveFileCount(Edit2.Text, StrList1);
    end;
    //XV
    Label2.Caption := 'Search=' + IntToStr(StrList1.Count);
    Label2.Refresh;

    //XV
    Label3.Caption := 'File=0';
    Label3.Refresh;
    //
    StrListFile.Clear;
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //
      iFind1 := -1;
      //gq𔻒
      if iFind1 = -1 then
      begin
        for iRow2 := 0 to FormMain.StrListWicExt.Count-1 do
        begin
          if Uppercase(ExtractFileExt(StrList1.Strings[iRow1])) = Uppercase(FormMain.StrListWicExt.Strings[iRow2]) then
          begin
            iFind1 := iRow2;
            Break;
          end;
        end;
      end;
      //gq𔻒
      if iFind1 = -1 then
      begin
        for iRow2 := 0 to FormMain.StrListGdiExt.Count-1 do
        begin
          if Uppercase(ExtractFileExt(StrList1.Strings[iRow1])) = Uppercase(FormMain.StrListGdiExt.Strings[iRow2]) then
          begin
            iFind1 := iRow2;
            Break;
          end;
        end;
      end;
      //YȂ
      if iFind1 = -1 then
      begin
        //
      end
      //Y
      else
      begin
        //ǉ
        StrListFile.Add(StrList1.Strings[iRow1]);
        //XV
        if (StrListFile.Count mod 10) = 0 then
        begin
          Label3.Caption := 'File=' + IntToStr(StrListFile.Count);
          Label3.Refresh;
          Application.ProcessMessages;
          Application.ProcessMessages;
        end;
      end;
    end;
    //XV
    Label3.Caption := 'File=' + IntToStr(StrListFile.Count);
    Label3.Refresh;

    //j
    StrList1.Free;

    //XV
    ButtonGet.Enabled      := TRUE;
    ButtonGet.Refresh;
    ButtonMake.Enabled     := TRUE;
    ButtonMake.Refresh;
    ButtonStop.Enabled     := FALSE;
    ButtonStop.Refresh;
    ButtonCancel.Enabled   := TRUE;
    ButtonCancel.Refresh;
    ButtonFileList.Enabled := TRUE;
    ButtonFileList.Refresh;
    ButtonBrowse.Enabled   := TRUE;
    ButtonBrowse.Refresh;
    ButtonInitGdi.Enabled  := TRUE;
    ButtonInitGdi.Refresh;
    ButtonInitWic.Enabled  := TRUE;
    ButtonInitWic.Refresh;
    Edit1.Enabled          := TRUE;
    Edit2.Enabled          := TRUE;
    Edit3.Enabled          := TRUE;
    ComboBox1.Enabled      := TRUE;
    ComboBox2.Enabled      := TRUE;
    if StrListFile.Count > 0 then
    begin
      ButtonFileList.Enabled := TRUE;
      ButtonFileList.Refresh;
    end;


    //
    if BoolStop = TRUE then
    begin
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : t@C擾𒆒f܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Get file had stopped.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end
    else
    begin
      //XV
      ListBox1.Items.BeginUpdate;
      ListBox1.Items.Assign(StrListFile);
      ListBox1.Items.EndUpdate;
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : t@C擾܂';
      end
      else
       begin
        FormMain.StrMsg := 'Information : Get file had done.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;

end;

procedure TFormThumbNail.ButtonMakeClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr10: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr31: String;
  sStr32: String;
  sStr33: String;
  sStr41: String;

  iFind1: Integer;
  CsvList1: TStringList;
  StrList5: TStringList;
  iRow1: Integer;
  iRow2: Integer;
  iRow3: Integer;
  bError1: Boolean;
  bError2: Boolean;

  Graphics: TGPGraphics;
  Img: TWICImage;
  Image: TGPImage;
  SrcBmp: TGPBitMap;
  DstBmp: TBitMap;
  shOpeStrct1: TSHFILEOPSTRUCT;

  ImageSrcWidth: Integer;
  ImageSrcHeight: Integer;
  iRotate1: Integer;
  iWidth2: integer;
  iWidth3: integer;
  iHeight2: integer;
  iHeight3: integer;
  VerticalRate: Real;
  HorizontalRate: Real;

  LpPropItem: PPropertyItem;
  LIdValue: Cardinal;
  LBufferSize: Cardinal;
  LpShortValue: PWORD;
  LShortValue: SHORT;

  encoderClsid: TGUID;
  encoderParameters: TEncoderParameters;
  quality: ULONG;

  File1: TWin32FindData;
  hFindData1: THandle;
  DateTime1: TDateTime;

  MemoryStream1 :TMemoryStream;
begin
    //
    if StrListFile.Count = 0 then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : t@C擾Ă܂';
      end
      else
       begin
        FormMain.StrMsg := 'Information : Get file had not done.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;

    //
    iFind1 := -1;
    sStr41 := UpperCase(Edit4.Text);
    for iRow1 := 0 to StrListFile.Count-1 do
    begin
      if Pos(sStr41, UpperCase(StrListFile.Strings[iRow1])) > 0 then
      begin
        iFind1 := iRow1;
        Break;
      end;
    end;
    if iFind1 <> -1 then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : 摜TlCtH_tH_Ɋ܂܂Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Thumbnails folder found in search folder.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;


    //ݒ
    IntCompressRatio   := StrToInt(ComboBox1.Text);
    IntThumbNialHeight := StrToInt(ComboBox2.Text);

    //XV
    ButtonGet.Enabled      := FALSE;
    ButtonGet.Refresh;
    ButtonMake.Enabled     := FALSE;
    ButtonMake.Refresh;
    ButtonStop.Enabled     := TRUE;
    ButtonStop.Refresh;
    ButtonCancel.Enabled   := FALSE;
    ButtonCancel.Refresh;
    ButtonFileList.Enabled := FALSE;
    ButtonFileList.Refresh;
    ButtonBrowse.Enabled   := FALSE;
    ButtonBrowse.Refresh;
    ButtonInitGdi.Enabled  := FALSE;
    ButtonInitGdi.Refresh;
    ButtonInitWic.Enabled  := FALSE;
    ButtonInitWic.Refresh;
    Edit1.Enabled          := FALSE;
    Edit2.Enabled          := FALSE;
    Edit3.Enabled          := FALSE;
    ComboBox1.Enabled      := FALSE;
    ComboBox2.Enabled      := FALSE;

    for iRow1 := 0 to 300 do
    begin
      sleep(1);
      Application.ProcessMessages;
    end;

    //m
    CsvList1 := TStringList.Create;
    StrList5 := TStringList.Create;

    //Nݒ
    sStr21 := FormatDateTime('yyyymmdd-hhnnss', Now);
    //폜pɐݒ
    sStr22 := ExtractFilePath(ParamStr(0)) + FOLDER_TMP_IMAGE  + '\' + sStr21;

    //ϊ
    bError1  := FALSE;
    bError2  := FALSE;
    BoolStop := FALSE;
    for iRow1 := 0 to StrListFile.Count-1 do
    begin
      //f
      if BoolStop = TRUE then
      begin
        Break;
      end;


      //sStr1  d:\123\456.jpg
      //sStr2  d:\123\
      //sStr3  d\123\
      //sStr4  456.jpg
      //C:\BonsFMmini\ImageCash\d\123\
      //C:\BonsFMmini\ImageCash\d\123\456.jpg

      //擾
      sStr1 := StrListFile.Strings[iRow1];
      sStr2 := ExtractFilePath(sStr1);
      sStr3 := Copy(sStr2, 1, 1) + Copy(sStr2, 3, Length(sStr2));
      sStr4 := ExtractFileName(sStr1);

      //XV
      if (iRow1 mod 10) = 0 then
      begin
        Label6.Caption := '[' + IntToStr(iRow1+1) + '/' + IntToStr(StrListFile.Count) +'] ' + sStr1;
        Label6.Refresh;
        Application.ProcessMessages;
        Application.ProcessMessages;
      end;

      //tH_쐬
      sStr5 := ExtractFilePath(ParamStr(0)) + FOLDER_TMP_IMAGE  + '\' + sStr21 + '\' + sStr3;
      if DirectoryExists(sStr5) = FALSE then
      begin
        ForceDirectories(sStr5);
      end;

      //tH_쐬
      sStr6 := StrThumbNailFolder + sStr3;
      if DirectoryExists(sStr6) = FALSE then
      begin
        ForceDirectories(sStr6);
      end;


      //ۑt@C
      sStr7 := ExtractFilePath(ParamStr(0)) + FOLDER_TMP_IMAGE  + '\' + sStr21 + '\' + sStr3 + sStr4 +  '.BMP';
      sStr8 := ExtractFilePath(ParamStr(0)) + FOLDER_TMP_IMAGE  + '\' + sStr21 + '\' + sStr3 + sStr4 +  '.JPG';

      //WIC
      for iRow3 := 0 to FormMain.StrListWicExt.Count-1 do
      begin
        if Uppercase(ExtractFileExt(sStr1)) = Uppercase(FormMain.StrListWicExt.Strings[iRow3]) then
        begin
          //t@C
          sStr9  := StrThumbNailFolder                                               + sStr3 + sStr4 +  '.WIC.JPG';
          Break;
        end;
      end;
      if FileExists(sStr9) = TRUE then
      begin
        Continue;
      end;

      //GDI
      for iRow3 := 0 to FormMain.StrListGdiExt.Count-1 do
      begin
        if Uppercase(ExtractFileExt(sStr1)) = Uppercase(FormMain.StrListGdiExt.Strings[iRow3]) then
        begin
          //t@C
          sStr9  := StrThumbNailFolder                                               + sStr3 + sStr4 +  '.GDI.JPG';
          Break;
        end;
      end;
      if FileExists(sStr9) = TRUE then
      begin
        Continue;
      end;

      //gq𔻒
      iFind1 := -1;
      //WIC
      if iFind1 = -1 then
      begin
        for iRow3 := 0 to FormMain.StrListWicExt.Count-1 do
        begin
          if Uppercase(ExtractFileExt(sStr1)) = Uppercase(FormMain.StrListWicExt.Strings[iRow3]) then
          begin
            //t@C
            sStr9  := StrThumbNailFolder                                               + sStr3 + sStr4 +  '.WIC.JPG';
            //ݒ
            sStr10 := sStr7;

            //m
            MemoryStream1 := TMemoryStream.Create;

            //
            try
              //쐬{Ǎ{ۑ
              Img := TWICImage.Create;
              // 9
              try
                Img.LoadFromFile(sStr1);
                Img.ImageFormat := wifJpeg;
                Img.SaveToStream(MemoryStream1);
                // 9
              finally
                Img.Free;
              end;
            except
              bError1 := TRUE;
              Break;
            end;

            //mہ{Ǎ
            SrcBmp := TGPBitMap.Create(TStreamAdapter.Create(MemoryStream1, soReference));
            //m
            DstBmp := TBitMap.Create;

            //Exif  IFD 擾
            iRotate1 := 0;
            StrList5.Clear;
            if GetValue(sStr1, StrList5, Sender) = TRUE then
            begin
              //WJ
              for iRow2 := 0 to StrList5.Count-1 do
              begin
                CsvList1.Clear;
                StringToCsvList(StrList5.Strings[iRow2], CsvList1);
                if CSvList1[0] = '0x0112' then
                begin
                  //0
                  if      CSvList1[3] = '0x00010000' then
                  begin
                    iRotate1 := 0;
                  end
                  //90
                  else if CSvList1[3] = '0x00060000' then
                  begin
                    iRotate1 := 1;
                  end
                  //180
                  else if CSvList1[3] = '0x00030000' then
                  begin
                    iRotate1 := 2;
                  end
                  //270
                  else if CSvList1[3] = '0x00080000' then
                  begin
                    iRotate1 := 3;
                  end
                  //0
                  else
                  begin
                    iRotate1 := 0;
                  end;
                  //
                  Break;
                end;
              end;
            end;

            //]
            if      iRotate1 = 0 then
            begin
              //
            end
            else if iRotate1 = 1 then
            begin
              SrcBmp.RotateFlip(Rotate90FlipNone);
            end
            else if iRotate1 = 2 then
            begin
              SrcBmp.RotateFlip(Rotate180FlipNone);
            end
            else if iRotate1 = 3 then
            begin
              SrcBmp.RotateFlip(Rotate270FlipNone);
            end
            else
            begin
              //
            end;

            // 2
            try
              // 3
              try
                //p̐ݒ
                ImageSrcHeight  := SrcBmp.GetHeight;
                ImageSrcWidth   := SrcBmp.GetWidth;

                //摜TCY̏cƉ œKȏԂŕ\悤ɐݒ肷
                VerticalRate   := ImageSrcHeight / IntThumbNialHeight;
                HorizontalRate := ImageSrcWidth  / IntThumbNialHeight;
                if (VerticalRate > 1) and (HorizontalRate > 1) then
                begin
                  if (VerticalRate >= HorizontalRate) then
                  begin
                    iHeight2 := IntThumbNialHeight - THUMB_NAIL_EDGE_WIDTH;
                    iWidth2  := Round(iHeight2 * ImageSrcWidth / ImageSrcHeight);
                  end
                  else
                  begin
                    iWidth2  := IntThumbNialHeight - THUMB_NAIL_EDGE_WIDTH;
                    iHeight2 := Round(iWidth2 * ImageSrcHeight / ImageSrcWidth);
                  end;
                end
                else if (VerticalRate > 1) then
                begin
                  iHeight2 := IntThumbNialHeight - THUMB_NAIL_EDGE_WIDTH;
                  iWidth2  := Round(iHeight2 * ImageSrcWidth / ImageSrcHeight);
                end
                else if (HorizontalRate > 1) then
                begin
                  iWidth2  := IntThumbNialHeight - THUMB_NAIL_EDGE_WIDTH;
                  iHeight2 := Round(iWidth2 * ImageSrcHeight / ImageSrcWidth);
                end
                else
                begin
                  iHeight2 := ImageSrcHeight;
                  iWidth2  := ImageSrcWidth;
                end;

                //ݒ
                DstBmp.Width  := iWidth2;
                DstBmp.Height := iHeight2;
                //ݒ
                iWidth3  := iWidth2;
                iHeight3 := iHeight2;

                //쐬
                Graphics  := TGPGraphics.Create(DstBmp.Canvas.Handle);
                // 4
                try
                  //쐬eDstɔf
                  Graphics.DrawImage(SrcBmp, 0, 0, iWidth3, iHeight3);
                  //t@Cۑ
                  DstBmp.SaveToFile(sStr8);

                  // Get an image from the disk.
                  Image := TGPImage.Create(sStr8);
                  // 5
                  try
                    // Get the CLSID of the JPEG encoder.
                    GetEncoderClsid('image/jpeg', encoderClsid);
                    encoderParameters.Count := 1;
                    encoderParameters.Parameter[0].Guid := EncoderQuality;
                    encoderParameters.Parameter[0].Type_ := EncoderParameterValueTypeLong;
                    encoderParameters.Parameter[0].NumberOfValues := 1;
                    // Save the image as a JPEG with quality level 100.
                    quality := IntCompressRatio;
                    encoderParameters.Parameter[0].Value := @quality;
                    //t@Cۑ
                    Image.Save(sStr9, encoderClsid, @encoderParameters);
                  // 5
                  finally
                    //j
                    Image.Free;
                  end;
                // 4
                finally
                  //j
                  Graphics.Free;
                end;
              // 3
              finally
                //j
                SrcBmp.Free;
                DstBmp.Free;
                MemoryStream1.Free;
              end;

            // 2
            except
              bError1 := TRUE;
            end;

            //擾
            if FileExists(sStr1) = TRUE then
            begin
              //t@C擾
              hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr1), File1);
              try
                ;
              finally
                WinApi.Windows.FindClose(hFindData1);
              end;
              //
              if hFindData1 <> INVALID_HANDLE_VALUE then
              begin
                //擾
                DateTime1 := FileTimeToDateTime(File1.ftLastWriteTime);
                //
                try
                  //ݒ
                  System.IOUtils.TFile.SetLastWriteTime(sStr9, DateTime1);
                except
                  //ݒ
                  if BoolJapanese = TRUE then
                  begin
                    FormMain.StrMsg := 'Error : ^CX^v̕ύXɎs܂' + #13#10 +
                                        sStr9;
                  end
                  else
                  begin
                    FormMain.StrMsg := 'Error : Change time stamp failed.' + #13#10 +
                                        sStr9 + #13#10 +
                                       '[OK]';
                  end;
                  ShowMessage(FormMain.StrMsg);
                  bError1 := TRUE;
                end;
              end;

            end;

            //s
            if bError1 = TRUE then
            begin
              Break;
            end;

            //f
            Break;
          end;
        end;
      end;

      //gq𔻒
      iFind1 := -1;
      //GDI
      if iFind1 = -1 then
      begin
        for iRow3 := 0 to FormMain.StrListGdiExt.Count-1 do
        begin
          if Uppercase(ExtractFileExt(sStr1)) = Uppercase(FormMain.StrListGdiExt.Strings[iRow3]) then
          begin
            //t@C
            sStr9  := StrThumbNailFolder                                               + sStr3 + sStr4 +  '.GDI.JPG';
            //ݒ
            sStr10 := sStr1;

            //mہ{Ǎ
            SrcBmp := TGPBitMap.Create(sStr10);
            //m
            DstBmp := TBitMap.Create;

            //Windows
            if FormMain.BoolWindows7Later = TRUE then
            begin
              //]擾
              LShortValue := 1;
              LIdValue := PropertyTagOrientation;
              LBufferSize := SrcBmp.GetPropertyItemSize(LIdValue);
              if LBufferSize > 0 then
              begin
                GetMem(LpPropItem, LBufferSize);
                try
                  SrcBmp.GetPropertyItem(LIdValue, LBufferSize, LpPropItem);
                  LpShortValue := LpPropItem^.value;
                  LShortValue := LpShortValue^;
                finally
                  FreeMem(LpPropItem);
                end;
              end;
              //]
              if      LShortValue = 1 then
              begin
                ;
              end
              else if LShortValue = 6 then
              begin
                SrcBmp.RotateFlip(Rotate90FlipNone);
              end
              else if LShortValue = 3 then
              begin
                SrcBmp.RotateFlip(Rotate180FlipNone);
              end
              else if LShortValue = 8 then
              begin
                SrcBmp.RotateFlip(Rotate270FlipNone);
              end
              else
              begin
                ;
              end;
            end;

            // 2
            try
              // 3
              try
                //p̐ݒ
                ImageSrcHeight  := SrcBmp.GetHeight;
                ImageSrcWidth   := SrcBmp.GetWidth;

                //摜TCY̏cƉ œKȏԂŕ\悤ɐݒ肷
                VerticalRate   := ImageSrcHeight / IntThumbNialHeight;
                HorizontalRate := ImageSrcWidth  / IntThumbNialHeight;
                if (VerticalRate > 1) and (HorizontalRate > 1) then
                begin
                  if (VerticalRate >= HorizontalRate) then
                  begin
                    iHeight2 := IntThumbNialHeight - THUMB_NAIL_EDGE_WIDTH;
                    iWidth2  := Round(iHeight2 * ImageSrcWidth / ImageSrcHeight);
                  end
                  else
                  begin
                    iWidth2  := IntThumbNialHeight - THUMB_NAIL_EDGE_WIDTH;
                    iHeight2 := Round(iWidth2 * ImageSrcHeight / ImageSrcWidth);
                  end;
                end
                else if (VerticalRate > 1) then
                begin
                  iHeight2 := IntThumbNialHeight - THUMB_NAIL_EDGE_WIDTH;
                  iWidth2  := Round(iHeight2 * ImageSrcWidth / ImageSrcHeight);
                end
                else if (HorizontalRate > 1) then
                begin
                  iWidth2  := IntThumbNialHeight - THUMB_NAIL_EDGE_WIDTH;
                  iHeight2 := Round(iWidth2 * ImageSrcHeight / ImageSrcWidth);
                end
                else
                begin
                  iHeight2 := ImageSrcHeight;
                  iWidth2  := ImageSrcWidth;
                end;

                //ݒ
                DstBmp.Width  := iWidth2;
                DstBmp.Height := iHeight2;
                //ݒ
                iWidth3  := iWidth2;
                iHeight3 := iHeight2;

                //쐬
                Graphics  := TGPGraphics.Create(DstBmp.Canvas.Handle);
                // 4
                try
                  //쐬eDstɔf
                  Graphics.DrawImage(SrcBmp, 0, 0, iWidth3, iHeight3);
                  //t@Cۑ
                  DstBmp.SaveToFile(sStr8);

                  // Get an image from the disk.
                  Image := TGPImage.Create(sStr8);
                  // 5
                  try
                    // Get the CLSID of the JPEG encoder.
                    GetEncoderClsid('image/jpeg', encoderClsid);
                    encoderParameters.Count := 1;
                    encoderParameters.Parameter[0].Guid := EncoderQuality;
                    encoderParameters.Parameter[0].Type_ := EncoderParameterValueTypeLong;
                    encoderParameters.Parameter[0].NumberOfValues := 1;
                    // Save the image as a JPEG with quality level 100.
                    quality := IntCompressRatio;
                    encoderParameters.Parameter[0].Value := @quality;
                    //t@Cۑ
                    Image.Save(sStr9, encoderClsid, @encoderParameters);
                  // 5
                  finally
                    //j
                    Image.Free;
                  end;
                // 4
                finally
                  //j
                  Graphics.Free;
                end;
              // 3
              finally
                //j
                SrcBmp.Free;
                DstBmp.Free;
              end;

            // 2
            except
              bError1 := TRUE;
            end;

            //擾
            if FileExists(sStr1) = TRUE then
            begin
              //t@C擾
              hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr1), File1);
              try
                ;
              finally
                WinApi.Windows.FindClose(hFindData1);
              end;
              //
              if hFindData1 <> INVALID_HANDLE_VALUE then
              begin
                //擾
                DateTime1 := FileTimeToDateTime(File1.ftLastWriteTime);
                //
                try
                  //ݒ
                  System.IOUtils.TFile.SetLastWriteTime(sStr9, DateTime1);
                except
                  //ݒ
                  if BoolJapanese = TRUE then
                  begin
                    FormMain.StrMsg := 'Error : ^CX^v̕ύXɎs܂' + #13#10 +
                                        sStr9;
                  end
                  else
                  begin
                    FormMain.StrMsg := 'Error : Change time stamp failed.' + #13#10 +
                                        sStr9 + #13#10 +
                                       '[OK]';
                  end;
                  ShowMessage(FormMain.StrMsg);
                  bError1 := TRUE;
                end;
              end;

            end;

            //s
            if bError1 = TRUE then
            begin
              Break;
            end;

            //f
            Break;
          end;
        end;
      end;

    end;

    //j
    CsvList1.Free;
    StrList5.Free;



    //XV
    if      BoolStop = FALSE then
    begin
      Label6.Caption := '[' + IntToStr(StrListFile.Count) + '/' + IntToStr(StrListFile.Count) +'] ' + sStr1;
      Label6.Refresh;
    end;

    //ݒ
    shOpeStrct1.Wnd               := Application.Handle;
    shOpeStrct1.wFunc             := FO_DELETE;
    shOpeStrct1.pFrom             := PWideChar(sStr22 + #0 + #0);
    shOpeStrct1.pTo               := nil;
    shOpeStrct1.fFlags            := FOF_FILESONLY or FOF_SILENT or FOF_NOCONFIRMATION;
    shOpeStrct1.hNameMappings     := nil;
    shOpeStrct1.lpszProgressTitle := nil;
    //s
    if SHFileOperation(shOpeStrct1) = 0 then
    begin
      //
    end
    else
    begin
      bError2 := TRUE;
    end;

    //XV
    ButtonGet.Enabled      := TRUE;
    ButtonGet.Refresh;
    ButtonMake.Enabled     := TRUE;
    ButtonMake.Refresh;
    ButtonStop.Enabled     := FALSE;
    ButtonStop.Refresh;
    ButtonCancel.Enabled   := TRUE;
    ButtonCancel.Refresh;
    ButtonFileList.Enabled := TRUE;
    ButtonFileList.Refresh;
    ButtonBrowse.Enabled   := TRUE;
    ButtonBrowse.Refresh;
    ButtonInitGdi.Enabled  := TRUE;
    ButtonInitGdi.Refresh;
    ButtonInitWic.Enabled  := TRUE;
    ButtonInitWic.Refresh;
    Edit1.Enabled          := TRUE;
    Edit2.Enabled          := TRUE;
    Edit3.Enabled          := TRUE;
    ComboBox1.Enabled      := TRUE;
    ComboBox2.Enabled      := TRUE;

    //
    if      BoolStop = TRUE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : TlC̍쐬𒆒f܂' + #13#10 +
                            sStr9;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Make thumbnails had stopped.' + #13#10 +
                            sStr9 + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end
    else if bError2 = TRUE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : tH_폜ł܂ł' + #13#10 +
                            sStr22;
      end
      else
      begin
        FormMain.StrMsg := 'Error : Delete folder failed.' + #13#10 +
                            sStr22 + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end
    else if bError1 = TRUE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : TlC̍쐬s܂' + #13#10 +
                            sStr22;
      end
      else
      begin
        FormMain.StrMsg := 'Error : Make thunmbnails failed.' + #13#10 +
                            sStr22 + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : TlC̍쐬܂' + #13#10 +
                            sStr9;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Make thumbnails had done.' + #13#10 +
                            sStr9 + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;
end;

procedure TFormThumbNail.ButtonStopClick(Sender: TObject);
begin
  //f
  BoolStop := TRUE;
end;

procedure TFormThumbNail.ButtonCancelClick(Sender: TObject);
var
  sStr1: String;
begin
  //
  sStr1 := Edit1.Text;
  if ExtractExtItem(sStr1, FormMain.StrListGdiExt, '', Sender) = FALSE then
  begin
    Exit;
  end;

  //I
  ModalResult := mrCancel;
end;

procedure TFormThumbNail.ThisListFilesDrive(DirName: String; TheList: TStringList);
var
  sStr2: string;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';

  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //f
      if BoolStop = TRUE then
      begin
        Break;
      end;

      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4 := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 := SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE);
        sstr6 := SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr7  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //tH_ɂ
          sStr3 := sStr3 + '\';
          //ǉ
//          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);
          TheList.Add(sStr3);

          //ċNIɌ
          Application.ProcessMessages;
          ThisListFilesDrive(sStr3, TheList);
          Application.ProcessMessages;
        end
        else
        begin
          //ǉ
//          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);
          TheList.Add(sStr3);

          //XV
          IntLocalCount := IntLocalCount+1;
          if (IntLocalCount mod 10) = 0 then
          begin
            Label2.Caption := 'Search=' + IntToStr(IntLocalCount);
            Label2.Refresh;
            Application.ProcessMessages;
            Application.ProcessMessages;
          end;
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;

procedure TFormThumbNail.ThisListFilesDriveFileCount(DirName: String; TheList: TStringList);
var
  sStr2: string;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';

  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //f
      if BoolStop = TRUE then
      begin
        Break;
      end;

      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4 := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 := SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE);
        sstr6 := SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr7  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //
        end
        else
        begin
          //ǉ
//          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);
          TheList.Add(sStr3);

          //XV
          IntLocalCount := IntLocalCount+1;
          if (IntLocalCount mod 10) = 0 then
          begin
            Label2.Caption := 'Search=' + IntToStr(IntLocalCount);
            Label2.Refresh;
            Application.ProcessMessages;
            Application.ProcessMessages;
          end;
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;

procedure TFormThumbNail.Timer1Timer(Sender: TObject);
begin
  //Zbg
  Timer1.Enabled := FALSE;

  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[hti쐬jł' + #13#10 +
                         '\[g[htiŏIXVjŎ擾܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Creation).' + #13#10 +
                         'But, get time by Date(LastWrite).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[htiŏIANZXjł' +#13#10 +
                         '\[g[htiŏIXVjŎ擾܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Last Access).' + #13#10 +
                         'But, get time by Date(LastWrite).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

function TFormThumbNail.FileTimeToDateTime(ATime: TFileTime): TDateTime;
var
  LSystemTime : TSystemTime;
  LTempTime   : TFileTime;
begin
  try
    //FileTime`(E莞)nɂ킹
    FileTimeToLocalFileTime(ATime, LTempTime);
    //FileTime`SystemTime`ɂ
    FileTimeToSystemTime(LTempTime, LSystemTime);
    //SystemTime`DelphiTDateTime`ɕϊ
    Result := SystemTimeToDateTime(LSystemTime);
  except
    Result := 0;
  end;
end;

procedure TFormThumbNail.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormThumbNail.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormThumbNail.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormThumbNail.Edit4KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormThumbNail.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormThumbNail.ComboBox2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

end.
