{$WARNINGS OFF}
//=============================================================================
//  TplContextMenu  ReLXgj[R|[lg
//  TplDropSource   hbv\[XR|[lg
//
//  gp@̓TCg̋LQ
//  TvvOW[814_ReLXgj[ R|]
//  http://mrxray.on.coocan.jp/Delphi/plSamples/814_ContextMenu_DropSource.htm
//
//  [Ql]
//  j[̑֌W֐Xg
//  http://msdn.microsoft.com/ja-jp/library/cc430229.aspx({)
//  http://msdn.microsoft.com/en-us/library/ff468865%28v=VS.85%29.aspx
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؂̊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2010N1031 Ver. 1.00
//    EJ
//
//  2010N1107 Ver. 1.01
//    EΏۂhCȕꍇɗO錻ۂC
//
//  2010N1207 Ver. 1.02
//    E[VK쐬]j[\ꂽ肵Ȃ肷錻ۂC
//    EΏۃtH_mɎ擾łȂۂC
//    E쒆ɗO錻ۂC
//    EhbvJnDoDrop\bḧListView̃nhw肵ꍇC
//      悪\Ă΃hbOɂ̉摜\悤ɂ
//      (Delphi2007ȏŃRpCꍇ̂)
//
//  2010N1208 Ver. 1.03
//    EOSVistaȍ~̏ꍇ́CVK쐬j[̕\͂Ȃ悤ɂ
//
//  2010N1218 Ver. 1.10
//    E[VK쐬]j[̃JX^}CY(폜̂)Cj[ҏWCftHg
//      쒆~̋@\O\ɂ邽߂ɁCCxg3ǉ
//    EsR}hID擾pVerbCmdIDvpeBǉ(Ǐop)
//    EL̕ύXɔCR}hs̃R[hC
//
//
//  2011N0102
//    Ehbv\[XIDropSourceC^[tFCXR|̃o[ɂ
//
//  2015N0110 Ver. 1.20
//    EDelphi 7UINT_PTR`ɂȂ錻ۂC
//      (ȑO̍XVUINT_PTRɂĂ܂炵)
//
//-----------------------------------------------------------------------------
//
//  ymFz (Delphi for Win32)
//
//  Windows XP(SP3) + Delphi 6(UP2) Pro + Delphi 7 Pro
//                  + Delphi 2007-R2 Pro
//                  + Delphi 2010(UP5) Pro
//                  + Delphi XE Pro
//
//  Windows 7 U64   + Delphi 2010(UP5) Pro
//                  + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plContextMenu;

interface

uses
  SysUtils, Windows, Messages, ShellAPI, ShlObj, ActiveX, Menus, Classes,
  Forms, ComObj;

const
  IDCMDSTR_PREVIEW    = 510; // vr[
  IDCMDSTR_PRINT      = 520; // 
  IDCMDSTR_EDIT       = 530; // ҏW
  IDCMDSTR_CUT        = 540; // ؎
  IDCMDSTR_COPY       = 550; // Rs[
  IDCMDSTR_PASTE      = 560; // \t
  IDCMDSTR_DELETE     = 570; // 폜
  IDCMDSTR_PROPERTIES = 580; // vpeB
  IDCMDSTR_EXPLORE    = 590; // GNXv[
  IDCMDSTR_OPEN       = 600; // J
  IDCMDSTR_FIND       = 610; // 

type
  TplContextSubItemEvent = procedure(Sender: TObject; ItemCaption: String;
                                     ItemID: Integer;
                                     var AddFlag: Boolean) of object;
  TplContextModifyEvent  = procedure(Sender: TObject;
                                     MenuHandle: HWND) of object;
  TplContextInvokeEvent  = procedure(Sender: TObject; CmdIndex: Integer;
                                     VerbNameStr: String;
                                     var InvokeFlag: Boolean) of object;

  TplContextShowFlag = (csf_NORMAL,
                        csf_DEFAULTONLY,
                        csf_EXPLORE,
                        csf_CANRENAME,
                        csf_CREATENEW);

  TplContextShowFlags = set of TplContextShowFlag;
  TplDropPItemIDs     = array of PItemIDList;

  TplContextMenu = class(Menus.TPopupMenu)
  private
    FAboutVCL       : String;
    FFiles          : TStrings;
    FDirectory      : String;
    FShellDesktop   : IShellFolder;
    FShellFolder    : IShellFolder;
    FpidlDesktop    : PItemIDList;
    FpidlFolder     : PItemIDList;
    FMenuOptions    : TplContextShowFlags;
    FVerbNameStr    : String;
    FVerbCmdID      : Integer;
    FInputCommndStr : AnsiString;

    FOnContextMenuClose        : TNotifyEvent;
    FOnBeforeContextAddSubItem : TplContextSubItemEvent;
    FOnBeforeContextShowMenu   : TplContextModifyEvent;
    FOnBeforeContextInvoke     : TplContextInvokeEvent;

    procedure SetFiles(const Value: TStrings);
    function DoCommand(CmdIDNo: Integer; X, Y: Integer): Boolean;
    function GetShellFolderFromPath(Dir: String; Files: TStrings;
      var CTMenu: IContextMenu2): Boolean;
  protected
    FIsOSBeforeVista : Boolean; // OSVistaÕo[W
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Popup(X, Y: Integer); override;
    function InvokeCommand(CmdIDNo: Integer): Boolean;
    property VerbNameStr : String  read FVerbNameStr;
    property VerbCmdID   : Integer read FVerbCmdID;
  published
    property AboutVCL    : String   read FAboutVCL;
    property Directory   : String   read FDirectory write FDirectory;
    property Files       : TStrings read FFiles     write SetFiles;
    property MenuOptions : TplContextShowFlags read FMenuOptions
                                               write FMenuOptions;
    property OnContextMenuClose        : TNotifyEvent
                                         read  FOnContextMenuClose
                                         write FOnContextMenuClose;
    property OnBeforeContextAddSubItem : TplContextSubItemEvent
                                         read  FOnBeforeContextAddSubItem
                                         write FOnBeforeContextAddSubItem;
    property OnBeforeContextShowMenu   : TplContextModifyEvent
                                         read  FOnBeforeContextShowMenu
                                         write FOnBeforeContextShowMenu;
    property OnBeforeContextInvoke     : TplContextInvokeEvent
                                         read  FOnBeforeContextInvoke
                                         write FOnBeforeContextInvoke;
  end;

  TplDropSource = class(TComponent, IDropSource)
  private
    FAboutVCL     : String;
    FDirectory    : String;
    FFiles        : TStrings;
    FpidlDesktop  : PItemIDList;
    FpidlFolder   : PItemIDList;
    FShellDesktop : IShellFolder;
    FShellFolder  : IShellFolder;
    procedure SetFiles(const Value: TStrings);
    function GetShellFolderAndDataFromPath(Dir: String; AFiles: TStrings;
      var PItemIDs: TplDropPItemIDs): Boolean;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function DoDrop(OwnerHandle: HWND): Integer;
    function QueryContinueDrag(fEscapePressed: BOOL;
      grfKeyState: Longint): HResult; stdcall;
    function GiveFeedback(dwEffect: Longint): HResult; stdcall;
  published
    property AboutVCL  : String   read FAboutVCL;
    property Directory : String   read FDirectory write FDirectory;
    property Files     : TStrings read FFiles     write SetFiles;
  end;

procedure Register;

function GetPItemIDFromFileName(ShFolder: IShellFolder;
  Path: String): PItemIDList;
function GetFullPathFromAbsPItemID(pidlFull: PItemIDList): String;

{$IF CompilerVersion < 21.0}
//---------------------------------------------------------------------------
//  Delphi 2010Õo[WłShlObj.pasɒ`Ȃ֐̂ł
//  Œ`
//  ̊֐ނWindows 2000ȍ~Shell32.dllŒ񋟂Ă
//  Windows 2000ł́C̊֐͔JAPIƂȂĂ
//---------------------------------------------------------------------------
function ILClone(pidl: PItemIDList): PItemIDList; stdcall;
function ILCreateFromPath(pszPath: LPCTSTR): PItemIDList; stdcall;
function SHBindToParent(pidl: PItemIDList; const riid: TIID; var ppv: Pointer;
  var ppidlLast: PItemIDList): HResult; stdcall;
//---------------------------------------------------------------------------
{$IFEND}

implementation

type
  {$IF CompilerVersion < 18.00}
  UINT_PTR = Cardinal;
  {$IFEND}

  // http://msdn.microsoft.com/ja-jp/library/kb145b0a.aspxQ
  PAppendMenuItemData = ^TAppendMenuItemData;
  tagAppendMenuItemData = packed record
    nFlags      : UINT;
    nIDNewItem  : UINT_PTR;
    lpszNewItem : LPCTSTR;
  end;
  TAppendMenuItemData = tagAppendMenuItemData;
  AppendMenuItemData = tagAppendMenuItemData;

const
  CMF_CREATENEW = $80000001;

  // CLSID_NewMenuDelphi 6ɂȂ̂Œǉ
  CLSID_NewMenu: TGUID = '{D969A300-E7FF-11D0-A93B-00A0C90F2719}';

  ContextShowFlags: array [TplContextShowFlag] of Cardinal = (
                                                  CMF_NORMAL,
                                                  CMF_DEFAULTONLY,
                                                  CMF_EXPLORE,
                                                  CMF_CANRENAME,
                                                  CMF_CREATENEW);
  {$IF CompilerVersion < 21.0}
  Shell32DLL = 'shell32.dll';
  function ILClone; external Shell32DLL index 18;
  function ILCreateFromPath; external Shell32DLL index 189;
  function SHBindToParent; external Shell32DLL;
  {$IFEND}

var
  g_plContextMenu    : TplContextMenu;
  g_ContextMenu      : IContextMenu2; // [VK쐬]ȊÕj[C^[tFCX
  g_ContextMenuNew   : IContextMenu2; // [VK쐬]̃j[̃C^[tFCX
  g_OriginWinProc    : TFarProc;
  g_SubMenuNewHandle : HMENU;
  g_CreateNewOnly    : Boolean;
  g_ItemNumber       : Integer;
  g_Malloc           : IMalloc;

// -----------------------------------------------------------------------------
//  t@Cڎʎqɕϊ֐
//  tpX擾ꍇShFolderɃfXNgbvIuWFNgw肷
//  wtH_̃tH_C΍ڎʎq擾ꍇ͂̃t@Ci[
//  ĂtH_̃VFIuWFNgShFoldorɗ^
// -----------------------------------------------------------------------------
function GetPItemIDFromFileName(ShFolder: IShellFolder;
  Path: String): PItemIDList;
var
  Len   : Cardinal;
  Flags : Cardinal;
begin
  Flags := 0;
  Len   := Length(Path);
  ShFolder.ParseDisplayName(Application.Handle,
                            nil,
                            PWideChar(StringToOleStr(Path)),
                            Len,
                            Result,
                            Flags);
end;

//-----------------------------------------------------------------------------
//  tpX̍ڎʎq(SPIDL)Ct@CVXẽtpXɕϊ
//  ̊֐gpɂusesShlObjKv
//-----------------------------------------------------------------------------
function GetFullPathFromAbsPItemID(pidlFull: PItemIDList): String;
var
  pShFolder : IShellFolder;
  pidl      : PItemIDList;
  StrRet    : TStrRet;
begin
  Result := '';

  //Yt@C̃tH_IuWFNg(pShFolder)ƁC΍ڎʎqpidlɎ擾
  SHBindToParent(pidlFull,
                 IShellFolder,
                 Pointer(pShFolder),
                 pidl);
  FillChar(StrRet, SizeOf(StrRet), 0);
  if pShFolder.GetDisplayNameOf(pidl, SHGDN_FORPARSING, StrRet) = S_OK then begin
    Result := StrRet.pOleStr;
  end;
end;

{ TplContextMenu }

//-----------------------------------------------------------------------------
//  ̃EBhEvV[W[̓j[CTuj[̕`掞ɌĂ΂
//  Windows Vistaȍ~ł́CWM_MEASUREITEMWM_DRAWITEMȂ
//  WM_INITMENUPOPUPbZ[W͔
//  winspectorɂ钲ł0x00000094̃bZ[Wʉ߂Ă
//  (J̓eȂ̂ŁCWindows̃}Ci[`FWŎgpsɂȂ\)
//-----------------------------------------------------------------------------
function SendToProc(Wnd: HWND; Msg: UINT; WParam, LParam: Integer): LRESULT;
  stdcall;
var
  lpData      : PAppendMenuItemData;
  ItemCaption : String;
  AddFlag     : Boolean;
  ARect       : TREct;
  VerbName    : array [0 .. MAX_PATH - 1] of Char;
  Info        : TMenuItemInfo;
  pDrawStruct : PDrawItemStruct;
  pItemStruct : PMeasureItemStruct;
  ItemID      : Integer;
begin
  case Msg of
  WM_INITMENUPOPUP:
    begin
      g_ItemNumber := 0;
      if g_SubMenuNewHandle <> 0 then begin
        if g_CreateNewOnly then begin
          g_ContextMenuNew.HandleMenuMsg(Msg, WParam, LParam);
        end else begin
          g_ContextMenuNew.HandleMenuMsg(Msg, g_SubMenuNewHandle, LParam);
        end;
      end;
      if g_ContextMenu <> nil then begin
        g_ContextMenu.HandleMenuMsg(Msg, WParam, LParam);
      end;
      Result := 0;
    end;
  $00000094:
    //for Vista and Windows 7
    begin
      FillChar(VerbName, SizeOf(VerbName), #0);
      Info.cbSize     := SizeOf(Info);
      Info.fMask      := MIIM_STRING or MIIM_ID;
      info.dwTypeData := VerbName;
      Info.cch        := Length(VerbName);

      GetMenuItemInfo(g_SubMenuNewHandle, g_ItemNumber, True, Info);
      ItemCaption := Info.dwTypeData;
      ItemID      := Info.wID;

      AddFlag := True;
      if Assigned(g_plContextMenu.FOnBeforeContextAddSubItem) then begin
        if ItemCaption <> '' then begin
          g_plContextMenu.FOnBeforeContextAddSubItem(g_plContextMenu,
                                                     ItemCaption,
                                                     ItemID,
                                                     AddFlag);
          if AddFlag = False then begin
            RemoveMenu(g_SubMenuNewHandle, ItemID, MF_BYCOMMAND);
          end;
        end;
      end;

      Result := CallWindowProc(g_OriginWinProc, Wnd, Msg, WParam, LParam);
      g_ItemNumber := g_ItemNumber + 1;
    end;
  WM_MEASUREITEM:
    begin
      //[VK쐬]̃Tuj[
      pItemStruct := nil;
      if g_SubMenuNewHandle <> 0 then begin
        pItemStruct := PMeasureItemStruct(LParam);
        lpData      := PAppendMenuItemData(pItemStruct^.itemData);
        ItemCaption := lpData.lpszNewItem;
        ItemID      := pItemStruct^.itemID;

        g_ContextMenuNew.HandleMenuMsg(Msg, WParam, LParam);
      end;
      if g_ContextMenu <> nil then begin
        AddFlag := True;
        if Assigned(g_plContextMenu.FOnBeforeContextAddSubItem) then begin
          if ItemCaption <> '' then begin
            g_plContextMenu.FOnBeforeContextAddSubItem(g_plContextMenu,
                                                       ItemCaption,
                                                       ItemID,
                                                       AddFlag);
            if AddFlag = False then begin
              pItemStruct^.itemHeight := 0;
              pItemStruct^.itemWidth  := 10;
              LParam := Integer(pItemStruct);
            end;
          end;
        end;
        g_ContextMenu.HandleMenuMsg(Msg, WParam, LParam);
      end;
      Result := 0;
    end;
  WM_DRAWITEM:
    begin
      pDrawStruct := PDrawItemStruct(LParam);
      ARect       := pDrawStruct^.rcItem;

      if g_SubMenuNewHandle <> 0 then begin
        if (ARect.Bottom - ARect.Top) > 0 then begin
          g_ContextMenuNew.HandleMenuMsg(Msg, WParam, LParam);
        end;
      end;
      if g_ContextMenu <> nil then begin
        g_ContextMenu.HandleMenuMsg(Msg, WParam, LParam);
      end;
      Result := 0;
    end;
  else
    Result := CallWindowProc(g_OriginWinProc, Wnd, Msg, WParam, LParam);
  end;
end;

//=============================================================================
//  Create
//  t@Ci[郊Xg̐
//  OS̃o[W擾āCVistaȍ~`FbN
//=============================================================================
constructor TplContextMenu.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FAboutVCL       := 'Version 1.20';
  FFiles          := TStringList.Create;
  FMenuOptions    := [csf_EXPLORE, csf_CANRENAME, csf_CREATENEW];
  g_plContextMenu := Self;

  //OS̃o[Wl擾Ă
  //łVistaȍ~ɑ΂锻Ȃ̂łꂾ
  FIsOSBeforeVista := (Win32MajorVersion <= 5) and (Win32MinorVersion <= 1);
end;

//=============================================================================
//  Destroy
//=============================================================================
destructor TplContextMenu.Destroy;
begin
  FShellDesktop := nil;
  FShellFolder  := nil;
  FreeAndNil(FFiles);
  inherited;
end;

//=============================================================================
//  t@C܂̓tH_̃Xg̃vpeBݒ胁\bh
//=============================================================================
procedure TplContextMenu.SetFiles(const Value: TStrings);
begin
  FFiles.Assign(Value);
end;

//=============================================================================
//  j[̃|bvAbv\bh(J\bh)
//  ̃\bh
//  (1) ̊֐𒼐ڎs
//  (2) }EXŉE{^NbN
//  (3) OnPopupCxgs
//  ɌĂяo
//=============================================================================
procedure TplContextMenu.Popup(X, Y: Integer);
begin
  FInputCommndStr := '';
  if Assigned(OnPopup) then OnPopup(Self);

  DoCommand(0, X, Y);
end;

//=============================================================================
//  j[\ȂŃR}hs郁\bh(J\bh)
//=============================================================================
function TplContextMenu.InvokeCommand(CmdIDNo: Integer): Boolean;
begin
  Result := False;

  FInputCommndStr := '';
  case CmdIDNo of
    IDCMDSTR_PREVIEW    : FInputCommndStr := 'preview';
    IDCMDSTR_PRINT      : FInputCommndStr := 'print';
    IDCMDSTR_EDIT       : FInputCommndStr := 'edit';
    IDCMDSTR_CUT        : FInputCommndStr := 'cut';
    IDCMDSTR_COPY       : FInputCommndStr := 'copy';
    IDCMDSTR_PASTE      : FInputCommndStr := 'paste';
    IDCMDSTR_DELETE     : FInputCommndStr := 'delete';
    IDCMDSTR_PROPERTIES : FInputCommndStr := 'properties';
    IDCMDSTR_EXPLORE    : FInputCommndStr := 'explore';
    IDCMDSTR_OPEN       : FInputCommndStr := 'open';
    IDCMDSTR_FIND       : FInputCommndStr := 'find';
  end;
  if FInputCommndStr <> '' then Result := DoCommand(CmdIDNo, 0, 0);
end;

//=============================================================================
//  Ŏgps֐
//  CmdIDNo = 0̎̓ReLXgj[̕\
//  0ȊO̓ReLXgj[\ȂŁCR}hs
//=============================================================================
function TplContextMenu.DoCommand(CmdIDNo: Integer; X, Y: Integer): Boolean;
const
  StrNewConst1  = 'VK쐬(&W)';
  StrNewconst2  = 'VK쐬(&X)';
  ReductionLine = 2048;
var
  ContextMenu    : IContextMenu2;
  ContextMenuNew : IShellExtInit;
  ici            : TCMInvokeCommandInfo;
  i              : Integer;
  Command        : BOOL;
  CmdIndex       : Integer;
  VerbName       : array [0 .. MAX_PATH - 1] of Char;
  Info           : TMenuItemInfo;
  ShowFlag       : Cardinal;
  StrNewMenu     : String;
  AddItemCnt     : Integer;
  IsLine         : Boolean;
  InvokeFlag     : Boolean;
  ItemCount      : Integer;
begin
  Result             := False;
  g_ContextMenu      := nil;
  g_ContextMenuNew   := nil;
  g_OriginWinProc    := nil;
  g_SubMenuNewHandle := 0;
  FVerbNameStr       := '';
  g_CreateNewOnly    := FMenuOptions = [csf_CREATENEW];

  if g_CreateNewOnly and (FIsOSBeforeVista = False) then exit;
  if g_CreateNewOnly then Items.Clear;

  //ContextMenuReLXgp̃j[nh
  //[VK쐬]ɂ͕ʂ̃nhKv
  if GetShellFolderFromPath(FDirectory, FFiles, ContextMenu) = False then exit;

  if (CmdIDNo = 0) and (g_CreateNewOnly = False) then begin
    //郁j[擾ăEBhEvV[W[ݒ
    if FAILED(ContextMenu.QueryInterface(IID_IContextMenu2,
                                         g_ContextMenu)) then exit;

    g_OriginWinProc := Pointer(SetWindowLong(WindowHandle,
                                             GWL_WNDPROC,
                                             Integer(@SendToProc)));
  end;

  try
    if (CmdIDNo = 0) and (FFiles.Count = 0) and
                         (Pos('::', FDirectory) = 0) and
                         (csf_CREATENEW in FMenuOptions) then begin

      //VK쐬̎擾
      //VK쐬̃Xg̓fXNgbṽtpXɑ鍀ڎʎqKv
      CoCreateInstance(CLSID_NewMenu,
                       nil,
                       CLSCTX_INPROC_SERVER,
                       IID_IShellExtInit,
                       ContextMenuNew);
      ContextMenuNew.Initialize(FpidlFolder, nil, 0);

      if FIsOSBeforeVista then begin
        AddItemCnt := 2;
      end else begin
        AddItemCnt := 1;
      end;

      if Succeeded(ContextMenuNew.QueryInterface(IID_IContextMenu2,
                                                 g_ContextMenuNew)) then begin
        //[VK쐬]ReLXgj[|bvAbvj[֐ݒ
        if Succeeded(g_ContextMenuNew.QueryContextMenu(Handle,
                                                       0,
                                                       Items.Count + AddItemCnt,
                                                       $7FFF,
                                                       CMF_EXPLORE)) then begin
          if g_OriginWinProc = nil then begin
            g_OriginWinProc := Pointer(SetWindowLong(WindowHandle,
                                                     GWL_WNDPROC,
                                                     Integer(@SendToProc)));
          end;
        end;
      end;
    end;

    //[VK쐬]ȊÕReLXgj[|bvAbvj[֐ݒ
    if (g_CreateNewOnly = False) and (FMenuOptions <> []) then begin
      ShowFlag := 0;
      if csf_DEFAULTONLY in FMenuOptions then ShowFlag := ShowFlag or CMF_DEFAULTONLY;
      if csf_NORMAL in FMenuOptions      then ShowFlag := ShowFlag or CMF_NORMAL;
      if csf_EXPLORE in FMenuOptions     then ShowFlag := ShowFlag or CMF_EXPLORE;
      if csf_CANRENAME in FMenuOptions   then ShowFlag := ShowFlag or CMF_CANRENAME;

      if FAILED(ContextMenu.QueryContextMenu(Handle,
                                             0,
                                             Items.Count + 1,
                                             $7FFF,
                                             ShowFlag)) then exit;
    end;

    Command := False;
    if (CmdIDNo = 0) then begin
      //OnBeforeContextMenuPopupCxgDǉCҏWC폜Ȃǂ͂Ŏs
      if Assigned(FOnBeforeContextShowMenu) then begin
        FOnBeforeContextShowMenu(Self, Handle);
      end;

      //j[ڂ̒(VKj̒Cڍ폜ŋ؂̏d)
      ItemCount := GetMenuItemCount(Handle);
      IsLine    := False;

      for i := ItemCount - 1 downto 0 do begin
        FillChar(VerbName, SizeOf(VerbName), #0);
        Info.cbSize     := SizeOf(Info);
        Info.fMask      := MIIM_SUBMENU or MIIM_TYPE;
        info.dwTypeData := VerbName;
        Info.cch        := Length(VerbName);

        GetMenuItemInfo(Handle, i, True, Info);
        //O̍ڂ_NV(؂)獡̕폜
        if Info.fType = ReductionLine then begin
          if IsLine then begin
            DeleteMenu(Handle, i, MF_BYPOSITION);
          end else
          if i = 0 then DeleteMenu(Handle, i, MF_BYPOSITION);
        end;
        IsLine := Info.fType = ReductionLine;

        //VK쐬Tuj[̃nh𒲍
        //̃nh̓Tuj[̕`Ɏgp
        //VKj[̃nh擾D{ł̂ݑΉ
        if (csf_CREATENEW in FMenuOptions) and (ContextMenuNew <> nil) then begin
          //܂Ɏ擾łȂ񂪂(Ă̂? Vistaȍ~)
          try
            StrNewMenu := Info.dwTypeData;
            if (Pos(StrNewConst1, StrNewMenu) > 0) or
               (Pos(StrNewConst2, StrNewMenu) > 0) then begin
              g_SubMenuNewHandle := Info.hSubMenu;
            end;
          except
          end;
        end;
        Application.ProcessMessages;
      end;
      //Ōオ؂蕶폜
      ItemCount := GetMenuItemCount(Handle);
      GetMenuItemInfo(Handle, ItemCount - 1, True, Info);
      if Info.fType = ReductionLine then begin
        DeleteMenu(Handle, ItemCount - 1, MF_BYPOSITION);
      end;

      // ReLXgj[J
      Command := TrackPopupMenu(Handle,
                                TPM_LEFTALIGN   or
                                TPM_LEFTBUTTON  or
                                TPM_RIGHTBUTTON or
                                TPM_RETURNCMD,
                                X,
                                Y,
                                0,
                                WindowHandle,
                                nil);
    end;

    //j[\s
    if (Command = False) and (CmdIDNo = 0) then begin
      Result := False;
    end else begin
      FVerbCmdID := Integer(Command);
      CmdIndex   := Integer(Command) - 1;
      //TPopupMenuɒǉj[̏ꍇ(ɉ)
      if (CmdIndex < Items.Count) and (CmdIDNo = 0) then begin
        Items[CmdIndex].Click;
      end else begin
        if CmdIDNo = 0 then CmdIDNo := CmdIndex - Items.Count;

        //OnBeforeContextMenuInvoke
        //̃CxgŁC̃j[́Cʂ̃vO̎s̎s\
        //Ⴆ[]͎̃AvŎs铙
        FillChar(VerbName, SizeOf(VerbName), 0);
        ContextMenu.GetCommandString(CmdIDNo,
                                     GCS_VERB,
                                     nil,
                                     @VerbName,
                                     SizeOf(VerbName));
        FVerbNameStr := VerbName;
        if CmdIDNo > 500 then FVerbNameStr := FInputCommndStr;

        InvokeFlag := True;
        if Assigned(FOnBeforeContextInvoke) then begin
          FOnBeforeContextInvoke(Self, Integer(Command), FVerbNameStr, InvokeFlag);
        end;

        //IꂽR}hs
        //fMaskCMIC_MASK_FLAG_NO_UI(mF_CAO\)w肵Ă邪
        //Vistaȍ~ł͂̃tOw肵Ȃ[폜]s
        //CVistaȍ~ł[폜]̊mF_CAO\Ȃ
        //[Q]http://support.microsoft.com/kb/327569/ja

        if InvokeFlag then begin
          FillChar(ici, SizeOf(ici), 0);
          ici.cbSize := SizeOf(ici);
          ici.fMask  := CMIC_MASK_FLAG_NO_UI;
          ici.HWND   := Handle;
          if CmdIDNo < 500 then begin
            ici.lpVerb := PAnsiChar(MAKEINTRESOURCE(CmdIDNo));
          end  else begin
            ici.lpVerb := PAnsiChar(FInputCommndStr);
          end;
          ici.lpParameters := nil;
          ici.lpDirectory  := nil;
          ici.dwHotKey     := 0;
          ici.hIcon        := 0;
          ici.nShow        := SW_SHOWNORMAL;

          //R}hs
          //MDSN̋Lł͐S_OKCȊOł̓G[R[hoł
          //ƂɂȂĂ邪Cۂɂ͗O
          if FIsOSBeforeVista then begin
            try
              //Tuj[ɎsȂWindows 2000ł̓ftHg
              //sĂ܂
              if Succeeded(g_ContextMenuNew.InvokeCommand(ici)) then begin
                Result := True;
              end else begin
                Result := Succeeded(ContextMenu.InvokeCommand(ici));
              end;
            except
              try
                Result := Succeeded(ContextMenu.InvokeCommand(ici));
              except
              end;
            end;
          end else begin
            //Vistȍ~ł͎sĂS_OK߂Ă̂ŗs
            try
              Result := Succeeded(ContextMenu.InvokeCommand(ici));
              Result := Succeeded(g_ContextMenuNew.InvokeCommand(ici));
            except
            end;
          end;
        end;
      end;
    end;
  finally
    for i := GetMenuItemCount(Handle) - Items.Count - 1 downto 0 do begin
      DeleteMenu(Handle, i, MF_BYPOSITION);
    end;
  end;

  if Assigned(g_OriginWinProc) then begin
    SetWindowLong(WindowHandle, GWL_WNDPROC, Integer(g_OriginWinProc));
  end;
  if Assigned(FOnContextMenuClose) then FOnContextMenuClose(Self);

  FShellDesktop := nil;
  FShellFolder  := nil;
  CoTaskMemFree(FpidlFolder);
end;

//=============================================================================
//  Ŏgp֐
//
//  w肵tH_Ct@CtH_̃VFIuWFNg擾
//  擾łReLXgj[擾
//  Ώەs̃tH_t@CPłFalseԂ
//=============================================================================
function TplContextMenu.GetShellFolderFromPath(Dir: String; Files: TStrings;
  var CTMenu: IContextMenu2): Boolean;
var
  PItemIDs    : array of PItemIDList;
  ADirectory  : String;
  DesktopPath : String;
  IsDesktop   : Boolean;
  i           : Integer;
begin
  FpidlDesktop := nil;
  FpidlFolder  := nil;

  Result := False;

  // fXNgbv֌W̒l擾
  if FAILED(SHGetDesktopFolder(FShellDesktop)) then exit;

  SHGetSpecialFolderLocation(0, CSIDL_DESKTOP, FpidlDesktop);
  DesktopPath := GetFullPathFromAbsPItemID(FpidlDesktop);
  ADirectory  := IncludeTrailingPathDelimiter(Dir);

  if Files.Count = 0 then begin
    SetLength(PItemIDs, 1);
  end else begin
    SetLength(PItemIDs, Files.Count);
  end;

  for i := 0 to Length(PItemIDs) - 1 do PItemIDs[i] := nil;

  IsDesktop := False;

  // fXNgbv
  if Dir = '' then begin
    PItemIDs[0]  := ILClone(FpidlDesktop);
    FpidlFolder  := ILClone(FpidlDesktop);
    FShellFolder := FShellDesktop;
    IsDesktop    := True;
    Result       := True;
  end else begin
    FpidlFolder := ILCreateFromPath(PChar(Dir));
    if FpidlFolder <> nil then begin
      if GetFullPathFromAbsPItemID(FpidlFolder) = DesktopPath then begin
        PItemIDs[0]  := ILClone(FpidlDesktop);
        FShellFolder := FShellDesktop;
        IsDesktop    := True;
        Result       := True;
      end else begin
        if (SHBindToParent(FpidlFolder,
                           IShellFolder,
                           Pointer(FShellFolder),
                           PItemIDs[0])) = S_OK then begin
          Result := True;
        end;
      end;
    end;
  end;

  if Result and (Files.Count > 0) then begin
    if (IsDesktop = False) then begin
      if FAILED(FShellDesktop.BindToObject(FpidlFolder,
                                           nil,
                                           IID_IShellFolder,
                                           Pointer(FShellFolder))) then begin
        Result := False;
      end;
    end;
    if Result then begin
      for i := 0 to Files.Count - 1 do begin
        PItemIDs[i] := GetPItemIDFromFileName(FShellFolder, Files[i]);
        if PItemIDs[i] = nil then begin
          PItemIDs[i] := GetPItemIDFromFileName(FShellFolder, '::' + Files[i]);
          if PItemIDs[i] = nil then begin
            Result := False;
            break;
          end;
        end;
      end;
    end;
  end;

  if Result then begin
    Result := False;
    //ReLXgj[̎擾
    //CTMenu(IContextMenu2)Ԃ
    //Ώەs̃tH_t@CPłƕ\Ȃ
    if Succeeded(FShellFolder.GetUIObjectOf(WindowHandle,
                                            Length(PItemIDs),
                                            PItemIDs[0],
                                            IID_IContextMenu,
                                            nil,
                                            Pointer(CTMenu))) then begin
      Result := True;
    end;
  end;
end;



//=============================================================================
//
//                 ȉChbO\[XR|[lg֌W
//
//=============================================================================

{ TplDropSource }

//=============================================================================
//  Create
//=============================================================================
constructor TplDropSource.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FAboutVCL := 'Version 1.20';
  FFiles    := TStringList.Create;
end;

// =============================================================================
// I
// =============================================================================
destructor TplDropSource.Destroy;
begin
  FShellDesktop := nil;
  FShellFolder  := nil;
  FreeAndNil(FFiles);
  inherited;
end;

//=============================================================================
//  FilesvpeBݒ胁\bh
//  t@CXg̃Zbg
//=============================================================================
procedure TplDropSource.SetFiles(const Value: TStrings);
begin
  FFiles.Assign(Value);
end;

//=============================================================================
//  hbvJn\bh(J\bh)
//  ̕R|̖{
//  ȊÓCPɑΏۂƂȂt@C̍ڎʎqCGetUIObjectOfPItemIDs
//  Zbg邽߂̂
//=============================================================================
function TplDropSource.DoDrop(OwnerHandle: HWND): Integer;
var
  PItemIDs    : TplDropPItemIDs;
  ACount      : Integer;
  IDataObj    : IDataObject;
  prgfInOut   : Pointer;
  dwEffect    : Longint;
  AMousePoint : TPoint;
  {$IF CompilerVersion > 18.49}
  pDragSourceHelper: IDragSourceHelper;
  {$IFEND}
begin
  Result := DROPEFFECT_NONE;

  if (OwnerHandle = 0) then exit;
  if (FFiles.Count = 0) and (FDirectory = '') then exit;

  if GetShellFolderAndDataFromPath(FDirectory, FFiles, PItemIDs) then begin

    ACount    := Length(PItemIDs);
    prgfInOut := nil;

    //ZbgPItemIDs̃t@CXgIDataObj擾
    if Succeeded(FShellFolder.GetUIObjectOf(OwnerHandle, ACount, PItemIDs[0],
        IDataObject, prgfInOut, Pointer(IDataObj))) then begin

      //Delphi2007ȏ
      {$IF CompilerVersion > 18.49}
      //IDragSourceHelper
      //OwnerHandleListView,TreeViewłāC摜\Ă΁Ch
      //bOJnƓɂ̉摜\
      CoCreateInstance(CLSID_DragDropHelper,
                       nil,
                       CLSCTX_INPROC_SERVER,
                       IID_IDragSourceHelper,
                       pDragSourceHelper);
      GetCursorPos(AMousePoint);
      //ł͉摜(C[W)\Window擾
      pDragSourceHelper.InitializeFromWindow(
                       OwnerHandle,
                       AMousePoint,
                       IDataObj);
      {$IFEND}

      //hbOJn
      DoDragDrop(IDataObj,
                 Self,
                 DROPEFFECT_COPY or DROPEFFECT_MOVE or DROPEFFECT_LINK, dwEffect);
      IDataObj    := nil;
      {$IF CompilerVersion > 18.49}
      pDragSourceHelper := nil;
      {$IFEND}
    end;
  end;
  CoTaskMemFree(FpidlDesktop);
  CoTaskMemFree(FpidlFolder);

  //šʂԂ
  //eDoDragDrop֐̑3̒l̂ǂꂩ
  Result := dwEffect;
end;

//=============================================================================
//  Ŏgp֐
//
//  vpeBDirectoryFilestH_̃VFIuWFNgƃt@C܂
//  t@C̍ڎʎq̃XgPItemIDsԂ
//
//  ̏TplContextMenuƂقƂǓŁCڎʎq֌W
//  ڎʎq̏֌WʂɂċʂɎgpĂC̃t@C2
//  R|ł͕ʁXɂD̕p҂ɂƂĂ͖{R|ނ̉ς₷
//  l
//=============================================================================
function TplDropSource.GetShellFolderAndDataFromPath(Dir: String;
  AFiles: TStrings; var PItemIDs: TplDropPItemIDs): Boolean;
var
  DesktopPath     : String;
  ADirectory      : String;
  IsDesktop       : Boolean;
  IsSpecialFolder : Boolean;
  i               : Integer;
begin
  Result := False;
  FpidlDesktop := nil;
  FpidlFolder := nil;
  IsDesktop := False;

  // fXNgbv֌W̒l擾
  if FAILED(SHGetDesktopFolder(FShellDesktop)) then exit;

  SHGetSpecialFolderLocation(0, CSIDL_DESKTOP, FpidlDesktop);
  DesktopPath := GetFullPathFromAbsPItemID(FpidlDesktop);

  ADirectory := IncludeTrailingPathDelimiter(Dir);

  if Files.Count = 0 then begin
    SetLength(PItemIDs, 1);
  end else begin
    SetLength(PItemIDs, Files.Count);
  end;

  for i := 0 to Length(PItemIDs) - 1 do PItemIDs[i] := nil;

  IsSpecialFolder := (ADirectory = ExtractFileDir(ADirectory)) or
                     (Pos('::', ADirectory) > 0);
  // fXNgbv
  if Dir = '' then begin
    if Files.Count > 0 then begin
      PItemIDs[0]  := ILClone(FpidlDesktop);
      FShellFolder := FShellDesktop;
      IsDesktop    := True;
      Result       := True;
    end;
  end else begin
    FpidlFolder := ILCreateFromPath(PChar(Dir));
    if FpidlFolder <> nil then begin
      if GetFullPathFromAbsPItemID(FpidlFolder) = DesktopPath then begin
        if Files.Count > 0 then begin
          PItemIDs[0]  := ILClone(FpidlDesktop);
          FShellFolder := FShellDesktop;
          IsDesktop    := True;
          Result       := True;
        end;
      end else begin
        if (SHBindToParent(FpidlFolder,
                           IShellFolder,
                           Pointer(FShellFolder),
                           PItemIDs[0])) = S_OK then begin
          if (Files.Count > 0) and (IsSpecialFolder = False) then begin
            Result := True;
          end;
        end;
      end;
    end;
  end;

  if Result and (Files.Count > 0) then begin
    if (IsDesktop = False) then begin
      if FAILED(FShellDesktop.BindToObject(FpidlFolder,
                                           nil,
                                           IID_IShellFolder,
                                           Pointer(FShellFolder))) then begin
        Result := False;
      end;
    end;
    if Result then begin
      for i := 0 to Files.Count - 1 do begin
        PItemIDs[i] := GetPItemIDFromFileName(FShellFolder, Files[i]);
        if PItemIDs[i] = nil then begin
          Result := False;
          break;
        end;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  IDropSourceC^[tFCX
//  }EXJ[\̌`ݒ
//  DRAGDROP_S_USEDEFAULTCURSORS͕W̃}EXJ[\
//-----------------------------------------------------------------------------
function TplDropSource.QueryContinueDrag(fEscapePressed: BOOL;
  grfKeyState: Integer): HResult;
begin
  //[ESC]ł͏I
  if fEscapePressed then begin
    Result := DRAGDROP_S_CANCEL;
  end else begin
    //E܂͍{^̏ꍇ̂݋
    if not(grfKeyState and MK_LBUTTON <> 0) and
                       not (grfKeyState and MK_RBUTTON <> 0) then begin
      Result := DRAGDROP_S_DROP;
    end else begin
      Result := NOERROR;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  IDropSourceC^[tFCX
//  hbOAhhbvp邩I邩Ԃ
//-----------------------------------------------------------------------------
function TplDropSource.GiveFeedback(dwEffect: Integer): HResult;
begin
  Result := DRAGDROP_S_USEDEFAULTCURSORS;
end;

//=============================================================================
//  R|[lgo^
//=============================================================================
procedure Register;
begin
  RegisterComponents('plXRAY', [TplContextMenu]);
  RegisterComponents('plXRAY', [TplDropSource]);
end;

//----------------------------------------------------------------------------
//  ƏI(ÂDelphio[Wp?)
//----------------------------------------------------------------------------
initialization
  SHGetMalloc(g_Malloc);
  OleInitialize(nil);

finalization
  OleUninitialize;
  g_Malloc := nil;

end.
