unit Archive;

interface

uses
  Windows, SysUtils, Dialogs;

const
  //
  DLLAddressErrMes = 'DLL̊֐ %s ̃AhX܂.';
  //
  FNAME_MAX32 =  512;
  COMMENT_MAX = 2048;
  //TArchiveFile.FindOpen  dwMode ɉLrbg}XN̑gݍ킹w
  M_INIT_NONE             = $00000000;	//ݒ
  M_INIT_FILE_USE			    = $00000001;	//WXg̐ݒgp
  M_REGARDLESS_INIT_FILE	= $00000002;	//WXggpȂ
  M_CHECK_ALL_PATH			  = $00000100;	//iȃt@CT[`
  M_CHECK_FILENAME_ONLY	  = $00000200;	//iȃt@CT[`sȂ
  M_USE_DRIVE_LETTER	   	= $00001000;	//hCui[
  M_NOT_USE_DRIVE_LETTER	= $00002000;	//hCui[Ȃ
  M_ERROR_MESSAGE_ON		  = $00400000;	//G[bZ[W\
  M_ERROR_MESSAGE_OFF		  = $00800000;	//G[bZ[W\Ȃ
  M_RECOVERY_ON           = $08000000;	//jwb_̓ǂݔ΂
  EXTRACT_FOUND_FILE	   	= $40000000;	//ꂽt@C
  EXTRACT_NAMED_FILE	   	= $80000000;	//w肵t@C

  LOAD_LIBRARY_FLAG       = $00000800 or $00000200; // LOAD_LIBRARY_SEARCH_SYSTEM32 + LOAD_LIBRARY_SEARCH_APPLICATION_DIR

{$IFDEF WIN32}
type
  //FindFist̍\
  TMyIndivisualInfo = packed record
    dwOriginalSize:	  DWORD;
    dwCompressedSize:	DWORD;
    dwCRC:            DWORD;
    uFlag:	          UINT;
    uOSType:			   	UINT;
    wRatio:				    WORD;
    wDate:				    WORD;
    wTime:				    WORD;
    szFileName:			  array[0..FNAME_MAX32] of AnsiChar;
    dummy1:				    array[0..2] of AnsiChar;
    szAttribute:	   	array[0..7] of AnsiChar;
    szMode:				    array[0..7] of AnsiChar;
    //ȉ͓Ǝgɂ\̒̈ʒu͍ۏ؂Ȃ
    WriteTime:		   	TFileTime;
    AccessTime:		   	TFileTime;
    CreateTime:		   	TFileTime;
    qwOriginalSize:  	int64;
    qwCompressedSize:	int64;
  end;
  PIndivisualInfo = ^TMyIndivisualInfo;
{$ENDIF}

{$IFDEF WIN64}
type
  //FindFist̍\
  TMyIndivisualInfo = record
    dwOriginalSize:	  DWORD;
    dwCompressedSize:	DWORD;
    dwCRC:            DWORD;
    uFlag:	          UINT;
    uOSType:			   	UINT;
    wRatio:				    WORD;
    wDate:				    WORD;
    wTime:				    WORD;
    szFileName:			  array[0..FNAME_MAX32] of AnsiChar;
    dummy1:				    array[0..2] of AnsiChar;
    szAttribute:	   	array[0..7] of AnsiChar;
    szMode:				    array[0..7] of AnsiChar;
    //ȉ͓Ǝgɂ\̒̈ʒu͍ۏ؂Ȃ
    WriteTime:		   	TFileTime;
    AccessTime:		   	TFileTime;
    CreateTime:		   	TFileTime;
    qwOriginalSize:  	int64;
    qwCompressedSize:	int64;
  end;
  PIndivisualInfo = ^TMyIndivisualInfo;
{$ENDIF}

//  mFp
 {
type
  //FindFist̍\
  TMyIndivisualInfo64 = record
    dwOriginalSize:	  DWORD;
    dwCompressedSize:	DWORD;
    dwCRC:            DWORD;
    uFlag:	          UINT;
    uOSType:			   	UINT;
    wRatio:				    WORD;
    wDate:				    WORD;
    wTime:				    WORD;
    szFileName:			  array[0..FNAME_MAX32] of AnsiChar;
    dummy1:				    array[0..2] of AnsiChar;
    szAttribute:	   	array[0..7] of AnsiChar;
    szMode:				    array[0..7] of AnsiChar;
    //ȉ͓Ǝgɂ\̒̈ʒu͍ۏ؂Ȃ
    WriteTime:		   	TFileTime;
    AccessTime:		   	TFileTime;
    CreateTime:		   	TFileTime;
    qwOriginalSize:  	int64;
    qwCompressedSize:	int64;
  end;
  PIndivisualInfo64 = ^TMyIndivisualInfo64;
}

  //
  HARC = HGLOBAL;

  //ONX
  DLLAddressErr = class(Exception);

  //UnLHA
  PFNUnLha = ^TFNUnLha;
  TFNUnLha = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNUnLhaOpenArchive = ^TFNUnLhaOpenArchive;
  TFNUnLhaOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNUnLhaCloseArchive = ^TFNUnLhaCloseArchive;
  TFNUnLhaCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNUnLhaFindFirst = ^TFNUnLhaFindFirst;
  TFNUnLhaFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNUnLhaFindNext = ^TFNUnLhaFindNext;
  TFNUnLhaFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNUnLhaCheckArchive = ^TFNUnLhaCheckArchive;
  TFNUnLhaCheckArchive = function(_szFileName: LPCSTR; const _dwMode: DWORD): Boolean; stdcall;

  //UnZIP
  PFNUnZip = ^TFNUnZip;
  TFNUnZip = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNUnZipOpenArchive = ^TFNUnZipOpenArchive;
  TFNUnZipOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNUnZipCloseArchive = ^TFNUnZipCloseArchive;
  TFNUnZipCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNUnZipFindFirst = ^TFNUnZipFindFirst;
  TFNUnZipFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNUnZipFindNext = ^TFNUnZipFindNext;
  TFNUnZipFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;


  //Zip
  PFNZipZip = ^TFNZipZip;
  TFNZipZip = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  //LMZIPZip
  PFNLMZipZip = ^TFNLMZipZip;
  TFNLMZipZip = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  //LMZIP
  PFNLMZip = ^TFNLMZip;
  TFNLMZip = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNLMZipOpenArchive = ^TFNLMZipOpenArchive;
  TFNLMZipOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNLMZipCloseArchive = ^TFNLMZipCloseArchive;
  TFNLMZipCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNLMZipFindFirst = ^TFNLMZipFindFirst;
  TFNLMZipFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNLMZipFindNext = ^TFNLMZipFindNext;
  TFNLMZipFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  //Cab
  PFNUnCab = ^TFNUnCab;
  TFNUnCab = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNUnCabOpenArchive = ^TFNUnCabOpenArchive;
  TFNUnCabOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNUnCabCloseArchive = ^TFNUnCabCloseArchive;
  TFNUnCabCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNUnCabFindFirst = ^TFNUnCabFindFirst;
  TFNUnCabFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNUnCabFindNext = ^TFNUnCabFindNext;
  TFNUnCabFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;


  //SevenZIP
  PFNSevenZip = ^TFNSevenZip;
  TFNSevenZip = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNSevenZipOpenArchive = ^TFNSevenZipOpenArchive;
  TFNSevenZipOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNSevenZipCloseArchive = ^TFNSevenZipCloseArchive;
  TFNSevenZipCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNSevenZipFindFirst = ^TFNSevenZipFindFirst;
  TFNSevenZipFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNSevenZipFindNext = ^TFNSevenZipFindNext;
  TFNSevenZipFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;


  //rar
  PFNUnRar = ^TFNUnRar;
  TFNUnRar = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNUnRarOpenArchive = ^TFNUnRarOpenArchive;
  TFNUnRarOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNUnRarCloseArchive = ^TFNUnRarCloseArchive;
  TFNUnRarCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNUnRarFindFirst = ^TFNUnRarFindFirst;
  TFNUnRarFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNUnRarFindNext = ^TFNUnRarFindNext;
  TFNUnRarFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNUnRarCheckArchive = ^TFNUnRarCheckArchive;
  TFNUnRarCheckArchive = function(_szFileName: LPCSTR; const _dwMode: DWORD): Boolean; stdcall;

  //tar
  PFNUnTar = ^TFNUnTar;
  TFNUnTar = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNUnTarOpenArchive = ^TFNUnTarOpenArchive;
  TFNUnTarOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNUnTarCloseArchive = ^TFNUnTarCloseArchive;
  TFNUnTarCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNUnTarFindFirst = ^TFNUnTarFindFirst;
  TFNUnTarFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNUnTarFindNext = ^TFNUnTarFindNext;
  TFNUnTarFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;


  //ISO
  PFNUnIso = ^TFNUnIso;
  TFNUnIso = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNUnIsoOpenArchive = ^TFNUnIsoOpenArchive;
  TFNUnIsoOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNUnIsoCloseArchive = ^TFNUnIsoCloseArchive;
  TFNUnIsoCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNUnIsoFindFirst = ^TFNUnIsoFindFirst;
  TFNUnIsoFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNUnIsoFindNext = ^TFNUnIsoFindNext;
  TFNUnIsoFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;


  //BGA
  PFNBga = ^TFNBga;
  TFNBga = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNBgaOpenArchive = ^TFNBgaOpenArchive;
  TFNBgaOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNBgaCloseArchive = ^TFNBgaCloseArchive;
  TFNBgaCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNBgaFindFirst = ^TFNBgaFindFirst;
  TFNBgaFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNBgaFindNext = ^TFNBgaFindNext;
  TFNBgaFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;


  //GCA
  PFNUnGca = ^TFNUnGca;
  TFNUnGca = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNUnGcaOpenArchive = ^TFNUnGcaOpenArchive;
  TFNUnGcaOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNUnGcaCloseArchive = ^TFNUnGcaCloseArchive;
  TFNUnGcaCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNUnGcaFindFirst = ^TFNUnGcaFindFirst;
  TFNUnGcaFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNUnGcaFindNext = ^TFNUnGcaFindNext;
  TFNUnGcaFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;


  //Arj
  PFNUnArj = ^TFNUnArj;
  TFNUnArj = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNUnArjOpenArchive = ^TFNUnArjOpenArchive;
  TFNUnArjOpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNUnArjCloseArchive = ^TFNUnArjCloseArchive;
  TFNUnArjCloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNUnArjFindFirst = ^TFNUnArjFindFirst;
  TFNUnArjFindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNUnArjFindNext = ^TFNUnArjFindNext;
  TFNUnArjFindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;


  //Yz1
  PFNYz1 = ^TFNYz1;
  TFNYz1 = function(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer; stdcall;

  PFNYz1OpenArchive = ^TFNYz1OpenArchive;
  TFNYz1OpenArchive = function(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC; stdcall;

  PFNYz1CloseArchive = ^TFNYz1CloseArchive;
  TFNYz1CloseArchive = function(_harc: HARC): Integer; stdcall;

  PFNYz1FindFirst = ^TFNYz1FindFirst;
  TFNYz1FindFirst = function(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;

  PFNYz1FindNext = ^TFNYz1FindNext;
  TFNYz1FindNext = function(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer; stdcall;


  procedure SetDllFolder(DllFolder: String);
  procedure SetExe64bits(Exe64bits: Boolean);


  //UnLha
  procedure InitLha();
  procedure DesrtroyLha();
  function  UnlhaOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  UnlhaCloseArchive(_harc: HARC): Integer;
  function  UnlhaFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnlhaFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  Unlha(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
  function  UnlhaCheckArchive(_szFileName: LPCSTR; const _dwMode: DWORD): Boolean; stdcall;


  //UnZip
  procedure InitZip();
  procedure DesrtroyZip();
  function  UnZipOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  UnZipCloseArchive(_harc: HARC): Integer;
  function  UnZipFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnZipFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnZip(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;


  //Zip
  procedure InitZipZip();
  procedure DesrtroyZipZip();
  function  ZipZip(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;

  //LMZip
  procedure InitLMZip();
  procedure DesrtroyLMZip();
  function  LMZipOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  LMZipCloseArchive(_harc: HARC): Integer;
  function  LMZipFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  LMZipFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  LMZip(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
  function  LMZipZip(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;

  //UnCab
  procedure InitCab();
  procedure DesrtroyCab();
  function  UnCabOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  UnCabCloseArchive(_harc: HARC): Integer;
  function  UnCabFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnCabFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnCab(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;


  //SevenZip
  procedure InitSevenZip();
  procedure DesrtroySevenZip();
  function  SevenZipOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  SevenZipCloseArchive(_harc: HARC): Integer;
  function  SevenZipFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  SevenZipFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  SevenZip(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;


  //UnRar
  procedure InitRar();
  procedure DesrtroyRar();
  function  UnRarOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  UnRarCloseArchive(_harc: HARC): Integer;
  function  UnRarFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnRarFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnRar(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
  function  UnRarCheckArchive(_szFileName: LPCSTR; const _dwMode: DWORD): Boolean;


  //UnTar
  procedure InitTar();
  procedure DesrtroyTar();
  function  UnTarOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  UnTarCloseArchive(_harc: HARC): Integer;
  function  UnTarFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnTarFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnTar(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;


  //unIso
  procedure InitUnIso();
  procedure DesrtroyUnIso();
  function  UnIsoOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  UnIsoCloseArchive(_harc: HARC): Integer;
  function  UnIsoFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnIsoFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnIso(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;


  //UnBga
  procedure InitBga();
  procedure DesrtroyBga();
  function  BgaOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  BgaCloseArchive(_harc: HARC): Integer;
  function  BgaFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  BgaFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  Bga(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;


  //UnGca
  procedure InitUnGca();
  procedure DesrtroyUnGca();
  function  UnGcaOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  UnGcaCloseArchive(_harc: HARC): Integer;
  function  UnGcaFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnGcaFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnGca(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;


  //UnArj
  procedure InitUnArj();
  procedure DesrtroyUnArj();
  function  UnArjOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  UnArjCloseArchive(_harc: HARC): Integer;
  function  UnArjFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnArjFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  UnArj(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;


  //Yz1
  procedure InitYz1();
  procedure DesrtroyYz1();
  function  Yz1OpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
  function  Yz1CloseArchive(_harc: HARC): Integer;
  function  Yz1FindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  Yz1FindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
  function  Yz1(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;



var
  //DLL
  UNLHADLL:    String = 'UNLHA32.DLL';
  UNZIPDLL:    String = 'UNZIP32.DLL';
  LMZIPDLL:    String = 'LMZIP32.dll';
  UNCABDLL:    String = 'cab32.dll';
  SEVENZIPDLL: String = '7-zip32.dll';
  UNRARDLL:    String = 'unrar32.dll';
  UNTARDLL:    String = 'tar32.dll';
  ZIPZIPDLL:   String = 'ZIP32J.DLL';
  UNISODLL:    String = 'UnIso32.dll';
  BGADLL:      String = 'Bga32.dll';
  UNGCADLL:    String = 'UnGca32.dll';
  UNARJDLL:    String = 'UNARJ32J.DLL';
  YZ1DLL:      String = 'Yz1.dll';

  DllFolderPath: String = '';
  Exe64bitsBool: Boolean = FALSE;


  //UnLha
  UNLHAModule:      HModule              = 0;
  Lha:              TFNUnLha             = nil;
  LhaOpenArchive:   TFNUnLhaOpenArchive  = nil;
  LhaCloseArchive:  TFNUnLhaCloseArchive = nil;
  LhaFindFirst:     TFNUnLhaFindFirst    = nil;
  LhaFindNext:      TFNUnLhaFindNext     = nil;
  LhaCheckArchive:  TFNUnLhaCheckArchive = nil;


  //UnZip
  UNZIPModule:      HModule              = 0;
  Zip1:             TFNUnZip             = nil;
  Zip1OpenArchive:  TFNUnZipOpenArchive  = nil;
  Zip1CloseArchive: TFNUnZipCloseArchive = nil;
  Zip1FindFirst:    TFNUnZipFindFirst    = nil;
  Zip1FindNext:     TFNUnZipFindNext     = nil;


  //ZipZip
  ZIPZIPModule:     HModule              = 0;
  Zip1A:            TFNZipZip            = nil;

  //LMZIP
  LMZIPModule:      HModule              = 0;
  Zip2:             TFNLMZip             = nil;
  Zip2OpenArchive:  TFNLMZipOpenArchive  = nil;
  Zip2CloseArchive: TFNLMZipCloseArchive = nil;
  Zip2FindFirst:    TFNLMZipFindFirst    = nil;
  Zip2FindNext:     TFNLMZipFindNext     = nil;
  Zip2A:            TFNLMZipZip          = nil;

  //UnCab
  UNCABModule:      HModule              = 0;
  Cab:              TFNUnCab             = nil;
  CabOpenArchive:   TFNUnCabOpenArchive  = nil;
  CabCloseArchive:  TFNUnCabCloseArchive = nil;
  CabFindFirst:     TFNUnCabFindFirst    = nil;
  CabFindNext:      TFNUnCabFindNext     = nil;


  //SevenZip
  SEVENZIPModule:   HModule                 = 0;
  Zip3:             TFNSevenZip             = nil;
  Zip3OpenArchive:  TFNSevenZipOpenArchive  = nil;
  Zip3CloseArchive: TFNSevenZipCloseArchive = nil;
  Zip3FindFirst:    TFNSevenZipFindFirst    = nil;
  Zip3FindNext:     TFNSevenZipFindNext     = nil;


  //UnRar
  UNRARModule:      HModule              = 0;
  Rar:              TFNUnRar             = nil;
  RarOpenArchive:   TFNUnRarOpenArchive  = nil;
  RarCloseArchive:  TFNUnRarCloseArchive = nil;
  RarFindFirst:     TFNUnRarFindFirst    = nil;
  RarFindNext:      TFNUnRarFindNext     = nil;
  RarCheckArchive:  TFNUnRarCheckArchive = nil;


  //UnTar
  UNTARModule:      HModule              = 0;
  Tar:              TFNUnTar             = nil;
  TarOpenArchive:   TFNUnTarOpenArchive  = nil;
  TarCloseArchive:  TFNUnTarCloseArchive = nil;
  TarFindFirst:     TFNUnTarFindFirst    = nil;
  TarFindNext:      TFNUnTarFindNext     = nil;


  //UnISO
  UNISOModule:   HModule                   = 0;
  UnIso1:             TFNUnIso             = nil;
  UnIso1OpenArchive:  TFNUnIsoOpenArchive  = nil;
  UnIso1CloseArchive: TFNUnIsoCloseArchive = nil;
  UnIso1FindFirst:    TFNUnIsoFindFirst    = nil;
  UnIso1FindNext:     TFNUnIsoFindNext     = nil;


  //Bga
  BgaModule:      HModule               = 0;
  Bga1:              TFNBga             = nil;
  Bga1OpenArchive:   TFNBgaOpenArchive  = nil;
  Bga1CloseArchive:  TFNBgaCloseArchive = nil;
  Bga1FindFirst:     TFNBgaFindFirst    = nil;
  Bga1FindNext:      TFNBgaFindNext     = nil;


  //UnGca
  UNGcaModule:   HModule                   = 0;
  UnGca1:             TFNUnGca             = nil;
  UnGca1OpenArchive:  TFNUnGcaOpenArchive  = nil;
  UnGca1CloseArchive: TFNUnGcaCloseArchive = nil;
  UnGca1FindFirst:    TFNUnGcaFindFirst    = nil;
  UnGca1FindNext:     TFNUnGcaFindNext     = nil;


  //UnArj
  UNArjModule:   HModule                   = 0;
  UnArj1:             TFNUnArj             = nil;
  UnArj1OpenArchive:  TFNUnArjOpenArchive  = nil;
  UnArj1CloseArchive: TFNUnArjCloseArchive = nil;
  UnArj1FindFirst:    TFNUnArjFindFirst    = nil;
  UnArj1FindNext:     TFNUnArjFindNext     = nil;


  //Yz1
  Yz1Module:      HModule               = 0;
  Yz11:              TFNYz1             = nil;
  Yz11OpenArchive:   TFNYz1OpenArchive  = nil;
  Yz11CloseArchive:  TFNYz1CloseArchive = nil;
  Yz11FindFirst:     TFNYz1FindFirst    = nil;
  Yz11FindNext:      TFNYz1FindNext     = nil;




implementation

procedure SetDllFolder(DllFolder: String);
begin
  DllFolderPath := DllFolder;
end;

procedure SetExe64bits(Exe64bits: Boolean);
begin
  Exe64bitsBool := Exe64bits;
end;

//UnLha
procedure InitLha();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    UNLHADLL := 'UNBYPASS.DLL';
  end
  //32bits
  else
  begin
    UNLHADLL := 'UNLHA32.DLL';
  end;

  //DLLĂяo
  if UNLHAModule = 0 then
  begin
//    UNLHAModule := LoadLibrary(PAnsiChar(UNLHADLL));
//    UNLHAModule := LoadLibrary(PWideChar(UNLHADLL));
    if DllFolderPath = '' then
    begin
      UNLHAModule := LoadLibraryEx(PWideChar(UNLHADLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      UNLHAModule := LoadLibrary(PWideChar(DllFolderPath + UNLHADLL));
    end;
  end;
end;

procedure DesrtroyLha();
begin
  //DLL
  if UNLHAModule <> 0 then
  begin
    FreeLibrary(UNLHAModule);
  end;
end;

function UnLhaOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  //DLL̏
  InitLha();
  //API̖ÕAhX擾
  if @LhaOpenArchive = nil then
  begin
    @LhaOpenArchive := GetProcAddress(UNLHAModule, 'UnlhaOpenArchive');
  end;
  //APIs
  if @LhaOpenArchive <> nil then
  begin
    Result := LhaOpenArchive(_hwnd, _szFileName, _dwMode);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnlhaOpenArchive']));
  end;
end;

function UnLhaCloseArchive(_harc: HARC): Integer;
begin
  //DLL̏
  InitLha();
  if @LhaCloseArchive = nil then
  //API̖ÕAhX擾
  begin
    @LhaCloseArchive := GetProcAddress(UNLHAModule, 'UnlhaCloseArchive');
  end;
  //APIs
  if @LhaCloseArchive <> nil then
  begin
    Result := LhaCloseArchive(_harc);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnlhaCloseArchive']));
  end;
end;

function UnLhaFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  //DLL̏
  InitLha();
  //API̖ÕAhX擾
  if @LhaFindFirst = nil then
  begin
    @LhaFindFirst := GetProcAddress(UNLHAModule, 'UnlhaFindFirst');
  end;
  //APIs
  if @LhaFindFirst <> nil then
  begin
    Result := LhaFindFirst(_harc, _szWildName, _lpSubInfo);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnlhaFindFirst']));
  end;
end;

function UnLhaFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  //DLL̏
  InitLha();
  //API̖ÕAhX擾
  if @LhaFindNext = nil then
  begin
    @LhaFindNext := GetProcAddress(UNLHAModule, 'UnlhaFindNext');
  end;
  //APIs
  if @LhaFindNext <> nil then
  begin
    Result := LhaFindNext(_harc, _lpSubInfo);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnlhaFindNext']));
  end;
end;

function UnLha(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  //DLL̏
  InitLha();
  //API̖ÕAhX擾
  if @Lha = nil then
  begin
    @Lha := GetProcAddress(UNLHAModule, 'Unlha');
  end;
  //APIs
  if @Lha <> nil then
  begin
    Result := Lha(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Unlha']));
  end;
  //j
//  DesrtroyLha();
end;


function UnLhaCheckArchive(_szFileName: LPCSTR; const _dwMode: DWORD): Boolean;
begin
  //DLL̏
  InitLha();
  //API̖ÕAhX擾
  if @LhaCheckArchive = nil then
  begin
    @LhaCheckArchive := GetProcAddress(UNLHAModule, 'UnlhaCheckArchive');
  end;
  //APIs
  if @LhaCheckArchive <> nil then
  begin
    Result := LhaCheckArchive(_szFileName, _dwMode);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnlhaCheckArchive']));
  end;
end;

//UnZip
procedure InitZip();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    UNZIPDLL := 'UNBYPASS.DLL';
  end
  //32bits
  else
  begin
    UNZIPDLL := 'UNZIP32.DLL';
  end;

  //DLLĂяo
  if UNZIPModule = 0 then
  begin
//    UNZIPModule := LoadLibrary(PAnsiChar(UNZIPDLL));
//    UNZIPModule := LoadLibrary(PWideChar(UNZIPDLL));
    if DllFolderPath = '' then
    begin
      UNZIPModule := LoadLibraryEx(PWideChar(UNZIPDLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      UNZIPModule := LoadLibrary(PWideChar(DllFolderPath + UNZIPDLL));
    end;
  end;
end;

procedure DesrtroyZip();
begin
  if UNZIPModule <> 0 then
  begin
    FreeLibrary(UNZIPModule);
  end;
end;

function UnZipOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitZip();
  if @Zip1OpenArchive = nil then
  begin
    @Zip1OpenArchive := GetProcAddress(UNZIPModule, 'UnZipOpenArchive');
  end;
  if @Zip1OpenArchive <> nil then
  begin
    Result := Zip1OpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnZipOpenArchive']));
  end;
end;

function UnZipCloseArchive(_harc: HARC): Integer;
begin
  InitZip();
  if @Zip1CloseArchive = nil then
  begin
    @Zip1CloseArchive := GetProcAddress(UNZIPModule, 'UnZipCloseArchive');
  end;
  if @Zip1CloseArchive <> nil then
  begin
    Result := Zip1CloseArchive(_harc);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnZipCloseArchive']));
  end;
end;

function UnZipFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitZip();
  if @Zip1FindFirst = nil then
  begin
    @Zip1FindFirst := GetProcAddress(UNZIPModule, 'UnZipFindFirst');
  end;
  if @Zip1FindFirst <> nil then
  begin
    Result := Zip1FindFirst(_harc, _szWildName, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnZipFindFirst']));
  end;
end;

function UnZipFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitZip();
  if @Zip1FindNext = nil then
  begin
    @Zip1FindNext := GetProcAddress(UNZIPModule, 'UnZipFindNext');
  end;
  if @Zip1FindNext <> nil then
  begin
    Result := Zip1FindNext(_harc, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnZipFindNext']));
  end;
end;

function UnZip(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitZip();
  if @Zip1 = nil then
  begin
    @Zip1 := GetProcAddress(UNZIPModule, 'UnZip');
  end;
  if @Zip1 <> nil then
  begin
    Result := Zip1(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnZip']));
  end;
//  DesrtroyZip();
end;

//ZipZip
procedure InitZipZip();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    ZIPZIPDLL := 'UNBYPASS.DLL';
  end
  //32bits
  else
  begin
    ZIPZIPDLL := 'ZIP32J.DLL';
  end;

  //DLLĂяo
  if ZIPZIPModule = 0 then
  begin
//    ZIPZIPModule := LoadLibrary(PWideChar(ZIPZIPDLL));
    if DllFolderPath = '' then
    begin
      ZIPZIPModule := LoadLibraryEx(PWideChar(ZIPZIPDLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      ZIPZIPModule := LoadLibrary(PWideChar(DllFolderPath + ZIPZIPDLL));
    end;
  end;
end;

procedure DesrtroyZipZip();
begin
  if ZIPZIPModule <> 0 then
  begin
    FreeLibrary(ZIPZIPModule);
  end;
end;

function ZipZip(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitZipZip();
  if @Zip1A = nil then
  begin
    @Zip1A := GetProcAddress(ZIPZIPModule, 'Zip');
  end;
  if @Zip1A <> nil then
  begin
    Result := Zip1A(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Zip']));
  end;
//  DesrtroyZip();
end;

//LMZIP32
procedure InitLMZip();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    LMZIPDLL := 'LMZIP64.dll';
  end
  //32bits
  else
  begin
    LMZIPDLL := 'LMZIP32.dll';
  end;

  //DLLĂяo
  if LMZIPModule = 0 then
  begin
//    LMZIPModule := LoadLibrary(PAnsiChar(LMZIPDLL));
//    LMZIPModule := LoadLibrary(PWideChar(LMZIPDLL));
    if DllFolderPath = '' then
    begin
      LMZIPModule := LoadLibraryEx(PWideChar(LMZIPDLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      LMZIPModule := LoadLibrary(PWideChar(DllFolderPath + LMZIPDLL));
    end;
  end;
end;

procedure DesrtroyLMZip();
begin
  if LMZIPModule <> 0 then
  begin
    FreeLibrary(LMZIPModule);
  end;
end;

function LMZipOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitLMZip();
  if @Zip2OpenArchive = nil then
  begin
    @Zip2OpenArchive := GetProcAddress(LMZIPModule, 'UnzipOpenArchive');
  end;
  if @Zip2OpenArchive <> nil then
  begin
    Result := Zip2OpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['LMZipOpenArchive']));
  end;
end;

function LMZipCloseArchive(_harc: HARC): Integer;
begin
  InitLMZip();
  if @Zip2CloseArchive = nil then
  begin
    @Zip2CloseArchive := GetProcAddress(LMZIPModule, 'UnzipCloseArchive');
  end;
  if @Zip2CloseArchive <> nil then
  begin
    Result := Zip2CloseArchive(_harc);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['LMZipCloseArchive']));
  end;
end;

function LMZipFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitLMZip();
  if @Zip2FindFirst = nil then
  begin
    @Zip2FindFirst := GetProcAddress(LMZIPModule, 'UnzipFindFirst');
  end;
  if @Zip2FindFirst <> nil then
  begin
    Result := Zip2FindFirst(_harc, _szWildName, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['LMZipFindFirst']));
  end;
end;

function LMZipFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitLMZip();
  if @Zip2FindNext = nil then
  begin
    @Zip2FindNext := GetProcAddress(LMZIPModule, 'UnzipFindNext');
  end;
  if @Zip2FindNext <> nil then
  begin
    Result := Zip2FindNext(_harc, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['LMZipFindNext']));
  end;
end;

function LMZip(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitLMZip();
  if @Zip2 = nil then
  begin
    @Zip2 := GetProcAddress(LMZIPModule, 'Unzip');
  end;
  if @Zip2 <> nil then
  begin
    Result := Zip2(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['LMZip']));
  end;
//  DesrtroyLMZip();
end;

function LMZipZip(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitLMZip();
  if @Zip2A = nil then
  begin
    @Zip2A := GetProcAddress(LMZIPModule, 'Zip');
  end;
  if @Zip2A <> nil then
  begin
    Result := Zip2A(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['LMZip']));
  end;
//  DesrtroyLMZip();
end;

//Cab
procedure InitCab();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    UNCABDLL := 'UNBYPASS.DLL';
  end
  //32bits
  else
  begin
    UNCABDLL := 'cab32.dll';
  end;

  //DLLĂяo
  if UNCABModule = 0 then
  begin
//    UNCABModule := LoadLibrary(PAnsiChar(UNCABDLL));
//    UNCABModule := LoadLibrary(PWideChar(UNCABDLL));
    if DllFolderPath = '' then
    begin
      UNCABModule := LoadLibraryEx(PWideChar(UNCABDLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      UNCABModule := LoadLibrary(PWideChar(DllFolderPath + UNCABDLL));
    end;
  end;
end;

procedure DesrtroyCab();
begin
  if UNCABModule <> 0 then
  begin
    FreeLibrary(UNCABModule);
  end;
end;

function  UnCabOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitCab();
  if @CabOpenArchive = nil then
  begin
    @CabOpenArchive := GetProcAddress(UNCABModule, 'CabOpenArchive');
  end;
  if @CabOpenArchive <> nil then
  begin
    Result := CabOpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['CabOpenArchive']));
  end;
end;

function  UnCabCloseArchive(_harc: HARC): Integer;
begin
  InitCab();
  if @CabCloseArchive = nil then
  begin
    @CabCloseArchive := GetProcAddress(UNCABModule, 'CabCloseArchive');
  end;
  if @CabCloseArchive <> nil then
  begin
    Result := CabCloseArchive(_harc);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['CabCloseArchive']));
  end;
end;

function  UnCabFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitCab();
  if @CabFindFirst = nil then
  begin
    @CabFindFirst := GetProcAddress(UNCABModule, 'CabFindFirst');
  end;
  if @CabFindFirst <> nil then
  begin
    Result := CabFindFirst(_harc, _szWildName, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['CabFindFirst']));
  end;
end;

function  UnCabFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitCab();
  if @CabFindNext = nil then
  begin
    @CabFindNext := GetProcAddress(UNCABModule, 'CabFindNext');
  end;
  if @CabFindNext <> nil then
  begin
    Result := CabFindNext(_harc, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['CabFindNext']));
  end;
end;

function  UnCab(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitCab();
  if @Cab = nil then
  begin
    @Cab := GetProcAddress(UNCABModule, 'Cab');
  end;
  if @Cab <> nil then
  begin
    Result := Cab(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Cab']));
  end;
//  DesrtroyCab();
end;

//SevenZip
procedure InitSevenZip();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    SEVENZIPDLL := '7-zip64.dll';
  end
  //32bits
  else
  begin
    SEVENZIPDLL := '7-zip32.dll';
  end;

  //DLLĂяo
  if SEVENZIPModule = 0 then
  begin
//    SEVENZIPModule := LoadLibrary(PWideChar(SEVENZIPDLL));
    if DllFolderPath = '' then
    begin
      SEVENZIPModule := LoadLibraryEx(PWideChar(SEVENZIPDLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      SEVENZIPModule := LoadLibrary(PWideChar(DllFolderPath + SEVENZIPDLL));
    end;
  end;
end;

procedure DesrtroySevenZip();
begin
  if SEVENZIPModule <> 0 then
  begin
    FreeLibrary(SEVENZIPModule);
  end;
end;

function SevenZipOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitSevenZip();
  if @Zip3OpenArchive = nil then
  begin
    @Zip3OpenArchive := GetProcAddress(SEVENZIPModule, 'SevenZipOpenArchive');
  end;
  if @Zip3OpenArchive <> nil then
  begin
    Result := Zip3OpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['SevenZipOpenArchive']));
  end;
end;

function SevenZipCloseArchive(_harc: HARC): Integer;
begin
  InitSevenZip();
  if @Zip3CloseArchive = nil then
  begin
    @Zip3CloseArchive := GetProcAddress(SEVENZIPModule, 'SevenZipCloseArchive');
  end;
  if @Zip3CloseArchive <> nil then
  begin
    Result := Zip3CloseArchive(_harc);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['SevenZipCloseArchive']));
  end;
end;

function SevenZipFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitSevenZip();
  if @Zip3FindFirst = nil then
  begin
    @Zip3FindFirst := GetProcAddress(SEVENZIPModule, 'SevenZipFindFirst');
  end;
  if @Zip3FindFirst <> nil then
  begin
    Result := Zip3FindFirst(_harc, _szWildName, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['SevenZipFindFirst']));
  end;
end;

function SevenZipFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitSevenZip();
  if @Zip3FindNext = nil then
  begin
    @Zip3FindNext := GetProcAddress(SEVENZIPModule, 'SevenZipFindNext');
  end;
  if @Zip3FindNext <> nil then
  begin
    Result := Zip3FindNext(_harc, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['SevenZipFindNext']));
  end;
end;

function SevenZip(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitSevenZip();
  if @Zip3 = nil then
  begin
    @Zip3 := GetProcAddress(SEVENZIPModule, 'SevenZip');
  end;
  if @Zip3 <> nil then
  begin
    Result := Zip3(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['SevenZip']));
  end;
//  DesrtroySevenZip();
end;

//rar
procedure InitRar();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    UNRARDLL := 'UNBYPASS.DLL';
  end
  //32bits
  else
  begin
    UNRARDLL := 'unrar32.dll';
  end;

  //DLLĂяo
  if UNRARModule = 0 then
  begin
//    UNRARModule := LoadLibrary(PWideChar(UNRARDLL));
    if DllFolderPath = '' then
    begin
      UNRARModule := LoadLibraryEx(PWideChar(UNRARDLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      UNRARModule := LoadLibrary(PWideChar(DllFolderPath + UNRARDLL));
    end;
  end;
end;

procedure DesrtroyRar();
begin
  if UNRARModule <> 0 then
  begin
    FreeLibrary(UNRARModule);
  end;
end;

function  UnRarOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitRar();
  if @RarOpenArchive = nil then
  begin
    @RarOpenArchive := GetProcAddress(UNRARModule, 'UnrarOpenArchive');
  end;
  if @RarOpenArchive <> nil then
  begin
    Result := RarOpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnrarOpenArchive']));
  end;
end;

function  UnRarCloseArchive(_harc: HARC): Integer;
begin
  InitRar();
  if @RarCloseArchive = nil then
  begin
    @RarCloseArchive := GetProcAddress(UNRARModule, 'UnrarCloseArchive');
  end;
  if @RarCloseArchive <> nil then
  begin
    Result := RarCloseArchive(_harc);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnrarCloseArchive']));
  end;
end;

function  UnRarFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitRar();
  if @RarFindFirst = nil then
  begin
    @RarFindFirst := GetProcAddress(UNRARModule, 'UnrarFindFirst');
  end;
  if @RarFindFirst <> nil then
  begin
    Result := RarFindFirst(_harc, _szWildName, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnrarFindFirst']));
  end;
end;

function  UnRarFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitRar();
  if @RarFindNext = nil then
  begin
    @RarFindNext := GetProcAddress(UNRARModule, 'UnrarFindNext');
  end;
  if @RarFindNext <> nil then
  begin
    Result := RarFindNext(_harc, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnrarFindNext']));
  end;
end;

function  UnRar(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitRar();
  if @Rar = nil then
  begin
    @Rar := GetProcAddress(UNRARModule, 'Unrar');
  end;
  if @Rar <> nil then
  begin
    Result := Rar(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Unrar']));
  end;
//  DesrtroyRar();
end;

function  UnRarCheckArchive(_szFileName: LPCSTR; const _dwMode: DWORD): Boolean;
begin
  InitRar();
  if @RarCheckArchive = nil then
  begin
    @RarCheckArchive := GetProcAddress(UNRARModule, 'UnrarCheckArchive');
  end;
  if @RarCheckArchive <> nil then
  begin
    Result := UnRarCheckArchive(_szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnRarCheckArchive']));
  end;
//  DesrtroyRar();
end;

//tar
procedure InitTar();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    UNTARDLL := 'UNBYPASS.DLL';
  end
  //32bits
  else
  begin
    UNTARDLL := 'tar32.dll';
  end;

  //DLLĂяo
  if UNTARModule = 0 then
  begin
//    UNTARModule := LoadLibrary(PWideChar(UNTARDLL));
    if DllFolderPath = '' then
    begin
      UNTARModule := LoadLibraryEx(PWideChar(UNTARDLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      UNTARModule := LoadLibrary(PWideChar(DllFolderPath + UNTARDLL));
    end;
  end;
end;

procedure DesrtroyTar();
begin
  if UNTARModule <> 0 then
  begin
    FreeLibrary(UNTARModule);
  end;
end;

function  UnTarOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitTar();
  if @TarOpenArchive = nil then
  begin
    @TarOpenArchive := GetProcAddress(UNTARModule, 'TarOpenArchive');
  end;
  if @TarOpenArchive <> nil then
  begin
    Result := TarOpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['TarOpenArchive']));
  end;
end;

function  UnTarCloseArchive(_harc: HARC): Integer;
begin
  InitTar();
  if @TarCloseArchive = nil then
  begin
    @TarCloseArchive := GetProcAddress(UNTARModule, 'TarCloseArchive');
  end;
  if @TarCloseArchive <> nil then
  begin
    Result := TarCloseArchive(_harc);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['TarCloseArchive']));
  end;
end;

function  UnTarFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitTar();
  if @TarFindFirst = nil then
  begin
    @TarFindFirst := GetProcAddress(UNTARModule, 'TarFindFirst');
  end;
  if @TarFindFirst <> nil then
  begin
    Result := TarFindFirst(_harc, _szWildName, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['TarFindFirst']));
  end;
end;

function  UnTarFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitTar();
  if @TarFindNext = nil then
  begin
    @TarFindNext := GetProcAddress(UNTARModule, 'TarFindNext');
  end;
  if @TarFindNext <> nil then
  begin
    Result := TarFindNext(_harc, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['TarFindNext']));
  end;
end;

function  UnTar(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitTar();
  if @Tar = nil then
  begin
    @Tar := GetProcAddress(UNTARModule, 'Tar');
  end;
  if @Tar <> nil then
  begin
    Result := Tar(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Tar']));
  end;
//  DesrtroyTar();
end;

//ISO
procedure InitUnIso();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    UNISODLL := '';
  end
  //32bits
  else
  begin
    UNISODLL := 'UnIso32.dll';
  end;

  //DLLĂяo
  if UNISOModule = 0 then
  begin
//    UNISOModule := LoadLibrary(PWideChar(SEVENZIPDLL));
    if DllFolderPath = '' then
    begin
      UNISOModule := LoadLibraryEx(PWideChar(UNISODLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      UNISOModule := LoadLibrary(PWideChar(DllFolderPath + UNISODLL));
    end;
  end;
end;

procedure DesrtroyUnIso();
begin
  if UNISOModule <> 0 then
  begin
    FreeLibrary(UNISOModule);
  end;
end;

function UnIsoOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitUnIso();
  if @UnIso1OpenArchive = nil then
  begin
    @UnIso1OpenArchive := GetProcAddress(UNISOModule, 'UnIsoOpenArchive');
  end;
  if @UnIso1OpenArchive <> nil then
  begin
    Result := UnIso1OpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnIsoOpenArchive']));
  end;
end;

function UnIsoCloseArchive(_harc: HARC): Integer;
begin
  InitUnIso();
  if @UnIso1CloseArchive = nil then
  begin
    @UnIso1CloseArchive := GetProcAddress(UNISOModule, 'UnIsoCloseArchive');
  end;
  if @UnIso1CloseArchive <> nil then
  begin
    Result := UnIso1CloseArchive(_harc);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnIsoCloseArchive']));
  end;
end;

function UnIsoFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitUnIso();
  if @UnIso1FindFirst = nil then
  begin
    @UnIso1FindFirst := GetProcAddress(UNISOModule, 'UnIsoFindFirst');
  end;
  if @UnIso1FindFirst <> nil then
  begin
    Result := UnIso1FindFirst(_harc, _szWildName, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnIsoFindFirst']));
  end;
end;

function UnIsoFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitUnIso();
  if @UnIso1FindNext = nil then
  begin
    @UnIso1FindNext := GetProcAddress(UNISOModule, 'UnIsoFindNext');
  end;
  if @UnIso1FindNext <> nil then
  begin
    Result := UnIso1FindNext(_harc, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnIsoFindNext']));
  end;
end;

function UnIso(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitUnIso();
  if @UnIso1 = nil then
  begin
    @UnIso1 := GetProcAddress(UNISOModule, 'UnIso');
  end;
  if @UnIso1 <> nil then
  begin
    Result := UnIso1(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnIso']));
  end;
//  DesrtroyUnIso();
end;

//Bga
procedure InitBga();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    BgaDLL := '';
  end
  //32bits
  else
  begin
    BgaDLL := 'Bga32.dll';
  end;

  //DLLĂяo
  if BgaModule = 0 then
  begin
    if DllFolderPath = '' then
    begin
      BgaModule := LoadLibraryEx(PWideChar(BgaDLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      BgaModule := LoadLibrary(PWideChar(DllFolderPath + BgaDLL));
    end;
  end;
end;

procedure DesrtroyBga();
begin
  if BgaModule <> 0 then
  begin
    FreeLibrary(BgaModule);
  end;
end;

function BgaOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitBga();
  if @Bga1OpenArchive = nil then
  begin
    @Bga1OpenArchive := GetProcAddress(BgaModule, 'BgaOpenArchive');
  end;
  if @Bga1OpenArchive <> nil then
  begin
    Result := Bga1OpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['BgaOpenArchive']));
  end;
end;

function BgaCloseArchive(_harc: HARC): Integer;
begin
  //DLL̏
  InitBga();
  if @Bga1CloseArchive = nil then
  //API̖ÕAhX擾
  begin
    @Bga1CloseArchive := GetProcAddress(BgaModule, 'BgaCloseArchive');
  end;
  //APIs
  if @Bga1CloseArchive <> nil then
  begin
    Result := Bga1CloseArchive(_harc);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['BgaCloseArchive']));
  end;
end;

function BgaFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  //DLL̏
  InitBga();
  //API̖ÕAhX擾
  if @Bga1FindFirst = nil then
  begin
    @Bga1FindFirst := GetProcAddress(BgaModule, 'BgaFindFirst');
  end;
  //APIs
  if @Bga1FindFirst <> nil then
  begin
    Result := Bga1FindFirst(_harc, _szWildName, _lpSubInfo);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['BgaFindFirst']));
  end;
end;

function BgaFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  //DLL̏
  InitBga();
  //API̖ÕAhX擾
  if @Bga1FindNext = nil then
  begin
    @Bga1FindNext := GetProcAddress(BgaModule, 'BgaFindNext');
  end;
  //APIs
  if @Bga1FindNext <> nil then
  begin
    Result := Bga1FindNext(_harc, _lpSubInfo);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['BgaFindNext']));
  end;
end;

function Bga(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  //DLL̏
  InitBga();
  //API̖ÕAhX擾
  if @Bga1 = nil then
  begin
    @Bga1 := GetProcAddress(BgaModule, 'Bga');
  end;
  //APIs
  if @Bga1 <> nil then
  begin
    Result := Bga1(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Bga']));
  end;
  //j
//  DesrtroyBga();
end;

//UnGca
procedure InitUnGca();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    UNGcaDLL := '';
  end
  //32bits
  else
  begin
    UNGcaDLL := 'UnGca32.dll';
  end;

  //DLLĂяo
  if UNGcaModule = 0 then
  begin
    if DllFolderPath = '' then
    begin
      UNGcaModule := LoadLibraryEx(PWideChar(UNGcaDLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      UNGcaModule := LoadLibrary(PWideChar(DllFolderPath + UNGcaDLL));
    end;
  end;
end;

procedure DesrtroyUnGca();
begin
  if UNGcaModule <> 0 then
  begin
    FreeLibrary(UNGcaModule);
  end;
end;

function UnGcaOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitUnGca();
  if @UnGca1OpenArchive = nil then
  begin
    @UnGca1OpenArchive := GetProcAddress(UNGcaModule, 'UnGCAOpenArchive');
  end;
  if @UnGca1OpenArchive <> nil then
  begin
    Result := UnGca1OpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnGcaOpenArchive']));
  end;
end;

function UnGcaCloseArchive(_harc: HARC): Integer;
begin
  InitUnGca();
  if @UnGca1CloseArchive = nil then
  begin
    @UnGca1CloseArchive := GetProcAddress(UNGcaModule, 'UnGCACloseArchive');
  end;
  if @UnGca1CloseArchive <> nil then
  begin
    Result := UnGca1CloseArchive(_harc);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnGcaCloseArchive']));
  end;
end;

function UnGcaFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitUnGca();
  if @UnGca1FindFirst = nil then
  begin
    @UnGca1FindFirst := GetProcAddress(UNGcaModule, 'UnGCAFindFirst');
  end;
  if @UnGca1FindFirst <> nil then
  begin
    Result := UnGca1FindFirst(_harc, _szWildName, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnGcaFindFirst']));
  end;
end;

function UnGcaFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitUnGca();
  if @UnGca1FindNext = nil then
  begin
    @UnGca1FindNext := GetProcAddress(UNGcaModule, 'UnGCAFindNext');
  end;
  if @UnGca1FindNext <> nil then
  begin
    Result := UnGca1FindNext(_harc, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnGcaFindNext']));
  end;
end;

function UnGca(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitUnGca();
  if @UnGca1 = nil then
  begin
    @UnGca1 := GetProcAddress(UNGcaModule, 'UnGCA');
  end;
  if @UnGca1 <> nil then
  begin
    Result := UnGca1(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnGca']));
  end;
//  DesrtroyUnGca();
end;

//UnArj
procedure InitUnArj();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    UNArjDLL := '';
  end
  //32bits
  else
  begin
    UNArjDLL := 'UNARJ32J.DLL';
  end;

  //DLLĂяo
  if UNArjModule = 0 then
  begin
    if DllFolderPath = '' then
    begin
      UNArjModule := LoadLibraryEx(PWideChar(UNArjDLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      UNArjModule := LoadLibrary(PWideChar(DllFolderPath + UNArjDLL));
    end;
  end;
end;

procedure DesrtroyUnArj();
begin
  if UNArjModule <> 0 then
  begin
    FreeLibrary(UNArjModule);
  end;
end;

function UnArjOpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitUnArj();
  if @UnArj1OpenArchive = nil then
  begin
    @UnArj1OpenArchive := GetProcAddress(UNArjModule, 'UnarjOpenArchive');
  end;
  if @UnArj1OpenArchive <> nil then
  begin
    Result := UnArj1OpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnarjOpenArchive']));
  end;
end;

function UnArjCloseArchive(_harc: HARC): Integer;
begin
  InitUnArj();
  if @UnArj1CloseArchive = nil then
  begin
    @UnArj1CloseArchive := GetProcAddress(UNArjModule, 'UnarjCloseArchive');
  end;
  if @UnArj1CloseArchive <> nil then
  begin
    Result := UnArj1CloseArchive(_harc);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnarjCloseArchive']));
  end;
end;

function UnArjFindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitUnArj();
  if @UnArj1FindFirst = nil then
  begin
    @UnArj1FindFirst := GetProcAddress(UNArjModule, 'UnarjFindFirst');
  end;
  if @UnArj1FindFirst <> nil then
  begin
    Result := UnArj1FindFirst(_harc, _szWildName, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnarjFindFirst']));
  end;
end;

function UnArjFindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  InitUnArj();
  if @UnArj1FindNext = nil then
  begin
    @UnArj1FindNext := GetProcAddress(UNArjModule, 'UnarjFindNext');
  end;
  if @UnArj1FindNext <> nil then
  begin
    Result := UnArj1FindNext(_harc, _lpSubInfo);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['UnarlFindNext']));
  end;
end;

function UnArj(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  InitUnArj();
  if @UnArj1 = nil then
  begin
    @UnArj1 := GetProcAddress(UNArjModule, 'Unarj');
  end;
  if @UnArj1 <> nil then
  begin
    Result := UnArj1(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Unarj']));
  end;
//  DesrtroyUnArj();
end;

//Yz1
procedure InitYz1();
begin
  //64bits
  if Exe64bitsBool = TRUE then
  begin
    Yz1DLL := '';
  end
  //32bits
  else
  begin
    Yz1DLL := 'Yz1.dll';
  end;

  //DLLĂяo
  if Yz1Module = 0 then
  begin
    if DllFolderPath = '' then
    begin
      Yz1Module := LoadLibraryEx(PWideChar(Yz1DLL), 0, LOAD_LIBRARY_FLAG);
    end
    else
    begin
      Yz1Module := LoadLibrary(PWideChar(DllFolderPath + Yz1DLL));
    end;
  end;
end;

procedure DesrtroyYz1();
begin
  if Yz1Module <> 0 then
  begin
    FreeLibrary(Yz1Module);
  end;
end;

function Yz1OpenArchive(const _hwnd: HWND; _szFileName: LPCSTR; const _dwMode: DWORD): HARC;
begin
  InitYz1();
  if @Yz11OpenArchive = nil then
  begin
    @Yz11OpenArchive := GetProcAddress(Yz1Module, 'Yz1OpenArchive');
  end;
  if @Yz11OpenArchive <> nil then
  begin
    Result := Yz11OpenArchive(_hwnd, _szFileName, _dwMode);
  end
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Yz1OpenArchive']));
  end;
end;

function Yz1CloseArchive(_harc: HARC): Integer;
begin
  //DLL̏
  InitYz1();
  if @Yz11CloseArchive = nil then
  //API̖ÕAhX擾
  begin
    @Yz11CloseArchive := GetProcAddress(Yz1Module, 'Yz1CloseArchive');
  end;
  //APIs
  if @Yz11CloseArchive <> nil then
  begin
    Result := Yz11CloseArchive(_harc);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Yz1CloseArchive']));
  end;
end;

function Yz1FindFirst(_harc: HARC; _szWildName: LPCSTR; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  //DLL̏
  InitYz1();
  //API̖ÕAhX擾
  if @Yz11FindFirst = nil then
  begin
    @Yz11FindFirst := GetProcAddress(Yz1Module, 'Yz1FindFirst');
  end;
  //APIs
  if @Yz11FindFirst <> nil then
  begin
    Result := Yz11FindFirst(_harc, _szWildName, _lpSubInfo);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Yz1FindFirst']));
  end;
end;

function Yz1FindNext(_harc: HARC; var _lpSubInfo: TMyIndivisualInfo): Integer;
begin
  //DLL̏
  InitYz1();
  //API̖ÕAhX擾
  if @Yz11FindNext = nil then
  begin
    @Yz11FindNext := GetProcAddress(Yz1Module, 'Yz1FindNext');
  end;
  //APIs
  if @Yz11FindNext <> nil then
  begin
    Result := Yz11FindNext(_harc, _lpSubInfo);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Yz1FindNext']));
  end;
end;

function Yz1(const _hwnd: HWND; _szCmdLine: LPCSTR; _szOutput: LPSTR; const _dwSize: DWORD): Integer;
begin
  //DLL̏
  InitYz1();
  //API̖ÕAhX擾
  if @Yz11 = nil then
  begin
    @Yz11 := GetProcAddress(Yz1Module, 'Yz1');
  end;
  //APIs
  if @Yz11 <> nil then
  begin
    Result := Yz11(_hwnd, _szCmdLine, _szOutput, _dwSize);
  end
  //G[
  else
  begin
    raise DLLAddressErr.Create(Format(DLLAddressErrMes, ['Yz1']));
  end;
  //j
//  DesrtroyYz1();
end;




initialization
//


finalization
//

end.

