unit Attribute;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_PLATFORM OFF} //W1002

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, MyUtility, Vcl.Menus;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 400;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormAttribute = class(TForm)
    Panel1: TPanel;
    ListBox1: TListBox;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrList1: TStringList;
    CsvList2: TStringList;
    StrLanguageFileName: String;
    BoolJapanese: Boolean;

  public
    { Public 錾 }

  end;

var
  FormAttribute: TFormAttribute;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormAttribute.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormAttribute.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormAttribute.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormAttribute.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormAttribute', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormAttribute', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormAttribute', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormAttribute', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormAttribute', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  CsvList2 := TStringList.Create;;
  StrList1 := TStringList.Create;;

  //Ǎ
  if FileExists(FormMain.StrExtractBase + ATTR_TXT) = TRUE then
  begin
    StrList1.LoadFromFile(FormMain.StrExtractBase + ATTR_TXT, TEncoding.Unicode);
  end;
  ListBox1.Items.Clear;
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    CsvList2.Clear;
    StringToCsvList(StrList1.Strings[iRow1], CsvList2);
    ListBox1.Items.Add(CsvList2[0]);
    //擪̓eŐݒ
    if iRow1 = 0 then
    begin
      //ݒ
      Edit1.Text := ExtractFilePath(CsvList2[0]);
      //ݒ
      if Copy(CsvList2[3], 1 ,1) = 'R' then
      begin
        CheckBox1.Checked := TRUE;
      end;
      if Copy(CsvList2[3], 2 ,1) = 'H' then
      begin
        CheckBox2.Checked := TRUE;
      end;
      if Copy(CsvList2[3], 3 ,1) = 'S' then
      begin
        CheckBox4.Checked := TRUE;
      end;
      if Copy(CsvList2[3], 4 ,1) = 'A' then
      begin
        CheckBox3.Checked := TRUE;
      end;
    end;
  end;
  ListBox1.ItemIndex := 0;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
  end;
end;

procedure TFormAttribute.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormAttribute', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormAttribute', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormAttribute', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormAttribute', 'Left',   FormAttribute.Left);
    IniFile.WriteInteger('FormAttribute', 'Top',    FormAttribute.Top);
    IniFile.WriteInteger('FormAttribute', 'Width',  FormAttribute.Width);
    IniFile.WriteInteger('FormAttribute', 'Height', FormAttribute.Height);
  end;
  //j
  IniFile.Free;

  //j
  CsvList2.Clear;
  StrList1.Clear;
end;

procedure TFormAttribute.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormAttribute.KeyPreview := TRUE;
  //ݒ
  CheckBox1.SetFocus;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormAttribute.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormAttribute.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormAttribute.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormAttribute.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormAttribute.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Attribute.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormAttribute, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormAttribute, StrLanguageFileName, Sender);
  end;
end;

procedure TFormAttribute.FormResize(Sender: TObject);
begin
  Edit1.Width    := Panel1.Width -30 -30;
  ListBox1.Width := Panel1.Width -30 -30;
end;

procedure TFormAttribute.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //
  else if (Shift = []) and (key = VK_RETURN) then
  begin
    if (CheckBox1.Focused = TRUE) or (CheckBox2.Focused = TRUE) or
       (CheckBox3.Focused = TRUE) or (CheckBox4.Focused = TRUE) then
    begin
      key := 0;
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormAttribute, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormAttribute, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormAttribute.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormAttribute.ButtonOKClick(Sender: TObject);
var
  iRow1: Integer;
  iAttr1: integer;
  iRet1: integer;
  IniFile: TIniFile;
begin
  //Jn
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    //WJ
    CsvList2.Clear;
    StringToCsvList(StrList1.Strings[iRow1], CsvList2);

    //ݒ
    iAttr1 := 0;
    if CheckBox1.Checked = true then
    begin
      iAttr1 := iAttr1 + FILE_ATTRIBUTE_READONLY;
    end;
    if CheckBox2.Checked = true then
    begin
      iAttr1 := iAttr1 + FILE_ATTRIBUTE_HIDDEN;
    end;
    if CheckBox3.Checked = true then
    begin
      iAttr1 := iAttr1 + FILE_ATTRIBUTE_ARCHIVE;
    end;
    if CheckBox4.Checked = true then
    begin
      iAttr1 := iAttr1 + FILE_ATTRIBUTE_SYSTEM;
    end;
    //ύX
    iRet1 := FileSetAttr(CsvList2[0], iAttr1);
    //s
    if iRet1 <> 0 then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : t@C̕ύXs܂' + #13#10 +
                            CsvList2[0];
      end
      else
      begin
        FormMain.StrMsg := 'Error : Change file attribute failed.' + #13#10 +
                           CsvList2[0] + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end
    else
    begin
      //擪
      if iRow1 = 0 then
      begin
        //m
        IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
        //ݒ
        IniFile.WriteString('Return', 'Target', RETURN_NAME);
        //j
        IniFile.Free;
        //߂l
        if FormMain.StrRetFormCopyEx = '' then
        begin
          FormMain.StrRetFormAttribute := CsvList2[0];
        end;
      end;
    end;
  end;

  //ݒ
  if BoolJapanese = TRUE then
  begin
    FormMain.StrMsg := 'Information : ύX܂';
  end
  else
  begin
    FormMain.StrMsg := 'Information : Change file attribute had done.' + #13#10 +
                       '[OK]';
  end;
  ShowMessage(FormMain.StrMsg);
  //I
  ModalResult := mrOK;
end;

procedure TFormAttribute.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormAttribute.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormAttribute.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

end.

