unit CopyFtp;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN UNIT_PLATFORM     OFF} //W1005
  {$WARN SYMBOL_PLATFORM   OFF} //W1002
  {$WARN SYMBOL_PLATFORM   OFF} //W1002  FileSetDate
  {$WARN SYMBOL_DEPRECATED OFF} //W1000  for FileCtrl

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,  Vcl.StdCtrls, Vcl.ExtCtrls,

  Shellapi, Filectrl, IniFiles, MyUtility, StrUtils,
  Math, ShlObj, ActiveX,
  System.DateUtils, System.UITypes,

  IdFTP, IdFTPList, IdAllFTPListParsers,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdExplicitTLSClientServerBase, IdAntiFreezeBase, Vcl.IdAntiFreeze,
  IdFTPCommon, IdURI, HTTPApp, Vcl.Menus;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 500;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX8_WIDTH       = 695;

type
  TFormCopyFtp = class(TForm)
    Panel21: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    ButtonCopy2: TButton;
    ButtonCancel2: TButton;
    ListBox1: TListBox;
    Edit1: TEdit;
    Label5: TLabel;
    Edit2: TEdit;
    Panel11: TPanel;
    Panel12: TPanel;
    ButtonGetList1: TButton;
    ButtonCancel1: TButton;
    ListBox8: TListBox;
    Panel31: TPanel;
    Panel32: TPanel;
    ButtonCancel3: TButton;
    ButtonOk3: TButton;
    Panel33: TPanel;
    Label9: TLabel;
    Label10: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label18: TLabel;
    Edit32: TEdit;
    Edit33: TEdit;
    Edit34: TEdit;
    Edit35: TEdit;
    Edit36: TEdit;
    ButtonFtpConnect3: TButton;
    ButtonFtpDisConnect3: TButton;
    CheckBox7: TCheckBox;
    Edit31: TEdit;
    ButtonFtpTree3: TButton;
    CheckBox9: TCheckBox;
    CheckBox11: TCheckBox;
    IdFTP1: TIdFTP;
    MainMenu2: TMainMenu;
    MenuItem2: TMenuItem;
    MenuEscape2: TMenuItem;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuEscape1: TMenuItem;
    MenuOperation: TMenuItem;
    MenuFtpInput: TMenuItem;
    MenuFtpDelete: TMenuItem;
    MenuFtpCopy: TMenuItem;
    MenuFtpPaste: TMenuItem;
    MainMenu3: TMainMenu;
    MenuItem1: TMenuItem;
    MenuEscape3: TMenuItem;
    ButtonAbort2: TButton;
    Label25: TLabel;
    Label26: TLabel;
    Label28: TLabel;
    Label4: TLabel;
    MenuQuit1: TMenuItem;
    MenuQuit2: TMenuItem;
    MenuQuit3: TMenuItem;
    Timer1: TTimer;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonCancel2Click(Sender: TObject);
    procedure ButtonCopy2Click(Sender: TObject);
    procedure ButtonFtpConnect3Click(Sender: TObject);
    procedure ButtonFtpDisConnect3Click(Sender: TObject);
    procedure ButtonFtpTree3Click(Sender: TObject);
    procedure ButtonOk3Click(Sender: TObject);
    procedure ButtonCancel3Click(Sender: TObject);
    procedure ButtonGetList1Click(Sender: TObject);
    procedure ButtonCancel1Click(Sender: TObject);
    procedure ButtonAbort2Click(Sender: TObject);

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox8DblClick(Sender: TObject);
    procedure ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox8KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ThisListFilesDrive(DirName :String; TheList:TStringList);
    procedure ThisListFilesDriveCurrent(DirName :String; TheList:TStringList);

    function  FtpConnect(Sender: TObject): Boolean;
    function  FtpDisConnect(Sender: TObject): Boolean;
    procedure FtpGetDirAndFilesList(ADir: String; TheList: TStringList);

    function  FtpExtractFilePath(FileName: String): String;
    function  FtpExtractFileName(FileName: String): String;
    function  FtpExtractFileExt(FileName: String): String;

    procedure SetItemList(ListBox: TListBox; Sender: TObject);

    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);

    procedure MenuFtpPasteClick(Sender: TObject);
    procedure MenuFtpCopyClick(Sender: TObject);
    procedure MenuFtpDeleteClick(Sender: TObject);
    procedure MenuFtpInputClick(Sender: TObject);
    procedure MenuEscape1Click(Sender: TObject);
    procedure MenuEscape2Click(Sender: TObject);
    procedure MenuEscape3Click(Sender: TObject);

    function  ThisCopyoDriveToFtp(Sender: TObject): Boolean;

    function  FtpForceDirectorys(FolderName: String; TheList: TStringList): Boolean;
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit31KeyPress(Sender: TObject; var Key: Char);
    procedure Edit32KeyPress(Sender: TObject; var Key: Char);
    procedure Edit33KeyPress(Sender: TObject; var Key: Char);
    procedure Edit34KeyPress(Sender: TObject; var Key: Char);
    procedure Edit35KeyPress(Sender: TObject; var Key: Char);
    procedure Edit36KeyPress(Sender: TObject; var Key: Char);
    procedure MenuQuit1Click(Sender: TObject);
    procedure MenuQuit2Click(Sender: TObject);
    procedure MenuQuit3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    CsvList2: TStringList;
    CsvList3: TStringList;
    CsvList4: TStringList;
    StrListSrc: TStringList;
    StrListDst: TStringList;
    StrListSrcFolder: TStringList;
    StrListDstFolder: TStringList;
    StrListFtpList: TStringList;
    StrListItems: TStringList;
    BoolAbort: Boolean;
    BoolShowMem: Boolean;
    BoolFileTimeWithin: Boolean;
    BoolJapanese: Boolean;
    StrCopyItem: String;
    StrLanguageFileName: String;
    IntFtpCount: Integer;
    IntLocalCount: Integer;

  public
    { Public 錾 }

  end;

var
  FormCopyFtp: TFormCopyFtp;

implementation

uses
  Main, InputFilename, FtpTree, FtpSelectCopy;

{$R *.dfm}

//explorer
//t@C̕Ń\[g
//name<TAB>....
function CompareLogical2(List: TStringList; Index1, Index2: Integer): Integer;
var
  iPos11: Integer;
  iPos21: Integer;
  sStr11: String;
  sStr12: String;
begin
  //PosEx  StrUtils Kv
  //ŏ<TAB>
  iPos11 := PosEx(#09, List[Index1], 1);
  //t@C𒊏o
  sStr11 := Copy(List[Index1], 1, iPos11-1);

  //ŏ<TAB>
  iPos21 := PosEx(#09, List[Index2], 1);
  //t@C𒊏o
  sStr12 := Copy(List[Index2], 1, iPos21-1);

  //r
  Result := StrCmpLogicalW(PWideChar(WideString(sStr11)), PWideChar(WideString(sStr12)));
end;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormCopyFtp.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormCopyFtp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormCopyFtp.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormCopyFtp.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
  sStr1: String;
  sStr9: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormCopyFtp', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormCopyFtp', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormCopyFtp', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormCopyFtp', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormCopyFtp', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //
  Timer1.Enabled := FALSE;

  //m
  CsvList2 := TStringList.Create;;
  CsvList3 := TStringList.Create;;
  CsvList4 := TStringList.Create;;
  StrListSrc    := TStringList.Create;
  StrListDst    := TStringList.Create;
  StrListSrcFolder := TStringList.Create;
  StrListDstFolder := TStringList.Create;
  StrListFtpList   := TStringList.Create;
  StrListItems     := TStringList.Create;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
    ListBox8.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
    ListBox8.Style := lbStandard;
  end;

  //ݒ
  Panel11.Visible        := TRUE;
  Panel21.Visible        := FALSE;
  Panel31.Visible        := FALSE;

  Panel11.Align          := alClient;
  Panel21.Align          := alClient;
  Panel31.Align          := alClient;

  Panel33.Align          := alClient;

  //ݒ
  Edit1.Text := '';
  Edit2.Text := FormMain.StrSetFormCopyFtp;

  //ݒ
  ButtonAbort2.Enabled := FALSE;
  ButtonAbort2.Refresh;

  //ݒ
  BoolShowMem         := FALSE;


  //Ǎ
  if FileExists(FormMain.StrExtractBase + COPY_TXT) = TRUE then
  begin
    FormMain.StrListCopyMoveSrc.LoadFromFile(FormMain.StrExtractBase + COPY_TXT, TEncoding.Unicode);
  end;
  ListBox1.Items.Clear;
  for iRow1 := 0 to FormMain.StrListCopyMoveSrc.Count-1 do
  begin
    sStr1 := FormMain.StrListCopyMoveSrc.Strings[iRow1];
    ListBox1.Items.Add(sStr1);
  end;
  if ListBox1.Items.Count > 0 then
  begin
    ListBox1.ItemIndex := 0;
  end;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  if BoolJapanese = TRUE then
  begin
    Label1.Caption := 'S  : ' + IntToStr(ListBox1.Items.Count);
  end
  else
  begin
    Label1.Caption := 'Total : ' + IntToStr(ListBox1.Items.Count);
  end;
  //ݒ
  Label25.Caption := 'Src=0';
  Label26.Caption := 'Dst=0';
  Label28.Caption := 'Copy=0';

  //ݒ
  SetShortCutKey(Sender);

  //mF
  sStr9 := ExtractFilePath(ParamStr(0)) + COPY_FTP_TXT;
  if FileExists(sStr9) = TRUE then
  begin
    //Ǎ
    StrListItems.LoadFromFile(sStr9, TEncoding.Unicode);
    //\
    SetItemList(ListBox8, Sender);
    //
    ListBox8.ItemIndex := 0;
  end
  else
  begin
    //쐬
    StrListitems.Clear;
    StrListitems.Add('  A' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  B' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  C' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  D' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  E' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  F' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  G' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  H' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  I' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  J' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  K' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  L' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  M' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  N' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  O' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  P' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  Q' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  R' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  S' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  T' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  U' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  V' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  W' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  X' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  Y' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  Z' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  0' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  1' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  2' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  3' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  4' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  5' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  6' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  7' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  8' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('  9' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+A' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+B' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+C' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+D' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+E' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+F' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+G' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+H' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+I' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+J' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+K' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+L' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+M' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+N' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+O' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+P' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+Q' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+R' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+S' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+T' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+U' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+V' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+W' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+X' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+Y' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+Z' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+0' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+1' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+2' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+3' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+4' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+5' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+6' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+7' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+8' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('s+9' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+A' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+B' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+C' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+D' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+E' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+F' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+G' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+H' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+I' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+J' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+K' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+L' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+M' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+N' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+O' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+P' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+Q' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+R' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+S' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+T' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+U' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+V' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+W' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+X' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+Y' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+Z' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+0' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+1' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+2' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+3' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+4' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+5' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+6' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+7' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+8' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    StrListitems.Add('c+9' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
    //ۑ
    StrListItems.SaveToFile(sStr9, TEncoding.Unicode);
    //\
    SetItemList(ListBox8, Sender);
    //
    ListBox8.ItemIndex := 0;
  end;

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
    ListBox8.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
    ListBox8.Style := lbStandard;
  end;

end;

procedure TFormCopyFtp.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormCopyFtp', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormCopyFtp', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormCopyFtp', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormCopyFtp', 'Left',   FormCopyFtp.Left);
    IniFile.WriteInteger('FormCopyFtp', 'Top',    FormCopyFtp.Top);
    IniFile.WriteInteger('FormCopyFtp', 'Width',  FormCopyFtp.Width);
    IniFile.WriteInteger('FormCopyFtp', 'Height', FormCopyFtp.Height);
  end;
  //j
  IniFile.Free;

  //j
  CsvList2.Free;
  CsvList3.Free;
  CsvList4.Free;
  StrListSrc.Free;
  StrListDst.Free;
  StrListSrcFolder.Free;
  StrListDstFolder.Free;
  StrListFtpList.Free;
  StrListItems.Free;
end;

procedure TFormCopyFtp.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormCopyFtp.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormCopyFtp.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormCopyFtp.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormCopyFtp.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormCopyFtp.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormCopyFtp.Handle, imClose);

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 3, 0);
  ListBox8.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 3, 0);

  //
  FormCopyFtp.Menu := FormCopyFtp.MainMenu1;
  BoolShowMem := TRUE;


  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'CopyFtp.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormCopyFtp, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormCopyFtp, StrLanguageFileName, Sender);
  end;

  //\[gx
  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    Timer1.Enabled := TRUE;
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    Timer1.Enabled := TRUE;
  end;
end;

procedure TFormCopyFtp.FormResize(Sender: TObject);
begin

  if BoolShowMem        = TRUE then
  begin
    ListBox1.Width       := Panel21.ClientWidth  -40;
    Edit1.Width          := Panel21.ClientWidth  -40;
    Edit2.Width          := Panel21.ClientWidth  -40;

    ListBox1.Height      := Panel21.ClientHeight -220;

    Label3.Top           := Panel21.ClientHeight -120;
    Edit1.Top            := Panel21.ClientHeight -95;

    ButtonCopy2.Top      := Panel21.ClientHeight -35;
    ButtonAbort2.Top     := Panel21.ClientHeight -35;
    ButtonCancel2.Top    := Panel21.ClientHeight -35;
    Label1.Top           := Panel21.ClientHeight -33;
    Label25.Top          := Panel21.ClientHeight -60;
    Label26.Top          := Panel21.ClientHeight -60;
    Label28.Top          := Panel21.ClientHeight -60;

    Edit31.Width         := Panel31.ClientWidth - 380;
    Edit32.Width         := Panel31.ClientWidth - 380;
    Edit33.Width         := Panel31.ClientWidth - 380;
    Edit34.Width         := Panel31.ClientWidth - 380;
    Edit35.Width         := Panel31.ClientWidth - 380;
    Edit36.Width         := Panel31.ClientWidth - 380;
  end;
end;

procedure TFormCopyFtp.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormCopyFtp.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Panel11.Visible = FALSE then
  begin
    //{
    if      ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
    begin
      //ݒ
      BoolJapanese := TRUE;
      //{
      FormMain.SetJapanese(FormCopyFtp, StrLanguageFileName, Sender);
      //
      Label1.Caption := 'S  : ' + IntToStr(ListBox1.Items.Count);
    end
    //p
    else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
    begin
      //ݒ
      BoolJapanese := FALSE;
      //p
      FormMain.SetEnglish(FormCopyFtp, StrLanguageFileName, Sender);
      //
      Label1.Caption := 'Total : ' + IntToStr(ListBox1.Items.Count);
    end
    //
    else
    begin
      //
    end;
    Exit;
  end;

  //key
  if (Shift = []) and (key = VK_A) then
  begin
    ListBox8.ItemIndex := 0;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_B) then
  begin
    ListBox8.ItemIndex := 1;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_C) then
  begin
    ListBox8.ItemIndex := 2;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_D) then
  begin
    ListBox8.ItemIndex := 3;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_E) then
  begin
    ListBox8.ItemIndex := 4;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_F) then
  begin
    ListBox8.ItemIndex := 5;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_G) then
  begin
    ListBox8.ItemIndex := 6;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_H) then
  begin
    ListBox8.ItemIndex := 7;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_I) then
  begin
    ListBox8.ItemIndex := 8;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_J) then
  begin
    ListBox8.ItemIndex := 9;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_K) then
  begin
    ListBox8.ItemIndex := 10;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_L) then
  begin
    ListBox8.ItemIndex := 11;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_M) then
  begin
    ListBox8.ItemIndex := 12;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_N) then
  begin
    ListBox8.ItemIndex := 13;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_O) then
  begin
    ListBox8.ItemIndex := 14;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_P) then
  begin
    ListBox8.ItemIndex := 15;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_Q) then
  begin
    ListBox8.ItemIndex := 16;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_R) then
  begin
    ListBox8.ItemIndex := 17;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_S) then
  begin
    ListBox8.ItemIndex := 18;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_T) then
  begin
    ListBox8.ItemIndex := 19;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_U) then
  begin
    ListBox8.ItemIndex := 20;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_V) then
  begin
    ListBox8.ItemIndex := 21;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_W) then
  begin
    ListBox8.ItemIndex := 22;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_X) then
  begin
    ListBox8.ItemIndex := 23;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_Y) then
  begin
    ListBox8.ItemIndex := 24;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_Z) then
  begin
    ListBox8.ItemIndex := 25;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_0) then
  begin
    ListBox8.ItemIndex := 26;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_1) then
  begin
    ListBox8.ItemIndex := 27;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_2) then
  begin
    ListBox8.ItemIndex := 28;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_3) then
  begin
    ListBox8.ItemIndex := 29;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_4) then
  begin
    ListBox8.ItemIndex := 30;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_5) then
  begin
    ListBox8.ItemIndex := 31;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_6) then
  begin
    ListBox8.ItemIndex := 32;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_7) then
  begin
    ListBox8.ItemIndex := 33;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_8) then
  begin
    ListBox8.ItemIndex := 34;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = []) and (key = VK_9) then
  begin
    ListBox8.ItemIndex := 35;
    ButtonGetList1Click(Sender);
  end
  //shift
  else if (Shift = [ssShift]) and (key = VK_A) then
  begin
    ListBox8.ItemIndex := 0+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_B) then
  begin
    ListBox8.ItemIndex := 1+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_C) then
  begin
    ListBox8.ItemIndex := 2+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_D) then
  begin
    ListBox8.ItemIndex := 3+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_E) then
  begin
    ListBox8.ItemIndex := 4+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_F) then
  begin
    ListBox8.ItemIndex := 5+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_G) then
  begin
    ListBox8.ItemIndex := 6+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_H) then
  begin
    ListBox8.ItemIndex := 7+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_I) then
  begin
    ListBox8.ItemIndex := 8+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_J) then
  begin
    ListBox8.ItemIndex := 9+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_K) then
  begin
    ListBox8.ItemIndex := 10+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_L) then
  begin
    ListBox8.ItemIndex := 11+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_M) then
  begin
    ListBox8.ItemIndex := 12+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_N) then
  begin
    ListBox8.ItemIndex := 13+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_O) then
  begin
    ListBox8.ItemIndex := 14+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_P) then
  begin
    ListBox8.ItemIndex := 15+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_Q) then
  begin
    ListBox8.ItemIndex := 16+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_R) then
  begin
    ListBox8.ItemIndex := 17+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_S) then
  begin
    ListBox8.ItemIndex := 18+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_T) then
  begin
    ListBox8.ItemIndex := 19+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_U) then
  begin
    ListBox8.ItemIndex := 20+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_V) then
  begin
    ListBox8.ItemIndex := 21+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_W) then
  begin
    ListBox8.ItemIndex := 22+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_X) then
  begin
    ListBox8.ItemIndex := 23+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_Y) then
  begin
    ListBox8.ItemIndex := 24+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_Z) then
  begin
    ListBox8.ItemIndex := 25+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_0) then
  begin
    ListBox8.ItemIndex := 26+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_1) then
  begin
    ListBox8.ItemIndex := 27+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_2) then
  begin
    ListBox8.ItemIndex := 28+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_3) then
  begin
    ListBox8.ItemIndex := 29+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_4) then
  begin
    ListBox8.ItemIndex := 30+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_5) then
  begin
    ListBox8.ItemIndex := 31+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_6) then
  begin
    ListBox8.ItemIndex := 32+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_7) then
  begin
    ListBox8.ItemIndex := 33+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_8) then
  begin
    ListBox8.ItemIndex := 34+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssShift]) and (key = VK_9) then
  begin
    ListBox8.ItemIndex := 35+36;
    ButtonGetList1Click(Sender);
  end
  //ctrl
  else if (Shift = [ssCtrl]) and (key = VK_A) then
  begin
    ListBox8.ItemIndex := 0+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_B) then
  begin
    ListBox8.ItemIndex := 1+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_C) then
  begin
    ListBox8.ItemIndex := 2+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_D) then
  begin
    ListBox8.ItemIndex := 3+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_E) then
  begin
    ListBox8.ItemIndex := 4+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_F) then
  begin
    ListBox8.ItemIndex := 5+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_G) then
  begin
    ListBox8.ItemIndex := 6+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_H) then
  begin
    ListBox8.ItemIndex := 7+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_I) then
  begin
    ListBox8.ItemIndex := 8+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_J) then
  begin
    ListBox8.ItemIndex := 9+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_K) then
  begin
    ListBox8.ItemIndex := 10+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_L) then
  begin
    ListBox8.ItemIndex := 11+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_M) then
  begin
    ListBox8.ItemIndex := 12+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_N) then
  begin
    ListBox8.ItemIndex := 13+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_O) then
  begin
    ListBox8.ItemIndex := 14+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_P) then
  begin
    ListBox8.ItemIndex := 15+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_Q) then
  begin
    ListBox8.ItemIndex := 16+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_R) then
  begin
    ListBox8.ItemIndex := 17+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_S) then
  begin
    ListBox8.ItemIndex := 18+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_T) then
  begin
    ListBox8.ItemIndex := 19+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_U) then
  begin
    ListBox8.ItemIndex := 20+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_V) then
  begin
    ListBox8.ItemIndex := 21+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_W) then
  begin
    ListBox8.ItemIndex := 22+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_X) then
  begin
    ListBox8.ItemIndex := 23+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_Y) then
  begin
    ListBox8.ItemIndex := 24+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_Z) then
  begin
    ListBox8.ItemIndex := 25+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_0) then
  begin
    ListBox8.ItemIndex := 26+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_1) then
  begin
    ListBox8.ItemIndex := 27+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_2) then
  begin
    ListBox8.ItemIndex := 28+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_3) then
  begin
    ListBox8.ItemIndex := 29+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_4) then
  begin
    ListBox8.ItemIndex := 30+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_5) then
  begin
    ListBox8.ItemIndex := 31+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_6) then
  begin
    ListBox8.ItemIndex := 32+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_7) then
  begin
    ListBox8.ItemIndex := 33+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_8) then
  begin
    ListBox8.ItemIndex := 34+36+36;
    ButtonGetList1Click(Sender);
  end
  else if (Shift = [ssCtrl]) and (key = VK_9) then
  begin
    ListBox8.ItemIndex := 35+36+36;
    ButtonGetList1Click(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormCopyFtp, StrLanguageFileName, Sender);
    //
    Label1.Caption := 'S  : ' + IntToStr(ListBox1.Items.Count);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormCopyFtp, StrLanguageFileName, Sender);
    //
    Label1.Caption := 'Total : ' + IntToStr(ListBox1.Items.Count);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormCopyFtp.ListBox8DblClick(Sender: TObject);
begin
  ButtonGetList1Click(Sender);
end;

procedure TFormCopyFtp.ListBox8DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin

  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;

end;

procedure TFormCopyFtp.ListBox8KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //Enter
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonGetList1Click(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormCopyFtp.MenuEscape1Click(Sender: TObject);
begin
  ButtonCancel1Click(Sender);
end;

procedure TFormCopyFtp.MenuEscape2Click(Sender: TObject);
begin
  ButtonCancel2Click(Sender);
end;

procedure TFormCopyFtp.MenuEscape3Click(Sender: TObject);
begin
  ButtonCancel3Click(Sender);
end;

procedure TFormCopyFtp.MenuFtpCopyClick(Sender: TObject);
var
  CsvList1: TStringList;
  bError: Boolean;
begin
  //
  bError := FALSE;
  //m
  CsvList1 := TStringList.Create;
  //WJ
  StringToCsvList(StrListItems.Strings[ListBox8.ItemIndex], CsvList1);
  //ݒ
  if CsvList1[2] = '' then
  begin
    if bError = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : T[oݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Server name is empty.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;
    bError := TRUE;
  end;
  //ݒ
  if (CsvList1[3] = '') and (bError = FALSE) then
  begin
    if bError = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : |[gԍݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Port number is empty.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;
    bError := TRUE;
  end;
  if (CsvList1[6] = '') and (bError = FALSE) then
  begin
    if bError = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : T[opXݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Server path is empty.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;
    bError := TRUE;
  end;
  //j
  CsvList1.Free;

  //
  if bError = TRUE then
  begin
    Exit;
  end;

  //ݒ
  StrCopyItem := StrListItems.Strings[ListBox8.ItemIndex];
end;

procedure TFormCopyFtp.MenuFtpDeleteClick(Sender: TObject);
var
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  sStr19: String;
  sStr20: String;
  sStr21: String;
  wRet8: Word;
  CsvList1: TStringList;
  iIndex1: Integer;
  iIndex2: Integer;
begin
  //m
  CsvList1 := TStringList.Create;
  //WJ
  StringToCsvList(StrListItems.Strings[ListBox8.ItemIndex], CsvList1);
  //ݒ
  sStr11 := CsvList1[0];
  sStr12 := CsvList1[1];
  sStr13 := CsvList1[2];
  sStr14 := CsvList1[3];
  sStr15 := CsvList1[4];
  sStr16 := CsvList1[5];
  sStr17 := CsvList1[6];
  sStr18 := CsvList1[7];
  sStr19 := CsvList1[8];
  sStr20 := CsvList1[9];
  sStr21 := CsvList1[10];
  //j
  CsvList1.Free;

  //mF
  if BoolJapanese = TRUE then
  begin
    sStr8 := 'Key : '    + Trim(sStr11) + #13#10 +
                                          #13#10 +
             'Name : '        + sStr12  + #13#10 +
             'ServerName : '  + sStr13  + #13#10 +
             'PortNumber : '  + sStr14  + #13#10 +
             'UserName : '    + sStr15  + #13#10 +
             'Password : '    + sStr16  + #13#10 +
             'ServerPath : '  + sStr17  + #13#10 +
             'LocalPath : '   + sStr18  + #13#10 +
             'Passive : '     + sStr19  + #13#10 +
             'Host : '        + sStr20  + #13#10 +
             'File : '        + sStr21  + #13#10 +
                                          #13#10 +
             '폜܂H';
  end
  else
  begin
    sStr8 := 'Key : '    + Trim(sStr11) + #13#10 +
                                          #13#10 +
             'Name : '        + sStr12  + #13#10 +
             'ServerName : '  + sStr13  + #13#10 +
             'PortNumber : '  + sStr14  + #13#10 +
             'UserName : '    + sStr15  + #13#10 +
             'Password : '    + sStr16  + #13#10 +
             'ServerPath : '  + sStr17  + #13#10 +
             'LocalPath : '   + sStr18  + #13#10 +
             'Passive : '     + sStr19  + #13#10 +
             'Host : '        + sStr20  + #13#10 +
             'File : '        + sStr21  + #13#10 +
                                          #13#10 +
             'Delete ?'                 + #13#10 +
             '[YES] / [NO]';
  end;
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    //XV
    iIndex1 := ListBox8.TopIndex;
    iIndex2 := ListBox8.ItemIndex;
    //
    StrListItems.Strings[iIndex2] := sStr11 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09;
    //XV
    SetItemList(ListBox8, Sender);
    //XV
    ListBox8.TopIndex  := iIndex1;
    ListBox8.ItemIndex := iIndex2;

    //ۑ
    sStr9 := ExtractFilePath(ParamStr(0)) + COPY_FTP_TXT;
    StrListItems.SaveToFile(sStr9, TEncoding.Unicode);
  end
  else
  begin
    //
  end;
end;

procedure TFormCopyFtp.MenuFtpInputClick(Sender: TObject);
var
  CsvList1: TStringList;
begin
  //f
  Panel11.Visible := FALSE;
  Panel21.Visible := FALSE;
  Panel31.Visible := TRUE;
  FormCopyFtp.Menu := FormCopyFtp.MainMenu3;
  //TCY
  FormResize(Sender);

  //m
  CsvList1 := TStringList.Create;
  //WJ
  StringToCsvList(StrListItems.Strings[ListBox8.ItemIndex], CsvList1);
  Edit31.Text := CsvList1[1];
  Edit32.Text := CsvList1[2];
  Edit33.Text := CsvList1[3];
  Edit34.Text := CsvList1[4];
  Edit35.Text := CsvList1[5];
  Edit36.Text := CsvList1[6];
  if CsvList1[8] = FTP_PASSIVE_ON then
  begin
    CheckBox7.Checked := TRUE;
  end
  else
  begin
    CheckBox7.Checked := FALSE;
  end;
  if CsvList1[9] = FTP_HOST_NONE then
  begin
    CheckBox9.Checked := TRUE;
  end;
  if CsvList1[10] = FTP_FILE_NONE then
  begin
    CheckBox11.Checked := TRUE;
  end;
  //j
  CsvList1.Free;

  //ݒ
  Edit31.SetFocus;
end;

procedure TFormCopyFtp.MenuFtpPasteClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  sStr19: String;
  sStr20: String;
  sStr21: String;
  sStr31: String;
  sStr32: String;
  sStr33: String;
  sStr34: String;
  sStr35: String;
  sStr36: String;
  sStr37: String;
  sStr38: String;
  sStr39: String;
  sStr40: String;
  sStr41: String;
  wRet8: Word;
  CsvList1: TStringList;
  CsvList2: TStringList;
  iIndex1: Integer;
  iIndex2: Integer;
begin
  //
  if StrCopyItem = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \t̓eł' + #13#10 +
                         'ŏɃRs[sĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Paste items is empty.' + #13#10 +
                         'Copy must be done before Paste' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //m
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;
  //WJ
  StringToCsvList(StrListItems.Strings[ListBox8.ItemIndex], CsvList1);
  StringToCsvList(StrCopyItem,                              CsvList2);
  //ݒ
  sStr11 := CsvList1[0];
  sStr12 := CsvList1[1];
  sStr13 := CsvList1[2];
  sStr14 := CsvList1[3];
  sStr15 := CsvList1[4];
  sStr16 := CsvList1[5];
  sStr17 := CsvList1[6];
  sStr18 := CsvList1[7];
  sStr19 := CsvList1[8];
  sStr20 := CsvList1[9];
  sStr21 := CsvList1[10];
  sStr31 := CsvList2[0];
  sStr32 := CsvList2[1];
  sStr33 := CsvList2[2];
  sStr34 := CsvList2[3];
  sStr35 := CsvList2[4];
  sStr36 := CsvList2[5];
  sStr37 := CsvList2[6];
  sStr38 := CsvList2[7];
  sStr39 := CsvList2[8];
  sStr40 := CsvList2[9];
  sStr41 := CsvList2[10];
  //j
  CsvList1.Free;
  CsvList2.Free;

  //mF
  if BoolJapanese = TRUE then
  begin
    sStr8 := 'Key : '        + Trim(sStr11) + #13#10 +
                                              #13#10 +
             'Name(Old) : '       + sStr12  + #13#10 +
             'Name(New) : '       + sStr32  + #13#10 +
                                              #13#10 +
             'ServerName(Old) : ' + sStr13  + #13#10 +
             'ServerName(New) : ' + sStr33  + #13#10 +
                                              #13#10 +
             'PortNumber(Old) : ' + sStr14  + #13#10 +
             'PortNumber(New) : ' + sStr34  + #13#10 +
                                              #13#10 +
             'UserName(Old) : '   + sStr15  + #13#10 +
             'UserName(New) : '   + sStr35  + #13#10 +
                                              #13#10 +
             'Password(Old) : '   + sStr16  + #13#10 +
             'Password(New) : '   + sStr36  + #13#10 +
                                              #13#10 +
             'ServerPass(Old) : ' + sStr17  + #13#10 +
             'ServerPath(New) : ' + sStr37  + #13#10 +
                                              #13#10 +
//           'LocalPath(Old) : '  + sStr18  + #13#10 +
//           'LocalPath(New) : '  + sStr38  + #13#10 +
//                                            #13#10 +
             'Passive(Old) : '    + sStr19  + #13#10 +
             'Passive(New) : '    + sStr39  + #13#10 +
                                              #13#10 +
                                              #13#10 +
             'Host(Old) : '       + sStr20  + #13#10 +
             'Host(New) : '       + sStr40  + #13#10 +
                                              #13#10 +
             'File(Old) : '       + sStr21  + #13#10 +
             'File(New) : '       + sStr41  + #13#10 +
                                              #13#10 +
             '㏑܂H';
  end
  else
  begin
    sStr8 := 'Key : '        + Trim(sStr11) + #13#10 +
                                              #13#10 +
             'Name(Old) : '       + sStr12  + #13#10 +
             'Name(New) : '       + sStr32  + #13#10 +
                                              #13#10 +
             'ServerName(Old) : ' + sStr13  + #13#10 +
             'ServerName(New) : ' + sStr33  + #13#10 +
                                              #13#10 +
             'PortNumber(Old) : ' + sStr14  + #13#10 +
             'PortNumber(New) : ' + sStr34  + #13#10 +
                                              #13#10 +
             'UserName(Old) : '   + sStr15  + #13#10 +
             'UserName(New) : '   + sStr35  + #13#10 +
                                              #13#10 +
             'Password(Old) : '   + sStr16  + #13#10 +
             'Password(New) : '   + sStr36  + #13#10 +
                                              #13#10 +
             'ServerPass(Old) : ' + sStr17  + #13#10 +
             'ServerPath(New) : ' + sStr37  + #13#10 +
                                              #13#10 +
//           'LocalPath(Old) : '  + sStr18  + #13#10 +
//           'LocalPath(New) : '  + sStr38  + #13#10 +
//                                            #13#10 +
             'Passive(Old) : '    + sStr19  + #13#10 +
             'Passive(New) : '    + sStr39  + #13#10 +
                                              #13#10 +
                                              #13#10 +
             'Host(Old) : '       + sStr20  + #13#10 +
             'Host(New) : '       + sStr40  + #13#10 +
                                              #13#10 +
             'File(Old) : '       + sStr21  + #13#10 +
             'File(New) : '       + sStr41  + #13#10 +
                                              #13#10 +
             'Over Write ?'                 + #13#10 +
             '[YES] / [NO]';
  end;
  wRet8 := MessageDlg(sStr8, mtInformation, [mbYes, mbNo ], 0);
  if wRet8 = mrYes then
  begin
    //s
  end
  else
  begin
    //~
    Exit;
  end;

  //XV
  iIndex1 := ListBox8.TopIndex;
  iIndex2 := ListBox8.ItemIndex;
  //
  sStr1 := Copy(StrListItems.Strings[ListBox8.ItemIndex], 1, 3);
  sStr2 := Copy(StrCopyItem, 4, Length(StrCopyItem));
  StrListItems.Strings[iIndex2] := sStr1 + sStr2;
  //XV
  SetItemList(ListBox8, Sender);
  //XV
  ListBox8.TopIndex  := iIndex1;
  ListBox8.ItemIndex := iIndex2;

  //ۑ
  sStr9 := ExtractFilePath(ParamStr(0)) + COPY_FTP_TXT;
  StrListItems.SaveToFile(sStr9, TEncoding.Unicode);
end;

procedure TFormCopyFtp.MenuQuit1Click(Sender: TObject);
begin
  ButtonCancel1Click(Sender);
end;

procedure TFormCopyFtp.MenuQuit2Click(Sender: TObject);
begin
  ButtonCancel2Click(Sender);
end;

procedure TFormCopyFtp.MenuQuit3Click(Sender: TObject);
begin
  ButtonCancel3Click(Sender);
end;

procedure TFormCopyFtp.ButtonOk3Click(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr9: String;
  iIndex1: Integer;
  iIndex2: Integer;
begin
  //
  if Edit31.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Oݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Name is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if Pos('\', Edit31.Text) > 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : O \ ̎w͂ł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Name is not available \.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if Edit32.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : T[oݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Serber name is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if Edit33.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : |[gԍݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Port number is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if Edit36.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : T[opXݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Server path is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if Pos('//', Edit36.Text) > 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : T[opX // ͎w͂ł܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Server path is not available //.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ݒ
  if Copy(Edit36.Text, Length(Edit36.Text), 1) <> '/' then
  begin
    Edit36.Text := Edit36.Text + '/';
  end;
  if Copy(Edit36.Text, 1, 1) <> '/' then
  begin
    Edit36.Text := '/' + Edit36.Text;
  end;

  //ݒ
  if CheckBox7.Checked = TRUE then
  begin
    sStr1 := FTP_PASSIVE_ON ;
  end
  else
  begin
    sStr1 := FTP_PASSIVE_OFF;
  end;
  //ݒ
  if CheckBox9.Checked = TRUE then
  begin
    sStr2 := FTP_HOST_NONE;
  end;
  //ݒ
  if CheckBox11.Checked = TRUE then
  begin
    sStr3 := FTP_FILE_NONE;
  end;
  sStr4 := Copy(StrListItems.Strings[ListBox8.ItemIndex], 1, 3)                    + #09 +
           Edit31.Text + #09 + Edit32.Text + #09 + Edit33.Text + #09 + Edit34.Text + #09 +
           Edit35.Text + #09 + Edit36.Text + #09 + ''          + #09 + sStr1       + #09 +
           sStr2       + #09 + sStr3       + #09 + ''          + #09 + ''          + #09;
  //XV
  iIndex1 := ListBox8.TopIndex;
  iIndex2 := ListBox8.ItemIndex;
  //
  StrListItems.Strings[ListBox8.ItemIndex] := sStr4;
  //ۑ
  sStr9 := ExtractFilePath(ParamStr(0)) + COPY_FTP_TXT;
  StrListItems.SaveToFile(sStr9, TEncoding.Unicode);
  //XV
  SetItemList(ListBox8, Sender);
  //XV
  ListBox8.TopIndex  := iIndex1;
  ListBox8.ItemIndex := iIndex2;

  //ؑ
  Panel11.Visible := TRUE;
  Panel21.Visible := FALSE;
  Panel31.Visible := FALSE;
  FormCopyFtp.Menu      := FormCopyFtp.MainMenu1;

  //ݒ
  ListBox8.SetFocus;


end;

procedure TFormCopyFTp.ButtonCopy2Click(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
  //
  if Edit1.Text <> '' then
  begin
    //
  end
  else
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʐ̃tH_ݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  FormFtpSelectCopy := TFormFtpSelectCopy.Create(Application);
  try
    if FormFtpSelectCopy.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormFtpSelectCopy.Free;
  end;

  if bResult = TRUE then
  begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //ݒ
    BoolFileTimeWithin := IniFile.ReadBool('FormFtpSelectCopy', 'TimeStampWithin',  FALSE);
    //j
    IniFile.Free;

    //s
    if ThisCopyoDriveToFtp(Sender) = TRUE then
    begin
      //
    end;
  end;
end;

procedure TFormCopyFtp.ButtonCancel2Click(Sender: TObject);
begin
  //ؑ
  Panel11.Visible        := TRUE;
  Panel21.Visible        := FALSE;
  Panel31.Visible        := FALSE;
  FormCopyFtp.Menu       := FormCopyFtp.MainMenu1;
;
end;

procedure TFormCopyFtp.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;



procedure TFormCopyFtp.ThisListFilesDrive(DirName :String; TheList:TStringList);
var
  sStr2: string;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';

  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4 := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 := SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE);
        sstr6 := SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr7  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //tH_ɂ
          sStr3 := sStr3 + '\';
          //ǉ
          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);

          //ċNIɌ
          Application.ProcessMessages;
          ThisListFilesDrive(sStr3, TheList);
          Application.ProcessMessages;
        end
        else
        begin
          //ǉ
          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);

          //XV
          IntLocalCount := IntLocalCount+1;
          if (IntLocalCount mod 10) = 0 then
          begin
            Label25.Caption := 'Src='    + IntToStr(IntLocalCount);
            Label25.Refresh;
          end;
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;

procedure TFormCopyFtp.ThisListFilesDriveCurrent(DirName :String; TheList:TStringList);
var
  sStr2: string;
  SStr3: String;
  SStr4: String;
  SStr5: String;
  SStr6: String;
  SStr7: String;
  i64Int1: Int64;
  File2: TWin32FindData;
  hFindData1: THandle;
begin
  //ݒ
  if Copy(DirName, Length(DirName), 1) <> '\' then
  begin
    DirName := DirName + '\';
  end;
  sStr2 := DirName + '*.*';
  //t@Č
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr2), File2);
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    repeat
      //efBNg܂͎qfBNg̔
      if (String(File2.cFileName) <> '..') and (String(File2.cFileName) <> '.') then
      begin
        //
        sStr4 := SearchRecAttributeToStrEx(File2.dwFileAttributes);
        //t
        sStr5 := SearchRecFileTimeToDateEx(File2.ftLastWriteTime, FALSE);
        sstr6 := SearchRecFileTimeToTimeEx(File2.ftLastWriteTime, FALSE);
        //TCY
        i64Int1 := File2.nFileSizeLow or Int64(File2.nFileSizeHigh) shl 32;
        sStr7  := ConvertInt64ToStr20(i64Int1);

        //t@C̐ݒ
        sStr3 := DirName + String(File2.cFileName);
        //fBNg̔)
        if Bool(File2.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = TRUE then
        begin
          //tH_ɂ
          sStr3 := sStr3 + '\';
          //ǉ
          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);
        end
        else
        begin
          //ǉ
          TheList.Add(sStr3 + #09 + sStr4 + #09 + sStr5 + #09 + sStr6 + #09 + sStr7);
        end;
      end;
    //Č
    until WinApi.Windows.FindNextFile(hFindData1, File2) <> TRUE;
    //I
    WinApi.Windows.FindClose(hFindData1);
  end;
  //
  Application.ProcessMessages;
end;


procedure TFormCopyFtp.Timer1Timer(Sender: TObject);
begin
  //Zbg
  Timer1.Enabled := FALSE;

  if (FormMain.IntSortMode1 = 5) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[hti쐬jł' + #13#10 +
                         '\[g[htiŏIXVjŎ擾܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Creation).' + #13#10 +
                         'But, get time by Date(LastWrite).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
  if (FormMain.IntSortMode1 = 6) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : \[g[htiŏIANZXjł' +#13#10 +
                         '\[g[htiŏIXVjŎ擾܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Sort mode is Date(Last Access).' + #13#10 +
                         'But, get time by Date(LastWrite).' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormCopyFtp.ButtonFtpConnect3Click(Sender: TObject);
begin
  //ݒ
  FormMain.StrServerName := Edit32.Text;
  FormMain.StrPortNumber := Edit33.Text;
  FormMain.StrUserName   := Edit34.Text;
  FormMain.StrPassword   := Edit35.Text;
  if CheckBox7.Checked = TRUE then
  begin
    FormMain.BoolPassiveMode := TRUE;
  end
  else
  begin
    FormMain.BoolPassiveMode := TRUE;
  end;

  //ڑ
  if FtpConnect(Sender) = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ڑ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Network connected.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormCopyFtp.ButtonFtpDisConnect3Click(Sender: TObject);
begin
  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    FtpDisConnect(Sender);
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ؒf܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Network disconnected.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end
  else
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ڑĂ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Network not connected.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormCopyFtp.ButtonFtpTree3Click(Sender: TObject);
var
  bResult: Boolean;
begin
  //ݒ
  FormMain.StrServerName := Edit32.Text;
  FormMain.StrPortNumber := Edit33.Text;
  FormMain.StrUserName   := Edit34.Text;
  FormMain.StrPassword   := Edit35.Text;
  if CheckBox7.Checked = TRUE then
  begin
    FormMain.BoolPassiveMode := TRUE;
  end
  else
  begin
    FormMain.BoolPassiveMode := TRUE;
  end;

  //ڑ
  if FtpConnect(Sender) = FALSE then
  begin
    Exit;
  end;
  //ؒf
  if FtpDisConnect(Sender) = FALSE then
  begin
    Exit;
  end;

    //
    FormFtpTree := TFormFtpTree.Create(Application);
    try
      if FormFtpTree.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormFtpTree.Free;
    end;
    //
    if bResult = TRUE then
    begin
      Edit36.Text := FormMain.StrRetFormFtpTree;
      Edit36.SetFocus;
    end;
end;

procedure TFormCopyFtp.ButtonGetList1Click(Sender: TObject);
var
  CsvList1: TStringList;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  bPassive: Boolean;
begin
  //m
  CsvList1 := TStringList.Create;

  //WJ
  StringToCsvList(StrListItems.Strings[ListBox8.ItemIndex], CsvList1);

  //ݒ
  sStr1 := CsvList1[0];
  sStr2 := CsvList1[1];
  sStr3 := CsvList1[2];
  sStr4 := CsvList1[3];
  sStr5 := CsvList1[4];
  sStr6 := CsvList1[5];
  sStr7 := CsvList1[6];
  sStr8 := CsvList1[7];
  if CsvList1[8] = FTP_PASSIVE_ON  then
  begin
    bPassive := TRUE;
  end
  else
  begin
    bPassive := FALSE;
  end;
  //j
  CsvList1.Free;

  //ݒ
  FormMain.StrFtpName       := sStr2;
  FormMain.StrServerName    := sStr3;
  FormMain.StrPortNumber    := sStr4;
  FormMain.StrUserName      := sStr5;
  FormMain.StrPassword      := sStr6;
  FormMain.StrFtpFolder     := sStr7;
  FormMain.StrLocalFolder   := sStr8;
  FormMain.BoolPassiveMode  := bPassive;

    //ؑ
    Panel11.Visible := FALSE;
    Panel21.Visible := TRUE;
    Panel31.Visible := FALSE;
    FormCopyFtp.Menu := FormCopyFtp.MainMenu2;

    //XN[o[\
    ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX8_WIDTH * 3, 0);

    //XV
    Label25.Caption := 'Src=0';
    Label26.Caption := 'Dst=0';
    Label28.Caption := 'Copy=0';
    Label25.Refresh;
    Label26.Refresh;
    Label28.Refresh;

    //XV
    ButtonCopy2.Enabled   := TRUE;
    ButtonCopy2.Refresh;
    ButtonAbort2.Enabled  := FALSE;
    ButtonAbort2.Refresh;
    ButtonCancel2.Enabled := TRUE;
    ButtonCancel2.Refresh;

    //XV
    Edit1.Text := FormMain.StrFtpFolder;

    //NA
    StrListSrc.Clear;
    StrListDst.Clear;
    StrListSrcFolder.Clear;

    //TCY
    FormResize(Sender);

end;

procedure TFormCopyFtp.ButtonAbort2Click(Sender: TObject);
begin
  if IdFTP1.Connected = TRUE then
  begin
    //f
    BoolAbort := TRUE;
    //f
    IdFTP1.Abort;
    //ؒf
    FtpDisConnect(Sender);
  end;

  //XV
  ButtonCopy2.Enabled    := TRUE;
  ButtonCopy2.Refresh;
  ButtonAbort2.Enabled   := FALSE;
  ButtonAbort2.Refresh;
  ButtonCancel2.Enabled  := TRUE;
  ButtonCancel2.Refresh;

end;

procedure TFormCopyFtp.ButtonCancel1Click(Sender: TObject);
begin
  //ؒf
  FtpDisConnect(Sender);
  //I
  ModalResult := mrCancel;
end;

procedure TFormCopyFtp.ButtonCancel3Click(Sender: TObject);
begin
  //ؑ
  Panel11.Visible        := TRUE;
  Panel21.Visible        := FALSE;
  Panel31.Visible        := FALSE;
  FormCopyFtp.Menu       := FormCopyFtp.MainMenu1;

  //ݒ
  ListBox8.SetFocus;
;
end;








function  TFormCopyFtp.FtpConnect(Sender: TObject): Boolean;
begin
  //
  Result := FALSE;

  if FormMain.StrServerName = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : T[oݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Server name is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if FormMain.StrPortNumber = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : |[gԍݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Port number is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    try
      IdFTP1.Disconnect;
    except
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : ؒfɎs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Network disconnect failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //ݒ
  IdFTP1.Host     :=          FormMain.StrServerName;
  IdFTP1.Port     := StrToInt(FormMain.StrPortNumber);
  IdFTP1.Username :=          FormMain.StrUserName;
  IdFTP1.Password :=          FormMain.StrPassword;
  IdFTP1.Passive  :=          FormMain.BoolPassiveMode;
  //
  try
    //ڑ
    IdFTP1.Connect;
  except
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : ڑɎs܂';
    end
    else
    begin
      FormMain.StrMsg := 'Error : Network connect failed.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  Result := TRUE;

end;

function  TFormCopyFtp.FtpDisConnect(Sender: TObject): Boolean;
begin
  //
  Result := FALSE;

  //ڑς
  if IdFTP1.Connected = TRUE then
  begin
    //ؒf
    try
      //ؒf
      IdFTP1.Disconnect;
    except
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : ؒfɎs܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Network disconnect failed.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //
  Result := TRUE;
end;

procedure TFormCopyFtp.FtpGetDirAndFilesList(ADir: String; TheList: TStringList);
var
  LFileList : TStringList;
  iRow1     : Integer;
  iRow2     : Integer;
  LCount    : Integer;
  LListItem : TIdFTPListItem;
  LFileName : String;
  LFileSize : Int64;
  LFileDate : TDateTime;
  LFilePermission: String;
  LCurDir   : String;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
begin
  //m
  LFileList := TStringList.Create;
  //s
  try
    try
      //ύX
      IdFTP1.ChangeDir(ADir);
    except
      ;
    end;
    //擾
    IdFTP1.List;

    //List\bhsDirectoryListingŃt@C̃Xg擾ł
    LCount := IdFTP1.DirectoryListing.Count;
    //DirectroyListing͐VList\bhsƏĂ܂
    //čċȀꍇ͗płȂ̂ŕʃXg쐬
    LFileList.Clear;
    //s
    for iRow1 := 0 to LCount - 1 do
    begin
      //f
      if BoolAbort = TRUE then
      begin
        Break;
      end;

      //ꗗ擾
      LListItem := IdFTP1.DirectoryListing[iRow1];
      //t@C
      LFileName := LListItem.FileName;
      //t@CTCY
      LFileSize := LListItem.Size;
      //t@C̍ŏIXV
      LFileDate := LListItem.ModifiedDate;
      //t@C̃p[~bV
      LFilePermission := LListItem.PermissionDisplay;

      //q܂͐e
      if (LFileName = '.') or (LFileName = '..') then
      begin
        Continue;
      end;

      //fBNg
      if LListItem.ItemType = ditDirectory then
      begin
        //擾
        LCurDir := IdFTP1.RetrieveCurrentDir + '/' + LFileName;
        LFileList.Add(LCurDir);
      end;


      //ݒ
      if LListItem.ItemType = ditDirectory then
      begin
        sStr1 := IdFTP1.RetrieveCurrentDir + '/' + LFileName + '/';
      end
      else
      begin
        sStr1 := IdFTP1.RetrieveCurrentDir + '/' + LFileName;
      end;
      //ݒ
      if LFilePermission = '' then
      begin
        sStr2 := '*****-**-*';
      end
      else
      begin
        sStr2 := LFilePermission;
      end;
      //ϊ
      DateTimeToString(sStr3, 'yyyy/MM/dd', LFileDate);
      DateTimeToString(sStr4, 'HH:mm:ss', LFileDate);
      //ϊ
      sStr5 := ConvertInt64ToStr20(LFileSize);

      //ǉ
      //[0]name [1]attr [2]date [3]time [4]size
      TheList.Add(sStr1 + #09 + sStr2 + #09 + sStr3 + #09 + sStr4 + #09 + sStr5);

      //tH_
      if LListItem.ItemType = ditDirectory then
      begin
        //
      end
      //t@C
      else
      begin
        //XV
        IntFtpCount := IntFtpCount+1;
        if (IntFtpCount mod 10) = 0 then
        begin
          Label26.Caption := 'Dst='    + IntToStr(IntFtpCount);
          Label26.Refresh;
        end;
      end;
    end;

    //̎_SLɉwfBNg΃pXœĂ
    //wfBNgċAIɌListBoxItemɒǉĂ
    for iRow2 := 0 to LFileList.Count - 1 do
    begin
      //f
      if BoolAbort = TRUE then
      begin
        Break;
      end;
      //擾
      FtpGetDirAndFilesList(LFileList[iRow2], TheList);
    end;
  finally
    //j
    FreeAndNil(LFileList);
  end;
end;


procedure TFormCopyFtp.SetItemList(ListBox: TListBox;Sender: TObject);
var
  iRow1: Integer;
  iMax1: Integer;
  iMax2: Integer;
  iMax3: Integer;
  iMax4: Integer;
  iMax5: Integer;
  iMax6: Integer;
  iMax7: Integer;
  iMax8: Integer;
  iMax9: Integer;
  iMax10: Integer;
  iLen1: Integer;
  iLen2: Integer;
  iLen3: Integer;
  iLen4: Integer;
  iLen5: Integer;
  iLen6: Integer;
  iLen7: Integer;
  iLen8: Integer;
  iLen9: Integer;
  iLen10: Integer;
  CsvList1: TStringList;
begin
  //ől擾
  iMax1  := 0;
  iMax2  := 0;
  iMax3  := 0;
  iMax4  := 0;
  iMax5  := 0;
  iMax6  := 0;
  iMax7  := 0;
  iMax8  := 0;
  iMax9  := 0;
  iMax10 := 0;

  //m
  CsvList1 := TStringList.Create;

  //ݒ
  for iRow1 := 0 to StrListItems.Count-1 do
  begin
//    StrListitems.Add('  A' + #09 + #09 + #09 + #09 + #09 + #09 + #09 + #09 + FTP_PASSIVE_ON + #09 + FTP_HOST_NONE + #09 + FTP_FILE_NONE + #09 + #09 + #09);
//PP
    //WJ
    CsvList1.Clear;
    StringToCsvList(StrListItems.Strings[iRow1], CsvList1);
    if Length(AnsiString(CsvList1[1])) > iMax1 then
    begin
      iMax1 := Length(AnsiString(CsvList1[1]));
    end;
    if Length(AnsiString(CsvList1[2])) > iMax2 then
    begin
      iMax2 := Length(AnsiString(CsvList1[2]));
    end;
    if Length(AnsiString(CsvList1[3])) > iMax3 then
    begin
      iMax3 := Length(AnsiString(CsvList1[3]));
    end;
    if Length(AnsiString(CsvList1[4])) > iMax4 then
    begin
      iMax4 := Length(AnsiString(CsvList1[4]));
    end;
    if Length(AnsiString(CsvList1[5])) > iMax5 then
    begin
      iMax5 := Length(AnsiString(CsvList1[5]));
    end;
    if Length(AnsiString(CsvList1[6])) > iMax6 then
    begin
      iMax6 := Length(AnsiString(CsvList1[6]));
    end;
    if Length(AnsiString(CsvList1[7])) > iMax7 then
    begin
      iMax7 := Length(AnsiString(CsvList1[7]));
    end;
    if Length(AnsiString(CsvList1[8])) > iMax8 then
    begin
      iMax8 := Length(AnsiString(CsvList1[8]));
    end;
    if Length(AnsiString(CsvList1[9])) > iMax9 then
    begin
      iMax9 := Length(AnsiString(CsvList1[9]));
    end;
    if Length(AnsiString(CsvList1[10])) > iMax10 then
    begin
      iMax10 := Length(AnsiString(CsvList1[10]));
    end;
  end;

  //XV
  ListBox.Items.BeginUpdate;
  //NA
  ListBox.Items.Clear;
  //ݒ
  for iRow1 := 0 to StrListItems.Count-1 do
  begin
    //WJ
    CsvList1.Clear;
    StringToCsvList(StrListItems.Strings[iRow1], CsvList1);
    iLen1  := Length(AnsiString(CsvList1[1]));
    iLen2  := Length(AnsiString(CsvList1[2]));
    iLen3  := Length(AnsiString(CsvList1[3]));
    iLen4  := Length(AnsiString(CsvList1[4]));
    iLen5  := Length(AnsiString(CsvList1[5]));
    iLen6  := Length(AnsiString(CsvList1[6]));
    iLen7  := Length(AnsiString(CsvList1[7]));
    iLen8  := Length(AnsiString(CsvList1[8]));
    iLen9  := Length(AnsiString(CsvList1[9]));
    iLen10 := Length(AnsiString(CsvList1[10]));
    ListBox.Items.Add(CsvList1[0]  + ' ' +
                      CsvList1[1]  + StringOfChar(' ', iMax1 -iLen1)  + ' ' +
                      CsvList1[2]  + StringOfChar(' ', iMax2 -iLen2)  + ' ' +
                      CsvList1[3]  + StringOfChar(' ', iMax3 -iLen3)  + ' ' +
                      CsvList1[4]  + StringOfChar(' ', iMax4 -iLen4)  + ' ' +
                      CsvList1[5]  + StringOfChar(' ', iMax5 -iLen5)  + ' ' +
                      CsvList1[6]  + StringOfChar(' ', iMax6 -iLen6)  + ' ' +
                      CsvList1[7]  + StringOfChar(' ', iMax7 -iLen7)  + ' ' +
                      CsvList1[8]  + StringOfChar(' ', iMax8 -iLen8)  + ' ' +
                      CsvList1[9]  + StringOfChar(' ', iMax9 -iLen9)  + ' ' +
                      CsvList1[10] + StringOfChar(' ', iMax10-iLen10)
                      );
  end;
  //XV
  ListBox.Items.EndUpdate;

  //j
  CsvList1.Free;
end;


procedure TFormCopyFtp.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
    //Ǎ
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_FTP_FILER_LIST;
    if FileExists(sStr1) = TRUE then
    begin
      FormMain.StrListKeyMapFtpFiler.LoadFromFile(sStr1, TEncoding.Unicode);
    end
    //t@CȂꍇ́AftHgŐݒ肳ĂeɂȂĂ
    else
    begin
      FormMain.StrListKeyMapFtpFiler.SaveToFile(sStr1, TEncoding.Unicode);
    end;

    //ݒ
    if FormMain.StrListKeyMapFtpFiler.Count > 0 then
    begin
      SetShortCutNew('1006', MenuQuit1, Sender);
      SetShortCutNew('1006', MenuQuit2, Sender);
      SetShortCutNew('1006', MenuQuit3, Sender);
      SetShortCutNew('1111', MenuEscape1, Sender);
      SetShortCutNew('1111', MenuEscape2, Sender);
      SetShortCutNew('1111', MenuEscape3, Sender);
    end;
end;

procedure TFormCopyFtp.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to FormMain.StrListKeyMapFtpFiler.Count-1 do
  begin
    //擾
    sStr11 := FormMain.StrListKeyMapFtpFiler.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //ݒ
    sStr3 := '';
  end
  else
  begin
    //ݒ
    sStr3 := sStr16;
  end;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;


function  TFormCopyFtp.ThisCopyoDriveToFtp(Sender: TObject): Boolean;
var
  StrList1: TStringList;
  StrList2: TStringList;
  StrList3: TStringList;
  StrList4: TStringList;
  CsvList1: TStringList;
  CsvList2: TStringList;

  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;

  iLen1: Integer;
  iRow1: Integer;
  iRow2: Integer;
  iRow3: Integer;
  iFind1: Integer;
  iFind3: Integer;
  iCopyNum1: Integer;

  date11: TDateTime;
  date21: TDateTime;
  i64Int2: Int64;

  bCopy1: Boolean;
  bRename1: Boolean;
  bResult: Boolean;
  bExcept1: Boolean;
  bRet1: Boolean;
begin


  //
  Result := FALSE;

  //擾
  sStr2 := Edit1.Text;

  //ڑ
  if FtpConnect(Sender) = TRUE then
  begin
    bExcept1 := FALSE;
    try
      //fBNgύXsȂ炻̃fBNgȂ̂Ɖ߂
      IdFTP1.ChangeDir(sStr2);
    except
      bExcept1 := TRUE;
    end;
  end
  else
  begin
    Result := FALSE;
    Exit;
  end;

  //
  if bExcept1 = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ʐ̃tH_܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Dst folder is not exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Result := FALSE;
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  StrList3 := TStringList.Create;
  StrList4 := TStringList.Create;
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;

  //XV
  ButtonCopy2.Enabled   := FALSE;
  ButtonCopy2.Refresh;
  ButtonAbort2.Enabled  := TRUE;
  ButtonAbort2.Refresh;
  ButtonCancel2.Enabled := FALSE;
  ButtonCancel2.Refresh;

  //XV
  Label25.Caption := 'Src=0';
  Label26.Caption := 'Dst=0';
  Label28.Caption := 'Copy=0';
  Label25.Refresh;
  Label26.Refresh;
  Label28.Refresh;

  //NA
  StrListSrc.Clear;
  StrListDst.Clear;
  StrListSrcFolder.Clear;
  StrListDstFolder.Clear;

  //ݒ
  BoolAbort := FALSE;
  bExcept1 := FALSE;
  bRet1 := FALSE;

  //
  sStr3 := Edit2.Text;
  if System.SysUtils.DirectoryExists(sStr3) = TRUE then
  begin
    //NA
    StrList4.Clear;
    StrList4.Sorted := FALSE;
    //z̃t@C
    ThisListFilesDriveCurrent(sStr3, StrList4);
  end;
  //tH_͍폜
  for iRow1 := StrList4.Count-1 downto 0 do
  begin
    if Copy(StrList4.Strings[iRow1], Length(StrList4.Strings[iRow1]), 1) = '\' then
    begin
      StrList4.Delete(iRow1);
    end;
  end;

  //
  for iRow1 := 0 to ListBox1.Items.Count-1 do
  begin
    //NA
    StrList1.Clear;
    StrList1.Sorted := FALSE;
    StrList2.Clear;
    StrList2.Sorted := FALSE;
    StrList3.Clear;
    StrList3.Sorted := FALSE;

    //擾
    sStr3 := ListBox1.Items.Strings[iRow1];
    //tH_
    if Copy(sStr3, Length(sStr3), 1) = '\' then
    begin
      //
      if System.SysUtils.DirectoryExists(sStr3) = TRUE then
      begin
        //z̃tH_
        ThisListFilesDrive(sStr3, StrList1);
        //ǉ
        StrListSrcFolder.Add(sStr3 + #09 + #09 + #09 + #09);

        //]
        StrList2.Sorted := TRUE;
        StrList3.Sorted := TRUE;
        for iRow2 := 0 to StrList1.Count-1 do
        begin
          //WJ
          CsvList2.Clear;
          StringToCsvList(StrList1.Strings[iRow2], CsvList2);
          //tH_
          if Copy(CsvList2[0], Length(CsvList2[0]), 1) = '\' then
          begin
            //
            StrList3.Add(StrList1.Strings[iRow2]);
          end
          //t@C
          else
          begin
           //
           StrList2.Add(StrList1.Strings[iRow2]);
          end;
        end;
      end;
    end
    //t@C
    else
    begin
      for iRow2 := 0 to StrList4.Count-1 do
      begin
        //WJ
        CsvList1.Clear;
        StringToCsvList(StrList4.Strings[iRow2], CsvList1);
        if UpperCase(CsvList1[0]) = UpperCase(sStr3) then
        begin
          //
          StrList2.Add(StrList4.Strings[iRow2]);
          Break;
         end;
       end;
     end;

    //f
    StrListSrc.AddStrings(StrList2);
    StrListSrcFolder.AddStrings(StrList3);

    //XV
    Label25.Caption := 'Src=' + InttoStr(StrListSrc.Count);
    Label25.Refresh;
  end;

  //XV
  Label25.Caption := 'Src=' + IntToStr(StrListSrc.Count);
  Label25.Refresh;

  //\[g
  StrListSrc.Sorted := FALSE;
  StrListSrc.CustomSort(CompareLogical2);
  //\[g
  StrListSrcFolder.Sorted := FALSE;
  StrListSrcFolder.CustomSort(CompareLogical2);

  //ڑ
  if FtpConnect(Sender) = TRUE then
  begin
    //NA
    StrList1.Clear;
    StrList1.Sorted := FALSE;
    StrList2.Clear;
    StrList2.Sorted := FALSE;
    StrList3.Clear;
    StrList3.Sorted := FALSE;
    IntFtpCount := 0;

    //z̃tH_
    FtpGetDirAndFilesList(Edit1.Text, StrList1);
    //ǉ
    StrList4.Insert(0, Edit1.Text + #09 + #09 + #09);

    //ݒ
    StrList2.Sorted := TRUE;
    StrList3.Sorted := TRUE;
    //ǉ
    StrList3.Add(Edit1.Text);
    //]
    for iRow2 := 0 to StrList1.Count-1 do
    begin
      //WJ
      CsvList2.Clear;
      StringToCsvList(StrList1.Strings[iRow2], CsvList2);
      //tH_
      if Copy(CsvList2[0], Length(CsvList2[0]), 1) = '/' then
      begin
        //
        StrList3.Add(StrList1.Strings[iRow2]);
      end
      //t@C
      else
      begin
        //
        StrList2.Add(StrList1.Strings[iRow2]);
      end;
    end;

    //f
    StrListDst.AddStrings(StrList2);
    StrListDstFolder.AddStrings(StrList3);

    //XV
    Label26.Caption := 'Dst=' + IntToStr(StrListDst.Count);
    Label26.Refresh;

    //\[g
    StrListDst.Sorted := FALSE;
    StrListDst.CustomSort(CompareLogical2);
    //\[g
    StrListDstFolder.Sorted := FALSE;
    StrListDstFolder.CustomSort(CompareLogical2);
  end
  else
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if StrList4 <> nil then
    begin
      StrList4.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonCopy2.Enabled   := TRUE;
    ButtonCopy2.Refresh;
    ButtonAbort2.Enabled  := FALSE;
    ButtonAbort2.Refresh;
    ButtonCancel2.Enabled := TRUE;
    ButtonCancel2.Refresh;
    //I
    Exit;
  end;


  //f
  if BoolAbort = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if StrList4 <> nil then
    begin
      StrList4.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonCopy2.Enabled   := TRUE;
    ButtonCopy2.Refresh;
    ButtonAbort2.Enabled  := FALSE;
    ButtonAbort2.Refresh;
    ButtonCancel2.Enabled := TRUE;
    ButtonCancel2.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : t@Cʂ𒆒f܂';
    end
    else
     begin
      FormMain.StrMsg := 'Information : Copy file had stopped.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;


  StrListSrc.SaveToFile(FormMain.StrExtractBase        + COPY_FTP_SRC_TXT,          TEncoding.Unicode);
  StrListDst.SaveToFile(FormMain.StrExtractBase        + COPY_FTP_DST_TXT,          TEncoding.Unicode);
  StrListSrcFolder.SaveToFile(FormMain.StrExtractBase  + COPY_FTP_SRC_FOLDER_TXT,   TEncoding.Unicode);
  StrListDstFolder.SaveToFile(FormMain.StrExtractBase  + COPY_FTP_DST_FOLDER_TXT,   TEncoding.Unicode);

  //ڑ
  if FtpConnect(Sender) = TRUE then
  begin
    //
    iCopyNum1 := 0;
    //ʂ
    iLen1 := Length(Edit2.Text);
    for iRow1 := 0 to StrListSrc.Count-1 do
    begin
      //f
      if BoolAbort = TRUE then
      begin
        Break;
      end;

      //WJ
      CsvList1.Clear;
      StringToCsvList(StrListSrc.Strings[iRow1], CsvList1);
      //擾
      sStr11 := CsvList1[1];
      sStr12 := CsvList1[2] +  ' ' + CsvList1[3];
      sStr13 := CsvList1[4];
      sStr14 := CsvList1[0];
      //ȍ~
      sStr4 := Copy(sStr14, iLen1+1, Length(sStr14));
      //̃tpX
      sStr5 := Edit1.Text + sStr4;
      sStr5 := StringReplace(sStr5, '\', '/', [rfReplaceAll]);

      //
      bCopy1   := FALSE;
      bRename1 := FALSE;
      bExcept1 := FALSE;
      iFind1 := -1;
      for iRow2 := 0 to StrListDst.Count-1 do
      begin
        //WJ
        CsvList2.Clear;
        StringToCsvList(StrListDst.Strings[iRow2], CsvList2);
        //擾
        sStr21 := CsvList2[1];
        sStr22 := CsvList2[2]  + ' ' + CsvList2[3];
        sStr23 := CsvList2[4];
        sStr24 := CsvList2[0];

        if UpperCase(sStr5) = UpperCase(sStr24) then
        begin
          //
          iFind1 := iRow2;

          //rŎsꍇ́At@CTCY 0 Ȃ̂ŁAɕʂ
          if sStr23 = '                   0' then
          begin
            bCopy1  := TRUE;
            Break;
          end;

          if FormMain.IntCopyModeIndex = COPY_MOVE_MODE_DATE then
          begin
            //t
            date11 := StrToDateTime(sStr12);
            //t
            date21 := StrToDateTime(sStr22);
            //b
            i64Int2 := System.DateUtils.SecondsBetween(date11, date21);

            //2bȓ͓ƂĔr
            if BoolFileTimeWithin = TRUE then
            begin
              //2bȓ
              if Abs(i64Int2) <= 2 then
              begin
                ;
              end
              //2bȏ
              else
              begin
                //]V
                if date11 > date21 then
                begin
                  bCopy1 := TRUE;
                end;
              end;
            end
            //Pɔr
            else
            begin
              //]V
              if date11 > date21 then
              begin
                bCopy1 := TRUE;
              end;
            end;
            Break;
          end;

          if FormMain.IntCopyModeIndex = COPY_MOVE_MODE_OVERWRITE then
          begin
            bCopy1  := TRUE;
            Break;
          end;

          if FormMain.IntCopyModeIndex = COPY_MOVE_MODE_NEW then
          begin
            bCopy1  := FALSE;
            Break;
          end;

          if FormMain.IntCopyModeIndex = COPY_MOVE_MODE_RENAME then
          begin
            bRename1  := TRUE;
            Break;
          end;
        end;
      end;


      //쐬
      if FtpForceDirectorys(FtpExtractfilePath(sStr5), StrListDstFolder) = TRUE then
      begin
        //
      end
      //s
      else
      begin
        bExcept1 := TRUE;
        Break;
      end;

      //
      if      (bCopy1 = TRUE) then
      begin
        //s
        try
          //XV
          iCopyNum1 := iCopyNum1+1;
          //oCiłeLXgt@CłftBinary̎w肪Kv
          IdFTP1.TransferType := ftBinary;
          //㏑ŃAbv[h
          IdFTP1.Put(sStr14, sStr5, TRUE);

          //XV
          Label28.Caption := 'Copy=' + IntToStr(iCopyNum1);
          Label28.Refresh;
          Application.ProcessMessages;
        except
          bExcept1 := TRUE;
          Break;
        end;
      end
      else if (iFind1 = -1) then
      begin
        //s
        try
          //XV
          iCopyNum1 := iCopyNum1+1;
          //oCiłeLXgt@CłftBinary̎w肪Kv
          IdFTP1.TransferType := ftBinary;
          //㏑ŃAbv[h
          IdFTP1.Put(sStr14, sStr5, TRUE);

          //XV
          Label28.Caption := 'Copy=' + IntToStr(iCopyNum1);
          Label28.Refresh;
          Application.ProcessMessages;
        except
          bExcept1 := TRUE;
          Break;
        end;
      end
      else if (bRename1 = TRUE) then
      begin
        //
        FormMain.StrRetFormInputFilename := FtpExtractFileName(sStr5);
        FormMain.StrSetFormInputFilename := FtpExtractFilePath(sStr5);

        //
        FormInputFilename := TFormInputFilename.Create(Application);
        try
          if FormInputFilename.ShowModal = mrOK then
          begin
            bResult := TRUE;
          end
          else
          begin
            bResult := FALSE;
          end;
        finally
          //j
          FormInputFilename.Free;
        end;
        Application.ProcessMessages;
        //ݒǍ
        if bResult = TRUE then
        begin
          //s
          try
            //t@CVݒ
            sStr6 := FtpExtractFilePath(sStr5) + FormMain.StrRetFormInputFilename;
            //XV
            iCopyNum1 := iCopyNum1+1;
            //oCiłeLXgt@CłftBinary̎w肪Kv
            IdFTP1.TransferType := ftBinary;
            //㏑ŃAbv[h
            IdFTP1.Put(sStr14, sStr6, TRUE);

            //XV
            Label28.Caption := 'Copy=' + IntToStr(iCopyNum1);
            Label28.Refresh;
            Application.ProcessMessages;
          except
            bExcept1 := TRUE;
            Break;
          end;
        end
        else
        begin
          //j
          if StrList1 <> nil then
          begin
            StrList1.Free;
          end;
          if StrList2 <> nil then
          begin
            StrList2.Free;
          end;
          if StrList3 <> nil then
          begin
            StrList3.Free;
          end;
          if StrList4 <> nil then
          begin
            StrList4.Free;
          end;
          if CsvList1 <> nil then
          begin
            CsvList1.Free;
          end;
          if CsvList2 <> nil then
          begin
            CsvList2.Free;
          end;

          //ؒf
          FtpDisConnect(Sender);
          //XV
          ButtonCopy2.Enabled     := TRUE;
          ButtonCopy2.Refresh;
          ButtonAbort2.Enabled  := FALSE;
          ButtonAbort2.Refresh;
          ButtonCancel2.Enabled := TRUE;
          ButtonCancel2.Refresh;
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Information : Vt@Cݒ肳܂ł';
          end
          else
          begin
            FormMain.StrMsg := 'Information : New filename is empty.' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Exit;
        end;
      end
      else
      begin
        //
      end;
    end;
  end
  else
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if StrList4 <> nil then
    begin
      StrList4.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonCopy2.Enabled     := TRUE;
    ButtonCopy2.Refresh;
    ButtonAbort2.Enabled  := FALSE;
    ButtonAbort2.Refresh;
    ButtonCancel2.Enabled := TRUE;
    ButtonCancel2.Refresh;
    //I
    Exit;
  end;

  //{^ɂ钆f
  if BoolAbort = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if StrList4 <> nil then
    begin
      StrList4.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //ؒf
    FtpDisConnect(Sender);
    //XV
    ButtonCopy2.Enabled     := TRUE;
    ButtonCopy2.Refresh;
    ButtonAbort2.Enabled  := FALSE;
    ButtonAbort2.Refresh;
    ButtonCancel2.Enabled := TRUE;
    ButtonCancel2.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Abv[h𒆒f܂';
    end
    else
     begin
      FormMain.StrMsg := 'Information : Upload had stopped.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //O̒f
  if  bExcept1 = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if StrList4 <> nil then
    begin
      StrList4.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //ؒf
    FtpDisConnect(Sender);
    //XV
    ButtonCopy2.Enabled     := TRUE;
    ButtonCopy2.Refresh;
    ButtonAbort2.Enabled  := FALSE;
    ButtonAbort2.Refresh;
    ButtonCancel2.Enabled := TRUE;
    ButtonCancel2.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : Abv[hɎs܂';
    end
    else
    begin
      FormMain.StrMsg := 'Error : Upload failed.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //tH_̍쐬
  for iRow1 := 0 to StrListSrcFolder.Count-1 do
  begin
    //WJ
    CsvList1.Clear;
    StringToCsvList(StrListSrcFolder.Strings[iRow1], CsvList1);
    //擾
    sStr11 := CsvList1[1];
    sStr12 := CsvList1[2] +  ' ' + CsvList1[3];
    sStr13 := CsvList1[4];
    sStr14 := CsvList1[0];
    //ȍ~
    sStr4 := Copy(sStr14, iLen1+1, Length(sStr14));
    //̃tpX
    sStr5 := Edit1.Text + sStr4;
    sStr5 := StringReplace(sStr5, '\', '/', [rfReplaceAll]);

    //tH_
    iFind3 := -1;
    for iRow3 := 0 to StrListDstFolder.Count-1 do
    begin
      if Pos(Uppercase(FtpExtractfilePath(sStr5)), UpperCase(StrListDstFolder.Strings[iRow3])) > 0 then
      begin
        iFind3 := iRow3;
        Break;
      end;
    end;
    //tH_Ȃ
    if iFind3 = -1 then
    begin
      try
        //쐬
        IdFTP1.MakeDir(sStr5);
      except
        bExcept1 := TRUE;
        Break;
      end;
    end;

  end;

  //
  if bExcept1 = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if StrList4 <> nil then
    begin
      StrList4.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonCopy2.Enabled     := TRUE;
    ButtonCopy2.Refresh;
    ButtonAbort2.Enabled  := FALSE;
    ButtonAbort2.Refresh;
    ButtonCancel2.Enabled := TRUE;
    ButtonCancel2.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Error : tH_쐬ł܂ł' +#13#10 +
                          ExtractFilePath(sStr5);
    end
    else
    begin
      FormMain.StrMsg := 'Error : Folder can not make.' + #13#10 +
                          ExtractFilePath(sStr5) + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  //f
  if BoolAbort = TRUE then
  begin
    //j
    if StrList1 <> nil then
    begin
      StrList1.Free;
    end;
    if StrList2 <> nil then
    begin
      StrList2.Free;
    end;
    if StrList3 <> nil then
    begin
      StrList3.Free;
    end;
    if StrList4 <> nil then
    begin
      StrList4.Free;
    end;
    if CsvList1 <> nil then
    begin
      CsvList1.Free;
    end;
    if CsvList2 <> nil then
    begin
      CsvList2.Free;
    end;
    //XV
    ButtonCopy2.Enabled     := TRUE;
    ButtonCopy2.Refresh;
    ButtonAbort2.Enabled  := FALSE;
    ButtonAbort2.Refresh;
    ButtonCancel2.Enabled := TRUE;
    ButtonCancel2.Refresh;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : tH_쐬𒆒f܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Make folder had stopped.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //j
  StrList1.Free;
  StrList2.Free;
  StrList3.Free;
  StrList4.Free;
  CsvList1.Free;
  CsvList2.Free;

  //XV
  ButtonCopy2.Enabled   := TRUE;
  ButtonCopy2.Refresh;
  ButtonAbort2.Enabled  := FALSE;
  ButtonAbort2.Refresh;
  ButtonCancel2.Enabled := TRUE;
  ButtonCancel2.Refresh;

  //ݒ
  if BoolJapanese = TRUE then
  begin
    FormMain.StrMsg := 'Information : t@C̕ʂ܂';
  end
  else
  begin
    FormMain.StrMsg := 'Information : Copy file had done.' + #13#10 +
                       '[OK]';
  end;
  ShowMessage(FormMain.StrMsg);
  Result := TRUE;

end;


function  TFormCopyFtp.FtpExtractFilePath(FileName: String): String;
var
 iPos1: Integer;
 iIndex1: Integer;
 sStr1: String;
 sStr2: String;
begin
  sStr1 := FileName;
  iIndex1 := 0;
  while TRUE do
  begin
    iPos1 := Pos('/', sStr1);
    if iPos1 > 0 then
    begin
      iIndex1 := iIndex1 + iPos1;
      sStr2 := Copy(sStr1, iPos1+1, Length(sStr1));
      sStr1 := sStr2;
    end
    else
    begin
      Break
    end;
  end;
  Result := Copy(FileName, 1, iIndex1);
end;

function  TFormCopyFtp.FtpExtractFileName(FileName: String): String;
var
 iPos1: Integer;
 iIndex1: Integer;
 sStr1: String;
 sStr2: String;
begin
  sStr1 := FileName;
  iIndex1 := 0;
  while TRUE do
  begin
    iPos1 := Pos('/', sStr1);
    if iPos1 > 0 then
    begin
      iIndex1 := iIndex1 + iPos1;
      sStr2 := Copy(sStr1, iPos1+1, Length(sStr1));
      sStr1 := sStr2;
    end
    else
    begin
      Break
    end;
  end;
  Result := Copy(FileName, iIndex1+1, Length(FileName));
end;

function  TFormCopyFtp.FtpExtractFileExt(FileName: String): String;
var
 iPos1: Integer;
 iPos2: Integer;
 iIndex1: Integer;
 iIndex2: Integer;
 sStr1: String;
 sStr2: String;
 sStr3: String;
 sStr4: String;
 sStr5: String;
begin
  sStr1 := FileName;
  iIndex1 := 0;
  while TRUE do
  begin
    iPos1 := Pos('/', sStr1);
    if iPos1 > 0 then
    begin
      iIndex1 := iIndex1 + iPos1;
      sStr2 := Copy(sStr1, iPos1+1, Length(sStr1));
      sStr1 := sStr2;
    end
    else
    begin
      Break
    end;
  end;
  sStr3 := Copy(FileName, iIndex1+1, Length(FileName));

  sStr4 := sStr3;
  iIndex2 := 0;
  while TRUE do
  begin
    iPos2 := Pos('.', sStr4);
    if iPos2 > 0 then
    begin
      iIndex2 := iIndex2 + iPos2;
      sStr5 := Copy(sStr4, iPos2+1, Length(sStr4));
      sStr4 := sStr5;
    end
    else
    begin
      Break
    end;
  end;
  Result := Copy(sStr3, iIndex2, Length(sStr3));
end;

function TFormCopyFtp.FtpForceDirectorys(FolderName: String; TheList: TStringList): Boolean;
var
  iPos1: Integer;
  iRow1: Integer;
  iRow2: Integer;
  iFind1: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  StrList1: TStringList;
  CsvList1: TStringList;
  bExcept1: Boolean;
begin
  //
  Result := FALSE;

  //
  if FolderName = '/' then
  begin
    Result := TRUE;
    Exit;
  end;

///temp/000/<TAB>*****-**-*<TAB>2019/11/01	08:33:09<TAB>	               4,096
///temp/000/resize/<TAB>*****-**-*<TAB>2019/11/01	08:33:09<TAB>	               4,096

  //m
  StrList1 := TStringList.Create;
  CsvList1 := TStringList.Create;

  //
  sStr1 := Copy(FolderName, 2, Length(FolderName));

  //Kwɕ
  while TRUE do
  begin
    iPos1 := Pos('/', sStr1);
    if iPos1 > 0 then
    begin
      // / O
      sStr2 := Copy(sStr1,       1, iPos1-1);
      StrList1.Add(sStr2);
      // / 
      sStr1 := Copy(sStr1, iPos1+1, Length(sStr1));
    end
    else
    begin
      Break;
    end;
  end;

  //
  bExcept1 := FALSE;
  sStr3 := '/';

  //tH_ύX
  try
    //tH_ύX
    IdFTP1.ChangeDir(sStr3);

    //
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //ݒ
      sStr3 := sStr3 + StrList1.Strings[iRow1] + '/';
      //
      iFind1 := -1;
      for iRow2 := 0 to TheList.Count-1 do
      begin
        CsvList1.Clear;
        StringToCsvList(TheList.Strings[iRow2], CsvList1);
        if UpperCase(sStr3) = UpperCase(CsvList1[0]) then
        begin
          iFind1 := iRow2;
          Break;
        end;
      end;

      //
      if iFind1 = -1 then
      begin
        //쐬
        sStr4 := StrList1.Strings[iRow1] + '/';
        try
          //tH_쐬
          IdFTP1.MakeDir(sStr4);
          //
          TheList.Add(sStr3 + #09 + #09 + #09);
        except
          bExcept1 := TRUE;
          Break;
        end;
      end;

      //tH_ύX
      try
        IdFTP1.ChangeDir(sStr3);
      except
        bExcept1 := TRUE;
        Break;
      end;

    end;

  except
    bExcept1 := TRUE;
  end;


  //j
  StrList1.Free;
  CsvList1.Free;

  if bExcept1 = FALSE then
  begin
    Result := TRUE;
  end;
end;

procedure TFormCopyFtp.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormCopyFtp.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormCopyFtp.Edit31KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormCopyFtp.Edit32KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormCopyFtp.Edit33KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormCopyFtp.Edit34KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormCopyFtp.Edit35KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormCopyFtp.Edit36KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

end.
