unit InputLauncher;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_DEPRECATED    OFF} //W1000 : for FileCtrl
  {$WARN UNIT_PLATFORM   OFF} //W1005 : for Filectrl
  {$WARN SYMBOL_PLATFORM   OFF} //W1002  FileSetDate

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Filectrl, IniFiles;

const
  FORM_WIDTH_SET  = 750;
  FORM_HEIGHT_SET = 420;
  FORM_MAX        = 'MAX';
  FORM_MIN        = 'MIN';
  FORM_NORMAL     = 'NORMAL';

type
  TFormInputLauncher = class(TForm)
    ButtonList: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    OpenDialog1: TOpenDialog;
    Label129: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ButtonBrowse: TButton;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    CheckBox2: TCheckBox;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonListClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure ButtonBrowseClick(Sender: TObject);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListItems: TStringList;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormInputLauncher: TFormInputLauncher;

implementation


{$R *.dfm}

uses  Main, Launcher, JumpFolder, Browse;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormInputLauncher.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormInputLauncher.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormInputLauncher.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormInputLauncher.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormInputLauncher.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr9: String;
  iRow11: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormInputLauncher', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormInputLauncher', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormInputLauncher', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormInputLauncher', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormInputLauncher', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListItems := TStringList.Create;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
  CheckBox2.Checked := IniFile.ReadBool('LauncherChangeDir', IntToStr(FormMain.IntLauncherIndex), FALSE);
  //j
  IniFile.Free;

  //mF
  if FormMain.StrAnnsFMPath = '' then
  begin
    sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_LNC;
  end
  else
  begin
    sStr9 := FormMain.StrAnnsFMPath +  FILENAME_LNC;
  end;
  if FileExists(sStr9) = TRUE then
  begin
    //Ǎ
    StrListItems.LoadFromFile(sStr9);
    //擾
    sStr13 := StrListItems.Strings[(FormMain.IntLauncherIndex * 5) + 1];
    if sStr13 <> '' then
    begin
      sStr11 := '';
      sStr12 := '';
      for iRow11 := 0 to Length(sStr13) do
      begin
        sStr12:= sStr12 + Copy(sStr13, iRow11+1, 1);
        if Length(AnsiString(sStr12)) <= LAUNCHER_NAME_MAX then
        begin
          sStr11:= sStr11 + Copy(sStr13, iRow11+1, 1);
        end;
      end;
    end
    else
    begin
      sStr11 := sStr13;
    end;
    //ݒ
    Edit1.Text := sStr11;
    //ݒ
    if            StrListItems.Strings[(FormMain.IntLauncherIndex * 5) + 2] = '1' then
    begin
      CheckBox1.Checked := TRUE;
    end
    else
    begin
      CheckBox1.Checked := FALSE;
    end;
    //ݒ
    Edit2.Text := StrListItems.Strings[(FormMain.IntLauncherIndex * 5) + 3];
    //ݒ
    Edit3.Text := StrListItems.Strings[(FormMain.IntLauncherIndex * 5) + 4];
  end
  else
  begin
    //쐬
    StrListitems.Clear;
    StrListitems.Add('  A');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  B');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  C');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  D');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  E');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  F');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  G');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  H');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  I');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  J');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  K');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  L');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  M');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  N');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  O');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  P');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  Q');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  R');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  S');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  T');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  U');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  V');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  W');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  X');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  Y');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  Z');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  0');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  1');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  2');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  3');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  4');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  5');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  6');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  7');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  8');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('  9');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+A');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+B');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+C');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+D');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+E');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+F');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+G');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+H');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+I');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+J');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+K');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+L');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+M');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+N');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+O');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+P');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+Q');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+R');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+S');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+T');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+U');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+V');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+W');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+X');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+Y');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+Z');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+0');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+1');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+2');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+3');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+4');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+5');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+6');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+7');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+8');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('s+9');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+A');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+B');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+C');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+D');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+E');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+F');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+G');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+H');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+I');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+J');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+K');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+L');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+M');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+N');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+O');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+P');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+Q');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+R');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+S');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+T');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+U');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+V');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+W');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+X');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+Y');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+Z');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+0');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+1');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+2');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+3');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+4');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+5');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+6');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+7');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+8');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    StrListitems.Add('c+9');
    StrListitems.Add('');
    StrListitems.Add('1');
    StrListitems.Add('');
    StrListitems.Add('');
    //ۑ
    StrListItems.SaveToFile(sStr9);
  end;

end;

procedure TFormInputLauncher.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormInputLauncher', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormInputLauncher', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormInputLauncher', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormInputLauncher', 'Left',   FormInputLauncher.Left);
    IniFile.WriteInteger('FormInputLauncher', 'Top',    FormInputLauncher.Top);
    IniFile.WriteInteger('FormInputLauncher', 'Width',  FormInputLauncher.Width);
    IniFile.WriteInteger('FormInputLauncher', 'Height', FormInputLauncher.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListItems.Free;
end;

procedure TFormInputLauncher.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormInputLauncher, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormInputLauncher, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormInputLauncher.FormResize(Sender: TObject);
begin
  Edit2.Width := Panel1.ClientWidth - 40;
  Edit3.Width := Panel1.ClientWidth - 40;
end;

procedure TFormInputLauncher.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormInputLauncher.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormInputLauncher.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormInputLauncher.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormInputLauncher.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormInputLauncher.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormInputLauncher.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'InputLauncher.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormInputLauncher, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormInputLauncher, StrLanguageFileName, Sender);
  end;
end;

procedure TFormInputLauncher.ButtonListClick(Sender: TObject);
begin
    OpenDialog1.Filter := 'Exe(*.exe)|*.exe|All(*.*)|*.*';
    if FileExists(Edit2.Text) = TRUE then
    begin
      OpenDialog1.InitialDir := ExtractFilePath(Edit2.Text);
      OpenDialog1.FileName   := ExtractFileName(Edit2.Text);
    end
    else
    begin
      OpenDialog1.InitialDir := '';
      OpenDialog1.FileName   := '';
    end;
    if OpenDialog1.Execute = TRUE then
    begin
      Edit2.Text := OpenDialog1.FileName;
      Edit2.SetFocus;
    end
    else
    begin
      Edit2.SetFocus;
    end;
end;

procedure TFormInputLauncher.ButtonOKClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr5: String;
  sStr9: String;
  iRow11: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  IniFile: TIniFile;
begin
  if Edit2.Text = '' then
  begin
    ButtonListClick(Sender);
    Exit;
  end;

    //ݒ
    sStr1 := Edit2.Text;

    //ExẽhCuύX
    if      UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%d') then
    begin
      sStr2 := FormMain.StrExeDrive + Copy(sStr1, 3,  Length(sStr1));
    end
    else if UpperCase(Copy(sStr1, 1, 2)) = UpperCase('%p') then
    begin
      sStr2 := FormMain.StrExePath  + Copy(sStr1, 3,  Length(sStr1));
    end
    else
    begin
      sStr2 := sStr1;
    end;

    //
    if sStr2 <> '' then
    begin
      if (Copy(sStr2, 1, 1) = '"') and (Copy(sStr2, Length(sStr2), 1) = '"') then
      begin
        sStr5 := Copy(sStr2, 2, Length(sStr2)-2);
        sStr2 := sStr5;
      end;
    end;
    if FileExists(sStr2) = FALSE then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : o^AvP[V܂' + #13#10 +
                           sStr2;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Registered application file is not exist.' + #13#10 +
                           sStr2 + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end
    else
    begin
      sStr13 := Edit1.text;
      if sStr13 <> '' then
      begin
        sStr11 := '';
        sStr12 := '';
        for iRow11 := 0 to Length(sStr13) do
        begin
          sStr12:= sStr12 + Copy(sStr13, iRow11+1, 1);
          if Length(AnsiString(sStr12)) <= LAUNCHER_NAME_MAX then
          begin
            sStr11:= sStr11 + Copy(sStr13, iRow11+1, 1);
          end;
        end;
      end
      else
      begin
        sStr11 := sStr13;
      end;

      StrListItems.Strings[(FormMain.IntLauncherIndex * 5) + 1] := sStr11;
      if CheckBox1.Checked = TRUE then
      begin
        StrListItems.Strings[(FormMain.IntLauncherIndex * 5) + 2] := '1';
      end
      else
      begin
        StrListItems.Strings[(FormMain.IntLauncherIndex * 5) + 2] := '0';
      end;
      StrListItems.Strings[(FormMain.IntLauncherIndex * 5) + 3] := Edit2.Text;
      StrListItems.Strings[(FormMain.IntLauncherIndex * 5) + 4] := Edit3.Text;
      //ۑ
      if FormMain.StrAnnsFMPath = '' then
      begin
        sStr9 := ExtractFilePath(ParamStr(0)) + FILENAME_LNC;
      end
      else
      begin
        sStr9 := FormMain.StrAnnsFMPath +  FILENAME_LNC;
      end;
      StrListItems.SaveToFile(sStr9);

      //m
      IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
      //JgfBNgɈړۑ邪A̍ڂ̂ BonsfMmini ɐp
      IniFile.WriteBool('LauncherChangeDir', IntToStr(FormMain.IntLauncherIndex),  CheckBox2.Checked);
      //j
      IniFile.Free;

      //ݒ
      FormMain.SetMenuLauncher(Sender);
      //ݒ
      FormMain.SetShortCutKey(Sender);

      //I
      ModalResult := mrOK;
    end;
end;

procedure TFormInputLauncher.ButtonBrowseClick(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FILE);
  //j
  IniFile.Free;

    //
    FormMain.StrRetFormBrowse := '';
    FormMain.StrSetFormBrowse := ExtractfilePath(FormMain.StrCurrent);
    //
    FormBrowse := TFormBrowse.Create(Application);
    try
      if FormBrowse.ShowModal = mrOK then
      begin
        bResult := TRUE;
      end
      else
      begin
        bResult := FALSE;
      end;
    finally
      //j
      FormBrowse.Free;
    end;
    //
    if bResult = TRUE then
    begin
      //t@C
      if FileExists(FormMain.StrRetFormBrowse) = TRUE then
      begin
        Edit2.Text := FormMain.StrRetFormBrowse;
        Edit2.SetFocus;
      end
      else
      begin
        Edit2.SetFocus;
      end;
    end
    else
    begin
      Edit2.SetFocus;
    end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString('Browse', 'Target', BROWSE_FOLDER);
  //j
  IniFile.Free;

end;

procedure TFormInputLauncher.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormInputLauncher.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormInputLauncher.Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //RETURN
  if Key = VK_RETURN then
  begin
    key := 0;
    if Edit2.Text = '' then
    begin
      //
    end
    else
    begin
      //s
      ButtonOK.SetFocus;
      ButtonOKClick(Sender);
    end;
  end;
end;

procedure TFormInputLauncher.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormInputLauncher.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

end.
