unit Rename;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_PLATFORM OFF} //W1002

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Shellapi, IniFiles, System.IOUtils;

const
  FORM_WIDTH_SET       = 770;
  FORM_HEIGHT_SET      = 500;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormRename = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    ListBox2: TListBox;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ButtonSkip: TButton;
    Label6: TLabel;
    CheckBox1: TCheckBox;
    Edit4: TEdit;
    Edit5: TEdit;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);

    procedure Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);

    procedure ListBox2Click(Sender: TObject);
    procedure ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonSkipClick(Sender: TObject);

    function  RenameFileFolder(Sender: TObject): Boolean;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure CheckBox1Click(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;

  public
    { Public 錾 }

  end;

var
  FormRename: TFormRename;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormRename.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormRename.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormRename.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormRename.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormRename.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormRename', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormRename', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormRename', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormRename', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormRename', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //Ǎ
  if FileExists(FormMain.StrExtractBase + RENAME_TXT) = TRUE then
  begin
    FormMain.StrListRenameSrc.LoadFromFile(FormMain.StrExtractBase + RENAME_TXT, TEncoding.Unicode);
  end;
  ListBox2.Items.Clear;
  for iRow1 := 0 to FormMain.StrListRenameSrc.Count-1 do
  begin
    ListBox2.Items.Add(FormMain.StrListRenameSrc.Strings[iRow1]);
  end;
  ListBox2.ItemIndex := 0;

  //NA
  FormMain.StrListRenameResult.Clear;

  //ݒ
  ListBox2.Enabled := FALSE;
  Edit1.Font.Color := clBlue;
  Edit1.ReadOnly   := TRUE;
  Edit3.Font.Color := clBlue;
  Edit3.ReadOnly   := TRUE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  CheckBox1.Checked := IniFile.ReadBool('FormRename', 'ShowExtention', FALSE);
  //j
  IniFile.Free;

  //ݒ
  ListBox2Click(Sender);
  Edit3.Text := ExtractFilePath(FormMain.Strcurrent);

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox2.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox2.Style := lbStandard;
  end;

  if ListBox2.Items.Count <= 1 then
  begin
    ButtonSkip.Visible := FALSE;
  end;
end;

procedure TFormRename.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormRename', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormRename', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormRename', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormRename', 'Left',   FormRename.Left);
    IniFile.WriteInteger('FormRename', 'Top',    FormRename.Top);
    IniFile.WriteInteger('FormRename', 'Width',  FormRename.Width);
    IniFile.WriteInteger('FormRename', 'Height', FormRename.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteBool('FormRename', 'ShowExtention', CheckBox1.Checked);
  //j
  IniFile.Free;
end;

procedure TFormRename.FormResize(Sender: TObject);
begin
  Edit1.Width    := Panel1.Width -30 -145;
  Edit2.Width    := Panel1.Width -30 -145;
  Edit3.Width    := Panel1.Width -30 -30;
  ListBox2.Width := Panel1.Width -30 -30;
  Edit4.Left     := Panel1.Width -130;
  Edit5.Left     := Panel1.Width -130;
end;

procedure TFormRename.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormRename.KeyPreview := TRUE;
  //ݒ
  Edit2.SetFocus;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormRename.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormRename.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormRename.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormRename.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormRename.Handle, imClose);

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Rename.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormRename, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormRename, StrLanguageFileName, Sender);
  end;
end;

procedure TFormRename.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormRename, StrLanguageFileName, Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormRename, StrLanguageFileName, Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormRename.ListBox2Click(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
begin
  //ݒ
  if Copy(ListBox2.Items.Strings[ListBox2.ItemIndex], Length(ListBox2.Items.Strings[ListBox2.ItemIndex]), 1) = '\' then
  begin
    Edit1.Text := Copy(ListBox2.Items.Strings[ListBox2.ItemIndex], 1, Length(ListBox2.Items.Strings[ListBox2.ItemIndex])-1);
    Edit2.Text := Copy(ListBox2.Items.Strings[ListBox2.ItemIndex], 1, Length(ListBox2.Items.Strings[ListBox2.ItemIndex])-1);
    if CheckBox1.Checked = TRUE then
    begin
      sStr1 := ChangeFileExt (Edit1.Text, '');
      sStr2 := ExtractFileExt(Edit1.Text);
      sStr3 := ChangeFileExt (Edit2.Text, '');
      sStr4 := ExtractFileExt(Edit2.Text);
      Edit1.Text := sStr1;
      Edit4.Text := sStr2;
      Edit2.Text := sStr3;
      Edit5.Text := sStr4;
    end
    else
    begin
      Edit4.Text := '';
      Edit5.Text := '';
    end;
  end
  else
  begin
    Edit1.Text := ListBox2.Items.Strings[ListBox2.ItemIndex];
    Edit2.Text := ListBox2.Items.Strings[ListBox2.ItemIndex];
    if CheckBox1.Checked = TRUE then
    begin
      sStr1 := ChangeFileExt (Edit1.Text, '');
      sStr2 := ExtractFileExt(Edit1.Text);
      sStr3 := ChangeFileExt (Edit2.Text, '');
      sStr4 := ExtractFileExt(Edit2.Text);
      Edit1.Text := sStr1;
      Edit4.Text := sStr2;
      Edit2.Text := sStr3;
      Edit5.Text := sStr4;
    end
    else
    begin
      Edit4.Text := '';
      Edit5.Text := '';
    end;
  end;
end;

procedure TFormRename.ListBox2DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormRename.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormRename.Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    //s
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end;
end;

procedure TFormRename.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormRename.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormRename.CheckBox1Click(Sender: TObject);
begin
  ListBox2Click(Sender);
end;

procedure TFormRename.ButtonOKClick(Sender: TObject);
begin
  if ListBox2.Items.Count = 1 then
  begin
    //ύX
    if RenameFileFolder(Sender) = FALSE then
    begin
      Exit;
    end;
    //I
    ModalResult := mrOK;
  end
  else if ListBox2.ItemIndex = (ListBox2.Items.Count - 1) then
  begin
    //ύX
    if RenameFileFolder(Sender) = FALSE then
    begin
      Exit;
    end;
    //I
    ModalResult := mrOK;
  end
  else
  begin
    //ύX
    if RenameFileFolder(Sender) = FALSE then
    begin
      Exit;
    end;
    //XLbv
    ButtonSkipClick(Sender);
    //tH[JXݒ
    Edit2.SetFocus;
  end;
end;

procedure TFormRename.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormRename.ButtonSkipClick(Sender: TObject);
begin
  if ListBox2.ItemIndex = (ListBox2.Items.Count - 1) then
  begin
    //I
    ModalResult := mrOK;
  end
  else
  begin
    ListBox2.ItemIndex := ListBox2.ItemIndex + 1;
    ListBox2Click(Sender);
  end;
end;

function  TFormRename.RenameFileFolder(Sender: TObject): Boolean;
var
//  shOpeStrct1: TSHFILEOPSTRUCT;
  sStr1: String;
  sStr2: String;
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos6: Integer;
  iPos7: Integer;
  iPos8: Integer;
  iPos9: Integer;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  bResult: Boolean;
  IniFile: TIniFile;
  File1: TWin32FindData;
  hFindData1: THandle;
  iRet3: Integer;
begin
//  AX^XN (*)
//  c_ (|)
//  ~L (\)
//  R (:)
//  dp (")
//  s (菬) (<)
//  s () (>)
//  ^╄ (?)
//  XbV (/)

  //
  Result := FALSE;

  //
  iPos1 := Pos('*', Edit2.Text);
  iPos2 := Pos('|', Edit2.Text);
  iPos3 := Pos('\', Edit2.Text);
  iPos4 := Pos(':', Edit2.Text);
  iPos5 := Pos('"', Edit2.Text);
  iPos6 := Pos('<', Edit2.Text);
  iPos7 := Pos('>', Edit2.Text);
  iPos8 := Pos('?', Edit2.Text);
  iPos9 := Pos('/', Edit2.Text);
  if (iPos1 > 0) or (iPos2 > 0) or (iPos3 > 0) or (iPos4 > 0) or
     (iPos5 > 0) or (iPos6 > 0) or (iPos7 > 0) or (iPos8 > 0) or
     (iPos9 > 0) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : sȕ܂܂Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Some letter can not accept.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //㔼폜
  sStr14 := TrimRight(Edit2.Text);
  //u
  sStr15 := StringReplace(sStr14, #09,    ' ', [rfReplaceAll]);
  sStr16 := StringReplace(sStr15, #13#10, ' ', [rfReplaceAll]);
  sStr17 := StringReplace(sStr16, #13,    ' ', [rfReplaceAll]);
  sStr18 := StringReplace(sStr17, #10,    ' ', [rfReplaceAll]);
  Edit2.Text := sStr18;

  //ݒ
  sStr1 := Edit3.Text + Edit1.Text + Edit4.Text;
  //ݒ
  sStr2 := Edit3.Text + Edit2.Text + Edit5.Text;

  //mF
  if (System.SysUtils.DirectoryExists(sStr2) = TRUE) or (System.SysUtils.FileExists(sStr2) = TRUE)  then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̃tH_܂̓t@C݂܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Same folder or file is exist.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;


  //t@C擾
  hFindData1 := WinApi.Windows.FindFirstFile(PWideChar(sStr1), File1);
  try
    ;
  finally
    WinApi.Windows.FindClose(hFindData1);
  end;

  //
  if hFindData1 <> INVALID_HANDLE_VALUE then
  begin
    //fBNg
    if (System.SysUtils.DirectoryExists(sStr1) = TRUE) then
    begin
      //SHFileOperation ͋󔒂܂񂾃t@C̕ϊɎŝ Directory g
      //ύX
      bResult := TRUE;
      try
        TDirectory.Move(sStr1, sStr2);
      except
        bResult := FALSE;
      end;

      //
      if bResult = FALSE then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : tH_̕ύXɎs܂';
        end
        else
        begin
          FormMain.StrMsg := 'Error : Folder name can not rename.' + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Result := FALSE;
      end;
      //mF
      if (System.SysUtils.DirectoryExists(sStr2) = FALSE) then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : tH_̕ύXɎs܂';
        end
        else
        begin
          FormMain.StrMsg := 'Error : Folder name can not rename.' + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        bResult := FALSE;
        Result := FALSE;
      end;

      //瑮ύX
      if bResult = TRUE then
      begin
        //ݒ
        iRet3 := FileSetAttr(sStr2, File1.dwFileAttributes);
        //s
        if iRet3 <> 0 then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Error : tH_̕ύXs܂';
          end
          else
          begin
            FormMain.StrMsg := 'Error : Folder attribute can not change.' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Result := FALSE;
        end
        //
        else
        begin
          Result := TRUE;
          //m
          IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
          //ݒ
          IniFile.WriteString('Return', 'Target', RETURN_NAME);
          //j
          IniFile.Free;
          //߂l
          if FormMain.StrRetFormRename = '' then
          begin
            FormMain.StrRetFormRename   := Edit3.Text + Edit2.Text + Edit5.Text + '\';
          end;
          //
          FormMain.StrListRenameResult.Add(Edit3.Text + Edit2.Text + Edit5.Text + '\');
        end;
      end
    end

    //t@C
    else if (System.SysUtils.FileExists(sStr1) = TRUE) then
    begin
      //SHFileOperation ͋󔒂܂񂾃t@C̕ϊɎŝ TFile g
      //ύX
      bResult := TRUE;
      try
        TFile.Move(sStr1, sStr2);
      except
        bResult := FALSE;
      end;

      //
      if bResult = FALSE then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : t@C̕ύXɎs܂';
        end
        else
        begin
          FormMain.StrMsg := 'Error : File name can not rename.' + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Result := FALSE;
      end;
      //mF
      if (System.SysUtils.FileExists(sStr2) = FALSE) then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : t@C̕ύXɎs܂';
        end
        else
        begin
          FormMain.StrMsg := 'Error : File name can not rename.' + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        bResult := FALSE;
        Result := FALSE;
      end;

      //瑮ύX
      if bResult = TRUE then
      begin
        //ݒ
        iRet3 := FileSetAttr(sStr2, File1.dwFileAttributes);
        //s
        if iRet3 <> 0 then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Error : t@C̕ύXs܂';
          end
          else
          begin
            FormMain.StrMsg := 'Error : File attribute can not change.' + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);
          Result := FALSE;
        end
        //
        else
        begin
          Result := TRUE;
          //m
          IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
          //ݒ
          IniFile.WriteString('Return', 'Target', RETURN_NAME);
          //j
          IniFile.Free;
          //߂l
          if FormMain.StrRetFormRename = '' then
          begin
            FormMain.StrRetFormRename   := Edit3.Text + Edit2.Text + Edit5.Text;
          end;
          //
          FormMain.StrListRenameResult.Add(Edit3.Text + Edit2.Text + Edit5.Text);
        end;
      end
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : t@CtH_łt@Cł܂';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Atribute is not folder or file.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Result := FALSE;
    end;

  end
  else
  begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Error : 擾ł܂ł';
      end
      else
      begin
        FormMain.StrMsg := 'Error : Atribute can not get.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Result := FALSE;
  end;
end;



end.

