unit TimeStamp;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_PLATFORM OFF} //W1002

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, DecEdit, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, MyUtility, System.IOUtils, Vcl.Mask, DateTimeEdit;

const
  FORM_WIDTH_SET       = 800;
  FORM_HEIGHT_SET      = 520;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

type
  TFormTimeStamp = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ListBox1: TListBox;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    Label5: TLabel;
    ButtonDate: TButton;
    DateTimeEdit1: TDateTimeEdit;
    DateTimeEdit2: TDateTimeEdit;
    DateTimeEdit3: TDateTimeEdit;
    DateTimeEdit4: TDateTimeEdit;
    DateTimeEdit5: TDateTimeEdit;
    DateTimeEdit6: TDateTimeEdit;
    ButtonTime: TButton;
    ButtonCopy: TButton;
    ButtonPaste: TButton;
    ButtonCopyChange: TButton;
    RadioGroup1: TRadioGroup;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);

    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    procedure DateTimeEditKeyPress(Sender: TObject; var Key: Char);
    procedure DateTimeEditEnter(Sender: TObject);
    procedure DateTimeEdit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DateTimeEdit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DateTimeEdit3KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DateTimeEdit4KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DateTimeEdit5KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure DateTimeEdit6KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ButtonDateClick(Sender: TObject);
    procedure ButtonTimeClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure ButtonCopyClick(Sender: TObject);
    procedure ButtonPasteClick(Sender: TObject);
    procedure ButtonCopyChangeClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    CsvList2: TStringList;
    CsvList3: TStringList;
    StrList1: TStringList;
    StrLanguageFileName: String;
    BoolJapanese: Boolean;

  public
    { Public 錾 }

  end;

var
  FormTimeStamp: TFormTimeStamp;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormTimeStamp.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormTimeStamp.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormTimeStamp.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(Self.Handle, imClose);
end;

procedure TFormTimeStamp.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormTimeStamp.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormTimeStamp', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormTimeStamp', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormTimeStamp', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormTimeStamp', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormTimeStamp', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //쐬
  CsvList2 := TStringList.Create;;
  CsvList3 := TStringList.Create;;
  StrList1 := TStringList.Create;;

  //Ǎ
  if FileExists(FormMain.StrExtractBase + TIME_TXT) = TRUE then
  begin
    StrList1.LoadFromFile(FormMain.StrExtractBase + TIME_TXT, TEncoding.Unicode);
  end;
  ListBox1.Items.Clear;
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    CsvList2.Clear;
    StringToCsvList(StrList1.Strings[iRow1], CsvList2);
    ListBox1.Items.Add(CsvList2[0]);
  end;

  //ݒ
  Edit1.Text := ExtractFilePath(CsvList2[0]);

  //e[}
  if FormMain.IntVclStyle = 0 then
  begin
    ListBox1.Style := lbOwnerDrawFixed;
  end
  else
  begin
    ListBox1.Style := lbStandard;
  end;
end;

procedure TFormTimeStamp.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormTimeStamp', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormTimeStamp', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormTimeStamp', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormTimeStamp', 'Left',   FormTimeStamp.Left);
    IniFile.WriteInteger('FormTimeStamp', 'Top',    FormTimeStamp.Top);
    IniFile.WriteInteger('FormTimeStamp', 'Width',  FormTimeStamp.Width);
    IniFile.WriteInteger('FormTimeStamp', 'Height', FormTimeStamp.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteInteger('FormTimeStamp', 'NameIndex', RadioGroup1.ItemIndex);
  //j
  IniFile.Free;

  //j
  CsvList2.Free;
  CsvList3.Free;
  StrList1.Free;
end;

procedure TFormTimeStamp.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormTimeStamp.KeyPreview := TRUE;

  //tH[JXݒ
  DateTimeEdit1.SetFocus;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormTimeStamp.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormTimeStamp.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormTimeStamp.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormTimeStamp.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormTimeStamp.Handle, imClose);


  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'TimeStamp.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormTimeStamp, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormTimeStamp, StrLanguageFileName, Sender);
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  RadioGroup1.ItemIndex := IniFile.ReadInteger('FormTimeStamp', 'NameIndex', 0);
  //j
  IniFile.Free;

  //ݒ
  RadioGroup1Click(Sender);
end;

procedure TFormTimeStamp.FormResize(Sender: TObject);
begin
  Edit1.Width    := Panel1.Width -30 -30;
  ListBox1.Width := Panel1.Width -30 -30;
end;

procedure TFormTimeStamp.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iIndex1: Integer;
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //L
    iIndex1 := RadioGroup1.ItemIndex;

    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormTimeStamp, StrLanguageFileName, Sender);

    //ݒ
    RadioGroup1.ItemIndex := iIndex1;
    //ݒ
    RadioGroup1Click(Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //L
    iIndex1 := RadioGroup1.ItemIndex;

    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormTimeStamp, StrLanguageFileName, Sender);

    //ݒ
    RadioGroup1.ItemIndex := iIndex1;
    //ݒ
    RadioGroup1Click(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormTimeStamp.ButtonOKClick(Sender: TObject);
var
  tDateTime1: TDateTime;
  iRow1: Integer;
  sStr1: String;
  iRet1: Integer;
  iAttr1: integer;
  iAttr2: integer;
begin
  if DateTimeEdit1.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : Nw肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Year is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
  if DateTimeEdit2.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : w肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Month is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if DateTimeEdit3.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : w肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Date is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if DateTimeEdit4.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : w肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Hour is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if DateTimeEdit5.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : w肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Minute is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if DateTimeEdit6.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : bw肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Second is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DateTimeEdit1.Text) < 1900 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : N̎w 1900 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Year must be set greater than or equal to 1900.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DateTimeEdit2.Text) < 1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 1 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Month must be set greater than or equal to 1.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DateTimeEdit2.Text) > 12 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 12 ȉɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Month must be set less than or equal to 12.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DateTimeEdit3.Text) < 1 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 1 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Day must be set greater than or equal to 1.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DateTimeEdit3.Text) > 31 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 31 ȉɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Day must be set less than or equal to 31.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DateTimeEdit4.Text) < 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 0 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Hour must be set greater than or equal to 1.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DateTimeEdit4.Text) > 23 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 23 ȉɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Hour must be set less than or equal to 23.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DateTimeEdit5.Text) < 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 0 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Minute must be set greater than or equal to 0.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DateTimeEdit5.Text) > 59 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ̎w 59 ȉɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Minute must be set less than or equal to 59.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  if StrToInt(DateTimeEdit6.Text) < 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : b̎w 0 ȏɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Second must be set greater than or equal to 0.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
  if StrToInt(DateTimeEdit6.Text) > 59 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : b̎w 59 ȉɂĉ';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Second must be set less than or equal to 59.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //TDateTime date = StrToDateTime("2006/8/14 10:23:42");
  sStr1 := DateTimeEdit1.Text + '/' + DateTimeEdit2.Text + '/' + DateTimeEdit3.Text + ' ' +
           DateTimeEdit4.Text + ':' + DateTimeEdit5.Text + ':' + DateTimeEdit6.Text;
  tDateTime1 := StrToDateTime(sStr1);


  //Jn
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    //WJ
    CsvList2.Clear;
    StringToCsvList(StrList1.Strings[iRow1], CsvList2);
    //ݒ
    if FormMain.StrRetFormTimeStamp = '' then
    begin
      FormMain.StrRetFormTimeStamp := CsvList2[0];
    end;

    //ReadOnly
    if Copy(CsvList2[3], 1 ,1) = 'R' then
    begin
      //ݒ
      iAttr1 := 0;
      if Copy(CsvList2[3], 1 ,1) = 'R' = true then
      begin
        iAttr1 := iAttr1 + FILE_ATTRIBUTE_READONLY;
      end;
      if Copy(CsvList2[3], 2 ,1) = 'H' = true then
      begin
        iAttr1 := iAttr1 + FILE_ATTRIBUTE_HIDDEN;
      end;
      if Copy(CsvList2[3], 3 ,1) = 'S' then
      begin
        iAttr1 := iAttr1 + FILE_ATTRIBUTE_SYSTEM;
      end;
      if Copy(CsvList2[3], 4 ,1) = 'A' then
      begin
        iAttr1 := iAttr1 + FILE_ATTRIBUTE_ARCHIVE;
      end;
      //ReadOnlyO
      iAttr2 := iAttr1 - FILE_ATTRIBUTE_READONLY;

      //UĕύX
      iRet1 := FileSetAttr(CsvList2[0], iAttr2);
      //s
      if iRet1 <> 0 then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : t@C鑀삪s܂' + #13#10 +
                              CsvList2[0];
        end
        else
        begin
          FormMain.StrMsg := 'Error : Change file attribute failed before change.' + #13#10 +
                             CsvList2[0] + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;

      //ύX
      try
        //ݒ
        System.IOUtils.TFile.SetLastWriteTime(CsvList2[0], tDateTime1);
      except
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : ^CX^v̕ύXɎs܂' + #13#10 +
                              CsvList2[0];
        end
        else
        begin
          FormMain.StrMsg := 'Error : Change time stamp failed.' + #13#10 +
                             CsvList2[0] + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;

      //ύXAɖ߂߂ɕύX
      iRet1 := FileSetAttr(CsvList2[0], iAttr1);
      //s
      if iRet1 <> 0 then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : t@C߂삪s܂' + #13#10 +
                              CsvList2[0];
        end
        else
        begin
          FormMain.StrMsg := 'Error : Change file attribute failed after change.' + #13#10 +
                             CsvList2[0] + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;

    end
    //ReadOnlyłȂ
    else
    begin
      //ύX
      try
        //ݒ
        System.IOUtils.TFile.SetLastWriteTime(CsvList2[0], tDateTime1);
      except
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Error : ^CX^v̕ύXɎs܂' + #13#10 + CsvList2[0];
        end
        else
        begin
          FormMain.StrMsg := 'Error : Change time stamp failed.' + #13#10 +
                             CsvList2[0] + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;
    end;
  end;

  //ݒ
  if BoolJapanese = TRUE then
  begin
    FormMain.StrMsg := 'Information : ύX܂';
  end
  else
  begin
    FormMain.StrMsg := 'Information : Change had done.' + #13#10 +
                       '[OK]';
  end;
  ShowMessage(FormMain.StrMsg);
  ModalResult := mrOK;
end;

procedure TFormTimeStamp.ButtonCopyChangeClick(Sender: TObject);
begin
  FormMain.StrTimeStampYear   := DateTimeEdit1.Text;
  FormMain.StrTimeStampMonth  := DateTimeEdit2.Text;
  FormMain.StrTimeStampDay    := DateTimeEdit3.Text;
  FormMain.StrTimeStampHour   := DateTimeEdit4.Text;
  FormMain.StrTimeStampMinute := DateTimeEdit5.Text;
  FormMain.StrTimeStampSecond := DateTimeEdit6.Text;
  ButtonOKClick(Sender);
end;

procedure TFormTimeStamp.ButtonCopyClick(Sender: TObject);
begin
  FormMain.StrTimeStampYear   := DateTimeEdit1.Text;
  FormMain.StrTimeStampMonth  := DateTimeEdit2.Text;
  FormMain.StrTimeStampDay    := DateTimeEdit3.Text;
  FormMain.StrTimeStampHour   := DateTimeEdit4.Text;
  FormMain.StrTimeStampMinute := DateTimeEdit5.Text;
  FormMain.StrTimeStampSecond := DateTimeEdit6.Text;
  ButtonCancelClick(Sender);
end;

procedure TFormTimeStamp.ButtonPasteClick(Sender: TObject);
begin
  DateTimeEdit1.Text := FormMain.StrTimeStampYear;
  DateTimeEdit2.Text := FormMain.StrTimeStampMonth;
  DateTimeEdit3.Text := FormMain.StrTimeStampDay;
  DateTimeEdit4.Text := FormMain.StrTimeStampHour;
  DateTimeEdit5.Text := FormMain.StrTimeStampMinute;
  DateTimeEdit6.Text := FormMain.StrTimeStampSecond;
  DateTimeEdit1.SetFocus;
end;

procedure TFormTimeStamp.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

procedure TFormTimeStamp.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormTimeStamp.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex = 0 then
  begin
    //WJ
    CsvList3.Clear;
    StringToCsvList(StrList1.Strings[0], CsvList3);
    //ݒ
    DateTimeEdit1.Text := Copy(CsvList3[1],  1, 4);
    DateTimeEdit2.Text := Copy(CsvList3[1],  6, 2);
    DateTimeEdit3.Text := Copy(CsvList3[1],  9, 2);
    DateTimeEdit4.Text := Copy(CsvList3[1], 12, 2);
    DateTimeEdit5.Text := Copy(CsvList3[1], 15, 2);
    DateTimeEdit6.Text := Copy(CsvList3[1], 18, 2);
    ListBox1.TopIndex  := 0;
    ListBox1.ItemIndex := 0;
  end
  else
  begin
    //WJ
    CsvList3.Clear;
    StringToCsvList(StrList1.Strings[FormMain.IntTimeStampFileIndex], CsvList3);
    //ݒ
    DateTimeEdit1.Text := Copy(CsvList3[1],  1, 4);
    DateTimeEdit2.Text := Copy(CsvList3[1],  6, 2);
    DateTimeEdit3.Text := Copy(CsvList3[1],  9, 2);
    DateTimeEdit4.Text := Copy(CsvList3[1], 12, 2);
    DateTimeEdit5.Text := Copy(CsvList3[1], 15, 2);
    DateTimeEdit6.Text := Copy(CsvList3[1], 18, 2);
    ListBox1.TopIndex  := FormMain.IntTimeStampFileIndex;
    ListBox1.ItemIndex := FormMain.IntTimeStampFileIndex;
  end;
end;

procedure TFormTimeStamp.DateTimeEditEnter(Sender: TObject);
begin
  (Sender as TEdit).SelStart := Length((Sender as TEdit).Text);
end;

procedure TFormTimeStamp.DateTimeEditKeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  //Back
  else if key = chr(VK_BACK) then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormTimeStamp.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;

end;

procedure TFormTimeStamp.DateTimeEdit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iNum1: Integer;
begin
  //
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if key = VK_DELETE then
  begin
    key := $0;
  end
  else if key = VK_LEFT then
  begin
    DateTimeEdit3.SetFocus;
  end
  else if key= VK_RIGHT then
  begin
    DateTimeEdit2.SetFocus;
  end
  else if key = VK_UP then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit1.Text);
    //Z
    iNum1 := iNum1+1;
    //
    if      iNum1 > 2100 then
    begin
      iNum1 := 2000;
    end
    else if iNum1 < 1900 then
    begin
      iNum1 := 2000;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit1.Text := Format('%.4d', [iNum1]);
    //J[\ړ
    DateTimeEdit1.SelStart := Length(DateTimeEdit1.Text);
  end
  else if key= VK_DOWN then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit1.Text);
    //Z
    iNum1 := iNum1-1;
    //
    if      iNum1 > 2100 then
    begin
      iNum1 := 2000;
    end
    else if iNum1 < 1900 then
    begin
      iNum1 := 2000;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit1.Text := Format('%.4d', [iNum1]);
    //J[\ړ
    DateTimeEdit1.SelStart := Length(DateTimeEdit1.Text);
  end
  else
  begin
    //
    inherited;
  end;
end;

procedure TFormTimeStamp.DateTimeEdit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iNum1: Integer;
begin
  //
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if key = VK_DELETE then
  begin
    key := $0;
  end
  else if key = VK_LEFT then
  begin
    DateTimeEdit1.SetFocus;
  end
  else if key= VK_RIGHT then
  begin
    DateTimeEdit3.SetFocus;
  end
  else if key = VK_UP then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit2.Text);
    //Z
    iNum1 := iNum1+1;
    //
    if      iNum1 > 12 then
    begin
      iNum1 :=1;
    end
    else if iNum1 < 1 then
    begin
      iNum1 := 12;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit2.Text := Format('%.2d', [iNum1]);
    //J[\ړ
    DateTimeEdit2.SelStart := Length(DateTimeEdit2.Text);
  end
  else if key= VK_DOWN then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit2.Text);
    //Z
    iNum1 := iNum1-1;
    //
    if      iNum1 > 12 then
    begin
      iNum1 := 1;
    end
    else if iNum1 < 1 then
    begin
      iNum1 := 12;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit2.Text := Format('%.2d', [iNum1]);
    //J[\ړ
    DateTimeEdit2.SelStart := Length(DateTimeEdit2.Text);
  end
  else
  begin
    //
    inherited;
  end;
end;

procedure TFormTimeStamp.DateTimeEdit3KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iNum1: Integer;
begin
  //
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if key = VK_DELETE then
  begin
    key := $0;
  end
  else if key = VK_LEFT then
  begin
    DateTimeEdit2.SetFocus;
  end
  else if key= VK_RIGHT then
  begin
    DateTimeEdit1.SetFocus;
  end
  else if key = VK_UP then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit3.Text);
    //Z
    iNum1 := iNum1+1;
    //
    if      iNum1 > 31 then
    begin
      iNum1 :=1;
    end
    else if iNum1 < 1 then
    begin
      iNum1 := 31;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit3.Text := Format('%.2d', [iNum1]);
    //J[\ړ
    DateTimeEdit3.SelStart := Length(DateTimeEdit3.Text);
  end
  else if key= VK_DOWN then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit3.Text);
    //Z
    iNum1 := iNum1-1;
    //
    if      iNum1 > 31 then
    begin
      iNum1 := 1;
    end
    else if iNum1 < 1 then
    begin
      iNum1 := 31;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit3.Text := Format('%.2d', [iNum1]);
    //J[\ړ
    DateTimeEdit3.SelStart := Length(DateTimeEdit3.Text);
  end
  else
  begin
    //
    inherited;
  end;
end;

procedure TFormTimeStamp.DateTimeEdit4KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iNum1: Integer;
begin
  //
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if key = VK_DELETE then
  begin
    key := $0;
  end
  else if key = VK_LEFT then
  begin
    DateTimeEdit6.SetFocus;
  end
  else if key= VK_RIGHT then
  begin
    DateTimeEdit5.SetFocus;
  end
  else if key = VK_UP then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit4.Text);
    //Z
    iNum1 := iNum1+1;
    //
    if      iNum1 > 23 then
    begin
      iNum1 :=0;
    end
    else if iNum1 < 0 then
    begin
      iNum1 := 23;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit4.Text := Format('%.2d', [iNum1]);
    //J[\ړ
    DateTimeEdit4.SelStart := Length(DateTimeEdit4.Text);
  end
  else if key= VK_DOWN then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit4.Text);
    //Z
    iNum1 := iNum1-1;
    //
    if      iNum1 > 23 then
    begin
      iNum1 := 0;
    end
    else if iNum1 < 0 then
    begin
      iNum1 := 23;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit4.Text := Format('%.2d', [iNum1]);
    //J[\ړ
    DateTimeEdit4.SelStart := Length(DateTimeEdit4.Text);
  end
  else
  begin
    //
    inherited;
  end;
end;

procedure TFormTimeStamp.DateTimeEdit5KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iNum1: Integer;
begin
  //
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if key = VK_DELETE then
  begin
    key := $0;
  end
  else if key = VK_LEFT then
  begin
    DateTimeEdit4.SetFocus;
  end
  else if key= VK_RIGHT then
  begin
    DateTimeEdit6.SetFocus;
  end
  else if key = VK_UP then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit5.Text);
    //Z
    iNum1 := iNum1+1;
    //
    if      iNum1 > 59 then
    begin
      iNum1 :=0;
    end
    else if iNum1 < 0 then
    begin
      iNum1 := 59;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit5.Text := Format('%.2d', [iNum1]);
    //J[\ړ
    DateTimeEdit5.SelStart := Length(DateTimeEdit5.Text);
  end
  else if key= VK_DOWN then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit5.Text);
    //Z
    iNum1 := iNum1-1;
    //
    if      iNum1 > 59 then
    begin
      iNum1 := 0;
    end
    else if iNum1 < 0 then
    begin
      iNum1 := 59;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit5.Text := Format('%.2d', [iNum1]);
    //J[\ړ
    DateTimeEdit5.SelStart := Length(DateTimeEdit5.Text);
  end
  else
  begin
    //
    inherited;
  end;
end;

procedure TFormTimeStamp.DateTimeEdit6KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iNum1: Integer;
begin
  //
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    key := 0;
    ButtonOK.SetFocus;
    ButtonOKClick(Sender);
  end
  else if key = VK_DELETE then
  begin
    key := $0;
  end
  else if key = VK_LEFT then
  begin
    DateTimeEdit5.SetFocus;
  end
  else if key= VK_RIGHT then
  begin
    DateTimeEdit4.SetFocus;
  end
  else if key = VK_UP then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit6.Text);
    //Z
    iNum1 := iNum1+1;
    //
    if      iNum1 > 59 then
    begin
      iNum1 :=0;
    end
    else if iNum1 < 0 then
    begin
      iNum1 := 59;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit6.Text := Format('%.2d', [iNum1]);
    //J[\ړ
    DateTimeEdit6.SelStart := Length(DateTimeEdit6.Text);
  end
  else if key= VK_DOWN then
  begin
    //ϊ
    iNum1 := StrToInt(DateTimeEdit6.Text);
    //Z
    iNum1 := iNum1-1;
    //
    if      iNum1 > 59 then
    begin
      iNum1 := 0;
    end
    else if iNum1 < 0 then
    begin
      iNum1 := 59;
    end
    else
    begin
      //
    end;
    //\
    DateTimeEdit6.Text := Format('%.2d', [iNum1]);
    //J[\ړ
    DateTimeEdit6.SelStart := Length(DateTimeEdit6.Text);
  end
  else
  begin
    //
    inherited;
  end;
end;


procedure TFormTimeStamp.ButtonDateClick(Sender: TObject);
var
  sStr1: String;
begin
  sStr1 := FormatDateTime('yyyymmdd-hhnnss', Now);
  DateTimeEdit1.Text := Copy(sStr1, 1, 4);
  DateTimeEdit2.Text := Copy(sStr1, 5, 2);
  DateTimeEdit3.Text := Copy(sStr1, 7, 2);
end;

procedure TFormTimeStamp.ButtonTimeClick(Sender: TObject);
var
  sStr1: String;
begin
  sStr1 := FormatDateTime('yyyymmdd-hhnnss', Now);
  DateTimeEdit4.Text := Copy(sStr1, 10, 2);
  DateTimeEdit5.Text := Copy(sStr1, 12, 2);
  DateTimeEdit6.Text := Copy(sStr1, 14, 2);
end;

end.

