unit View;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN SYMBOL_DEPRECATED    OFF} //W1000 : for FileCtrl

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.Menus, Vcl.ExtCtrls,
  IniFiles, MyUtility;

const
  FORM_WIDTH_SET         = 480;
  FORM_HEIGHT_SET        = 320;
  CSVLIST_COLUMN_MAX     = 64;
  CSVLIST_COLUMN_WIDTH_0 = 72;
  CSVLIST_COLUMN_WIDTH   = 256;
  TITLE_VIEW_JPN         = 'eLXg\ ';
  TITLE_VIEW_ENG         = 'TextView ';

type
  TFormView = class(TForm)
    Panel3: TPanel;

    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    ColorDialog1: TColorDialog;
    ColorDialog2: TColorDialog;
    Memo1: TMemo;
    MenuEscape: TMenuItem;
    PopupMenu1: TPopupMenu;
    PopUpCopy1: TMenuItem;
    MenuQuit: TMenuItem;
    MenuView: TMenuItem;
    MenuWrapNone: TMenuItem;
    MenuWrapWindowWidth: TMenuItem;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);

    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure MenuEscapeClick(Sender: TObject);
    procedure MenuQuitClick(Sender: TObject);
    procedure MenuWrapWindowWidthClick(Sender: TObject);
    procedure MenuWrapNoneClick(Sender: TObject);

    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
    procedure PopUpCopy1Click(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListKeyMap: TStringList;
    StrListText: TStringList;
    StrLanguageFileName: String;
    BoolJapanese: Boolean;

  public
    { Public 錾 }

  end;

var
  FormView: TFormView;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormView.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormView.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //IMEIt
  SetImeMode(FormView.Handle, imClose);
end;

procedure TFormView.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormView.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormView', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormView', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormView', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormView', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormView', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //
  Memo1.Align := alClient;
  Memo1.Visible := TRUE;
  Memo1.Modified := FALSE;
  Memo1.ReadOnly := TRUE;
  Memo1.Lines.Clear;

  //m
  StrListKeyMap := TStringList.Create;
  StrListText := TStringList.Create;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  FormMain.FRichEditViewColor     := StringToColor(IniFile.ReadString('FRichEditView',      'Color',     ColorToString(clWhite)));
  FormMain.FRichEditViewFontColor := StringToColor(IniFile.ReadString('FRichEditView',      'FontColor', ColorToString(clBlack)));
  FormMain.FRichEditViewFontName  :=               IniFile.ReadString('FRichEditView',      'FontName',  'lr SVbN');
  FormMain.FRichEditViewFontSize  :=      StrToInt(IniFile.ReadString('FRichEditView',      'FontSize',  '14'));
  //
  Memo1.Color      := FormMain.FRichEditViewColor;
  Memo1.Font.Color := FormMain.FRichEditViewFontColor;
  Memo1.Font.Name  := FormMain.FRichEditViewFontName;
  Memo1.Font.Size  := FormMain.FRichEditViewFontSize;
  //
  MenuWrapNone.Checked          :=          IniFile.ReadBool  ('Editor', 'WrapNone',        TRUE);
  MenuWrapWindowWidth.Checked   :=          IniFile.ReadBool  ('Editor', 'WrapWindowWidth', FALSE);
  //j
  IniFile.Free;

  //f
  if MenuWrapNone.Checked = TRUE then
  begin
    Memo1.ScrollBars := ssBoth;
    Memo1.WordWrap := FALSE;
    MenuWrapNone.Enabled        := FALSE;
    MenuWrapWindowWidth.Enabled := TRUE;
  end;
  if MenuWrapWindowWidth.Checked = TRUE then
  begin
    Memo1.ScrollBars := ssVertical;
    Memo1.WordWrap := TRUE;
    MenuWrapNone.Enabled        := TRUE;
    MenuWrapWindowWidth.Enabled := FALSE;
  end;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //ݒ
  SetShortCutKey(Sender);
end;

procedure TFormView.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormView', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormView', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormView', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormView', 'Left',   FormView.Left);
    IniFile.WriteInteger('FormView', 'Top',    FormView.Top);
    IniFile.WriteInteger('FormView', 'Width',  FormView.Width);
    IniFile.WriteInteger('FormView', 'Height', FormView.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool  ('Editor', 'WrapNone',          MenuWrapNone.Checked);
  IniFile.WriteBool  ('Editor', 'WrapWindowWidth',   MenuWrapWindowWidth.Checked);
  //j
  IniFile.Free;

  //j
  StrListKeyMap.Free;
  StrListText.Free;
end;

procedure TFormView.FormShow(Sender: TObject);
var
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iRow1: Integer;
  iMax1: Integer;
  iMax2: Integer;
  iMax3: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  CsvList1: TStringList;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormView.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormView.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormView.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormView.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormView.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormView.Handle, imClose);

  //FormCreate ł͍sƃG[ɂȂ
  if BoolJapanese = TRUE then
  begin
    FormView.Caption := TITLE_VIEW_JPN;
  end
  else
  begin
    FormView.Caption := TITLE_VIEW_ENG;
  end;

  //t@Cǂݍ
  if FileExists(FormMain.StrSetFormView) = TRUE then
  begin
    //vpeB
    iPos1 := Pos(PROPATY_SHELL_TXT, FormMain.StrSetFormView);
    iPos2 := Pos(PROPATY_PE_TXT,    FormMain.StrSetFormView);
    iPos3 := Pos(INFORMATION_TXT,   FormMain.StrSetFormView);
    iPos4 := Pos(FOLDER_SIZE_TXT,   FormMain.StrSetFormView);
    //vpeB
    if      (iPos1 > 0) or (iPos2 > 0) then
    begin
      //m
      CsvList1 := TStringList.Create;
      //Ǎ
      StrListText.LoadFromFile(FormMain.StrSetFormView, TEncoding.Unicode);
      //ő啶擾
      iMax1 := 0;
      iMax2 := 0;
      iMax3 := 0;
      for iRow1 := 0 to StrListText.Count-1 do
      begin
        CsvList1.Clear;
        StringToCsvList(StrListText.Strings[iRow1], CsvList1);
        if Length(AnsiString(CsvList1[0])) > iMax1 then
        begin
          iMax1 := Length(AnsiString(CsvList1[0]));
        end;
        if Length(AnsiString(CsvList1[1])) > iMax2 then
        begin
          iMax2 := Length(AnsiString(CsvList1[1]));
        end;
        if Length(AnsiString(CsvList1[2])) > iMax3 then
        begin
          iMax3 := Length(AnsiString(CsvList1[2]));
        end;
      end;

      //ݒ
      Memo1.Lines.BeginUpdate;
      for iRow1 := 0 to StrListText.Count-1 do
      begin
        CsvList1.Clear;
        StringToCsvList(StrListText.Strings[iRow1], CsvList1);
        sStr1 := CsvList1[0] + StringOfChar(' ', iMax1-Length(AnsiString(CsvList1[0])));
        sStr2 := CsvList1[1] + StringOfChar(' ', iMax2-Length(AnsiString(CsvList1[1])));
        sStr3 := CsvList1[2] + StringOfChar(' ', iMax3-Length(AnsiString(CsvList1[2])));
        Memo1.Lines.Add(sStr1 + '  ' + sStr2 + '  ' + sStr3)
      end;
      Memo1.Lines.EndUpdate;

      //j
      CsvList1.Free;
    end
    //t@C
    else if (iPos3 > 0) then
    begin
      Memo1.Lines.LoadFromFile(FormMain.StrSetFormView, TEncoding.Unicode);
    end
    //tH_
    else if (iPos4 > 0) then
    begin
      //m
      CsvList1 := TStringList.Create;
      //Ǎ
      StrListText.LoadFromFile(FormMain.StrSetFormView, TEncoding.Unicode);
      //ő啶擾
      iMax1 := 0;
      iMax2 := 0;
      for iRow1 := 0 to StrListText.Count-1 do
      begin
        CsvList1.Clear;
        StringToCsvList(StrListText.Strings[iRow1], CsvList1);
        if Length(AnsiString(CsvList1[0])) > iMax1 then
        begin
          iMax1 := Length(AnsiString(CsvList1[0]));
        end;
        if Length(AnsiString(CsvList1[1])) > iMax2 then
        begin
          iMax2 := Length(AnsiString(CsvList1[1]));
        end;
      end;

      //ݒ
      Memo1.Lines.BeginUpdate;
      for iRow1 := 0 to StrListText.Count-1 do
      begin
        CsvList1.Clear;
        StringToCsvList(StrListText.Strings[iRow1], CsvList1);
        sStr1 := CsvList1[0] + StringOfChar(' ', iMax1-Length(AnsiString(CsvList1[0])));
        sStr2 := CsvList1[1] + StringOfChar(' ', iMax2-Length(AnsiString(CsvList1[1])));
        Memo1.Lines.Add(sStr1 + '  ' + sStr2)
      end;
      Memo1.Lines.EndUpdate;

      //j
      CsvList1.Free;
    end
    //vpeBȊO
    else
    begin
      Memo1.Lines.LoadFromFile(FormMain.StrSetFormView, TEncoding.Unicode);
    end;
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormView.Caption := TITLE_VIEW_JPN + FormMain.StrSetFormView;
    end
    else
    begin
      FormView.Caption := TITLE_VIEW_ENG + FormMain.StrSetFormView;
    end;
  end;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'View.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormView, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormView, StrLanguageFileName, Sender);
  end;

  //j[ݒ
  if BoolJapanese = TRUE then
  begin
    PopUpCopy1.Caption := 'Rs[(&C)';
  end
  else
  begin
    PopUpCopy1.Caption := 'Copy(&C)';
  end;
end;

procedure TFormView.FormResize(Sender: TObject);
begin
;
end;

procedure TFormView.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //{
  if      ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormView, StrLanguageFileName, Sender);
    //j[ݒ
    PopUpCopy1.Caption := 'Rs[(&C)';
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormView, StrLanguageFileName, Sender);
    //j[ݒ
    PopUpCopy1.Caption := 'Copy(&C)';
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormView.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;


procedure TFormView.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
  //oȂ
  key := #0;
end;

procedure TFormView.Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //oȂ
  key := 0;
end;

procedure TFormView.MenuEscapeClick(Sender: TObject);
begin
  //I
  ModalResult := mrOK;
end;

procedure TFormView.MenuQuitClick(Sender: TObject);
begin
  //I
  ModalResult := mrOK;
end;

procedure TFormView.MenuWrapNoneClick(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
begin
  if MenuWrapNone.Checked = FALSE then
  begin
    //L
    sStr1 := Memo1.Text;

    //ݒ
    MenuWrapNone.Enabled        := FALSE;
    MenuWrapWindowWidth.Enabled := TRUE;
    MenuWrapNone.Checked        := TRUE;
    MenuWrapWindowWidth.Checked := FALSE;
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //
    IniFile.WriteBool  ('Editor', 'WrapNone',         MenuWrapNone.Checked);
    IniFile.WriteBool  ('Editor', 'WrapWindowWidth',  MenuWrapWindowWidth.Checked);
    //j
    IniFile.Free;

    //ݒ
    Memo1.Lines.BeginUpdate;
    Memo1.Lines.Clear;
    Memo1.Lines.EndUpdate;

    //ݒ
    Memo1.WordWrap := FALSE;
    Memo1.ScrollBars := ssBoth;
    //߂
    Memo1.Lines.BeginUpdate;
    Memo1.Text := sStr1;
    Memo1.Lines.EndUpdate;
  end;
end;

procedure TFormView.MenuWrapWindowWidthClick(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
begin
  if MenuWrapWindowWidth.Checked = FALSE then
  begin
    //L
    sStr1 := Memo1.Text;

    //ݒ
    MenuWrapNone.Enabled        := TRUE;
    MenuWrapWindowWidth.Enabled := FALSE;
    MenuWrapNone.Checked        := FALSE;
    MenuWrapWindowWidth.Checked := TRUE;
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //
    IniFile.WriteBool  ('Editor', 'WrapNone',         MenuWrapNone.Checked);
    IniFile.WriteBool  ('Editor', 'WrapWindowWidth',  MenuWrapWindowWidth.Checked);
    //j
    IniFile.Free;

    //f
    Memo1.Lines.BeginUpdate;
    Memo1.Lines.Clear;
    Memo1.Lines.EndUpdate;

    //f
    Memo1.WordWrap := TRUE;
    Memo1.ScrollBars := ssVertical;
    //߂
    Memo1.Lines.BeginUpdate;
    Memo1.Text := sStr1;
    Memo1.Lines.EndUpdate;
  end;
end;

procedure TFormView.PopUpCopy1Click(Sender: TObject);
begin
  if Memo1.SelLength > 0 then
  begin
    Memo1.CopyToClipboard;
  end;
end;

procedure TFormView.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //annsfm
  if FormMain.IntKeyMenuTypeIndex = KEYBORD_MENU_ANNSFM then
  begin
    //Ǎ
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_ANNSFM_LIST;
    if FileExists(sStr1) = TRUE then
    begin
      StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
    end;

    //ݒ
    if StrListKeyMap.Count > 0 then
    begin
      SetShortCutNew('1017', MenuQuit, Sender);
      SetShortCutNew('1311', MenuEscape, Sender);
    end;
  end;
end;

procedure TFormView.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    //ݒ
    sStr3 := '';
  end
  else
  begin
    //ݒ
    sStr3 := sStr16;
  end;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

end.

